MODULE prog_constants

!    Message Window codes [1-6]
      integer*4 INFO_WINDOW, QUEST_WINDOW, QUEST_WINDOW_R,               &
                QUEST_WINDOW_YES_NO, QUEST_WINDOW_NO_YES,                &
                WARN_WINDOW, ERR_WINDOW, SEVERE_ERR_WINDOW,              &
                THREE_BUTTONS
      common /WindoMess/ INFO_WINDOW, QUEST_WINDOW, QUEST_WINDOW_R,      &
                QUEST_WINDOW_YES_NO, QUEST_WINDOW_NO_YES,                &
                WARN_WINDOW, ERR_WINDOW, SEVERE_ERR_WINDOW,              &
                THREE_BUTTONS

   enum, bind(c)
     enumerator :: ERR_MISSING_SPG = 1001, ERR_UNKNOWN_SPG, ERR_CELL_PARAM, ERR_STRUCTURE
   endenum
END MODULE prog_constants

module trig_constants
!  Trigonometric constants
   real, parameter :: pi     = 4.0*atan(1.0)     ! pi
   real, parameter :: twopi  = 2.0*pi            ! 2*pi
   real, parameter :: twopis = 2.0*pi*pi         ! 2*pi*pi
   real, parameter :: rtod   = 180.0/pi          ! radiant to degree
   real, parameter :: dtor   = 1.0/rtod          ! degree to radiant
end module trig_constants
