#ifndef NUMSPECIES
#define NUMSPECIES 18
#endif
void        set_dash_style            (gpointer gc);
void        reset_style               (gpointer gc);
int         cMsgWinErr                (const char *cmsg, int type,
                                       int tempo=0, int def_resp=1);
void        print_mess                (const char *riga);
gpointer    draw_bonds               (int x1, int y1, int x2, int y2,double DL, 
                                       gpointer gc, GdkWindow *win, int icolor, GdkColor Colori[]);
void        string_to_vector          (char *atoms, char *Atomi[]);
gpointer     getCurrentWindow         ();
gpointer     getCurrentPix            ();
gpointer     getCurrentContext        ();
gboolean     ManageExpose             (GtkWidget *w, gpointer obj, gpointer );
void        PrintScreen               (GtkWidget *item, gpointer data);
void        open_khelp                (GtkWidget *main_window, std::string fhelp);
void        setta_foreground          (int new_color, gpointer gc);
typedef struct {
                 GtkWidget *widget;
                 gpointer  pix;
                 char      *title;
                 int       width;
                 int       height;
                 int       ifResize;
                 void      (*cbResize)(int *, int *);
                 void      (*cbZoom)(int *);
               } _Viewer;

#include <sir_application.h>

