      subroutine elimHeavy(radius,xH,ier)
      USE General
      USE Symmetry
      USE Mappa
      USE Atomi
      USE PhaseModule
      USE Param

      common /cent/ tl(3,4),fs(3,3,24),mlat
      common/conue/shi(4),ishi,shi1(4)
      dimension kx(3),ka(3),kxmi(3,500),kxma(3,500),xfin(3),b(3),xn(3)
      real xH(1:np(1),1:np(2),1:np(3))


      if (radius.eq.0.0) return
      radius1=radius
      radius=abs(radius)


      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      !Rtot=suma
      denel=0.0
      npunti=0
      write(lo,*)'  ***************************************'
      write(lo,*)'  *    Heavy atom residue elimination    *'
      write(lo,*)'  ***************************************'

!     call srlin (15,lsn,lixx,ljxx,lkxx,llxx)
!     if (lixx.gt.0) then
!     if (lixx.gt.0) then
      if (InfoOK(15) == 1) then
*gl*     call sfl15(interp)  !!gl
         call PutGetXyzs(2, interp)
         numset = numbrun
      else
         write(lo,20)
         ier=-1
         return
      endif
  20  format(/,' *** error *** No coordinates in direct access file',/)
  
*------------------------
      do 30 i=1,nats
      itp=iabs(nz(i)/100)
      if (itp.ne.0) then
         do j=1,3
          if (ishi.gt.0) xyzs(j,i)=shi(4)*xyzs(j,i)-shi(j)
          if (xyzs(j,i).lt.0.0) xyzs(j,i)=xyzs(j,i)-int(xyzs(j,i))+1.0
          if (xyzs(j,i).ge.1.0) xyzs(j,i)=xyzs(j,i)-int(xyzs(j,i))
          enddo
          itp=nalfd(itp)
          write(lo,40) itp,i,xyzs(5,i),bfac(i),(xyzs(j,i),j=1,3)
      else
c         write(lo,45) i,xyzs(5,i),bt,(xyzs(j,i),j=1,3)
      endif
 30   continue
   40 format('atom ',a2,i4,5x,5f10.4)
   45 format('atom q ', i4,5x,5f10.4)
*------------
      do i=1,3
        b(i)=cell(i)/float(np(i))
      enddo
*------
      call prepeqv
*------
      do 400 iat=1,nats
c      itp=iabs(nz(iat)/100)
       itp=iabs(nz(iat))
       if (itp.eq.0) goto 400
       xx=xyzs(1,iat)
       yy=xyzs(2,iat)
       zz=xyzs(3,iat)
       do 200 k=1,nsym
        call oper(k,xn,xx,yy,zz)
        nbox=1
c       write(lo,'(2x,5hbox =,i4)')nbox
        do j=1,3
         if (xn(j).lt.0.0) xn(j)=xn(j)-int(xn(j))+1.0
         if (xn(j).gt.1.0) xn(j)=xn(j)-int(xn(j))
          xmi=xn(j)-radius/cell(j)
          xma=xn(j)+radius/cell(j)
          kxmi(j,nbox)=nint(xmi*np(j))+1
          kxma(j,nbox)=nint(xma*np(j))+1
        enddo

c       write(6,*)kxmi(1,1),kxma(1,1)
c       write(6,*)kxmi(2,1),kxma(2,1)
c       write(6,*)kxmi(3,1),kxma(3,1)

       do 150 irep=1,3
        nbox1=nbox
        do 140 ib=1,nbox1
          do 130 j=1,3
            if (kxmi(j,ib).lt.1) then
               nbox=nbox+1
               kxmi(j,nbox)=np(j)+kxmi(j,ib)
               kxma(j,nbox)=np(j)
               do 120 jj=1,3
                 if (jj.eq.j) goto 120
                 kxmi(jj,nbox)=kxmi(jj,ib)
                 kxma(jj,nbox)=kxma(jj,ib)
 120           continue
               kxmi(j,ib)=1
            endif
            if (kxma(j,ib).gt.np(j)) then
               nbox=nbox+1
               kxmi(j,nbox)=1
               kxma(j,nbox)=kxma(j,ib)-np(j)
               do 110 jj=1,3
                 if (jj.eq.j) goto 110
                 kxmi(jj,nbox)=kxmi(jj,ib)
                 kxma(jj,nbox)=kxma(jj,ib)
 110           continue
               kxma(j,ib)=np(j)
          endif
 130    continue
 140    continue
 150    continue

         do 300 nn1=1,nbox

c        write(6,*)nn1,kxmi(1,nn1),kxma(1,nn1)
c        write(6,*)nn1,kxmi(2,nn1),kxma(2,nn1)
c        write(6,*)nn1,kxmi(3,nn1),kxma(3,nn1)

          do 350 ix=kxmi(1,nn1),kxma(1,nn1)
           do 350 iy=kxmi(2,nn1),kxma(2,nn1)
              do 350 iz=kxmi(3,nn1),kxma(3,nn1)
                 xfin(1)=float(ix-1)/float(nnx)
                 xfin(2)=float(iy-1)/float(nny)
                 xfin(3)=float(iz-1)/float(nnz)
                 dis=dista(xn,xfin)
                 if (dis.gt.radius) goto 350
                 npunti=npunti+1
                 denel=denel+xH(ix,iy,iz)
                 if (radius.gt.0.0) then
                    xH(ix,iy,iz)=0.0
                 else
                    xH(ix,iy,iz)= xH(ix,iy,iz)*2.0
                 endif
 350          continue
 300     continue


 200   continue
 400   continue

      write(lo,1000) radius,npunti,denel/(volume*float(npunti))
 1000 format('   Radius of the sfere .................',f9.3,/,
     +       '   Number of grid point changed.........',i5,/,
     +       '   Average density eliminated ..........',f9.3,/)


       return
       end     
*----------------------------------------------------------------*
      subroutine dist(ib,ii,jj,kk,icont,d)

      USE General
      common/combox/xns0(500,3),b(3),D0,npbox(500,3),demed(500,2),nyold

      dimension delta(3),xns(3)

      xns(1)=float(ii)
      xns(2)=float(jj)
      xns(3)=float(kk)

      a1=cell(4)*dtor
      a2=cell(5)*dtor
      a3=cell(6)*dtor

      a1=cos(a1)
      a2=cos(a2)
      a3=cos(a3)

      sumd2=0.0
      a12=0.0
      a13=0.0
      a23=0.0

      do 10 id=1,3
        delta(id)= (xns(id)-xns0(ib,id))*b(id)
        sumd2=sumd2+delta(id)**2
 10   continue

     a12=2.0*delta(1)*delta(2)*a3
      a13=2.0*delta(1)*delta(3)*a2
      a23=2.0*delta(2)*delta(3)*a1

      d2= sumd2+a12+a13+a23
      d=sqrt(d2)
      if (d.lt.d0) icont=1
      return
      end
*----------------------------------
