*-----------------------------------------------------------------------*
*----               Envelope MASK  Subroutine                       ----*
*-----------------------------------------------------------------------*
      subroutine envelopeMask(jenveTipo,smax,vol,x)
      USE General
      USE Riflessi
      USE Mappa
c     USE Envelope
      USE PhaseModule
      USE Param

      real x(*)
      character (len=200)   :: strTemp


c     if (kverbo == 4) then
       write(lo,*)
       write(lo,*)'      **********************************'
       write(lo,*)'      *        ENVELOPE MASK SECTION   *'
       write(lo,*)'      **********************************'
c     endif

*---- change F000 per fare l'envelope
      f000_old=f000
      f000=volume*(0.32*(1.0-vol)+0.43*vol)

      FORTHenv = 0

      select case (jenveTipo)
      case (0)
        if (ihism > 0) then
          fcoef(:)=fovet_mod(:) * wt(:)
        else
          fcoef(:)=fovet(:) * wt(:)
        endif
        call MakeMap(fcoef,iphaz,nrefl,0,x,
     *                    FORTHenv,BACKenv)
      case (1)
        fcoef(:)=fovet(:)
        call MakeMap(fcoef,ipub,nrefl,0,x,
     *                    FORTHenv,BACKenv)
      case (2)  ! per fourie di differenza
        if (ihism > 0) then
          fcoef(:)=fovet_mod(:) * wt(:)
        else
          fcoef(:)=fovet(:) * wt(:)
        endif
        call MakeMap(fcoef,iphaz,nrefl,0,x,
     *                    FORTHenv,BACKenv)
      end select

      call zflush
      call DoSingleIteration()

      jflag=4
      if (jenveTipo == 2) then
        npunti=np(1)*np(2)*np(3)
c       perc=0.20
c       npts1=npunti*(1.0-perc)
c       call denhist(0,x,x,npts1,0)
c       den_p_memo=den_p
c       perc=0.30
c       npts1=npunti*perc
c       call denhist(0,x,x,npts1,0)
c       den_s=den_p_memo
c       jflag=7
c       write(6,*) 'prima',den_p,den_s
c
        jflag=1
c       perc=0.30
        perc=abs(vol)
        npts1=npunti*perc
        call denhist(0,x,x,npts1,0)
        write(6,*) 'prima',den_p
      endif

      sog=0.0
      call ChangeMapFlex(x,x,sog,jflag,0)

      call zflush
      call DoSingleIteration()

*---- Make the envelop map  (the Mask) ----*
!!gpu call InvEnv(np(1),np(2),np(3),smax,FORTHenv,BACKenv)
      call InvEnv(np(1),np(2),np(3),smax,x,FORTHenv,BACKenv)
      call zflush
      call DoSingleIteration()

      if (jenveTipo == 2) then
        npunti=np(1)*np(2)*np(3)
c       perc=0.20
c       npts1=npunti*(1.0-perc)
c       call denhist(0,x,x,npts1,0)
c       den_p_memo=den_p
c       perc=0.30
c       npts1=npunti*perc
c       call denhist(0,x,x,npts1,0)
c       den_s=den_p_memo
c       write(6,*) 'dopo',den_p,den_s
c       perc=0.30
        perc=abs(vol)
        npts1=npunti*perc
        call denhist(0,x,x,npts1,0)
        write(6,*) 'dopo',den_p
      else
        npts=vol*(np(1)*np(2)*np(3))
        call envhist(x,npts)
      endif
      call zflush
      call DoSingleIteration()
c     if (jenveTipo == 2) then
c       call envmaskDif(x,den_p,den_s,npunti)
c     else
        call envmask(x,den_p,npunti)
c     endif
      call zflush
      call DoSingleIteration()


c     if (kverbo == 4) then
      if (jenveTipo==1) write(lo,'("   === True Phases ===")') 
      write(lo,1000)Renve,vol*100.0,1/sqrt(smax),f000/volume,
     +             den_p/volume,npunti
c     endif

 1000 format (/,'   Radius (A) ................ ',f6.2,/,
     +          '   Volume (%) ................ ',f6.2,/,
     +          '   Resolution (A) ............ ',f6.2,/,
     +          '   F000 ...................... ',f8.4,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Envelope grid point ....... ',i8,/)

      f000=f000_old

c     npts=np(1)*np(2)*np(3)
c     x(1:npts) = x(1:npts) * vol
c     strTemp=StructureName(1:Lung(StructureName))//'_mask.map'
c     call CCP4MAPOUT(0,x,np,strTemp)
c     x(1:npts) = x(1:npts) / vol
c     stop

c     call DistruggiPiani(FORTHenv,BACKenv)

      return
      end
*-----------------------------------------------------------------------*
*----               Envelope  Subroutine                             ----*
*-----------------------------------------------------------------------*
      subroutine envelopeOLD(smax,vol,x,jrelM,corrEnv)
      USE General
      USE Riflessi
      USE Mappa
c     USE Envelope
      USE PhaseModule
      USE Param

      real x(*)
      character (len=200)   :: strTemp


c     if (kverbo == 4) then
       write(lo,*)
       write(lo,*)'      **********************************'
       write(lo,*)'      *        ENVELOPE SECTION        *'
       write(lo,*)'      **********************************'
c     endif

*---- change F000 per fare l'envelope
      f000_old=f000
      f000=volume*(0.32*(1.0-vol)+0.43*vol)
      FORTHenv = 0

      if (ihism > 0) then
        fcoef(:)=wt(:)*fovet_mod(:)
        call MakeMap(fcoef,iphaz,nrefl,0,x,
     *                    FORTHenv,BACKenv)
      else
        fcoef(:)=wt(:)*fovet(:)
        call MakeMap(fcoef,iphaz,nrefl,0,x,
     *                    FORTHenv,BACKenv)
      endif

      call zflush
      call DoSingleIteration()

      jflag=4
      sog=0.0
      call ChangeMapFlex(x,x,sog,jflag,0)

      call zflush
      call DoSingleIteration()

*---- Make the envelop map  (the Mask) ----*
!!gpu call InvEnv(np(1),np(2),np(3),smax,FORTHenv,BACKenv)
      call InvEnv(np(1),np(2),np(3),smax,x,FORTHenv,BACKenv)
      call zflush
      call DoSingleIteration()

      npts=vol*(np(1)*np(2)*np(3))
      call envhist(x,npts)
      call zflush
      call DoSingleIteration()
      call envmask(x,den_p,npunti)
      call zflush
      call DoSingleIteration()


c     if (kverbo == 4) then
      write(lo,1000)Renve,vol*100.0,1/sqrt(smax),f000/volume,
     +             den_p/volume,npunti
c     endif

 1000 format (/,'   Radius (A) ................ ',f6.2,/,
     +          '   Volume (%) ................ ',f6.2,/,
     +          '   Resolution (A) ............ ',f6.2,/,
     +          '   F000 ...................... ',f8.4,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Envelope grid point ....... ',i8,/)

      f000=f000_old

c     npts=np(1)*np(2)*np(3)
c     x(1:npts) = x(1:npts) * vol
c     strTemp=StructureName(1:Lung(StructureName))//'_mask.map'
c     call CCP4MAPOUT(0,x,np,strTemp)
c     x(1:npts) = x(1:npts) / vol
c     stop

c     call DistruggiPiani(FORTHenv,BACKenv)

      return
      end

*-----------------------------------------------------------------------*
*----               Patterson Envelope  Subroutine                  ----*
*-----------------------------------------------------------------------*
      subroutine envelopPatt(smax,vol,x,jrelM,corrEnv)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
c     USE Envelope
      USE PhaseModule
      USE Param
      USE CowMod, only: ncol, ndim1, ndim2

      real x(*)

*     common/dada/ncol,ndim1,ndim2
      common/twomap/bwil,icoeff


      write(lo,*)
      write(lo,*)'      **********************************'
      write(lo,*)'      *        Patt. ENVELOPE SECTION  *'
      write(lo,*)'      **********************************'


!
!-- switch to the Patterson Space Group
!
c     icent=1
c     tsmat(:,:)=0.
c     call musym()
c     nsymTot=nsym*(icent+1)*pts
c     neqv=nsymTot

*---- change F000
      f000_old=f000
      f000=volume*(0.32*(1.0-vol)+0.43*vol)
c     f000=f000**2
      f000=0.0

      fcoef(:)=fovet(:)*fovet(:)
c     fcoef(:)=fovet(:)
      call MakeMap(fcoef,ipub,nrefl,1,x,
     *                 FORTHenv,BACKenv)
      jflag=4
      jflag=2 ! solo l aparte positiva
      sog=0.0
      call ChangeMapFlex(x,x,sog,jflag,0)

*---- Make the envelop map  (the Mask) ----*
!!gpu call InvEnv(np(1),np(2),np(3),smax,FORTHenv,BACKenv)
      call InvEnv(np(1),np(2),np(3),smax,x,FORTHenv,BACKenv)

!!gpu call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACKenv)
      call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACKenv,x)

c     npts=vol*(np(1)*np(2)*np(3))
c     call envhist(x,npts)
c     call envmask(x,volume,den_p,npunti)

      f000=f000_old


      return
      end
*------------------------------------------------------------------------
      subroutine Solvent_Control(x,x1,D0)
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      integer,  allocatable ::noper(:,:)

      if  (D0.le.0.0) return

      nnx = np(1)
      nny = np(2)
      nnz = np(3)
      npunti=nnx*nny*nnz

      allocate(noper(20000,2), stat=ierr)


c-----troviamo den_p---
      npts1=v_p*npunti
      call denhist(0,x,x,npts1,0)

      a1=cell(4)*dtor
      a1=cos(a1)


      b1=cell(1)/float(nnx)
      b2=cell(3)/float(nnz)
      
      id=0
      do 20 i=-5,5
         do 30 j=-5,5
            r = errefun(i,j,a1,b1,b2)
            if (r.le.D0) then
                id=id+1
                noper(id,1)=i
                noper(id,2)=j
            endif
 30      continue
 20   continue
      

      npu=id
      npunti_agg=0

      do 1000 ky=1,nny
        do 1100 kz=1,nnz
           do 1200 kx=1,nnx
              xx=x(kx,ky,kz)
              xx1=x1(kx,ky,kz)/100
              if (xx1.eq.1) goto 1200
              npt=0
              npp=0
              do 1300 id=1,npu
                  npt=npt+1
                  ix = noper(id,1) + kx
                  iz = noper(id,2) + kz

                  if (ix.gt.nnx) ix = ix - nnx
                  if (iz.gt.nnz) iz = iz - nnz
                  if (ix.lt.1)   ix = nnx + ix
                  if (iz.lt.1)   iz = nnz + iz

                  xx1=x1(ix,ky,iz)/100
                  if (xx1.eq.1) npp=npp+1
 1300         continue
c----------          
              if (npp.eq.0.0) then
c                x1(kx,ky,kz)=200.0
              else
CCC              ppp=npp/float(npt)
CCC              w=2.0*ppp
CCC              w=min(w,0.7)
CCC              x1(kx,ky,kz)=w*100.0
                 if (xx.gt.2.0*den_p) then
                     npunti_agg=npunti_agg+1
                     w=0.7
                     x1(kx,ky,kz)=w*100.0
                 endif
              endif
c----------          
 1200      continue
 1100   continue
         
 1000 continue

      write(lo,2000) D0,npunti_agg
 2000 format('  ------ Solvent_Control------- :'/,
     *       '                  Radius =',f6.2,/,
     *       'Point add in the Envelop =',i7)

      deallocate(noper, stat=ierr)

      return
      end
*-----------------------------------------------
      function errefun(i,j,a1,b1,b2)

      x=b1 * float(i)
      y=b2 * float(j)

      d2=x**2 + y**2 + 2.0 * x * y * a1

      errefun=0.0
      if (d2.gt.0.0) errefun=sqrt(d2)

      return
      end

*-----------------------------------------------
      subroutine ReadSezione1(nsect,nnx,nny,nnz,nstore,jrelM)

      integer  nstore(nnx*(nnz+1)),itemp(nnx)
c
      if (jrelM.le.0) return
      irec=0
      nsto  = 0
      nnx1 = nnx + 1
      nny1 = nny + 1
      nnz1 = nnz + 1

         do 30 ky = 1, nny
             do 20 kz = 1, nnz
                irec = irec + 1
                if (ky.ne.nsect) go to 20
                read(jrelM,rec=irec) ( itemp(i), i = 1 , nnx )
                itemp(nnx1) = itemp(1)
                do 10 kx = 1, nnx1
                   nsto = nsto + 1
                   nstore(nsto) = itemp(kx)
 10             continue
 20          continue
 30       continue
          do 40 kx = 1, nnx1
             nsto = nsto + 1
             nstore(nsto) = nstore(kx)
 40       continue
        return
        end
*-----------------------------------------------------------
      subroutine ReadSezione(nsect,nnx,nny,nnz,nstore,jrelM)
      integer  nstore(nnx*(nnz+1)),itemp(nnx)
c
      if (jrelM.le.0) return
      irec=0
      nsto  = 0
      do 30 ky = 1, nny
         do 20 kz = 1, nnz
            irec = irec + 1
            if (ky.ne.nsect) go to 20
            read(jrelM,rec=irec) ( itemp(i), i = 1 , nnx )
            do 10 kx = 1, nnx
                nsto = nsto + 1
                nstore(nsto) = itemp(kx)
 10         continue
 20          continue
 30       continue
          do 40 kx = 1, nnx
             nsto = nsto + 1
             nstore(nsto) = nstore(kx)
 40       continue
        return
        end
*------------------------------------------------------------
      subroutine WriteSezione(nsect,nnx,nny,nnz,nstore,jrelM)
      dimension  nstore(nnx*nnz),itemp(nnx)
c
      if (jrelM.le.0) return
      irec=0
      nsto  = 0
      do 30 ky = 1, nny
         do 20 kz = 1, nnz
             irec = irec + 1
             if (ky.ne.nsect) go to 20
             do 10 kx = 1, nnx
                nsto = nsto + 1
                itemp(kx)=nstore(nsto)
 10          continue
             write(jrelM,rec=irec) ( itemp(i), i = 1 , nnx )
 20       continue
 30   continue
      do 40 kx = 1, nnx
         nsto = nsto + 1
         itemp(kx) = nstore(nsto)
 40   continue

      return
      end
*------------------------------------
      subroutine mapfilead(x,jrelM)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      integer, allocatable  ::nstore(:)

      nx=np(1)
      ny=np(2)
      nz=np(3)

      allocate(nstore(nx),stat= ierr)
 
      irec=0
      do 10 j=1,ny
       do 20 k=1,nz
         irec=irec+1
         do 30 i=1,nx
            nstore(i)=nint(x(i,j,k))
 30      continue
          write(jrelM,rec=irec)(nstore(i),i=1,nx)
 20    continue
 10   continue

      deallocate(nstore,stat= ierr)

c     stop
      return
      end
*------------------------------------
      subroutine filemapad(jrelM,x)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      integer, allocatable  ::nstore(:)

      nx=np(1)
      ny=np(2)
      nz=np(3)

      allocate(nstore(nx*nz),stat= ierr)
 
      irec=0
      do 10 iy=1,ny
         call ReadSezione(iy,nx,ny,nz,nstore,jrelM)
       do 20 iz=1,nz
         do 30 ix=1,nx
            indr = nx * ( iz - 1 ) + ix
            x(ix,iy,iz)=float(nstore(indr))
            write(3,*)x(ix,iy,iz)
 30      continue
 20    continue
 10   continue

      deallocate(nstore,stat= ierr)

      return
      end
*------------------------------------
      subroutine filemapad2(jrelM,x)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      integer, allocatable  ::nstore(:)
      double precision :: rr

      nx=np(1)
      ny=np(2)
      nz=np(3)

      allocate(nstore(nx*nz),stat= ierr)
      !open(1,file='app_ICA_b.dat')
      open(1,file='app_would_be_a_mask.dat')
 
      irec=0
      do 10 iy=1,ny
         !call ReadSezione(iy,nx,ny,nz,nstore,jrelM)
       do 20 iz=1,nz
         do 30 ix=1,nx
            read(1,'(48x,e11.7)')rr
            !write(2,*)real(rr)
            x(ix,iy,iz)=x(ix,iy,iz)-real(rr)*100.
            !indr = nx * ( iz - 1 ) + ix
            !x(ix,iy,iz)=float(nstore(indr))
 30      continue
 20    continue
 10   continue

      deallocate(nstore,stat= ierr)

      return
      end
