*-----------------------------------------------------*
*---- Routine principale -----------------------------*
*-----------------------------------------------------*

      subroutine flexmain

      USE General
      Use Mappa
c     Use Envelope
      Use MapTest
      USE Riflessi
      USE PlotsData
      USE PhaseModule
      USE Param
      USE Skeleton
      USE Atomi

      character (len=80)    :: strHead(3),strTitleContour
      character (len=80)    :: nameout,nameold
      character (len=200)   :: strTemp
      character (len=200)   :: strLog,strLog_old
      character (len=80)    :: tirang
      character (len=200)   :: strMaps

      common/super1/nmaMa1,iexte,fdri(3,100),percref(100),percc1(100),
     *              ncycl1(100)
      common/conue/shi(4),ishi,shi1(4)
      common/twomap/bwil,icoeff
      common/inptfile/iold,nameout,nameold
      common/parenve/Renve0,vp0,pv0
      common/omitmap/iomit,iy,nxomit(3,3)
      common/koti/irefcold,jrelSKold
      common/spheremap/sphere
      common/resshell/dmin_old,dmin_new,dmin
      common/super3/ncycl3(100),percc3(100),nmaMa3
c     common/SuperCycleTotal/nSuperCycT,nsuMaxT
c     common/soglie/sogres,sogw,sogres2,soge
      common/super4/ncycl4(100),percc4(100),nmaMa4

      dmin=0.5/sqrt(rhomax)
c
      irefcold=0
      jrelSKold=0

      RATMax=0.0
      RtotMin=999.0

      rfreeMin=999.0

      corrMax=0.0
      corrMin=999.0

      npunti=np(1)*np(2)*np(3)

      if (irefc.eq.0) jrelSK=0

 10   continue

      call readhist
      call zflush
      call DoSingleIteration()

      ifl=1

      ! se c'e' un file frammento dei atomi pesanti

      if (ifPDBheavy > 0) then
         nats = 500
         call AllocaAtomi(-2)
         LeggiHetam = 1
c        jgrapSav = jgrap
c        jgrap = 55
         ifHOH = 0
         kAla = 0
         LeggiHetam = 1
         nMolMr = 1
         call LeggiPDB(0, ifHOH, LeggiHetam, kAla, 0, ier)
c        jgrap = jgrapSav
      endif
      if (elimhe > 0.0) then
         xmapDif(:,:,:) = 0.0
c        radSphere = 2.0
         radSphere = elimhe
         xyzs(4,1:nats) = 100.0
         call Atoms2Mask(radSphere,nats,nsym,xyzs,xmapDif)
         write(6,*)'Punti Heavy-Mask pos:', count(xmapDif > 0.0)
         write(6,*)'Punti Heavy-Mask neg:', count(xmapDif < 0.0)
         write(6,*)'mask value:          ', maxval(xmapDif)
c        strTemp=StructureName(1:Lung(StructureName))//'_HAmask.map'
c        xmapDif = xmapDif * volume
c        call CCP4MAPOUT(0,xmapDif,np,strTemp)
c        xmapDif = xmapDif / volume 
         ! mappa
         fcoef(:)=fovet(:)*wt(:)
         call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK) 
         strMaps='Mappa 1.'
         call rhostats(xmap,xmapDif,strMaps)

c        strTemp=StructureName(1:Lung(StructureName))//'_conHA.map'
c        call CCP4MAPOUT(0,xmap,np,strTemp)
         !
         call flatmap(xmap,xmapDif,-3,0.0) ! con mask dall'atomo pesante
         strMaps='Mappa 2.'
         call rhostats(xmap,xmapDif,strMaps)
         strTemp=StructureName(1:Lung(StructureName))//'_senzaHA.map'
         call CCP4MAPOUT(0,xmap,np,strTemp)
         !invertiamo la mappa senza il contributo dell'atomo pesante
         call ChangeAndInvMap(xmap,xenve,0,0.0,0,ier)
         fcoef(:)=fcvet(:)
         call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK) 
         strMaps='Mappa 3.'
         call rhostats(xmap,xmapDif,strMaps)
         strTemp=StructureName(1:Lung(StructureName))//'_senzaHA2.map'
         call CCP4MAPOUT(0,xmap,np,strTemp)
         fovet(1:nrefl) = fcvet(1:nrefl)
         !
         return
      endif

      xmap=0.0
      xenve=0.0
      if (knw.eq.1) xmodel=0.0
      corr=0.0
      corrM=0.0
      corre=0.0

      if (knw.eq.1) then
        fcoef(:)=fovet(:)*wt(:)
        call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK) 
        call mapcorr0(xmap,xmapT,0,corr,ier)
c       ! test anna
c       call ChangeAndInvMap(xmap,xenve,0,0.0,0,ier)
c       stop
        !
        xmodel=xmap
        if (abs(ifDEDM) > 0) then
          fcoef(:)=fcvet(:)*wt(:)
          call MakeMap(fcoef,iphaz,nrefl,0,xmodel,
     *                   FORTH,BACK)
        endif
        call mapcorr0(xmap,xmodel,0,corrM,ier)
      endif
      call zflush
      call DoSingleIteration()

      if (ifreweight > 0) then
        if (knw > 0.and.ifDEDM==0) then
          call esamin(khl,mkang,ipub,iphaz,
     *        nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)
          tirang='weight'
         call ParamDistribution(tirang,2,wt,khl,nrefl,1,ipub,iphaz,
     *    shi1,wt,segni1,20,1.0)
        endif
       if (ifreweight == 1) then
c---- pesi: HM con P(wt) "teorica"
        work1(1:nrefl) = wt(1:nrefl)
        work2(1:nrefl) = wt(1:nrefl)

        nsip1=100
        nwizm1=25
        call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,3)
        wt(1:nrefl) = work1(1:nrefl)
        wtd(1:nrefl) = work1(1:nrefl)
        wtt_in(1:nrefl) = work1(1:nrefl)
        wtt_o(1:nrefl) = work1(1:nrefl)

       else
        ! calc. pesi dal sigmaA
         call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
         npts1=np(1)*np(2)*np(3)*v_p
         call denhist(1,xmap,xenve,npts1,0)
         call ChangeAndInvMap(xmap,xenve,1,0.0,0,ier)

         call sigmaA(1,fovet,sigmav,fovet,mkang,rhov,epsv,fcvet,
     *               ipub,iphaz,wt,iphad,wtd,wvar,pesMod,Dluz,e1,e2,
     *               nreflDim,nrefl,nrefl,0,1.0,1.0,0)

         iphaz(1:nrefl) = iphad(1:nrefl)
         wtd(1:nrefl) = wt(1:nrefl)
         wtt_in(1:nrefl) = wt(1:nrefl)
         wtt_o(1:nrefl) = wt(1:nrefl)
       endif

       fcoef(:)=fovet(:)*wt(:)
       call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                 FORTH,BACK)
       if (knw.eq.1) then
         call mapcorr0(xmap,xmapT,0,corr,ier)
         xmodel=xmap
         call mapcorr0(xmap,xmodel,0,corrM,ier)
       endif
       if (knw.gt.0)  then
         call esamin(khl,mkang,ipub,iphaz,
     *      nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)
         tirang='weight'
         call ParamDistribution(tirang,2,wt,khl,nrefl,1,ipub,iphaz,
     *      shi1,wt,segni1,20,1.0)
       endif
c      return
      endif
      !-----

      kk=0
      errinv=0
      errinvp=0
      Rtot=0.0
      rfree=.0
      RAT=0.0
      sigAmed=0.0

      corrE=0.0
      realfreeR=0.0
      realfreeR2=0.0
      realfreeR4=0.0
      if (knw > 0) then
        if (ifEDM <  0) then
          write(lo,'(1x,"SU",1x,"MA",1x,"MI",1x,"FOMs",2x,"NPHASED",4x,
     *          "CC",7x,
     *          "CCM",6x,"CCE",5x,"ERR",6x,"WERR",6x,"Rt",5x,"Rfree",4x,
     *          "DPHI")')
c    *          "RAT",6x,"Rsir",4x,"%Rsir",5x,"DPHI")')
          write(lo,'(3i3,1x,4hFOMs,1x,i6,12(1x,f8.3))')
c         write(lo,'(3i3,1x,4hFOMs,1x,i6,15(1x,f8.3))')
     *      kk,kk,kk,nref1,corr,corrM,corrE,errm1,errmw1,
     *      Rtot,rfree,errm12
c    *      Rtot,rfree,RAT,Rsir,Rsir,errm12
        else
          write(lo,'(1x,"MA",1x,"MI",1x,"FOMs",2x,"NPHASED",4x,"CC",7x,
     *          "CCM",6x,"CCE",5x,"ERR",6x,"WERR",6x,"Rt",5x,"Rfree",4x,
     *          "RRFREE",4x,"DPHI")')
c    *          "RAT",6x,"Rsir",4x,"%Rsir",4x,"RRFREE",5x,"DPHI")')
c         write(lo,'(2i3,1x,4hFOMs,1x,i6,15(1x,f8.3))')
          write(lo,'(2i3,1x,4hFOMs,1x,i6,12(1x,f8.3))')
     *      kk,kk,nref1,corr,corrM,corrE,errm1,errmw1,
     *      Rtot,rfree,realfreeR,errm12
c    *      Rtot,rfree,RAT,Rsir,Rsir,realfreeR,errm12
      endif
c      return
      endif

c     ! test per la mappa di MR
c     call ImproveMapMR
c     stop
      ! test skeleton
      if (iskelet > 0) call skeleton_greer(xmap)



*---- il numero dei supercicli
      if (ifEDM < 0) then
        ! nel caso FLEX
        vp0 = v_p
        pv0 = pv_p
        Renve0 = Renve
        Rmin = sqrt(rhomax*4)
        Rmin = 1.0/Rmin+2.0
        nsuMax3 = nint((Renve-Rmin)/abs(stepE)) + 1
        if (nsuMax3 == 0) nsuMax3 = 1
        !        2 volte il super3 + super1 + super 2
        nsuMax= 2.* nsuMax3 + 2 
      else
        ! nel caso FLEX-new
        nsuMax=1
      endif

      call AllocaPlots(1,3,200)

      npuntiPlotEnd=0
      ngridPointEnd=0

      nfree=0
      nSuperCyc=0

      call toflush()

      ! Calculate real space metric : notazione CCP4
      call calcmetric

      ! test per four. di diff
      if (abs(ifDEDM) > 0) then
          call TestFq(abs(ifDEDM))
          return
          iflat=2
          nSuperCyc = nSuperCyc + 1
          if (knw > 0) then
          fcoef(:)=fovet(:)*wt(:)
          call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                     FORTH,BACK) 
          call mapcorr0(xmap,xmapT,0,corr,ier)
          call mapcorr0(xmap,xmodel,0,corrM,ier)
          kk=-1
          errinv=0
          errinvp=0
          Rtot=0.0
          rfree=.0
          RAT=0.0
          sigAmed=0.0
    
          corrE=0.0
          realfreeR=0.0
          realfreeR2=0.0
          realfreeR4=0.0
          if (knw > 0) then
           call esamin(khl,mkang,ipub,iphaz,
     *      nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)
            write(lo,'(2i3,1x,4hFOMs,1x,i6,12(1x,f8.3))')
     *      kk,kk,nref1,corr,corrM,corrE,errm1,errmw1,
     *      Rtot,rfree,realfreeR,errm12
           endif
           kk=0
          endif
          ifDEDM = 0
c         if (ifDEDM < 0) return
          call super_new(nfree,nsuMax)
          return
      endif
      !
      ! test per i riflessi a bassa resoluzione
c       call LowResDM(0.0)
      !
      ! Calculate real space metric : notazione CCP4
c      call calcmetric
      !


      if (ifEDM >= 0) then
        ! check strategy : dres and Heavy/Tot
        dresMax=0.5/sqrt(rhomax)
        sumZ2heavy=nw(nk)*no(nk)**2
        sumZ2tot=sum(nw(1:nk)*no(1:nk)**2)
        rHeavyTot=sumZ2heavy/sumZ2tot
        if (knw > 0) write(6,*)'Resmax,rheavy/Tot',dresMax,rHeavyTot
c       if (dresMax < 1.1) then
        if (dresMax < 1.5) then
c       if (rHeavyTot > 0.1 .and.dresMax < 1.1) then
c       if (rHeavyTot > 0.1 .or.dresMax < 1.1) then
           nmaMa4=2
           ncycl4(2)=50
        endif
        iflat=2
        nSuperCyc = nSuperCyc + 1
        call super_new(nfree,nsuMax)
c       call EDMdritan(nfree)
      else
        ! procedure vecchia (FLEX)
        ihism=0 ! senza HM
        iflat=1 ! flattening con den*0.5
        call super_one(0,nfree,1,nsuMax)
        call toflush()
        !
        call super_two(nfree,2,nsuMax,Rmin)
        call toflush()
        !
        nSuperCyc = 2
        do irep=1,2
          call super_three(nfree,nSuperCyc,nsuMax,nsuMax3,Rmin)
          call toflush()
c         nsuMax=nsuMax+(nsuMax-1)
          Renve=Renve0
          v_p=vp0
          pv_p=pv0
        enddo
      endif


      ! crea la mappa in formato ccp4
      strTemp=StructureName(1:Lung(StructureName))//'_edm.map'
      write(lo,'(" MAP Filename after EDM procedure: ",a)')
     *          strTemp(1:Lung(strTemp))
      write(ktml,'("<br><br> Output MAP File (CCP4 format) ",
     *         "after EDM procedure: <b>",a,"</b>")')
     *         strTemp(1:Lung(strTemp))
      write(jlog,'("<br><br><b> MAP File (CCP4 format) ",
     *         "after EDM procedure: </b>",a)')
     *         strTemp(1:Lung(strTemp))

      call CCP4MAPOUT(0,xmap,np,strTemp)



 1000 format(/,1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,6hNREF =,i6,
     *  1x,4hCC =,1x,f7.4,3h ( ,f7.4,2h ),
     *  1x,7hERRco =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,8hERRinv =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,5hDPH =,1x,f5.2,1x,'Rt =',f7.3,' Rfree =',f7.3,' RAT=',f7.3)


 2000 format(1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,
     *       1x,4hCC =,f7.4,1x,5hERR =,f6.2)

c     call AllocaPlots(2,3,200)

      return
      end
*----------------------------------------------------------------------
      subroutine super_new(nfree,nsuMax)


      USE General
      USE Riflessi
      Use Grafici
      USE Molcom
      USE Param
!gianluca      USE PhaseModule , only : kverbo

      !
      Use Mappa
c     Use Envelope
      Use MapTest
      USE StrLogModule
      USE PlotsData

      character (len=80)    :: strHead(3),strTitleContour
      character (len=200)   :: strLogMa4,strTemp
      character (len=200)   :: strLog
      character (len=200)   :: strMaps
      character (len=200)   :: strTime
      character (len=200)   :: strBoxTitle


      common/conue/shi(4),ishi,shi1(4)
      common/super4/ncycl4(100),percc4(100),nmaMa4
      character*80 tirang
      logical convRRfree,convRfree,freerstat,freestat

      integer*8            :: FORTHini, BACKini
      real, allocatable  ::xinit(:,:,:)
      real, allocatable  ::xplot(:,:),yplot(:,:),xgrid(:)

      strBoxTitle=
     *    '<big><b>EDM Parameters for the current Cycle:</b></big>'
      convRRfree = .False.
      convRfree = .False.

      IF (.NOT. ALLOCATED(xinit))
     *   ALLOCATE (xinit(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierr)

      xinit(:,:,:)=0.0
      FORTHini = 0
      BACKini = 0 

      call prepeqv

      rf1=1.0
      rf2=1.0
      ! backup starting set 
      pesi(:)=wtd(:)
      ifasi(:)=iphad(:)

      !--check number of reflextion to be extended
      nref_phased=count(wt(1:nrefl) > 0.0)
      nref_nophased=nrefl - nref_phased
      ncycle_ext=nint(nref_nophased/1000.)
      nref_unobs=count(inobs(:) > 0)
      nref_nophased_obs=nref_nophased - nref_unobs

      write(lo,'(//,29h  Nr. of phased reflections: ,i6 )')nref_phased
      write(lo,'(35h  Nr. of reflections to be phased: ,i6)')
     *             nref_nophased
      write(ktml,'(29h  Nr. of phased reflections: ,i6 )')nref_phased
      write(ktml,'(35h  Nr. of reflections to be phased: ,i6)')
     *             nref_nophased

      npuntiPlotT=nmaMa4*sum(ncycl4(1:nmaMa4))
      allocate(xplot(3,npuntiPlotT),yplot(3,npuntiPlotT), stat = ierr)
      allocate(xgrid(nmaMa4),stat=ierr)

c     iy=67543
c     ix=iy

      xplot(:,:)=0.0
      yplot(:,:)=0.0
      xgrid(:)=0.0

      npunti=np(1)*np(2)*np(3)
      npts=nint(npunti*v_p)

      nprima=1

      strLogS=' '
      strLogSp=' '
      strLogMa=' '
      strLogMap=' '
      strLogMi=' '
      strLogMip=' '
      strInfo(:)= ' '
      strInfoC(:)= color_BLUE
      nInfo=0
      rhomax_obs=maxval(rhov(1:nrefl))
     
      ! set valore iniziale per Real-Rfree
      realfree=1.0e6
      if (ifreem == 0) realfree = 0.0
      rfree = 0.0
      if (ifree == 1) then
        rfree = 1.0e6
        free1(1:nrefl) = fovet(1:nrefl) 
      endif

      npuntiPlot=0
      ngridPoint=0
      nmacro=0
      strLogMa4=' '

 200  nmacro=nmacro+1

      if (nmacro > 1) then
       fovet_mod(:)=fovet(:)
      endif

      write(lo,'(//,2x,a10,1x,i2,1h/,i2)')'MACROCYCLE', nmacro,nmaMa4
      write(ktml,'(/,1x,13h MacroCycle: ,i2,1h/,i2,/)')nmacro,nmaMa4

      strLogMap=strLogMa4
      if (nmacro == 1) then
          write(strLogMa,'(13h MacroCycle: ,i2,1h/,i2)') nmacro,nmaMa4
      else
          if (ifree.eq.1) then
          write(strLogMa,1210) nmacro-1,nmaMa4,realfree*100.,Rfree*100.,
     *                        errm12
 1210     format(' MacroCycle: ',i2,1h/,i2,
     *       ' Real-R<sub>free</sub> =',f5.2,'% ',
     *       ' R<sub>free</sub> =',f5.2,'% ',
     *       ' <span lang="Greek">Df</span>=',f5.2)
          else
          write(strLogMa,1220) nmacro-1,nmaMa4,realfree*100.,Rtot*100.,
     *                         errm12
 1220     format(' MacroCycle: ',i2,1h/,i2,
     *       ' Real-R<sub>free</sub> =',f5.2,'% ',
     *       ' R<sub>tot</sub> =',f5.2,'% ',
     *       ' <span lang="Greek">Df</span>=',f5.2)
          endif

          if (knw > 0)  then
            write(strTemp,'(4h CC=,f7.4)')corr
            k1=len_trim(strLogMa4)
            k2=len_trim(strTemp)
            strLogMa4=strLogMa4(1:k1) // strTemp(1:k2)
            k1=len_trim(strLogMa)
            strLogMa=strLogMa(1:k1) // strTemp(1:k2)
          endif
      endif

      nmiMa=ncycl4(nmacro)

      nmicro=0
      Rsir=0.0
      realfreeR2=0.0
      realfreeR4=0.0
      
 300  nmicro=nmicro+1

      Rsir_p=Rsir
c     write(lo,'(2x,a10,1x,i2,1h/,i2)')'MICROCYCLE', nmicro,nmiMa

      if (nmicro==1) then
          write(strLogMi,'(13h MicroCycle: ,i2,1h/,i2)') nmicro,nmiMa
      else
        if (ifree.eq.1) then
          write(strLogMi,1310) nmicro-1,nmiMa,realfree*100.,Rfree*100.,
     *                         errm12
 1310     format(' MicroCycle: ',i2,1h/,i2,
     *     ' Real-R<sub>free</sub> =',f5.2,'% ',
     *     ' R<sub>free</sub> =',f5.2,'% ',
     *     ' <span lang="Greek">Df</span>=',f5.2)
        else
          write(strLogMi,1320) nmicro-1,nmiMa,realfree*100.,Rtot*100.,
     *                         errm12
 1320     format(' MicroCycle: ',i2,1h/,i2,
     *     ' Real-R<sub>free</sub> =',f5.2,'% ',
     *     ' R<sub>tot</sub> =',f5.2,'% ',
     *     ' <span lang="Greek">Df</span>=',f5.2)
        endif

        if (knw > 0)  then
          write(strTemp,'(4h CC=,f7.4)')corr
          k1=len_trim(strLogMi)
          k2=len_trim(strTemp)
          strLogMi=strLogMi(1:k1) // strTemp(1:k2)
        endif
      endif

      call PlotFlexInfo
      

      if (ifree.eq.1) then
          write(strLogMip,'(20x,7hRfree =,f6.3,2h% ,
     *         5h RAT=,f6.3)')rfree*100.,RAT
      else
          write(strLogMip,'(20x,3hRt=,f6.3,2h% ,
     *         5h RAT=,f6.3)')Rtot*100.,RAT
      endif

      if (knw > 0) then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMip)
        k2=len_trim(strTemp)
        strLogMip=strLogMip(1:k1) // strTemp(1:k2)
      endif

 400  continue
      if (ifree > 0) then
         ! selezionare i riflessi per Rfree
         call setfree
         ncf=1
         ncfree=1
         nfree=nfree+1
         call setfreer(ncf,ncfree,nfree)
         do i=1,nrefl
           if (jinc1(i).le.0.0) wt(i)=0.0
         enddo
      endif


      fcoef(:)=wt(:)*fovet_mod(:)

      call MakeMap(fcoef,iphaz,nrefl,0,xmap,FORTH,BACK)
      call zflush
      call DoSingleIteration()
c     call elimHeavy(elimhe,xmap,ier)
      if (elimhe > 0) call flatmap(xmap,xmapDif,-3,0.0) ! con mask dall'atomo pesante


      icycl=nmicro

      rmax=0.5/sqrt(rhomax_obs)
      rnrflc=100 + numres(rmax)
      wangmd=131.0
      wangrd=-2.0
      iwp=int(wangmd/100) + 1
      sw=sum(wt(1:nrefl)**iwp)
      Renve=abs(wangrd)*(rnrflc/sw)**0.33*rmax
      Renve=min(Renve,10.0)
      !
      smax=rhomax_obs*4.0

      
      f000_old=f000
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)

      FORTHenv = 0

      call PreMaskSirProt(0,v_p,xenve,FORTHenv,BACKenv)
      call Map2EnveMask(0,smax,v_p,xenve,FORTHenv,BACKenv)
      if (knw > 0) then
        call PreMaskSirProt(1,v_p,xenveT,FORTHenv,BACKenv)
        call Map2EnveMask(1,smax,v_p,xenveT,FORTHenv,BACKenv)
        call mapcorr(xenve,xenveT,corrE)
      endif
      f000=f000_old

      call zflush
      call DoSingleIteration()


      nInfo=0
      nInfo=nInfo+1
      strInfo(nInfo)='Histogram Matching : YES'
      nInfo=nInfo+1
      write(strInfo(nInfo),'(11hWang Radius,8x,1h:,f6.2)') Renve
      write(lo,'(/,2x,11hWang Radius,8x,1h:,f6.2)') Renve
      write(ktml,'(7x,11hWang Radius,1x,1h=,f6.2)') Renve

      if (ifconv == 0.or.ifconv == 3) then
        nInfo=nInfo+1
        strInfo(nInfo)='Convergence Criteria : ' //
     *                  '<span lang="Greek">Df</span>'

        nInfo=nInfo+1
        strInfo(nInfo)='On the Graphic :'
        nInfo=nInfo+1
        strInfoC(nInfo)= color_LIGHTRED
        strInfo(nInfo)='                               : ' //
     *   ' <span lang="Greek">Df</span>'
        nInfo=nInfo+1
        strInfoC(nInfo)= color_GREEN
        if (ifree > 0) then
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>free</sub>'
        else
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>tot</sub>'
        endif
        if (ifreem == 1) then
          nInfo=nInfo+1
          strInfoC(nInfo)= color_BLUE
          strInfo(nInfo)='                               : ' //
     *     ' Real-R<sub>free</sub>'
        endif
      elseif(ifconv == 1) then
        nInfo=nInfo+1
        strInfo(nInfo)='Convergence Criteria : Real-R<sub>free</sub>'
        nInfo=nInfo+1
        strInfo(nInfo)='On the Graphic :'
        nInfo=nInfo+1
        strInfoC(nInfo)= color_LIGHTRED
        strInfo(nInfo)='                               : ' //
     *   ' Real-R<sub>free</sub>'
        nInfo=nInfo+1
        strInfoC(nInfo)= color_GREEN
        strInfo(nInfo)='                               : ' //
     *   ' <span lang="Greek">Df</span>'
        nInfo=nInfo+1
        strInfoC(nInfo)= color_BLUE
        if (ifree > 0) then
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>free</sub>'
        else
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>tot</sub>'
       endif
      elseif(ifconv == 2) then
        strInfo(nInfo)='Convergence Criteria : R<sub>free</sub>'
        nInfo=nInfo+1
        strInfo(nInfo)='On the Graphic :'
        nInfo=nInfo+1
        strInfoC(nInfo)= color_LIGHTRED
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>free</sub>'

        nInfo=nInfo+1
        strInfoC(nInfo)= color_GREEN
        strInfo(nInfo)='                               : ' //
     *   ' <span lang="Greek">Df</span>'
        if (ifreem == 1) then
          nInfo=nInfo+1
          strInfoC(nInfo)= color_BLUE
          strInfo(nInfo)='                               : ' //
     *     ' Real-R<sub>free</sub>'
        endif

      endif

      call PlotCurrentCycleInfo(nInfo,strBoxTitle)


      if (knw > 0) then
        strMaps='Mappa oss.'
        call rhostats(xmap,xenve,strMaps)
      endif

      if (ifreem > 0) then
        ! calc rR-free from free-mask (spheres)
        ! put spheres
        call zflush
        call DoSingleIteration()
        call getfreemask(xenve,xinit,np(1),np(2),np(3))
        call zflush
        call DoSingleIteration()
        ! calc. rRfree
        convRRfree=freerstat(xmap,xinit,xenve,rmax,realfree)
        call zflush
        call DoSingleIteration()
      endif
      select case (ifconv)
      case (0)
        !senza convergenza, si controlla solo dPHI
        if (nmicro > 2.and.errm12 < 2.0) goto 250
      case (1)
        !
        if (convRRfree) goto 250  ! raggiunto la convergenza
        if (nmicro > 2.and.(errm12 < 2.0.or.nmicro > 10)) goto 250 ! quando Real-Rfree non ha funzionato(!)
      case (2)
        ! con Rfree 
        if (convRfree) goto 250  ! raggiunto la convergenza
      case (3)
        ! "convergenza" con dPHi con ciclo precedente
        if (nmicro > 2.and.errm12 < 2.0) goto 250
      end select

      call flatmap(xmap,xenve,iflat,Xflip)
      call zflush
      call DoSingleIteration()
      if (nmacro==1) then
       if (ihism > 0) call HM_Flex(xmap,xenve)
       if (kverbo==4) then
         strMaps='Mappa oss. + DM'
         call rhostats(xmap,xenve,strMaps)
        endif
      endif
      call zflush
      call DoSingleIteration()

      if (jgamma==1.and.icomb==1.and.nmacro==1) then
       ! calc Fper(coef.random), Foper (coef.oss + Fper)
       ! backup pesi e fasi obs (serve in CalcGamma)
       iphi2_in(:)=iphaz(:)
       wtt_in(:)=wt(:)
       call ObsPerturbation
       ! mappa perturbata
       call MakeMap(foper,iphoper,nrefl,0,xinit,
     *                  FORTHini,BACKini)
c      call elimHeavy(elimhe,xinit,ier)
       if (kverbo==4) then
        strMaps='Mappa (obs+per.)'
        call rhostats(xinit,xenve,strMaps)
       endif
       ! modifica la mappa perturbata
       call flatmap(xinit,xenve,iflat,Xflip)
       if (ihism > 0) call HM_Flex(xinit,xenve)
       ! inv. la mappa pertub
       if (kverbo==4) then
        strMaps='Mappa (obs+per.)'
        call rhostats(xinit,xenve,strMaps)
       endif
c      write(lo,*)'inv. pert. map'
       call zflush
       call DoSingleIteration()
       call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACKini)
c      ! F ,PHi after the inv. of perturb map
       iphoper(:)=iphaz(:)
       foper(:)=fcvet(:)
      endif

      ! inv. la mappa corrente
      if (nmacro==1) then
        call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACK)
      else
        npts1=npts*percc4(nmacro)
        call denhist(1,xmap,xenve,npts1,0)
        call ChangeAndInvMap(xmap,xenve,1,0.0,0,ier)
      endif
     
      if (jgamma==1.and.icomb==1.and.nmacro==1) then
       ! applic. y-correction over fcvet, iphaz
        call CalcGamma(.false.)  
      endif

      if (ifree.eq.1) then
        do i=1, nrefl
         if (jinc1(i).lt.0) free2(i)=fcvet(i)
        enddo
      endif

      call zflush
      call DoSingleIteration()

      if (jsigmaa <=  3) then
       select case (ifExtra)
       case (-1)
          nreflSIGMAA1=nrefl-nrefExt
          nreflSIGMAA2=nrefl
       case (0)
          nreflSIGMAA1=nrefl
          nreflSIGMAA2=nrefl
       case (1)
          nreflSIGMAA1=nrefl
          nreflSIGMAA2=nreflTot
       end select 

       jPrintStat = 0
       if (knw > 0) jPrintStat = 1
       call sigmaA(jsigmaa,fovet_mod,sigmav,fovet_mod,mkang,rhov,epsv,
     *  fcvet,ipub,iphaz,wt,iphad,wtd,
     *  wvar,pesmod,Dluz,e1,e2,
     *  nreflDim,nreflSIGMAA1,nreflSIGMAA2,
     *  icomb,rf1,rf2,jPrintStat)

        !
        call calcFOMs(0)
      endif

      if (ifextref > 0.and. nmicro <=nmiMa) then
        nmiMaExt = 5
        if (ifconv ==  0) nmiMaExt = nmiMa
        call ExtendReflections(nmicro,nmiMaExt,ifextref)
      endif

      if (knw > 0) then
       call esamin(khl,mkang,ipub,iphaz,
     *        nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)
c      call statres
      endif
      

      nrefPhased=count(wt(1:nrefl) > 0.0)
      pnoPhased=100.*(nrefl-nrefPhased)/float(nrefl)
      ! backup phases and weights corrent cycle
      wtt_o(:)=wt(:)
      iphi2_o(:)=iphaz(:)

      smax=rhomax_obs*4.0
      if (ifree.eq.1) convRfree = freestat(smax,rfree)

      if (knw > 0) then
        fcoef(:)=fovet(:)*wt(:)
        call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
        call mapcorr(xmap,xmapT,corr)
        call mapcorr(xmap,xmodel,corrM)
      endif
      call zflush
      call DoSingleIteration()

      nref1=count(wt(1:nrefl) >0.0)
      if (Rsir_p > 0.0) then
         perRsir=(Rsir-Rsir_p)/Rsir_p
         perRsir=perRsir*100.0
      else
         perRsir=100.0
      endif

      perRsir=min(100.,perRsir)
      perRsir=max(0.0,perRsir)
      
      if (knw > 0) then
        write(lo,3000)nmacro,nmicro,nref1,corr,corrM,corrE,errm1,errmw1,
     *                Rtot,rfree,realfree,errm12
      endif
        
c3000 format(2i3,1x,4hFOMs,1x,i6,15(1x,f8.3))
 3000 format(2i3,1x,4hFOMs,1x,i6,12(1x,f8.3))
 3100 format(2x,'Cycle:',i4,' (',i4,')',1x,i6,4(2x,f8.3))

      if (ifree.eq.1) then
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    8h Rfree =,f6.3,9h R-Rfree=,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,
     *    rfree,realfree,errm12
      else
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    4h Rt=,f6.3,9h R-Rfree=,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,
     *    Rtot,realfree,errm12
      endif
      if (knw > 0)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLog)
        k2=len_trim(strTemp)
        strLog=strLog(1:k1) // strTemp(1:k2)
      endif
      write(ktml,'(1x,a)')trim(strLog)
**    call flush(ktml)
      if (knw == 0) then
         nref1=count(wt(1:nrefl) > 0.0) 
         write(strTemp,'(6h Nref=,i6)')nref1
         k1=len_trim(strLog)
         k2=len_trim(strTemp)
         strLog=strLog(1:k1) // strTemp(1:k2)
         write(lo,'(/,a)')trim(strLog)
         write(lo,'(/,20h ===================,/)')
      endif

      nprima=0
      call toflush()

      ! plot Graphs

      npuntiPlot=npuntiPlot+1
      xplot(1,npuntiPlot)=float(npuntiPlot)
      nrGrafici = 2
      select case (ifconv)
      case (0)
       yplot(1,npuntiPlot)=errm12
       yplot(2,npuntiPlot)=Rtot*100.
       if (ifree == 1) yplot(2,npuntiPlot)=rfree*100.
       if (ifreem == 1) then
           nrGrafici = nrGrafici + 1
           yplot(3,npuntiPlot)=realfree*100.   
       endif
      case (3)
       yplot(1,npuntiPlot)=errm12
       yplot(2,npuntiPlot)=Rtot*100.
       if (ifree == 1) yplot(2,npuntiPlot)=rfree*100.
       if (ifreem == 1) then
           nrGrafici = nrGrafici + 1
           yplot(3,npuntiPlot)=realfree*100.   
       endif
      case (1)
       yplot(1,npuntiPlot)=realfree*100.
       yplot(2,npuntiPlot)=errm12
       yplot(3,npuntiPlot)=Rtot*100.
       if (ifree == 1) yplot(3,npuntiPlot)=rfree*100.
       nrGrafici = 3
      case (2)
       yplot(1,npuntiPlot)=rfree*100      
       yplot(2,npuntiPlot)=errm12
       if (ifreem == 1) then
           nrGrafici = nrGrafici + 1
           yplot(3,npuntiPlot)=realfree*100.   
       endif
      end select      

      if (nmicro==nmiMa) then
        ngridPoint=ngridPoint+1
        xgrid(ngridPoint)=npuntiPlot
      endif


      call PlotFlexCycle(xplot,yplot,3,npuntiPlot,nrGrafici,
     *                   xgrid,ngridPoint,0)


      if (nmicro.lt.nmiMa) goto 300

 250  continue

      if (nmacro.lt.nmaMa4) then
        ! quando ci sono piu' di 1 macrociclo
        iflat=1       ! uso di mask 100/50
        ifextref = 6  ! estendere in funzione di Epp (E2)
        ifconv=0      ! senza un criterio per fermare la procedura
c       ifreem=0      ! senza calcolare Rfree
c       realfree=0.0
        ! scelta riflessi per il MacroCiclo successivo (riflessi iniziali)
        do i=1,nrefl
         if (wtd(i) > 0.0) then
         else
          wt(i)=0.0
         endif
        enddo
        goto 200
      endif

      if (ifree==1)then
        write(strLogSp,'(20x,7hRfree =,f6.3,
     *        5h RAT=,f6.3)')rfree,RAT
      else
        write(strLogSp,'(20x,3hRt=,f6.3,
     *        5h RAT=,f6.3)')Rtot,RAT
      endif


      if (knw > 0)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogSp)
        k2=len_trim(strTemp)
        strLogSp=strLogSp(1:k1) // strTemp(1:k2)
      endif


      deallocate(xplot,yplot,xgrid, stat = ierr)
      deallocate(xinit, stat = ierr)

      return
      end
*----------------------------------------------------------------------
      subroutine super_one(jenve,nfree,nSuperCyc,nsuMax)

c     USE Mappa
c     USE Riflessi
c     USE PlotsData

      USE General
      USE Riflessi
      USE PlotsData
      Use Mappa
c     Use Envelope
      Use MapTest
      Use Grafici
      USE Molcom
      USE PhaseModule
      USE StrLogModule
      USE Param
      USE CowMod, only: ncol, ndim1, ndim2


      character (len=80)    :: strHead(3),strTitleContour
      character (len=200)   :: strLogMa1,strTemp
      character (len=200)   :: strLog,strBoxTitle

      common/conue/shi(4),ishi,shi1(4)
      common/super1/nmaMa1,iexte,fdri(3,100),percref(100),percc1(100),
     *              ncycl1(100)
      common/twomap/bwil,icoeff
      common/koti/irefcold,jrelSKold
      common/omitmap/iomit,iy,nxomit(3,3)
*     common/dada/ncol,ndim1,ndim2
      common/spheremap/sphere
c     common/SuperCycleTotal/nSuperCycT,nsuMaxT
      character*80 tirang

      logical convRRfree,convRfree,freerstat,freestat   ! gianluca 12/10/07
      
      real, allocatable   ::xplot(:,:),yplot(:,:),xgrid(:)

      strBoxTitle=
     *    '<big><b>EDM Parameters for the current Cycle:</b></big>'

      !--check number of reflextion to be extended
      nref_phased=count(wt(1:nrefl) > 0.0)
      nref_nophased=nrefl - nref_phased
      ncycle_ext=nint(nref_nophased/1500.)
      nref_unobs=count(inobs(:) > 0)
      nref_nophased_obs=nref_nophased - nref_unobs

      if (nref_nophased_obs > 0 )then
        ncycle_ext=max(ncycle_ext,5)
        ncycle_ext=min(ncycle_ext,10)
      else
        ncycle_ext=5
      endif
      ncycl1(1)=ncycle_ext
      pr=1.0/float(ncycl1(1)-1)
      percref(1)=pr
      percref(ncycl1(1))=1.0
      do i=2,ncycl1(1)-1
         percref(i)=percref(i-1)+pr
      enddo

      !---end

**    call flush(ktml)

      npuntiPlotT=nmaMa1*sum(ncycl1(1:nmaMa1))
      allocate(xplot(3,npuntiPlotT),yplot(3,npuntiPlotT), stat = ierr)
      allocate(xgrid(nmaMa1),stat=ierr)

      xplot(:,:)=0.0
      yplot(:,:)=0.0
      xgrid(:)=0.0

      npunti=np(1)*np(2)*np(3)
      corrSolv=0.5+(1.0-v_p)
      corrSolv=min(1.0,corrSolv)
      npts=nint(npunti*v_p)

      rfree = 0.0
      if (ifree == 1) then
        rfree = 1.0e6
        free1(1:nrefl) = fovet(1:nrefl) 
      endif

      nprima=1

      strLogS=' '
      strLogSp=' '
      strLogMa=' '
      strLogMap=' '
      strLogMi=' '
      strLogMip=' '
      strInfo(:)= ' '
      strInfoC(:)= color_BLUE

c     nSuperCyc=nSuperCyc+1
c     nSuperCycT=nSuperCycT+1

      write(lo,'(/,2x,a10,1x,i2,1h/,i2,/)')'SUPERCYCLE',nSuperCyc,nsuMax

      write(lo,'(29h  Nr. of phased reflections: ,i5 )')nref_phased
      write(lo,'(35h  Nr. of reflections to be phased: ,i5,
     *           5h (in ,i3,8h cycles),/)')
     *           nref_nophased,ncycle_ext

      write(ktml,'(1x,13h SuperCycle: ,i2,1h/,i2)')nSuperCyc,nsuMax
      write(ktml,'(29h  Nr. of phased reflections: ,i5 )')nref_phased
      write(ktml,'(35h  Nr. of reflections to be phased: ,i5,
     *           5h (in ,i3,8h cycles),/)')
     *           nref_nophased,ncycle_ext


      write(strLogS,'(13h SuperCycle: ,i2,1h/,i2)')nSuperCyc,nsuMax

      npuntiPlot=0
      ngridPoint=0
      nmacro=0
      strLogMa1=' '
 200  nmacro=nmacro+1
      write(lo,'(2x,a10,1x,i2,1h/,i2)')'MACROCYCLE', nmacro,nmaMa1
      write(ktml,'(/,1x,13h MacroCycle: ,i2,1h/,i2)')nmacro,nmaMa1

      strLogMap=strLogMa1
      if (nmacro == 1) then
          write(strLogMa,'(13h MacroCycle: ,i2,1h/,i2)') nmacro,nmaMa1
      else
          if (ifree.eq.1) then
          write(strLogMa,1210) nmacro-1,nmaMa1,Rfree,errm12
 1210     format(' MacroCycle: ',i2,1h/,i2,
     *       ' R<sub>free</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
          else
          write(strLogMa,1220) nmacro-1,nmaMa1,Rtot,errm12
 1220     format(' MacroCycle: ',i2,1h/,i2,
     *       ' R<sub>tot</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
          endif
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMa1)
        k2=len_trim(strTemp)
        strLogMa1=strLogMa1(1:k1) // strTemp(1:k2)
        k1=len_trim(strLogMa)
        strLogMa=strLogMa(1:k1) // strTemp(1:k2)
      endif

      nmiMa=ncycl1(nmacro)

      nmicro=0
      RATp=0.0
      Rsir=0.0
      realfreeR2=0.0
      realfreeR4=0.0
 300  nmicro=nmicro+1
      Rsir_p=Rsir
      icycl=nmicro
      write(lo,'(2x,a10,1x,i2,1h/,i2)')'MICROCYCLE', nmicro,nmiMa

      if (nmicro==1) then
          write(strLogMi,'(13h MicroCycle: ,i2,1h/,i2)') nmicro,nmiMa
      else
        if (ifree.eq.1) then
          write(strLogMi,1310) nmicro-1,nmiMa,Rfree,errm12
 1310     format(' MicroCycle: ',i2,1h/,i2,
     *     ' R<sub>free</sub> =',f5.2,
     *     ' <span lang="Greek">Df</span>=',f5.2)
        else
          write(strLogMi,1310) nmicro-1,nmiMa,Rtot,errm12
 1320     format(' MicroCycle: ',i2,1h/,i2,
     *     ' R<sub>tot</sub> =',f5.2,
     *     ' <span lang="Greek">Df</span>=',f5.2)
        endif
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMi)
        k2=len_trim(strTemp)
        strLogMi=strLogMi(1:k1) // strTemp(1:k2)
      endif

      call PlotFlexInfo
      
      nInfo=1
      strInfo(nInfo)='Histogram Matching : NO'
      nInfo=nInfo+1
      strInfo(nInfo)='Envelope Mask      : NO'
      nInfo=nInfo+1
      if (iexte.ge.1) then
        strInfo(nInfo)='Extend Reflections : YES'
      else
        strInfo(nInfo)='Extend Reflections : FINISHED'
      endif

      nInfo=nInfo+1
      write(strInfo(nInfo),'(38hPercentage of Protein for Inversion : ,
     *                   f6.2)') percc1(nmacro)*100.0

      if (nmicro==1) then
        write(ktml,*)
        write(lo,*)
        do jg=1,nInfo
         write(ktml,'(4x,a)')trim(strInfo(jg))
         write(lo,'(4x,a)')trim(strInfo(jg))
        enddo
        write(ktml,*)
        write(lo,*)
      endif

      nInfo=nInfo+1
      strInfo(nInfo)='Convergence Criteria : fix number of Cycles'

      nInfo=nInfo+1
      strInfo(nInfo)='On the Graphic :'
      nInfo=nInfo+1
      strInfoC(nInfo)= color_LIGHTRED
      if (ifree > 0) then
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>free</sub>'
      else
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>tot</sub>'
      endif
      nInfo=nInfo+1
      strInfoC(nInfo)= color_GREEN
      strInfo(nInfo)='                               : ' //
     *   ' <span lang="Greek">Df</span>'


c     if (nmicro==1) then
      call PlotCurrentCycleInfo(nInfo,strBoxTitle)
c     endif

      if (ifree.eq.1) then
         call setfree
         ncf=1
         ncfree=1
         nfree=nfree+1
         call setfreer(ncf,ncfree,nfree)
         do i=1,nrefl
           if (jinc1(i).le.0) wt(i)=0.0
         enddo
         if (nprima.eq.1) then
           fcoef(:)=fovet(:)*wt(:)
           call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                     FORTH,BACK)
         endif

      endif


      if (nprima.eq.0) then
        fcoef(:)=fovet(:)*wt(:)
        call MakeMap(fcoef,iphaz,nreflTot,0,xmap,
     *                   FORTH,BACK)
      endif

      call elimHeavy(elimhe,xmap,ier)
      npts1=npts*percc1(nmacro)
      if (jenve==1) then
       smax=rhomax*4.0
       call envelopeMask(0,smax,v_p,xenve)
       call flatmap(xmap,xenve,1,Xflip)
      endif

c     if (iexte.ge.1.and.ihism.eq.1) call HM_Flex(x,x1)
c     if (ihism==1) call HM_Flex(x,x1)

      call denhist(jenve,xmap,xenve,npts1,0)
      call ChangeAndInvMap(xmap,xenve,1,0.0,0,ier)

      call afterinv
      if (iexte.ge.1) call exteref(nmicro)
      emme1=1.0
      emme2=1.0
      if (iexte.eq.0) call prepmerge(nmacro,nmicro,emme1,emme2)
      call mergephase(emme1,emme2)

      if (ifree.eq.1) then
        do i=1, nrefl
         if (jinc1(i).lt.0) free2(i)=fcvet(i)
        enddo
        smax=rhomax*4.0
        convRfree = freestat(smax,rfree)
      endif

      if (knw.eq.1) then
         fcoef(:)=fovet(:)*wt(:)
         call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
         call mapcorr0(xmap,xmapT,0,corr,ier)
         call mapcorr0(xmap,xmodel,0,corrM,ier)
      endif
      nref1=count(wt(1:nrefl) >0.0)


      if (Rsir_p > 0.0) then
         perRsir=(Rsir-Rsir_p)/Rsir_p
         perRsir=perRsir*100.0
      else
         perRsir=100.0
      endif
      corrE=0.0

      if (knw > 0) then
        write(lo,3000)nSuperCyc,nmacro,nmicro,nref1,corr,corrM,corrE,
     *                errm1,errmw1,
     *                Rtot,rfree,RAT,Rsir,perRsir,errm12
      endif

 3000 format(3i3,1x,4hFOMs,1x,i6,15(1x,f8.3))


      if (ifree.eq.1) then
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    8h Rfree =,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,rfree,errm12
         write(lo,'("  END Cycle: ",
     *    8h Rfree =,f6.3,6h dphi=,f6.3,/)')rfree,errm12
      else
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    4h Rt=,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,Rtot,errm12
         write(lo,'("  END Cycle: ",
     *    8h Rtot =,f6.3,6h dphi=,f6.3,/)')Rtot,errm12
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLog)
        k2=len_trim(strTemp)
        strLog=strLog(1:k1) // strTemp(1:k2)
      endif
      write(ktml,'(1x,a)')trim(strLog)

      nprima=0
      call toflush()


      ! plot Graphs
      npuntiPlot=npuntiPlot+1
      xplot(1,npuntiPlot)=float(npuntiPlot)

      if (ifree.eq.1) then
       yplot(1,npuntiPlot)=rfree*100.
      else
       yplot(1,npuntiPlot)=Rtot*100.
      endif
      if (nmicro==nmiMa) then
        ngridPoint=ngridPoint+1
        xgrid(ngridPoint)=npuntiPlot
      endif

      yplot(2,npuntiPlot)=errm12

      call PlotFlexCycle(xplot,yplot,3,npuntiPlot,2,
     *                   xgrid,ngridPoint,0)

      !-----------
c     if (iexte==0) then
c      if (nmicro.lt.nmiMa.and.RAT < RATp) goto 300
c     else 
       if (nmicro.lt.nmiMa) goto 300
c     endif
      RATp=RAT

      if (nmacro.eq.1) then
        ! new starting set after the first macrocycle
        iexte=0
        wtt_in(1:nrefl)=wt(1:nrefl)
        iphi2_in(1:nrefl)=iphaz(1:nrefl)
      endif

      if (nmacro.lt.nmaMa1) goto 200

 1000 format(/,1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,6hNREF =,i6,
     *  1x,4hCC =,1x,f7.4,3h ( ,f7.4,2h ),
     *  1x,7hERRco =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,8hERRinv =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,5hDPH =,1x,f5.2,1x,'Rt =',f5.2,' Rfree =',f5.2,' RAT=',f5.2)

 2000 format(1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,
     *       1x,4hCC =,f7.4,1x,5hERR =,f6.2)



c     call ShiftToDerivative(-1,1)


      if (ifree==1)then
      write(strLogSp,'(20x,7hRfree =,f6.3,
     *      5h RAT=,f6.3)')rfree,RAT
      else
      write(strLogSp,'(20x,3hRt=,f6.3,
     *      5h RAT=,f6.3)')Rtot,RAT
      endif


      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogSp)
        k2=len_trim(strTemp)
        strLogSp=strLogSp(1:k1) // strTemp(1:k2)
      endif


      ngridPointEnd=ngridPointEnd+1
      xgridEnd(ngridPointEnd)=npuntiPlotEnd
        ! new starting set after the first supercyle
c       sumwt=sum(wt(1:nrefl))
c       numwt=count(wt(1:nrefl)>0.0)
c       wtmed=sumwt/float(numwt)
c       scalewt=0.6/wtmed
c       wtt_in(1:nrefl)=wt(1:nrefl)*scalewt
c       wtt_in(1:nrefl)=min(wt(1:nrefl),1.0)
c       sumwt=sum(wtt_in(1:nrefl))
c       numwt=count(wtt_in(1:nrefl)>0.0)
c       wtmed=sumwt/float(numwt)
c       iphi2_in(1:nrefl)=iphaz(1:nrefl)

c       do i=1, nrefl
c         if (wtd(i) > 0.0) then
c           wtt_in(i)=wt(i)
c           iphi2_in(i)=iphaz(i)
c           wtd(i)=wt(i)
c           iphad(i)=iphaz(i)
c         else
c           wt(i)=0.0
c           wtt_in(i)=0.0
c         endif
c       enddo

      deallocate(xplot,yplot,xgrid, stat = ierr)

      return
      end
!----------------------------------------
      subroutine super_two(nfree,nSuperCyc,nsuMax,Rmin)

      USE General
      USE Mappa
c     Use Envelope
      Use MapTest

      USE Riflessi
      USE PlotsData
      USE PhaseModule
      USE StrLogModule
      Use Grafici
      USE Molcom
      USE Param
      USE CowMod, only: ncol, ndim1, ndim2

      character (len=200)  :: strLogMa1,strLogSp1,strTemp
      character (len=80)   :: strHead(3),strTitleContour
      character (len=200)  :: strLog,strBoxTitle

      common/conue/shi(4),ishi,shi1(4)
      common/twomap/bwil,icoeff
      common/super2/ncycl(100),percc(100),nmaMa
      common/omitmap/iomit,iy,nxomit(3,3)
*     common/dada/ncol,ndim1,ndim2
      common/koti/irefcold,jrelSKold
c     common/SuperCycleTotal/nSuperCycT,nsuMaxT
      character*80 tirang

      logical convRRfree,convRfree,freerstat,freestat   ! gianluca 12/10/07

      real, allocatable   ::xplot(:,:),yplot(:,:),xgrid(:)


      strBoxTitle=
     *    '<big><b>EDM Parameters for the current Cycle:</b></big>'
      npunti=np(1)*np(2)*np(3)
      corrSolv=0.5+(1.0-v_p)
      corrSolv=min(1.0,corrSolv)
      npts=nint(npunti*v_p*corrSolv)


      npuntiPlotT=nmaMa*sum(ncycl(1:nmaMa))
      allocate(xplot(3,npuntiPlotT),yplot(3,npuntiPlotT), stat = ierr)
      allocate(xgrid(nmaMa),stat=ierr)
      xplot(:,:)=0.0
      yplot(:,:)=0.0
      xgrid(:)=0.0

      strInfo(:)= ' '
      strInfoC(:)= color_BLUE


      strLogMa=' '
      strLogMap=' '
      strLogMi=' '
      strLogMip=' '

      write(lo,'(/,2x,a10,1x,i2,1h/,i2)')'SUPERCYCLE',nSuperCyc,nsuMax
      write(ktml,'(/,1x,13h SuperCycle: ,i2,1h/,i2)')nSuperCyc,nsuMax

CCCC  if (knw.eq.1) call truenve(v_p)  ! True envelope

      if (ifree.eq.1) then
        write(strLogS,1110) nSuperCyc,nsuMax,Rfree,errm12
 1110  format(' SuperCycle: ',i2,1h/,i2,
     *       ' R<sub>free</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
      else
        write(strLogS,1120) nSuperCyc,nsuMax,Rtot,errm12
 1120     format(' SuperCycle: ',i2,1h/,i2,
     *       ' R<sub>tot</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogS)
        k2=len_trim(strTemp)
        strLogS=strLogS(1:k1) // strTemp(1:k2)
      endif



      strLogSp1=strLogSp
      strLogSp=' ' 


      nprima=1

      npuntiPlot=0
      ngridPoint=0

      nmacro=0
      strLogMa1=' '
 200  nmacro=nmacro+1
      write(lo,'(2x,a10,1x,i2,1h/,i2)')'MACROCYCLE', nmacro,nmaMa
      write(ktml,'(/,1x,13h MacroCycle: ,i2,1h/,i2)')nmacro,nmaMa

      strLogMap=strLogMa1

      if (nmacro == 1) then
          write(strLogMa,'(13h MacroCycle: ,i2,1h/,i2)') nmacro,nmaMa
      else
          if (ifree.eq.1) then
          write(strLogMa,1210) nmacro-1,nmaMa,Rfree,errm12
 1210     format(' MacroCycle: ',i2,1h/,i2,
     *       ' R<sub>free</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
          else
          write(strLogMa,1220) nmacro-1,nmaMa,Rtot,errm12
 1220     format(' MacroCycle: ',i2,1h/,i2,
     *       ' R<sub>tot</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
          endif
      endif



      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMa1)
        k2=len_trim(strTemp)
        strLogMa1=strLogMa1(1:k1) // strTemp(1:k2)
        k1=len_trim(strLogMa)
        strLogMa=strLogMa(1:k1) // strTemp(1:k2)
      endif

c---
      nmiMa=ncycl(nmacro)
     
      nmicro=0
      RATp=0.0
 300  nmicro=nmicro+1
      write(lo,'(2x,a10,1x,i2,1h/,i2)')'MICROCYCLE',nmicro,nmiMa

      if (nmicro==1) then
          write(strLogMi,'(13h MicroCycle: ,i2,1h/,i2)') nmicro,nmiMa
      else
        if (ifree.eq.1) then
          write(strLogMi,1310) nmicro-1,nmiMa,Rfree,errm12
 1310     format(' MicroCycle: ',i2,1h/,i2,
     *     ' R<sub>free</sub> =',f5.2,
     *     ' <span lang="Greek">Df</span>=',f5.2)
        else
          write(strLogMi,1310) nmicro-1,nmiMa,Rtot,errm12
 1320     format(' MicroCycle: ',i2,1h/,i2,
     *     ' R<sub>tot</sub> =',f5.2,
     *     ' <span lang="Greek">Df</span>=',f5.2)
        endif
      endif


      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMi)
        k2=len_trim(strTemp)
        strLogMi=strLogMi(1:k1) // strTemp(1:k2)
      endif


      call PlotFlexInfo

      nInfo=1
      if (ihism==0) then
        strInfo(nInfo)='Histogram Matching : NO'
      else
        strInfo(nInfo)='Histogram Matching : YES'
      endif
      nInfo=nInfo+1
      strInfo(nInfo)='Envelope Mask      : YES'
      nInfo=nInfo+1
      write(strInfo(nInfo),'(9x,12hRadius    : ,f6.2)')Renve
      nInfo=nInfo+1
      strInfo(nInfo)='Extend Reflections : FINISHED'

      nInfo=nInfo+1
      write(strInfo(nInfo),'(38hPercentage of Protein for Inversion : ,
     *                   f6.2)') percc(nmacro)*100.0


      if (nmicro==1) then
        write(ktml,*)
        write(lo,*)
        do jg=1,4
         write(ktml,'(4x,a)')trim(strInfo(jg))
         write(lo,'(4x,a)')trim(strInfo(jg))
        enddo
        write(ktml,*)
        write(lo,*)
      endif

      nInfo=nInfo+1
      strInfo(nInfo)='Convergence Criteria : fix number of Cycles'


      nInfo=nInfo+1
      strInfo(nInfo)='On the Graphic :'
      nInfo=nInfo+1
      strInfoC(nInfo)= color_LIGHTRED
      if (ifree > 0) then
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>free</sub>'
      else
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>tot</sub>'
      endif
      nInfo=nInfo+1
      strInfoC(nInfo)= color_GREEN
      strInfo(nInfo)='                               : ' //
     *   ' <span lang="Greek">Df</span>'


     
      call PlotCurrentCycleInfo(nInfo,strBoxTitle)



      if (ifree.eq.1) then
      write(strLogMip,'(20x,7hRfree =,f6.3,
     *     5h RAT=,f6.3)')rfree,RAT
      else
      write(strLogMip,'(20x,3hRt=,f6.3,
     *     5h RAT=,f6.3)')Rtot,RAT
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMip)
        k2=len_trim(strTemp)
        strLogMip=strLogMip(1:k1) // strTemp(1:k2)
      endif


      if (ifree.eq.1) then
        call setfree
        ncf=1
        ncfree=1
        nfree=nfree+1
        call setfreer(ncf,ncfree,nfree)
        do i=1,nrefl
          if (jinc1(i).le.0) wt(i)=0.0
        enddo
      endif

      smax=rhomax*4.0
      call envelopeMask(0,smax,v_p,xenve)

      fcoef(:)=fovet(:)*wt(:)
      call MakeMap(fcoef,iphaz,nreflTot,0,xmap,
     *                   FORTH,BACK)

! -- jrelSKold sempre zero e x non dimensionata gianluca 27/01/2012
*gl*  if (jrelSKold.gt.0) call mergemap(x,jrelSKold)
CCC   call Solvent_Control(jrel,jrelE,solc)
      if (ihism.eq.1) call HM_Flex(xmap,xenve)

      call flatmap(xmap,xenve,iflat,Xflip)
      npts1=npts*percc(nmacro)
      call denhist(1,xmap,xenve,npts1,0)

      call ChangeAndInvMap(xmap,xenve,1,sogrho,1,ier)

      call afterinv

      call weit_rap

      if (knw.gt.0) call esamin(khl,mkang,ipub,iphaz,
     *      nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)

      emme1=1.0
      emme2=1.0

      call prepmerge(nmacro,nmicro,emme1,emme2)

      call mergephase(emme1,emme2)
c     if (knw.gt.0) call statres

      if (ifree.eq.1) then
        do i=1, nrefl
         if (jinc1(i).lt.0) free2(i)=fcvet(i)
        enddo
        smax=rhomax*4.0
        convRfree = freestat(smax,rfree)
      endif

      if (knw.eq.1) then
         fcoef(:)=fovet(:)*wt(:)
         call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
         call mapcorr0(xmap,xmapT,0,corr,ier)
         call mapcorr0(xmap,xmodel,0,corrM,ier)
      endif
      nref1=count(wt(1:nrefl) >0.0)

      if (knw > 0) then
        write(lo,3000)nSuperCyc,nmacro,nmicro,nref1,corr,corrM,corrE,
     *                errm1,errmw1,
     *                Rtot,rfree,RAT,Rsir,perRsir,errm12
      endif

 3000 format(3i3,1x,4hFOMs,1x,i6,15(1x,f8.3))

      if (ifree.eq.1) then
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    8h Rfree =,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,rfree,errm12
         write(lo,'("  END Cycle: ",
     *    8h Rfree =,f6.3,6h dphi=,f6.3,/)')rfree,errm12
      else
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    4h Rt=,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,Rtot,errm12
         write(lo,'("  END Cycle: ",
     *    8h Rtot =,f6.3,6h dphi=,f6.3,/)')Rtot,errm12
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLog)
        k2=len_trim(strTemp)
        strLog=strLog(1:k1) // strTemp(1:k2)
      endif
      write(ktml,'(a)') trim(strLog)
**    call flush(ktml)

      call toflush()
      nprima=0

      ! plot Graphs
      npuntiPlot=npuntiPlot+1
      xplot(1,npuntiPlot)=float(npuntiPlot)

      if (ifree.eq.1) then
       yplot(1,npuntiPlot)=rfree*100.
      else
       yplot(1,npuntiPlot)=Rtot*100.
      endif
      if (nmicro==nmiMa) then
        ngridPoint=ngridPoint+1
        xgrid(ngridPoint)=npuntiPlot
      endif

      yplot(2,npuntiPlot)=errm12

      call PlotFlexCycle(xplot,yplot,3,npuntiPlot,2,
     *                   xgrid,ngridPoint,0)


      if (nmicro < nmiMa) goto 300

      if (nmacro.lt.nmaMa) goto 200

      v_p=v_p+(pv_p*v_p)
      Renve=Renve+stepE
      Renve=max(Renve,Rmin)

 1000 format(/,1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,6hNREF =,i6,
     *  1x,4hCC =,1x,f7.4,3h ( ,f7.4,2h ),
     *  1x,7hERRco =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,8hERRinv =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,5hDPH =,1x,f5.2,1x,'Rt =',f5.2,' Rfree =',f5.2,' RAT=',f5.2)


 2000 format(1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,
     *       1x,4hCC =,f7.4,1x,5hERR =,f6.2)


      deallocate(xplot,yplot,xgrid, stat = ierr)
      return
      end
*----------------------------------------------------------------------*
      subroutine super_three(nfree,nSuperCycT,nsuMaxT,nsuMax,Rmin)

      USE General
      USE Mappa
c     Use Envelope
      Use MapTest

      USE Riflessi
      USE PlotsData
      USE PhaseModule
      USE StrLogModule
      Use Grafici
      USE Molcom
      USE Param
      USE CowMod, only: ncol, ndim1, ndim2


      character (len=80) strHead(3),strTitleContour
      character (len=200) strLogMa1,strLogSp1,strTemp
      character (len=200)   :: strLog,strBoxTitle


      common/conue/shi(4),ishi,shi1(4)
      common/twomap/bwil,icoeff
      common/super3/ncycl(100),percc(100),nmaMa
      common/omitmap/iomit,iy,nxomit(3,3)
*     common/dada/ncol,ndim1,ndim2
      common/koti/irefcold,jrelSKold
c     common/SuperCycleTotal/nSuperCycT,nsuMaxT
      character*80 tirang

      logical convRRfree,convRfree,freerstat,freestat   ! gianluca 12/10/07

      real, allocatable   ::xplot(:,:),yplot(:,:),xgrid(:)


      strBoxTitle=
     *    '<b>EDM Parameters for the current Cycle:</b></big>'
      npunti=np(1)*np(2)*np(3)

      nSuperCyc = 0
      istop=0

 100  nSuperCyc=nSuperCyc+1 !nr. dei supercicli dentro il tipo SUPER3
      if (nSuperCyc.gt.nsuMax) return

      nSuperCycT=nSuperCycT+1

      npuntiPlotT=nmaMa*sum(ncycl(1:nmaMa))

      allocate(xplot(3,npuntiPlotT),yplot(3,npuntiPlotT), stat = ierr)
      allocate(xgrid(nmaMa),stat=ierr)

      corrSolv=0.5+(1.0-v_p)
      corrSolv=min(1.0,corrSolv)
      npts=nint(npunti*v_p*corrSolv)

      xplot(:,:)=0.0
      yplot(:,:)=0.0
      xgrid(:)=0.0
      strInfo(:)= ' '
      strInfoC(:)= color_BLUE

      strLogMa=' '
      strLogMap=' '
      strLogMi=' '
      strLogMip=' '


c     if (knw.eq.1) call truenve(v_p)  ! True envelope



      write(lo,'(/,2x,a10,1x,i2,1h/,i2)')'SUPERCYCLE',nSuperCyc,nsuMax
      write(ktml,'(1x,1x,13h SuperCycle: ,i2,1h/,i2)')
     *                       nSuperCycT,nsuMaxT

      if (ifree.eq.1) then
        write(strLogS,1110) nSuperCycT,nsuMaxT,Rfree,errm12
 1110  format(' SuperCycle: ',i2,1h/,i2,
     *       ' R<sub>free</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
      else
        write(strLogS,1120) nSuperCycT,nsuMaxT,Rtot,errm12
 1120     format(' SuperCycle: ',i2,1h/,i2,
     *       ' R<sub>tot</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
      endif


      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogS)
        k2=len_trim(strTemp)
        strLogS=strLogS(1:k1) // strTemp(1:k2)
      endif


      strLogSp1=strLogSp
      nprima=1

      npuntiPlot=0
      ngridPoint=0

      strLogMa1=' ' 
      nmacro=0
 200  nmacro=nmacro+1
      write(lo,'(2x,a10,1x,i2,1h/,i2)')'MACROCYCLE', nmacro,nmaMa
      write(ktml,'(/,1x,13h MacroCycle: ,i2,1h/,i2)')nmacro,nmaMa

      strLogMap=strLogMa1

      if (ifree.eq.1) then
          write(strLogMa,1210) nmacro,nmaMa,Rfree,errm12
 1210     format(' MacroCycle: ',i2,1h/,i2,
     *       ' R<sub>free</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
      else
          write(strLogMa,1220) nmacro,nmaMa,Rtot,errm12
 1220     format(' MacroCycle: ',i2,1h/,i2,
     *       ' R<sub>tot</sub> =',f5.2,
     *       ' <span lang="Greek">Df</span>=',f5.2)
      endif


      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMa1)
        k2=len_trim(strTemp)
        strLogMa1=strLogMa1(1:k1) // strTemp(1:k2)
        k1=len_trim(strLogMa)
        strLogMa=strLogMa(1:k1) // strTemp(1:k2)
      endif

      nmiMa=ncycl(nmacro)
     
      nmicro=0
      RATp=0.0
 300  nmicro=nmicro+1
      write(lo,'(2x,a10,1x,i2,1h/,i2)')'MICROCYCLE',nmicro,nmiMa

      if (nmicro==1) then
          write(strLogMi,'(13h MicroCycle: ,i2,1h/,i2)') nmicro,nmiMa
      else
        if (ifree.eq.1) then
          write(strLogMi,1310) nmicro-1,nmiMa,Rfree,errm12
 1310     format(' MicroCycle: ',i2,1h/,i2,
     *     ' R<sub>free</sub> =',f5.2,
     *     ' <span lang="Greek">Df</span>=',f5.2)
        else
          write(strLogMi,1310) nmicro-1,nmiMa,Rtot,errm12
 1320     format(' MicroCycle: ',i2,1h/,i2,
     *     ' R<sub>tot</sub> =',f5.2,
     *     ' <span lang="Greek">Df</span>=',f5.2)
        endif
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMi)
        k2=len_trim(strTemp)
        strLogMi=strLogMi(1:k1) // strTemp(1:k2)
      endif


      call PlotFlexInfo

      nInfo=1
      if (ihism==0) then
        strInfo(nInfo)='Histogram Matching : NO'
      else
        strInfo(nInfo)='Histogram Matching : YES'
      endif
      nInfo=nInfo+1
      strInfo(nInfo)='Envelope Mask      : YES'
      nInfo=nInfo+1
      write(strInfo(nInfo),'(9x,12hRadius    : ,f6.2)')Renve
      nInfo=nInfo+1
      strInfo(nInfo)='Extend Reflections : FINISHED'

      nInfo=nInfo+1
      write(strInfo(nInfo),'(38hPercentage of Protein for Inversion : ,
     *                   f6.2)') percc(nmacro)*100.0

      if (nmicro==1) then
        write(ktml,*)
        write(lo,*)
        do jg=1,4
         write(ktml,'(4x,a)')trim(strInfo(jg))
         write(lo,'(4x,a)')trim(strInfo(jg))
        enddo
        write(ktml,*)
        write(lo,*)
      endif

      nInfo=nInfo+1
      strInfo(nInfo)='Convergence Criteria : fix number of Cycles'


      nInfo=nInfo+1
      strInfo(nInfo)='On the Graphic :'
      nInfo=nInfo+1
      strInfoC(nInfo)= color_LIGHTRED
      if (ifree > 0) then
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>free</sub>'
      else
        strInfo(nInfo)='                               : ' //
     *           ' R<sub>tot</sub>'
      endif
      nInfo=nInfo+1
      strInfoC(nInfo)= color_GREEN
      strInfo(nInfo)='                               : ' //
     *   ' <span lang="Greek">Df</span>'

      call PlotCurrentCycleInfo(nInfo,strBoxTitle)



      if (ifree.eq.1) then
      write(strLogMip,'(20x,7hRfree =,f6.3,
     *     5h RAT=,f6.3)')rfree,RAT
      else
      write(strLogMip,'(20x,3hRt=,f6.3,
     *     5h RAT=,f6.3)')Rtot,RAT
      endif

      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLogMip)
        k2=len_trim(strTemp)
        strLogMip=strLogMip(1:k1) // strTemp(1:k2)
      endif


      if (ifree.eq.1) then
         call setfree
         ncf=1
         ncfree=1
         nfree=nfree+1
         call setfreer(ncf,ncfree,nfree)
         do i=1,nrefl
           if (jinc1(i).le.0) wt(i)=0.0
         enddo
      endif

      smax=rhomax*4.0
      call envelopeMask(0,smax,v_p,xenve)

      fcoef(:)=fovet(:)*wt(:)
      call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)

      if (jrelSKold.gt.0) call mergemap(xmap,jrelSKold) 
      call elimHeavy(elimhe,xmap,ier)
      if (ihism.eq.1) call HM_Flex(xmap,xenve)

      call flatmap(xmap,xenve,iflat,Xflip)
      npts1=npts*percc(nmacro)
      call denhist(1,xmap,xenve,npts1,0)

      call ChangeAndInvMap(xmap,xenve,1,sogrho,1,ier)
      call afterinv
      call weit_rap
      if (knw.gt.0) call esamin(khl,mkang,ipub,iphaz,
     *      nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)

      emme1=1.0
      emme2=1.0

      call prepmerge(nmacro,nmicro,emme1,emme2)

      call mergephase(emme1,emme2)

c     if (knw.gt.0) call statres

      if (ifree.eq.1) then
        do i=1, nrefl
         if (jinc1(i).lt.0) free2(i)=fcvet(i)
        enddo
        smax=rhomax*4.0
        convRfree = freestat(smax,rfree)
      endif

      if (knw.eq.1) then
         fcoef(:)=fovet(:)*wt(:)
         call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
         call mapcorr0(xmap,xmapT,0,corr,ier)
         call mapcorr0(xmap,xmodel,0,corrM,ier)
      endif
      nref1=count(wt(1:nrefl) >0.0)

      if (knw > 0) then
        write(lo,3000)nSuperCycT,nmacro,nmicro,nref1,corr,corrM,corrE,
     *                errm1,errmw1,
     *                Rtot,rfree,RAT,Rsir,perRsir,errm12
      endif

 3000 format(3i3,1x,4hFOMs,1x,i6,15(1x,f8.3))

      if (ifree.eq.1) then
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    8h Rfree =,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,rfree,errm12
         write(lo,'("  END Cycle: ",
     *    8h Rfree =,f6.3,6h dphi=,f6.3,/)')rfree,errm12
      else
         write(strLog,'(13h      Cycle: ,i2,1h/,i2,
     *    4h Rt=,f6.3,6h dphi=,f6.3)')nmicro,nmiMa,Rtot,errm12
         write(lo,'("  END Cycle: ",
     *    8h Rtot =,f6.3,6h dphi=,f6.3,/)')Rtot,errm12
      endif


      if (knw.eq.1)  then
        write(strTemp,'(4h CC=,f7.4)')corr
        k1=len_trim(strLog)
        k2=len_trim(strTemp)
        strLog=strLog(1:k1) // strTemp(1:k2)
      endif

      write(ktml,'(a)') trim(strLog)

**    call flush(ktml)
      call toflush()
      nprima=0

      ! plot Graphs
      npuntiPlot=npuntiPlot+1
      xplot(1,npuntiPlot)=float(npuntiPlot)

      if (ifree.eq.1) then
       yplot(1,npuntiPlot)=rfree*100.
      else
       yplot(1,npuntiPlot)=Rtot*100.
      endif
      if (nmicro==nmiMa) then
        ngridPoint=ngridPoint+1
        xgrid(ngridPoint)=npuntiPlot
      endif

      yplot(2,npuntiPlot)=errm12

      call PlotFlexCycle(xplot,yplot,3,npuntiPlot,2,
     *                   xgrid,ngridPoint,0)


      if (nSuperCycT.eq.nsuMaxT.and.nmacro.eq.nmaMa.
     *    and.errm12.lt.2.0) goto 4000

      call toflush()

      if (nmicro < nmiMa) goto 300

      if (nmacro.lt.nmaMa) goto 200

      v_p=v_p+(pv_p*v_p)
      Renve=Renve+stepE
      Renve=max(Renve,Rmin)
      if ((Renve-Rmin).lt.stepE) Renve=Rmin

      if (nSuperCyc.lt.nsuMax) goto 100 ! superciclo interno

 4000 continue

 1000 format(/,1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,6hNREF =,i6,
     *  1x,4hCC =,1x,f7.4,3h ( ,f7.4,2h ),
     *  1x,7hERRco =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,8hERRinv =,1x,f6.2,1x,1h(,f6.2,2h ),
     *  1x,5hDPH =,1x,f5.2,1x,'Rt =',f5.2,' Rfree =',f5.2,' RAT=',f5.2)
 2000 format(1x,4hSu =,i2,5h Ma =,i2,5h Mi =,i2,1x,
     *       1x,4hCC =,f7.4,1x,5hERR =,f6.2)


      deallocate(xplot,yplot,xgrid, stat = ierr)

      return
      end

c---------------------------------------------------------------------
      subroutine afterinv

      USE General
      USE Symmetry
      USE Mappa
      USE Riflessi
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)
      common/conue/shi(4),ishi,shi1(4)
      common/twomap/bwil,icoeff
      dimension i1(3)
      real, allocatable :: eobs(:),ecalc(:),Psort(:)

      allocate(eobs(nrefl),ecalc(nrefl),Psort(nrefl),stat=ierr)

      bwil=bt
c     if (ihism.gt.0) bwil=0.0

*---- Scalare de Fc rispetto a Fo ----*
      sumdenor=0.0
      sumfo2=0.0
      sumfp2=0.0
      sumfo=0.0
      sumfp=0.0
      nnobs=0
      
      eobs(:)=0.0
      ecalc(:)=0.0
      Psort(:)=0.0

      do 10 i=1,nrefl
        ii=iorde(i)
        if (wt(ii).le.0.0) goto 10
c       if (rhov(ii).gt.rhomax) goto 10
        if (inobs(ii).eq.1) then
            nnobs=nnobs+1
            goto 10
        endif
        fo=fovet(ii)
c       if (ihism.gt.0) fo=fovet_mod(ii)
        if (icoeff.eq.8) fo=evet(ii)
        fc=fcvet(ii)
        sumfo2=sumfo2 + fo*fo
        sumfp2=sumfp2 + fc*fc
        sumfo=sumfo + abs(fo)
        sumfp=sumfp + abs(fc)
 10   continue
      
      scale2=sqrt(perc*sumfo2/sumfp2)
      scale3=(sumfo/sumfp)
      
      sum1=0.0
      sumfoMAD=0.0
      sumMAD=0.0
      sumfoRid=0.0
      sumRid=0.0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0
      nrefRes=0
      do 15 i=1,nrefl
       ii=iorde(i)
       if (wt(ii).le.0.0) goto 15
c      if (rhov(ii).gt.rhomax) goto 15
       if (inobs(ii).eq.1) goto 15
       fo=abs(fovet(ii))
CC     if (ihism.gt.0) fo=fovet_mod(ii)
       if (icoeff.eq.8) fo=evet(ii)
       fc=abs(fcvet(ii))
       sum1=sum1 + abs( fo-fc*scale3 )
       fc1=fc*scale3

       if (evet(ii).gt.0.5) then
          sumfoRid=sumfoRid+fo
          sumRid=sumRid + abs( fo-fc*scale3 )
       endif
       dres=0.5/sqrt(rhov(ii))
       if (dres.gt.4.0) then
          sumfoMAD=sumfoRid+fo
          sumMAD=sumMAD + abs( fo-fc*scale3 )
          vmedt=vmedt + fo
          vmedc=vmedc + fc1
          vmedtc=vmedtc + fo * fc1
          vmed2t=vmed2t + fo * fo
          vmed2c=vmed2c + fc1 * fc1
          nrefRes=nrefRes+1
       endif

 15   continue

      suma=sum1/sumfo
      sumaRid=sumRid/sumfoRid
      sumaMAD=sumMAD/sumfoMAD



      sum1=sum1/float(nrefl-nnobs)

      vmedt=vmedt/float(nrefRes)
      vmedc=vmedc/float(nrefRes)
      vmedtc=vmedtc/float(nrefRes)
      vmed2t=vmed2t/float(nrefRes)
      vmed2c=vmed2c/float(nrefRes)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corrFoFc=rnum/rden


      do 20 i=1,nrefl
       ii=iorde(i)
       if (wt(ii).le.0.0) goto 20
c      if (rhov(ii).gt.rhomax) goto 20
       fcvet(ii)=fcvet(ii)*scale2
       if (jinc1(i).lt.0) free2(i)=fcvet(i)
       if (inobs(ii).eq.1)fovet(ii)=fcvet(ii)
 20   continue

*---- Calcolo del E' ed E'p ----*
      fact=perc
      if (fact.gt.0.5)  fact=0.5 + (fact-0.5)/2.0
      fact=sqrt(1.0-fact)
      sum1=0.0
      sum2=0.0
      sum3=0.0
      sum4=0.0

      do 30 i=1,nrefl
         ii=iorde(i)
         if (wt(ii).le.0.0) goto 30
         i1(1:3)=khl(1:3,ii)
         eps=epsv(ii)
         rho2=rhov(ii)
         sinth=100.0*sqrt(rho2)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         denor=denor*exp(-2*bwil*rho2)
  310    continue
         denor=sqrt(denor)
         sum1=sum1+evet(ii)
         e1(ii)=fovet(ii)/(denor*fact)
         sum2=sum2+e1(ii)
         e2(ii)=fcvet(ii)/(denor*fact)
         emod(ii)=fcvet(ii)/(denor)
         if (icoeff.eq.8) e2(ii)=fcvet(ii)/fact
         if (inobs(ii).eq.0) then
           eobs(ii)=fovet(ii)/denor
           Psort(ii)=fovet(ii)/denor
           ecalc(ii)=fcvet(ii)/denor
           sum3=sum3+e2(ii)
         else
           sum4=sum4+e2(ii)
           sumdenor=sumdenor+denor
         endif
         dres=0.5/sqrt(rhov(ii))
         wt(ii)=bes(2.0*e2(ii))

c        if (inobs(ii).eq.0) wt(ii)=bes(2.0*e2(ii)*evet(ii))
c        if (inobs(ii).eq.0.and.wtd(ii).le.0.0) 
c    *       wt(ii)=wt(ii)*1.5/evet(ii)
c        if (isuper1.eq.2) wt(ii)=bes(2.0*e2(ii)*dres/4.0)
c        if (jinc1(i).lt.0) wt(i)=0.0

         wt(ii)=min(wt(ii),1.0)
 30    continue
*--------
      sum1=sum1/float(nrefl-nnobs)
      sum2=sum2/float(nrefl-nnobs)
      sum3=sum3/float(nrefl-nnobs)
      if (nnobs.gt.0) sum4=sum4/float(nnobs)
      Rtot=suma

*     calcolo RAT
      call sortall(-1,Psort,nrefl-nnobs)
      nrefRAT=0.70*(nrefl-nnobs)
      sogRAT=Psort(nrefRAT)
      sumRc2=0.0
      sumRo2=0.0
      sumw2=0.0
      sumRo4=0.0
      sumw4=0.0
      sumRo2w2=0.0
      nrefObs=0
      nrefCalc=0
      do i=1,nrefl-nnobs
        if (eobs(i).gt.0.1.and.eobs(i).lt.1.2) then
        sumRo2=sumRo2+eobs(i)**2
        sumw2=sumw2+wt(i)**2
        sumRo4=sumRo4+eobs(i)**4
        sumw4=sumw4+wt(i)**4
        sumRo2w2=sumRo2w2+(eobs(i)**2) * (wt(i)**2)
        nrefObs=nrefObs+1
        endif
        if (ecalc(i).lt.sogRAT) then
         nrefCalc=nrefl+1
         sumRc2=sumRc2+ecalc(i)**2
        endif
      enddo
      vmedRc2=sumRc2/float(nrefCalc)
      vmedRo2=sumRo2/float(nrefObs)
      vmedw2=sumw2/float(nrefObs)
      vmedRo4=sumRo4/float(nrefObs)
      vmedw4=sumw4/float(nrefObs)
      vmedRo2w2=sumRo2w2/float(nrefObs)
      CC1=vmedRo2w2-(vmedRo2*vmedw2)
      CC2= sqrt(vmedRo4-vmedRo2**2) * sqrt(vmedw4-vmedw2**2)
      CC=CC1/CC2
      RAT=CC/vmedRc2
      ! calc. of cfom as for MAD phases
      cfom_FLEX=RAT*corrFoFc/Rtot

c     xmap=0.0
c     call makemap1(khl,fovet,iphaz,wt,nrefl,0,xmap)

c     npunti=np(1)*np(2)*np(3)
c     npts=nint(npunti*v_p)
c     npts1=npunti*0.02
c     call denhist(0,xmap,xmap,npts1,0)
c     FOMrc=sum(xmap,xmap > den_p)
c     npst1=count(xmap > den_p)

c     xmap=0.0
c     call makemap1(khl,fovet,iphaz,wt,nrefl,1,xmap)

c     npunti=np(1)*np(2)*np(3)
c     npts=nint(npunti*v_p)
c     npts1=npunti*0.10
c     call denhist(0,xmap,xmap,npts1,0)
c     dnormFOMrc=sum(xmap,xmap > den_p)
c     npts2=count(xmap > den_p)
c     FOMrc=FOMrc/dnormFOMrc
c     cfom_FLEX=cfom_FLEX*FOMrc
*---------------
      if (kverbo==4) then
        write(lo,*)'  ***************************************'
        write(lo,*)'  *    After Inverse FFT Routine        *'
        write(lo,*)'  ***************************************'
        write(lo,1000) scale2,scale3,sum1,sum2,sum3,sum4,Rtot,
     *                 sumaRid,sumaMAD,corrFoFc,RAT,cfom_FLEX

1000  format(/,'  scale(Fo,Fc) ................',f6.2,2x,f6.2,/
     +        ,'  <E> .........................',f6.2,/ 
     +        ,'  <E1> ........................',f6.2,/ 
     +        ,'  <E1pi> (observed ref.) ......',f6.2,/ 
     +        ,'  <E1pi> (no-observed ref.) ...',f6.2,/
     +        ,'  Rtot ........................',f6.2,/
     +        ,'  Rrid ........................',f6.2,/
     +        ,'  Rlow ........................',f6.2,/
     +        ,'  ccFoFc.......................',f6.2,/
     +        ,'  RAT..........................',f6.2,/
     +        ,'  CFOM.........................',f6.2,/)

      endif

  
      deallocate(eobs,ecalc,Psort,stat=ierr)
      return
      end

c------------------------------------------------------------------
      subroutine mapcorr0(x1,x2,jrelM,correlation,ier)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x1(1:np(1),1:np(2),1:np(3))
      real x2(1:np(1),1:np(2),1:np(3))

      integer, allocatable ::nstore(:)



      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      allocate(nstore(nnx*(nnz+1)), stat= ierr)


      npunti=0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do 50 iy=1,nny
        if (jrelM > 0) then
          call ReadSezione(iy,nnx,nny,nnz,nstore,jrelM)
        endif
        do 30 iz=1,nnz
          do 20 ix=1,nnx
             xx1=x1(ix,iy,iz)
             if (jrelM > 0) then
              indr = nnx * ( iz - 1 ) + ix
              xx2=float(nstore(indr))
             else
              xx2=x2(ix,iy,iz)
             endif
c            xx1=xx1-f000
c            xx2=xx2-f000
             npunti=npunti+1
             vmedt=vmedt + xx1
             vmedc=vmedc + xx2
             vmedtc=vmedtc + xx1 * xx2
             vmed2t=vmed2t + xx1 * xx1
             vmed2c=vmed2c + xx2 * xx2
 20      continue
 30     continue
 50   continue

      vmedt = vmedt/float(npunti)
      vmedc = vmedc/float(npunti)
      vmedtc = vmedtc/float(npunti)
      vmed2t = vmed2t/float(npunti)
      vmed2c = vmed2c/float(npunti)

      rnum = vmedtc - (vmedt*vmedc)
      aa = vmed2t-vmedt**2
      bb = vmed2c-vmedc**2
      if (aa > 0.0.and.bb > 0.0) then
        rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
        correlation = rnum/rden
      else
        correlation = 0.0
      endif

c     write(lo,25)correlation,npunti
 25   format(4x,'CC Map1-Map2:',f7.4,2x,i6)

      deallocate(nstore, stat= ierr)

      return
      end

c------------------------------------------------------------------
      subroutine SkewnessKurtosis(x,ier)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x(1:np(1),1:np(2),1:np(3))
      real kurtosis


      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      denmin=1.0e25
      denmax=-1.0e25

      call maxminSP(0,nnx,nny,nnz,denmin,denmax,avden,stden,x)

      npunti=0
      sum1=0.0
      sum2=0.0

      do 50 iy=1,nny
        do 30 iz=1,nnz
          do 20 ix=1,nnx
             xx=x(ix,iy,iz)
             npunti=npunti+1
             sum1=sum1 + ((xx-avden)/stden)**3
             sum2=sum2 + ((xx-avden)/stden)**4
 20      continue
 30     continue
 50   continue

      skewness=sum1/real(npunti)
      kurtosis=(sum2/real(npunti))  - 3.0

      write(lo,*)'====================='
      write(lo,25)avden/volume,stden/volume,skewness,kurtosis
      write(lo,*)'====================='
 25   format(4x,'avden .........',f6.2,/
     +       4x,'stden .........',f6.2,/
     +       4x,'Skewness ......',f6.2,/
     +       4x,'Kurtosis ......',f6.2)

      return
      end

c------------------------------------------------------------------
      subroutine envcorr(x,jrelM,corre,ier)

      USE General
      USE Mappa
      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x(1:np(1),1:np(2),1:np(3))

      integer, allocatable ::nstore(:)




      if (jrelM.le.0) return
      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      npunti=nnx*nny*nnz

      allocate(nstore(nnx*(nnz+1)), stat= ierr)

      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do 50 nsect=1,nny
        call ReadSezione(nsect,nnx,nny,nnz,nstore,jrelM)
        do 30 kz=1,nnz
           do 20 kx=1,nnx
             xx=x(kx,nsect,kz)
             indr = nnx * ( kz - 1 ) + kx
             xx1=float(nstore(indr))
             if (xx.eq.100.0) then
                xx=1.0
             else
                xx=0.0
             endif
             if (xx1.eq.100.0) then
                xx1=1.0
             else
                xx1=0.0
             endif
             vmedt=vmedt + xx
             vmedc=vmedc + xx1
             vmedtc=vmedtc + xx * xx1
             vmed2t=vmed2t + xx * xx
             vmed2c=vmed2c + xx1 * xx1
 20      continue
 30     continue
 50   continue

      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden

      deallocate(nstore, stat= ierr)


      return
      end
c------------------------------------------------------------------
      subroutine envcorr1(jrelM1,jrelM2,corre,ier)
     
      USE General
      USE Mappa
      common /tran/ scale,mh(3),level,it4,xlim(3)

      integer, allocatable ::nstore(:),nstore1(:)



      if (jrelM1.le.0.or.jrelM2.le.0) return
      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      allocate(nstore(nnx*(nnz+1)),nstore1(nnx*(nnz+1)), stat= ierr)

      npunti=nnx*nny*nnz

      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do 50 nsect=1,nny
        call ReadSezione(nsect,nnx,nny,nnz,nstore,jrelM1)
        call ReadSezione(nsect,nnx,nny,nnz,nstore1,jrelM2)
        do 30 kz=1,nnz
           do 20 kx=1,nnx
             indr = nnx * ( kz - 1 ) + kx
             xx=float(nstore(indr))/100
             xx1=float(nstore1(indr))/100
             vmedt=vmedt + xx
             vmedc=vmedc + xx1
             vmedtc=vmedtc + xx * xx1
             vmed2t=vmed2t + xx * xx
             vmed2c=vmed2c + xx1 * xx1
 20      continue
 30     continue
 50   continue

      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden

      deallocate(nstore,nstore1, stat= ierr)

      return
      end
c------------------------------------------------------------------
      subroutine envcorr2(x1,x2,corre,ier)
     
      USE General
      USE Mappa
      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x1(1:np(1),1:np(2),1:np(3))
      real x2(1:np(1),1:np(2),1:np(3))


      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      npunti=nnx*nny*nnz

      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do 50 ky=1,nny
        do 30 kz=1,nnz
           do 20 kx=1,nnx
             xx1=x1(kx,ky,kz)
             xx2=x2(kx,ky,kz)
             if (xx1.ge.100.0) then
                xx1=1.0
             else
                xx1=0.0
             endif
             if (xx2.ge.100.0) then
                xx2=1.0
             else
                xx2=0.0
             endif

             vmedt=vmedt + xx1
             vmedc=vmedc + xx2
             vmedtc=vmedtc + xx1 * xx2
             vmed2t=vmed2t + xx1 * xx1
             vmed2c=vmed2c + xx2 * xx2
 20      continue
 30     continue
 50   continue

      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden
      return
      end
*------------------------------------------*
      subroutine prepmerge(nmacro,nmicro,f1,f2)

      USE General
      common/super1/nmaMa1,iexte,fdri(3,100),percref(100),percc1(100),
     *              ncycl1(100)


      f1ma=fdri(1,nmacro)
      f1mi=fdri(2,nmacro)
      step=fdri(3,nmacro)

      f2mi=2.0-f1ma
      f2ma=2.0-f1mi

      f1=f1ma-(nmicro-1)*step
      f2=f2mi+(nmicro-1)*step
      f1=amax1(f1,f1mi)
      f2=amin1(f2,f2ma)

      return
      end

*------------------------------------------*
      subroutine mergephase(f1,f2)

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      common/conue/shi(4),ishi,shi1(4)


      if (f1.le.0.0.and.f2.le.0.0) return

      iwt12=0
      iwt12f=0
      errinv=0.0
      errinvp=0.0
      sumwt1=0.0
      sumwt2=0.0
      sumwt2f=0.0
      errmp1=0.0
      errmp2=0.0

      iwt4=0
      iwt4f=0
      sumwt4=0.0
      sumwt4f=0.0
      errmp4=0.0


*--
      ncent=0
c-----combinare le fasi ----
      do 20 i=1,nrefl
         ii=iorde(i)
         if (wtt_in(ii).gt.0.0.and.wt(ii).gt.0.0) then
            dif1=0.0
            dif2=0.0
	    if (wt(ii).gt.0.0) then
               dif1=float(iphi2_in(ii)-ipub(ii))
               dif1=abs(amod(dif1+3600.,360.))
               if (dif1.gt.180.0) dif1=360.0-dif1
               dif2=float(iphaz(ii)-ipub(ii))
               dif2=abs(amod(dif2+3600.,360.))
               if (dif2.gt.180.0) dif2=360.0-dif2
	    endif
            if (inobs(ii).eq.0) then
              iwt12=iwt12+1
	      if (wtt1(ii).gt.0.0) then
                iwt12f=iwt12f+1
                errmp1=errmp1+dif1
                errmp2=errmp2+dif2
                errinv=errinv+dif2
                errinvp=errinvp+dif2*wt(ii)
                sumwt2f=sumwt2f+wt(ii)
	      endif
              sumwt1=sumwt1+wtt_in(ii)
              sumwt2=sumwt2+wt(ii)
            endif
            g1=besinv(wtt_in(ii))
            g2=besinv(wt(ii))
            sumnum=f1*g1*sin(iphi2_in(ii)*dtor)+
     *             f2*g2*sin(iphaz(ii)*dtor)
            sumden=f1*g1*cos(iphi2_in(ii)*dtor)+
     *             f2*g2*cos(iphaz(ii)*dtor)
            if ((sumnum**2 + sumden**2) > 0.0 )then
            ang=atan2(sumnum,sumden)*rtod
            ip=ang+sign(0.5,ang)
            ip=mod(ip+3600,360)
            if (ip.eq.0) ip=360
            iphaz(ii)=ip
            g=(f1*g1+f2*g2)/(f1+f2)
            wt(ii)=bes(g)
            else
             wt(ii)=0.0
            endif
         elseif (wtt_in(ii).gt.0.0) then
            dif=0.0
            if (wtt1(ii).gt.0) then
              dif=float(iphi2_in(ii)-ipub(ii))
              dif=abs(amod(dif+3600.,360.))
              if (dif.gt.180.0) dif=360.0-dif
            endif
         elseif (wt(ii).gt.0.0) then
            dif=0.0
            if (wtt1(ii).gt.0) then
              dif=float(iphaz(ii)-ipub(ii))
              dif=abs(amod(dif+3600.,360.))
              if (dif.gt.180.0) dif=360.0-dif
              ih=khl(1,ii)
              ik=khl(2,ii)
              il=khl(3,ii)
            endif
            if (inobs(ii).eq.0) then
              iwt4=iwt4+1
              sumwt4=sumwt4+wt(ii)
	      if (wtt1(ii).gt.0.0) then
                iwt4f=iwt4f+1
                errmp4=errmp4+dif
                errinv=errinv+dif
                errinvp=errinvp+dif*wt(ii)
                sumwt4f=sumwt4f+wt(ii)
	      endif
            endif
         endif
 20   continue
c--------- statistiche ---------

         errm1=0.0
         errmw1=0.0
         errm1d=0.0
         errmw1d=0.0
         errm1n=0.0
         errm12=0.0
         errm12d=0.0
         errm12n=0.0
         in1=0
         in1f=0
         sw1=0.0
         in1d=0
         sw1d=0.0
         sw1n=0.0
         in12=0
         in12d=0
         in12n=0
         do 60 i=1,nrefl
            ii=iorde(i)
            dres=0.5/sqrt(rhov(ii))
            if (ii.le.nrefl) then
               if (wt(ii).le.0.0) goto 60
               in1=in1+1
               in1d=in1d+1
               dif=0.0
               if (wtt1(ii).gt.0) then
                 in1f=in1f+1
                 dif=float(iphaz(ii)-ipub(ii))
                 dif=abs(amod(dif+3600.,360.))
                 if (dif.gt.180.0) dif=360.0-dif
                 errm1=errm1+dif
                 errmw1=errmw1+dif*wt(ii)
                 errm1d=errm1d+dif
                 errmw1d=errmw1d+dif*wt(ii)
                 sw1=sw1+wt(ii)
                 sw1d=sw1d+wt(ii)
	       endif
               if (wtt_o(ii).le.0.001) goto 60
               in12=in12+1
               in12d=in12d+1
               dif=float(iphaz(ii)-iphi2_o(ii))
               dif=abs(amod(dif+3600.,360.))
               if (dif.gt.180.0) dif=360.0-dif
               errm12=errm12+dif
               errm12d=errm12d+dif
            else
               if (wt(ii).le.0.0) goto 60
               dif=0.0
               if (wtt1(ii).gt.0) then
                  dif=float(iphaz(ii)-ipub(ii)) 
                  dif=abs(amod(dif+3600.,360.))
                  if (dif.gt.180.0) dif=360.0-dif
               endif
               if (inobs(ii).eq.0) then
                  in1=in1+1
                  if (wtt1(ii).gt.0) then
                    in1f=in1f+1
                    errm1=errm1+dif
                    errmw1=errmw1+dif*wt(ii)
                    sw1=sw1+wt(ii)
		  endif
               endif
               if (wtt_o(ii).le.0.0) goto 60
               dif=float(iphaz(ii)-iphi2_o(ii)) 
               dif=abs(amod(dif,360.))
               if (dif.gt.180.0) dif=360.0-dif
               if (inobs(ii).eq.0) then
                  in12=in12+1
                  in12n=in12n+1
                  if (wtt1(ii).gt.0) then
                    errm12=errm12+dif
                    errm12n=errm12n+dif
		  endif
               endif
            endif
 60      continue
c--------
         if ((iwt12f+iwt4f).gt.0) then
             errinv=errinv/float(iwt12f+iwt4f)
             errinvp=errinvp/(sumwt2f+sumwt4f)
         endif
         if (iwt12f.gt.0) then
             errmp1=errmp1/float(iwt12f)
             errmp2=errmp2/float(iwt12f)
         endif
         if (iwt12.gt.0) then
             sumwt1=sumwt1/float(iwt12)
             sumwt2=sumwt2/float(iwt12)
         endif
         if (iwt4f.gt.0) errmp4=errmp4/float(iwt4f)
         if (iwt4.gt.0) sumwt4=sumwt4/float(iwt4)
c------

         if (in1f.gt.0) errm1=errm1/float(in1f)
         if (sw1.gt.0.0) errmw1=errmw1/sw1

         if (in1d.gt.0) errm1d=errm1d/float(in1d)
         if (sw1d.gt.0.0) errmw1d=errmw1d/sw1d
         if (in12.gt.0) errm12=errm12/float(in12)
         if (in12d.gt.0) errm12d=errm12d/float(in12d)
         if (in12n.gt.0) errm12n=errm12n/float(in12n)

C        write(lo,1000) ncicli,ncycle,in1,errm1,errmw1,in1d,errm1d,errmw1d,
c        write(lo,2000) ncycle,in12,errm12,in12d,errm12d,in12n,errm12n,

 1000    format(1x,2i5,1h*,12hPHASE ERROR:,4x,i6,2f8.2,
     *          2x,1h[,3(i6,2f8.2),1x,1h])
c2000    format(1x,i3,1h*,21hAVERAGE CHANGE PHASE:,2x,i6,f8.2,
c    *          2x,1h[,3(i6,f8.2),1x,1h])
c------
        do 70 i=1,nrefl
          ii=iorde(i)
          wtt_o(ii)=wt(ii)
          iphi2_o(ii)=iphaz(ii)
 70     continue
c------

c     write(lo,*)'  *****************************'
c     write(lo,*)'  *       Merge Phases        *'
c     write(lo,*)'  *****************************'

       write(lo,*)
       write(lo,*)'   Phase Combination:'
       write(lo,*)'   --------------------'

       if (knw > 0) then
         write(lo,3000) iwt12,errmp1,sumwt1,f1
         write(lo,4000) iwt12,errmp2,sumwt2,f2
       else
         write(lo,3100) iwt12,sumwt1,f1
         write(lo,4100) iwt12,sumwt2,f2
       endif

       if (iwt4.gt.0.and.knw > 0) then
         write(lo,*)'No-Combined Phases'
         write(lo,*)'      -----------------------'
         write(lo,5000) iwt4,errmp4,sumwt4
       endif
       write(lo,*)

 3000 format(5x,6hNref =,i6,2x,f6.2,2x,7h<wt1> =,f5.2,
     *       2x,6h( m1 =,f5.2,2h ))
 4000 format(5x,6hNref =,i6,2x,f6.2,2x,7h<wt2> =,f5.2,
     *       2x,6h( m2 =,f5.2,2h ))
 3100 format(4x,"Previous: ","Nref =",i6,2x,"<w>=",f5.2,
     *       2x,"(coef =",f5.2,")")
 4100 format(4x,"Current:  ", 6hNref =,i6,2x,"<w>=",f5.2,
     *       2x,"(coef =",f5.2,")")
 5000 format(5x,6hNref =,i6,2x,f6.2,2x,7h<wt4> =,f5.2,/)


      return
      end
*----------------------------------------*
*----     Extend reflections         ----*
*----------------------------------------*
      subroutine exteref(ncycle)

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      common/conue/shi(4),ishi,shi1(4)
      common/super1/nmaMa1,iexte,fdri(3,100),percref(100),percc1(100),
     *              ncycl1(100)
      common/resshell/dmin_old,dmin_new,dmin

      real, allocatable   ::Psort(:),Psortu(:),gg(:)

      allocate(Psort(nrefl),Psortu(nrefl),gg(nrefl), stat = ierr)


c     print*,'Extend reflections:'
      gg(:)=0.0
      Psort(:)=0.0
      Psortu(:)=0.0

      epcot=0.0
      epcot2=0.0

      ncond=0
      ncondu=0
      nrap=0
      do 30 i=1,nrefl
        ii=iorde(i)
        dres=0.5/sqrt(rhov(ii))
c       if (dmin_new.ne.dmin_old) then
c          if (dres.ge.dmin_old.and.wtd(i).le.0.0) then
c             wt(i)=0.0
c             goto 30
c          endif
c       endif

        gg(ii)=e2(ii)
        if (wtd(ii).gt.0.0) goto 30
        if (wt(ii).le.0.0) goto 30
        if (inobs(ii).eq.0) then
            ncond=ncond+1
            Psort(ncond)=gg(ii)
        else
            ncondu=ncondu+1
            Psortu(ncondu)=gg(ii)
        endif
 30   continue


      call sortall(-1,Psort,ncond)
      call sortall(-1,Psortu,ncondu)

      ncond1=nint(ncond*percref(ncycle))
      ncond2=nint(ncondu*percref(ncycle))

c     print*,ncond,ncond1
c     print*,ncondu,ncond2

      if (ncond1.gt.ncond) ncond1=ncond
      if (ncond2.gt.ncondu) ncond2=ncondu
      if (ncond1.gt.0) epcot=Psort(ncond1)
      if (ncond2.gt.0) epcot2=Psortu(ncond2)
      
c     print*,ncond1,epcot
c     print*,ncond2,epcot2

      nreffased=count(wt(1:nrefl) > 0)
c     print*,'nrefl fased', nreffased,nrefl
      nreffased=count(wt(nrefl+1:nrefl) > 0)
c     print*,'nrefl fased', nreffased,nrefl-nrefl

      ic=0
      do 40 i=1,nrefl
       ii=iorde(i)
       if (wtd(ii).gt.0.0) goto 40
       if (wt(ii).le.0.0) goto 40
       if (inobs(ii).eq.0.and.gg(ii).lt.epcot) wt(ii)=0.0
       if (inobs(ii).eq.1.and.gg(ii).lt.epcot2) wt(ii)=0.0
c      if (soge2.gt.0.0.and.inobs(ii).eq.0.and.e2(ii).lt.soge2)
c    *     wt(ii)=0.0
 40   continue

      nreffased=count(wtd(1:nrefl) > 0)
c     print*,'nrefl fased init', nreffased,nrefl

      nreffased=count(wt(1:nrefl) > 0)
c     print*,'nrefl fased', nreffased,nrefl

      nreffased=count(wt(nrefl+1:nrefl) > 0)
c     print*,'nrefl fased', nreffased,nrefl-nrefl

      deallocate(Psort,Psortu,gg, stat = ierr)

      return
      end
*----------------------------------------*
*----     Extend reflections New     ----*
*----------------------------------------*
      subroutine exterefn(ncycle,numb)

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      common/conue/shi(4),ishi,shi1(4)
      common/super1/nmaMa1,iexte,fdri(3,100),percref(100),percc1(100),
     *              ncycl1(100)
      common/resshell/dmin_old,dmin_new,dmin

      real, allocatable   ::Psort(:),Psortu(:),gg(:)

      allocate(Psort(nrefl),Psortu(nrefl),gg(nrefl), stat = ierr)

      gg(:)=0.0
      Psort(:)=0.0
      Psortu(:)=0.0

      epcot=0.0
      epcot2=0.0

      ncond=0
      ncondu=0
      nrap=0
      do 30 i=1,nrefl
        ii=iorde(i)
        dres=0.5/sqrt(rhov(ii))
c       if (dmin_new.ne.dmin_old) then
c          if (dres.ge.dmin_old.and.wtd(i).le.0.0) then
c             wt(i)=0.0
c             goto 30
c          endif
c       endif

        gg(ii)=e2(ii)
        if (evet(ii).le.0.5) then
            wt(ii)=0.0
            goto 30
        endif
        if (wtd(ii).gt.0.0) goto 30
        if (wt(ii).le.0.0) goto 30
        if (inobs(ii).eq.0) then
            ncond=ncond+1
            Psort(ncond)=gg(ii)
        else
            ncondu=ncondu+1
            Psortu(ncondu)=gg(ii)
        endif
 30   continue


      call sortall(-1,Psort,ncond)
      call sortall(-1,Psortu,ncondu)

      if (numb.gt.0) then
        ncond1=numb
        ncond2=numb/2.0
      else
        ncond1=nint(ncond*percref(ncycle))
        ncond2=nint(ncondu*percref(ncycle))
      endif

      if (ncond1.gt.ncond) ncond1=ncond
      if (ncond2.gt.ncondu) ncond2=ncondu
      if (ncond1.gt.0) epcot=Psort(ncond1)
      if (ncond2.gt.0) epcot2=Psortu(ncond2)
      
      do 40 i=1,nrefl
       ii=iorde(i)
       if (wtd(ii).gt.0.0) goto 40
       if (wt(ii).le.0.0) goto 40
       if (inobs(ii).eq.0.and.gg(ii).lt.epcot) wt(ii)=0.0
       if (inobs(ii).eq.1.and.gg(ii).lt.epcot2) wt(ii)=0.0
       if (soge2.gt.0.0.and.inobs(ii).eq.0.and.e2(ii).lt.soge2)
     *     wt(ii)=0.0
 40   continue

      deallocate(Psort,Psortu,gg, stat = ierr)

      return
      end

*----------------------------------------*
*     Extend reflections                 *
*      2 - res                           *
*      3 - weight                        *
*      4 - Fc                            *
*      5 - Fo                            *
*----------------------------------------*
      subroutine ExtendReflections(ncycle,ncycleT,jflag)

      USE General
      USE Riflessi

      real, allocatable   ::Psort(:),Psortu(:),criterio(:)

      allocate(Psort(nreflTot),Psortu(nreflTot),criterio(nreflTot), 
     *             stat = ierr)


      if (ncycle > ncycleT) return
      write(lo,*)'Extend reflections:'
      Psort(:)=0.0
      Psortu(:)=0.0

      epcot=0.0
      epcot2=0.0

      ncond=0
      ncondu=0
      nrap=0
      ic=0
      jflagEx = iabs(jflag)
      nrefExMin = 1
      nrefExMax = nrefl
      if (jflag  < 0 ) then
        nrefExMin = nrefl + 1
        nrefExMax = nreflTot
      endif

      do 10 i=nrefExMin,nrefExMax
c       if (wtd(i) > 0.0) goto 10
        if (pesi(i) > 0.0) goto 10
        ic=ic+1
        select case (jflagEx)
        case (1)
        ! 
        case (2)
          Psort(ic)=0.5/sqrt(rhov(i))
          criterio(i)=0.5/sqrt(rhov(i))
        case (3)
          Psort(ic)=wt(i)
          criterio(i)=wt(i)
        case (4)
          Psort(ic)=fcvet(i)
          criterio(i)=fcvet(i)
        case (5)
          Psort(ic)=fovet(i)
          criterio(i)=fovet(i)
        case (6)
          Psort(ic)=e2(i)
          criterio(i)=e2(i)
        end select
 10   continue

      if (ic <= 0) return
      nsort=ic
      call sortall(-1,Psort,nsort)
      pnrcut=float(ncycle)/float(ncycleT)
      nrcut=nint(pnrcut*nsort)
      nrcut=min(nsort,nrcut)

! gianluca 13/01/2012 per edm sulla crambina abbiamo solo 
!                     un riflesso con wt=0
      if (nrcut <= 0) return  ! gianluca 13/01/2012

      cutoff=Psort(nrcut)
      write(lo,*)'extension=',jflag
      write(lo,*)'nrcut=',nrcut
      write(lo,*)'Cutoff=',cutoff

        
      do 30 i=nrefExMin,nrefExMax
c      if (wtd(i) > 0.0) goto 30
       if (pesi(i) > 0.0) goto 30
       if (criterio(i) < cutoff) then
           wt(i)=0.0
       endif
 30   continue

      deallocate(Psort,Psortu,criterio, stat = ierr)

      return
      end
*---------------------------------------
      subroutine weit_rap

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      common/twomap/bwil,icoeff


      real, allocatable   ::rap(:),Psortr(:)

      allocate(rap(nrefl),Psortr(nrefl), stat = ierr)

      Psortr(:)=0.0
      rap(:)=0.0

c---- correzione del peso per RAP < RAP0
      nrap=0
      do 50 i=1,nrefl
         ii=iorde(i)
         if (inobs(ii).gt.0.or.wt(ii).le.0.0) goto 50
         fo=fovet(ii)
c        if (ihism.gt.0) fo=fovet_mod(ii)
         fc=fcvet(ii)
         if (fo.gt.0.0) then
             rap(ii)=abs(fo-fc)/fo
             nrap=nrap+1
             Psortr(nrap)=rap(ii)
         endif
 50   continue

      call sortall(1,Psortr,nrap)

      ncond3=0.5*nrap
      if (ncond3.gt.0) rap0=Psortr(ncond3)

      rap0=0.5

      s1=0
      sw1=0.0
      sw12=0.0
      sf1=0.0

      s2=0
      sw2=0.0
      sw22=0.0
      sf2=0.0

      do 60 i=1,nrefl
       ii=iorde(i)
       if (rap(ii).le.0.0) goto 60
       if (rap(ii).gt.rap0) then
           s2=s2+1.0
           sw2=sw2+wt(ii)
c          if (knw.gt.0) then
              dif=float(iphaz(ii)-ipub(ii))
              dif=abs(amod(dif+3600.,360.))
              if (dif.gt.180.0) dif=360.0-dif
              sf2=sf2+dif
c          endif
CCC        arg=(rap(ii)-rap0)/(2.0*rap(ii))
CCC        w=exp(-arg)
CCC        w=amax1(0.6,w)
CCC        w=amax1(0.8,w)
CCC        w=wt(ii)*w
CCC        wt(ii)=w
           sw22=sw22+wt(ii)
       else
           s1=s1+1.0
           sw1=sw1+wt(ii)
c          if (knw.gt.0) then
             dif=float(iphaz(ii)-ipub(ii))
             dif=abs(amod(dif+3600.,360.))
             if (dif.gt.180.0) dif=360.0-dif
             sf1=sf1+dif
c          endif
CCC        w=1.0 + 0.35*(rap0-rap(ii))/rap0
           w=1.2
           wt(ii)=amin1(1.0,wt(ii)*w)
           sw12=sw12+wt(ii)
       endif
 60   continue
     
      if (s1.gt.0.0) then
         sw1=sw1/s1
         sw12=sw12/s1
         sf1=sf1/s1

         sw2=sw2/s2
         sw22=sw22/s2
         sf2=sf2/s2

CC       write(6,*) ' Rap0',rap0,nrap
CC       write(6,*) ' Rap < Rap0',s1,sf1,sw1,sw12
CC       write(6,*) ' Rap > Rap0',s2,sf2,sw2,sw22
      endif 
 100  continue

      deallocate(rap,Psortr, stat = ierr)

      return
      end
*----------------------------------------------------*

      subroutine divhist(xfin,ndiv,range,his,rmin,rmax,nrang)

      dimension xfin(ndiv+1),range(nrang),his(nrang)
      nt1=0
      do 10 i=1,nrang
         if (range(i).lt.rmin) goto 10
         if (range(i).gt.rmax) goto 10
         nt1=nt1+his(i)
 10   continue
      nd1=nt1/ndiv
      if (nd1.eq.0) nd1=1
      npunti=nt1
 
      nt1=0
      idiv1=1
      xfin(1)=range(1)

      nsum=0
      do 30 j=1,nrang-1
         if (range(j).lt.rmin) goto 30
         if (range(j).gt.rmax) goto 30
         nt1=nt1+his(j)
 25      if (nt1.ge.nd1) then
            nsup=nt1-nd1
            if (nsup.gt.0) then
               idiv1=idiv1+1
               rz=(range(j+1)-range(j))/his(j)
               xfin(idiv1)=range(j) + rz*(his(j)-nsup)
c              write(6,*)idiv1,xfin(idiv1),nt1,nd1,nsup
               nt1=nsup
               nsum=nsum+nd1
            else
               idiv1=idiv1+1
               xfin(idiv1)=range(j+1)
               write(6,*)idiv1,xfin(idiv1)
               nt1=0
               nsum=nsum+nd1
            endif
            goto 25
         endif
 30   continue
       
      
      xfin(ndiv+1)=range(nrang)
c     write(6,*)xfin(ndiv+1),npunti-nsum,npunti,nsum
      return
      end
c-----------------------------------------------------------------------
      subroutine calc_mult(i1,eps,mult)
      USE Symmetry
c
c     compute epsilon and multiplicity by generating equivalent
c     reflexions
c     epsylon = number of times same reflexion appears in list
c     multiplicity = number different reflexions in list
c
      dimension i1(3),i2(3)
c
      eps=1.0
      mult=1
c     in triclinic space groups eps = 1.0 and mult = 1
      if(nsym.eq.1) go to 600
      k1=65536*i1(1)+256*(i1(2)+128)+i1(3)+128
      ik1=65792-k1
      do 500 j=2,nsym
      do 100 l=1,3
  100 i2(l)=0
      do 400 l=1,3
      do 300 k=1,2
      m=iabs(ismat(k,l,j))
      if(m.gt.0) i2(m)=i2(m)+i1(l)*isign(1,ismat(k,l,j))
  300 continue
  400 continue
      k2=65536*i2(1)+256*(i2(2)+128)+i2(3)+128
      if(k2.eq.k1) eps=eps+1.0
      if(icent.ne.0.and.k2.eq.ik1) eps=eps+1.0
      if(k2.eq.k1.or.k2.eq.ik1) mult=mult+1
  500 continue
  600 continue
      mult=nsym/mult
      return
      end
c------------------------------------------------------------------
      subroutine denhist1(x,x1,percSOL,npts)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))



      nx=np(1)
      ny=np(2)
      nz=np(3)

      denmin=1.0e25
      denmax=-1.0e25
      call maxminSP(0,nx,ny,nz,denmin,denmax,avden,stden,x)

      nrange=500
      rang=(denmax - denmin)/nrange
      npunti=0
      do 10 i=1,nrange+1
         hisp(i)=0.0
         hisp1(i)=0.0
         range(i)=denmin + rang*(i-1)
 10   continue

      do 150 ky=1,ny
         do 100 kz=1,nz
           do 50 kx=1,nx
               xx=x(kx,ky,kz)
               xx1=x1(kx,ky,kz)/100.0
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               if (xx1.gt.0.5) then
                  hisp(n)=hisp(n)+1.0
               else
                  hisp1(n)=hisp1(n)+1.0
               endif

 50         continue
 100     continue

 150  continue

      write(lo,*)
      write(lo,*)'  ***************************************'
      write(lo,*)'  *           HISTOGRAM MAP             *'
      write(lo,*)'  ***************************************'
      write(lo,*)
*---------
      write(lo,*) '    Range      Points(Protein)  Points(solvent)'
      nstep=25
      num=hisp(1)
      num1=hisp1(1)
      ico=1
      do 200 i=1,nrange,nstep
         ic=i
         if (i.gt.1) then
           num=0
           num1=0
           do ii=ico,ic
              num=num+ hisp(ii)
              num1=num1+ hisp1(ii)
           enddo
         endif
         write(lo,1000) range(i)/volume,num,num1
      ico=ic
 200  continue
 1000 format(f10.3,i12,5x,i12)
*---------

      npts2=npts*(percSOL)
      jflag=-2
      den_s=avden+0.8*stden
      call findsog(hisp, den_s,npts2,jflag)

c     npts1=npts-npts2
      npts1=npts
      jflag=1
      call findsog(hisp1, den_p,npts1,jflag)

      write(lo,2000) denmax/volume,denmin/volume,avden/volume,
     +      stden/volume,den_p/volume,npts1,den_s/volume,npts2
 2000 format(/,'   Maximum density ............ ',f8.3,/,
     +       '   Minimum density ............ ',f8.3,/,
     +       '   Average density ............ ',f8.3,/,
     +       '   Standar deviation .......... ',f8.3,/,
     +       '   Level in envelope ...........',f8.3,1x,i7,/,
     +       '   Level out envelope ..........',f8.3,1x,i7,/)

      return
      end
*---------------------------*
      subroutine paraomit

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common/omitmap/iomit,iy,nxomit(3,3)
      dimension b(3),ax(3)

      do i=1,3
        b(i)=cell(i)/float(np(i))
      enddo
      a1=cos(cell(4)*pi/180.0)
      a2=cos(cell(5)*pi/180.0)
      a3=cos(cell(6)*pi/180.0)
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
      volume=cell(1)*cell(2)*cell(3)*sqrt(arg)
      npunti=np(1)*np(2)*np(3)


      ix=iy
      call randu1(ix,iy,yfl)
      flag=real(int(yfl*3.0)+1.0)
      ipref=nint(flag)
      ix=iy

      do 10 i=1,3
        do 10 j=1,2
        call randu1(ix,iy,yfl)
        iflag=int(yfl*np(i))+1
        ix=iy
        nxomit(j,i)=iflag
 10   continue

      do 20 i=1,3
         if (nxomit(1,i).gt.nxomit(2,i) ) then
            ia=nxomit(1,i)
            nxomit(1,i)=nxomit(2,i)
            nxomit(2,i)=ia
         endif
         n1=abs(nxomit(1,i))
         n2=abs(nxomit(2,i))
         kx=n1/np(i)+n2/np(i) 
         nxomit(3,i)=kx
CCC      ax(i)=real((nxomit(2,i)-nxomit(1,i)))*b(i)
         ax(i)=abs(nxomit(2,i)-nxomit(1,i))+1
         n1=mod(n1,np(i))
         nxomit(1,i)=isign(n1,nxomit(1,i))
         n2=mod(n2,np(i))
         nxomit(2,i)=isign(n2,nxomit(2,i))
 20   continue

      abc=1.0
      do 30 i=1,3
         if (i.eq.ipref) goto 30
          abc=abc*ax(i)
 30   continue
      
c     v10=0.10*volume
c     zz=v10/(abc*sqrt(arg))
c     zz=real(nint(zz))/b(ipref)
c     izz=nint(zz)

      izz=nint(0.1*npunti/(abc))
      
      call randu1(ix,iy,yfl)
      ix=iy
      if (yfl.lt.0.5) izz=-izz
      nxomit(2,ipref)=(izz+nxomit(1,ipref)-1)
      if (nxomit(1,ipref).gt.nxomit(2,ipref)) then
         ia=nxomit(1,ipref)
         nxomit(1,ipref)=nxomit(2,ipref)
         nxomit(2,ipref)=ia
      endif
      n1=abs(nxomit(1,ipref))
      n2=abs(nxomit(2,ipref))
      kx=n1/np(ipref)+n2/np(ipref) 
      nxomit(3,ipref)=kx
      n1=mod(n1,np(ipref))
      nxomit(1,ipref)=isign(n1,nxomit(1,ipref))
      n2=mod(n2,np(ipref))
      nxomit(2,ipref)=isign(n2,nxomit(2,ipref))

      write(6,*)'ipref=',ipref
      write(6,*)nxomit

      return
      end
*-----------------------*
      subroutine omit(x)

      USE General
      USE Mappa
      common/omitmap/iomit,iyy,nxomit(3,3)
      real x(1:np(1),1:np(2),1:np(3))


      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npu=0
      ny1=nxomit(1,2)
      ny2=nxomit(2,2)
      kyy=nxomit(3,2)
      nz1=nxomit(1,3)
      nz2=nxomit(2,3)
      kzz=nxomit(3,3)
      nx1=nxomit(1,1)
      nx2=nxomit(2,1)
      kxx=nxomit(3,1)

      do 50 ky=ny1,ny2
       iy=ky
       if (ky.lt.1) iy=nny+ky
       if (ky.gt.nny) iy=ky-nny

       do 40 kz=nz1,nz2
         iz=kz
         if (kz.lt.1) iz=nnz+kz
         if (kz.gt.nnz) iz=kz-nnz

         do 30 kx=nx1,nx2
           ix=kx
           if (kx.lt.1) ix=nnx+kx
           if (kx.gt.nnx) ix=kx-nnx
           indr = ( nnx * nnz ) * ( iy - 1 )
     *            + nnx * ( iz - 1 )
     *            + ix
           x(kx,ky,kz)=0.0
           npu=npu+1
 30      continue
 40    continue
 50   continue


      do 100 iy=1,nny*kyy
       do 90 kz=nz1,nz2
         iz=kz
         if (kz.lt.1) iz=nnz+kz
         if (kz.gt.nnz) iz=kz-nnz
        do 80 kx=nx1,nx2
           ix=kx
           if (kx.lt.1) ix=nnx+kx
           if (kx.gt.nnx) ix=kx-nnx
           x(kx,ky,kz)=0.0
           npu=npu+1
 80      continue
 90    continue
 100  continue

      do 200 ky=ny1,ny2
         iy=ky
         if (ky.lt.1) iy=nny+ky
         if (ky.gt.nnz) iy=ky-nny
       do 190 iz=1,nnz*kzz
        do 180 kx=nx1,nx2
           ix=kx
           if (kx.lt.1) ix=nnx+kx
           if (kx.gt.nnx) ix=kx-nnx
           x(kx,ky,kz)=0.0
           npu=npu+1
 180     continue
 190   continue
 200  continue

      do 300 ky=ny1,ny2
       iy=ky
       if (ky.lt.1) iy=nny+ky
       if (ky.gt.nny) iy=ky-nny
       do 290 kz=nz1,nz2
         iz=kz
         if (kz.lt.1) iz=nnz+kz
         if (kz.gt.nnz) iz=kz-nnz
        do 280 ix=1,nnx*kxx
           x(kx,ky,kz)=0.0
           npu=npu+1
 280     continue
 290   continue
 300  continue

      write(6,*)'OMIT-map',npu
      return
      end
c------------------------------------------------------------------
      subroutine mergemap(x,jrelM)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x(1:np(1),1:np(2),1:np(3))

      integer, allocatable ::nstore(:)

      if (jrelM.le.0) return
      nx=np(1)
      ny=np(2)
      nz=np(3)
      allocate(nstore(nx*nz), stat= ierr)

      npunti=0

      do 50 iy=1,ny
         call ReadSezione(iy,nx,ny,nz,nstore,jrelM)
          do 30 iz=1,nz
           do 20 ix=1,nx
             xx1=x(ix,iy,iz)
             indr = nx * ( iz - 1 ) + ix
             xx2=float(nstore(indr))
             if (xx2.le.0) goto 20
             xx=(xx1+xx2)/2.0
             npunti=npunti+1
             x(ix,iy,iz)=xx
 20      continue
 30     continue
 50   continue

      write(lo,25)npunti
 25   format(4x,'Points in Merge Map :',i6)

      deallocate(nstore, stat= ierr)
      return
      end
c---------------------------------------------------------------------
      subroutine afterinv_mod

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)
      common/conue/shi(4),ishi,shi1(4)
      common/twomap/bwil,icoeff
      dimension i1(3)

      bwil=bt
*---- Scalare de Fc rispetto a Fo ----*
      sumdenor=0.0
      sumfo2=0.0
      sumfp2=0.0
      sumfo=0.0
      sumfp=0.0
      nnobs=0
      do 10 i=1,nrefl
        ii=iorde(i)
        if (inobs(ii).eq.1) goto 10
        fo=fmod(ii)
        fc=fcvet(ii)
        sumfo2=sumfo2 + fo*fo
        sumfp2=sumfp2 + fc*fc
        sumfo=sumfo + abs(fo)
        sumfp=sumfp + abs(fc)
 10   continue
      
      fact=sqrt(perc*sumfo2/sumfp2)
      fact1=(sumfo/sumfp)
      write(6,*)fact,fact1
      
      sum=0.0
      do 15 i=1,nrefl
       ii=iorde(i)
       if (inobs(ii).eq.1) goto 15
       fo=abs(fmod(ii))
       fc=abs(fcvet(ii))
       sum=sum + abs( fo-fc*fact1 )
 15   continue
      suma=sum/sumfo
      sum=sum/float(nrefl-nnobs)

      do 20 i=1,nrefl
       ii=iorde(i)
       fcvet(ii)=fcvet(ii)*fact
 20   continue

*---- Calcolo del E' ed E'p ----*
      fact=perc
      if (fact.gt.0.5)  fact=0.5 + (fact-0.5)/2.0
      fact=sqrt(1.0-fact)
      sum1=0.0
      sum2=0.0
      sum3=0.0
      sum4=0.0

      nref1=0
      do 30 i=1,nrefl
         ii=iorde(i)
         if (inobs(ii).gt.0) goto 30
         nref1=nref1+1
         i1(1:3)=khl(1:3,ii)
         eps=epsv(ii)
         multt=mult(ii)
         rho2=rhov(ii)
         sinth=100.0*sqrt(rho2)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         denor=denor*exp(-2*bwil*rho2)
  310    continue
         denor=sqrt(denor)
         sum1=sum1+emod(ii)
         e1(ii)=fovet(ii)/(denor*fact)
         sum2=sum2+e1(ii)
         e2(ii)=fcvet(ii)/(denor*fact)
         emod(ii)=fcvet(ii)/(denor)
         sum3=sum3+e2(ii)
         dres=0.5/sqrt(rhov(ii))
         wt(ii)=bes(2.0*evet(ii)*emod(ii))
c        wt(ii)=bes(2.0*emod(ii)*dres)
	 diff=emod(ii)-evet(ii) 
         if (diff.lt.0.0) wt(ii)=wt(ii)*0.7
c        if (diff.gt.1.0) then
c             wt(ii)=wt(ii)*1.0
c        elseif (diff.gt.0.8) then
c             wt(ii)=wt(ii)*0.9
c        elseif (diff.gt.0.5) then
c             wt(ii)=wt(ii)*0.8
c        elseif (diff.gt.0.3) then
c             wt(ii)=wt(ii)*0.7
c        elseif (diff.gt.0.2) then
c             wt(ii)=wt(ii)*0.6
c        else
c             wt(ii)=wt(ii)*0.5
c        endif
c        if (dres.ge.5.0) wt(ii)=wt(ii)*1.0
c        if (dres.gt.3.0.and.dres.lt.5.0) wt(ii)=wt(ii)*0.9
c        if (dres.gt.3.0.and.dres.le.4.0) wt(ii)=wt(ii)*0.8
c        if (dres.gt.2.0.and.dres.le.3.0) wt(ii)=wt(ii)*0.7
c        if (dres.lt.2.0) wt(ii)=0.0
 30    continue
*--------
      sum1=sum1/float(nref1)
      sum2=sum2/float(nref1)
      sum3=sum3/float(nref1)
      write(6,'(3x,8hR %    =,f8.2)')suma*100.0
      write(6,'(3x,8h<E>    =,f6.2,2x,f10.2)')sum1
      write(6,'(3x,8h<E1>   =,f6.2,2x,f10.2)')sum2
      write(6,'(3x,8h<E1pi> =,f6.2,2x,f10.2)')sum3
  
      return
      end

c------------------------------------------------------------------
      subroutine mapstat(x,x1,jrelK)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param
     
      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))



      nx=np(1)
      ny=np(2)
      nz=np(3)

      denmin=1.0e25
      denmax=-1.0e25
      call maxminSP(0,nx,ny,nz,denmin,denmax,avden,stden,x)

      sog=avden+1.0*stden

      npunti=0
      npunti_d=0
      npunti_f=0
      nsog_d=0
      nsog_f=0
      do 50 j=1,ny
         do 40 k=1,nz
            do 30 i=1,nx
               npunti=npunti+1
               xx=x(i,j,k)
               xx1=x1(i,j,k)
               if (xx1.ne.100.0) then
                  npunti_f=npunti_f+1
                  if (xx.gt.sog) nsog_f=nsog_f+1
               else
                  npunti_d=npunti_d+1
                  if (xx.gt.sog) nsog_d=nsog_d+1
               endif
 30          continue
 40      continue
 50   continue
      write(lo,*)'   Map Points..................',npunti
      write(lo,*)'   Envelope Points ............',npunti_d
      write(lo,*)'   Envelope Points gt sog......',nsog_d
      write(lo,*)'   NoEnvelope Points ..........',npunti_f
      write(lo,*)'   NoEnvelope Points gt sog....',nsog_f

      return
      end
c------------------------------------------------------------------
      subroutine histmap(map,mask)

      USE General
      USE Mappa
      USE Param
     
      dimension   hisS(501)
!g    dimension   range(501),hisP(501),hisS(501),dip(501),
!g   +            range1(501),hisp1(501),dip1(501)

      real map(1:np(1),1:np(2),1:np(3))
      real mask(1:np(1),1:np(2),1:np(3))


      nx=np(1)
      ny=np(2)
      nz=np(3)
      npunti=nx*ny*nz


      denmin=1.0e25
      denmax=-1.0e25
      call maxminSP(0,nx,ny,nz,denmin,denmax,avden,stden,map)

      nrange=100
      rang=(denmax - denmin)/nrange
      do 10 i=1,nrange+1
         hisP(i)=0
         hisS(i)=0
         range(i)=denmin + rang*(i-1)
 10   continue
      nrange=nrange+1

      do 150 k=1,nz
         do 100 j=1,ny
            do 50 i=1,nx
              xx=map(i,j,k)
              n=int((xx-denmin)/rang) + 1
              ix=int(mask(i,j,k))
              ix=int(ix/100)
              if (ix == 1) then
                hisP(n)=hisP(n)+1.0
              else
                hisS(n)=hisS(n)+1.0
              endif

 50         continue
 100     continue

 150  continue

      write(lo,*)
      write(lo,*)'  ***************************************'
      write(lo,*)'  *           HISTOGRAM MAP             *'
      write(lo,*)'  ***************************************'
      write(lo,*)
      write(lo,*) '    Range      Points(Protein)'
      nstep=5
      num=hisp(1)
      ico=1
      do 200 i=1,nrange,nstep
         ic=i
         if (i.gt.1) then
           num=0
           do ii=ico,ic
              num=num+ int(hisp(ii))
           enddo
         endif
         write(lo,1000) range(i)/volume,num
      ico=ic
 200  continue
 1000 format(f10.3,i12,5x,i12)
      write(lo,*)

      write(lo,2000) denmax/volume,denmin/volume,avden/volume,
     +             stden/volume
 2000 format('   Maximum density ............ ',f8.3,/,
     +       '   Minimum density ............ ',f8.3,/,
     +       '   Average density ............ ',f8.3,/,
     +       '   Standar deviation .......... ',f8.3,/)
      
      return
      end
c------------------------------------------------------------------
      subroutine resetmap(x)
     
      USE Mappa
      real x(1:np(1),1:np(2),1:np(3))

      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      do 50 iy=1,nny
        do 30 iz=1,nnz
          do 20 ix=1,nnx
             x(ix,iy,iz)=0.0
 20      continue
 30     continue
 50   continue

      return
      end
*---------------------------------------------------------*
      subroutine CopyMap(x,x1)

      USE General
      USE Mappa
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))


      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npunti=0

      do 50 ix=1,nnx
        do 30 iy=1,nny
           do 20 iz=1,nnz
             x1(ix,iy,iz)=x(ix,iy,iz)
 20      continue
 30     continue

 50   continue    

      return
      end

*--------------------------------------------
      subroutine Rfacerr(pdum,sog,Rtot,err,nrefl,itoto)

      USE Riflessi

      dimension pdum(nrefl)

      sum=0.0
      sumfo=0.0
      sumerr=0.0
      itoto=0
      do 10 i=1, nrefl 
        if (Pdum(i).lt.sog) then
          wt(i)=0.0
        else
         itoto=itoto+1
         fo=fovet(i)
         fc=fcvet(i)
         sumfo=sumfo+fo
         sum=sum + abs(fo-fc)
         diff=abs(iphaz(i)-ipub(i))
         diff=abs(amod(diff,360.))
         if (diff.gt.180.)diff=360.-diff
         sumerr=sumerr+diff
        endif
 10   continue

      err = sumerr/real(itoto)
      rtot=sum/sumfo
      write(6,*)'RfacErr',itoto,rtot,err

      return
      end

*-----------------------------------------------------     
      subroutine ModMap(x)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))



      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      do 50 ix=1,nnx
        do 30 iy=1,nny
          do 20 iz=1,nnz
             xx1=x(ix,iy,iz)
             x(ix,iy,iz)=xx1**1.5
 20      continue
 30     continue
 50   continue

      return
      end
*-----------------------------------------------------     
      subroutine gammaemp(x,xmod)
     
      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      common /tran/ scale,mh(3),level,it4,xlim(3)
      real x(1:np(1),1:np(2),1:np(3))
      real xmod(1:np(1),1:np(2),1:np(3))

      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      si=0.0
      si2=0.0
      sm=0.0
      sm2=0.0
      sim=0.0
      ss=0.0

      do 50 ix=1,nnx
        do 30 iy=1,nny
          do 20 iz=1,nnz
             ss=ss+1.0 
             xx=x(ix,iy,iz)
             xxmod=xmod(ix,iy,iz)
             si=si + xx
             si2=si2 + xx**2
             sm=sm + xxmod
             sm2=sm2 + xxmod**2
             sim=sim+xx*xxmod
 20      continue
 30     continue
 50   continue


      si=si/ss
      sm=sm/ss
      si2=si2/ss
      sm2=sm2/ss
      sim=sim/ss

      gamma=(sim-si*sm)/(si2-si*si)
      write(lo,*)'gamma emp=',gamma

      return
      end
c---------------------------------
      subroutine LowResDM(cutLow)

      USE General
      USE Riflessi
      Use Mappa
c     Use Envelope
      Use MapTest
      USE Param

      common/conue/shi(4),ishi,shi1(4)
      character*80 tirang

      tirang='Res (A)'
      call ParamDistribution(tirang,knw,dreso,khl,nrefl,1,ipub,iphaz,
     *  shi1,wt,segni1,50,0.0)

      rhomax_obs=maxval(rhov(1:nrefl))
      rmax=0.5/sqrt(rhomax_obs)
      rnrflc=100 + numres(rmax)
      wangmd=131.0
      wangrd=-2.0
      iwp=int(wangmd/100) + 1
      sw=sum(wt(1:nrefl)**iwp)
      Renve=abs(wangrd)*(rnrflc/sw)**0.33*rmax
      Renve=min(Renve,10.0)
      smax=rhomax_obs*4.0
      Renve=9.0

      ! test con ls struttura vera
c     iphaz(:) = ipub(:)
c     wt(:) = 1.0
      !

      ihism_save = ihism  
      ihism = 0 ! per fare l'envelope con Fo e non con F(0)o
      ! l'envelope "true"
      call envelopeMask(1,smax,v_p,xenveT)
c     xenveT=xenveT*volume
c     call CCP4MAPOUT(0,xenveT,np,"enveT.map")
c     xenveT=xenveT/volume

      call envelopeMask(0,smax,v_p,xenve)
c     xenve=xenve*volume
c     call CCP4MAPOUT(0,xenve,np,"enve1.map")
c     xenve=xenve/volume
      call mapcorr0(xenve,xenveT,0,correnve,ier)
      write(lo,*) 'CC_enve',correnve

      call zflush
      call DoSingleIteration()

      wtd(:) = wt(:)
      iphad(:) = iphaz(:)

      fcoef(1:nrefl) = fovet(1:nreflTot)*wt(1:nreflTot)
      call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)

      iflatL = 1   ! protein/solvente*0.5
      call flatmap(xmap,xenve,iflatL,0.0)

      npts = np(1)*np(2)*np(3)*v_p ! nr. punti della proteina
      npts1 = npts * 0.10 ! perc. da invertire

      call denhist(1,xmap,xenve,npts1,0)
      call ChangeAndInvMap(xmap,xenve,1,0.0,1,ier)

      if (knw > 0) then
c      call esamin(khl,mkang,ipub,iphaz,
c    *        nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)
c      call statres
      tirang='Res (A)'
      call ParamDistribution(tirang,knw,dreso,khl,nrefl,1,ipub,iphaz,
     *  shi1,wtd,segni1,50,0.0)

      endif

      iphi2_o(1:nrefl) = iphaz(1:nrefl)



!     solvente

      wt(:) = wtd(:)
      iphaz(:) = iphad(:)

      fcoef(1:nrefl) = fovet(1:nreflTot)*wt(1:nreflTot)
      call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
c     call CCP4MAPOUT(0,xmap,np,"solvent.map")

      ! applicare envelope a contrario (azzerare la proteina)
c     iflatL = -1  ! solvente = - solvente
      iflatL = -2  ! solvente = -0.34
      call flatmap(xmap,xenve,iflatL,0.0)

      npts = np(1)*np(2)*np(3)*(1.0 - v_p) ! nr. punti solvente
      npts1 = npts * 1.0 ! perc. da invertire

c     call denhist(1,xmap,xenve,npts1,0)
      call ChangeAndInvMap(xmap,xenve,0,0.0,1,ier)

      if (knw > 0) then
c      call esamin(khl,mkang,ipub,iphaz,
c    *        nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi1)
c      call statres

      tirang='Res (A)'
      call ParamDistribution(tirang,knw,dreso,khl,nrefl,1,ipub,iphaz,
     *  shi1,wtd,segni1,50,0.0)

      endif

      tirang='Res (A)'
      call ParamDistribution(tirang,knw,dreso,khl,nrefl,1,iphi2_o,iphaz,
     *  shi1,wt,segni1,50,0.0)


      ! prendiamo le fasi per dres > 8.0 A dal "solvente"
      do i = 1, nrefl
        if (dreso(i) > 8.7) then
         iphad(i) = iphaz(i)
        else
         iphad(i) = iphi2_o(i)
        endif
      enddo

      iphaz(1:nrefl) = iphad(1:nrefl)
      wt(1:nrefl) = wtd(1:nrefl)

      call envelopeMask(0,smax,v_p,xenve)
c     xenve=xenve*volume
c     call CCP4MAPOUT(0,xenve,np,"enve2.map")
c     xenve=xenve/volume
      call mapcorr0(xenve,xenveT,0,correnve,ier)
      write(lo,*) 'CC_enve',correnve

      ihism = ihism_save

      stop

      return
      end
