#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
#define RESET_PNG "reset"
#define INFO_PNG "info_icon"
#else
#define RESET_PNG "reset1"
#define INFO_PNG "info"
#endif
static mr_action_entry menu_entries[] = {
{0, 1, "File", "_File", "File Operations", NULL, NULL, NULL, -2, 1, 0}, 
#ifndef JAV
{1, 1, "Import Structure", "_Import Structure", "File import", "importb", G_CALLBACK(on_import), NULL, -2, 1, 0}, 
{1, 1, "Import Fragment", "_Import Fragment", "Fragment import", "importb", NULL, NULL, -2, 1, 0}, 
{2, 1, "ImportTetra", "_Tetrahedron ", "Add tetrahedron", NULL, G_CALLBACK(on_import_tetra), NULL, -2, 1, 0}, 
{2, 1, "ImportOcta", "_Octahedron ", "Add octahedron", NULL, G_CALLBACK(on_import_octa), NULL, -2, 1, 0}, 
{2, 1, "ImportSqP", "_Square Plane ", "Add sqare plane", NULL, G_CALLBACK(on_import_squarep), NULL, -2, 1, 0}, 
{2, 1, "ImportIsoAt", "_Isolated Atoms ", "Add isolated atoms", NULL, G_CALLBACK(on_import_isolated), NULL, -2, 1, 0}, 
{1, 1, "Export Structure", "_Export Structure", "File Export", "exportb", G_CALLBACK(on_export), NULL, -2, 1, 0},
#else
{1, 1, "Open", "_Open", "Open file", "blueopen", G_CALLBACK(on_OpenGeneral), NULL, -2, 1, 0},
{1, 4},
{1, 1, "Export Structure", "_Export Structure", "File Export", "exportb", G_CALLBACK(on_export), NULL, -2, 1, 0},
//{1, 1, "View Log", "View Log", "View Log File ", "output", G_CALLBACK(on_ViewOutput), NULL, -2, 1, 0},
#if 0
{1, 4},
{1, 1, "Load Examples", "Load Examples", "Load Examples", "blueopen", NULL, NULL, -2, 1, 0},
{2, 1, "Small molecule", "Small molecule", "Small molecule", NULL, G_CALLBACK(on_LoadSmall), NULL, -2, 1, 0},
{2, 1, "Macro molecule", "Macro molecule", "Macro molecule", NULL, G_CALLBACK(on_LoadMacro), NULL, -2, 1, 0},
#ifndef NDEBUG
{1, 1, "Import Example", "Import Example", "Import Example", "blueopen", G_CALLBACK(on_LoadAscii), NULL, -2, 1, 0},
{1, 1, "Export Example", "Export Example", "Export Example", "filesaveas", G_CALLBACK(on_SaveAscii), NULL, -2, 1, 0},
#endif
#endif
{1, -1, "Last Run", "Last Run", "Restore Last Run", "restore", G_CALLBACK(on_LastRun), "<Control>l", -2, 1, 0},
{1, 4},
{1, -1, "Save Run", "Save Run", "Save Run", "filesave", G_CALLBACK(on_SaveRun), NULL, -2, 1, 0},
{1, -1, "Load Old Run", "Load Old Run", "Load Old Run", "blueopen", G_CALLBACK(on_LoadRun), NULL, -2, 1, 0},
{1, 1, "Remove", "_Remove Map/Model", "Remove Map/Model File ", "cancel", G_CALLBACK(on_Close), "<Control>r", -2, 1, 0},
#endif
{1, 4},
{1, 1, "Export scene", "Export scene", "Export scene for 3D printing", NULL, G_CALLBACK(on_exportScene), NULL, -2, 1, 0},
#ifdef JAV
{1, 1, "Import STL", "Import STL", "Import STL", NULL, G_CALLBACK(on_importSTL), NULL, -2, 1, 0},
#endif
{1, 4},
{1, 1, "Screenshot", "Screenshot", "Screenshot ", "camera", G_CALLBACK(on_Screenshot), "<Control>h", -2, 1, 0}, 
{1, 4},
{1, 1, "Exit", "E_xit", "Exit", "quit", G_CALLBACK(on_Quit), "<Control>q", -2, 1, 0}, 
{0, 1, "Modify", "_Modify", "Modify", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Undo", "Undo", "Undo previous action ", "undo", G_CALLBACK(on_undo), "<Control>z", -2, 1, 0}, 
{1, 1, "Redo", "_Redo", "Redo", "redo", G_CALLBACK(on_redo), "<Control>y", -2, 1, 0}, 
{1, 4},
{1, 1, "Delete Selection", "Delete Selected atoms or bonds", "Delete selected objects", "delete", G_CALLBACK(on_delete), NULL, -2, 1, 0}, 
{1, 1, "Delete Bonds", "Delete Bonds", "Delete selected bonds", "bondoff", G_CALLBACK(on_delete_bonds), NULL, -2, 1, 0}, 
{1, 1, "Delete All Type ...", "Delete All Type ...", "Delete all type ...", "delat", NULL, NULL, -2, 1, 0}, 
{1, 1, "Delete Duplicate Atoms", "Delete Duplicate Atoms", "Delete Duplicate Atoms", "bondoff", G_CALLBACK(on_delete_dup), NULL, -2, 1, 0},
{1, 4},
{1, 1, "Change Species", "_Change Species", "Change species of selected atoms", "relabel", NULL, NULL, -2, 1, 0}, 
{1, 1, "Rename", "_Rename", "Rename selected atoms", "rename_ico", G_CALLBACK(on_rename), NULL, -2, 1, 0}, 
{1, 1, "Renumber", "Re_number", "Renumber selected atoms", "renumber", G_CALLBACK(on_renumber), NULL, -2, 1, 0}, 
{1, 1, "Sort by Species", "_Sort by Species", "Sort by Species", "sort", G_CALLBACK(on_sortbyspec), NULL, -2, 1, 0}, 
{1, 1, "Add Bonds", "_Add Bonds", "Add bonds", "bondon", G_CALLBACK(on_addbond), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "Properties", "_Properties", "Properties", "edit", NULL, NULL, -2, 1, 0}, 
{2, 1, "Atom Properties", "_Atom Properties", "Atom Properties", NULL, G_CALLBACK(StructureEdit), NULL, -2, 1, 0},
{2, 1, "Bond Properties", "_Bond Properties", "Bond Properties", NULL, G_CALLBACK(PropsEdit), NULL, -2, 1, 0},
{2, 1, "Angle Properties", "An_gle Properties", "Angle Properties", NULL, G_CALLBACK(OnAngsEdit), NULL, -2, 1, 0},
{2, 1, "Torsion Properties", "_Torsion Properties", "Torsion Properties", NULL, G_CALLBACK(OnTorsEdit), NULL, -2, 1, 0}, 
#ifndef JAV
{1, 4},
{1, 1, "Add fragments", "_Add fragments", "Add fragments ", "importb", NULL, NULL, -2, 1, 0}, 
{2, 1, "From File", "From File ", "Add fragment from file", NULL, G_CALLBACK(on_add_frag_fromfile), NULL, -2, 1, 0}, 
{2, -1, "From SMILES", "From SMILES ", "Add fragment from SMILES", NULL, G_CALLBACK(on_add_frag_fromsmiles), NULL, -2, 1, 0}, 
{2, 1, "Add Tetrahedron", "_Tetrahedron ", "Add tetrahedron", NULL, G_CALLBACK(on_add_tetra), NULL, -2, 1, 0}, 
{2, 1, "Add Octahedron", "_Octahedron ", "Add octahedron", NULL, G_CALLBACK(on_add_octa), NULL, -2, 1, 0}, 
{2, 1, "Add Square Plane", "_Square Plane ", "Add square plane", NULL, G_CALLBACK(on_add_squarep), NULL, -2, 1, 0}, 
{2, 1, "Add Isolated Atoms", "_Isolated Atoms ", "Add isolated atoms", NULL, G_CALLBACK(on_add_isolated), NULL, -2, 1, 0}, 
{2, 1, "Duplicate All", "Duplicate All", "Duplicate All", NULL, G_CALLBACK(on_dup_all), NULL, -2, 1, 0}, 
{2, 1, "Duplicate Selected Atoms", "Duplicate Selected Atoms", "Duplicate Selected Atoms", NULL, G_CALLBACK(on_dup_sel), NULL, -2, 1, 0}, 
#endif
{1, 4},
{1, 1, "Add Atom", "Add Atom", "Add Atom ", NULL, NULL, NULL, -2, 1, 0},
{0, 1, "Select", "Select", "Select", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Selection Mode", "_Selection Mode", "Enter selection mode", "selecton", NULL, NULL, -2, 1, 0},
{2, 1, "Atom", "_Atoms or Bonds", "Enter atom/bond selection mode", NULL, G_CALLBACK(on_select_mode), NULL, -2, 1, 0},
{2, 1, "Rectangular", "_Rectangular", "Enter rectangular selection mode", NULL, G_CALLBACK(on_rect_select_mode), NULL, -2, 1, 0},
{2, 1, "Molecule", "_Molecule", "Enter molecule selection mode", NULL, G_CALLBACK(on_mol_select_mode), NULL, -2, 1, 0},
{1, 1, "Zoom Mode", "_Zoom Mode", "Exit selection mode", "preview22", G_CALLBACK(on_zoom_mode), NULL, -2, 1, 0}, 
{1, 1, "Manipulation Mode", "_Manipulation Mode", "Enter manipulation mode", "selectoff", G_CALLBACK(on_manipulation_mode), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "Select All", "Select _All", "Select all objects", "area", G_CALLBACK(on_select), NULL, -2, 1, 0}, 
{1, 1, "Select None", "Select _None", "Unselect all selected objects", "selectnone", G_CALLBACK(on_unselect), NULL, -2, 1, 0}, 
{1, 1, "Invert selection", "_Invert selection", "Invert selection", "sel_invert", G_CALLBACK(on_invselect), NULL, -2, 1, 0}, 
{1, 1, "Select Type ...", "Select Type ...", "Select type ...", "apply", NULL, NULL, -2, 1, 0}, 
{1, 1, "Expand to molecule", "Expand to molecule", "Expand selection to whole molecule", NULL, G_CALLBACK(on_expand_sel), NULL, -2, 1, 0}, 
{0, 1, "ViewMenu", "_View", "View", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Preferences", "Preferences", "Modify application settings", "advanced", G_CALLBACK(AdvancedSettings), NULL, -2, 1, 0}, 
#ifdef JAV
{1, 1, "Colours Preferences", "Colours Preferences", " Define User Colours Table", "col_ico", G_CALLBACK(ColorTable), NULL, -2, 1, 0},
#endif
#if defined(SIR_PGM) || defined(JAV)
{1, 1, "Go to atom", "Go to atom", "Go to atom ", "right_arrow", G_CALLBACK(GoToAtom), NULL, -2, 1, 0},
#endif
{1, 4},
{1, 1, "Symmetry", "Symmetry", "Symmetry ", "symmon", NULL, NULL, -2, 1, 0}, 
{2, 3, "Packing", "Packing", "Symmetry On/Off ", NULL, G_CALLBACK(PackOnOff), NULL, -2, 1, 0}, 
{2, 1, "Expand", "Expand", "Expand packing range ", NULL, G_CALLBACK(IncPack), NULL, -2, 1, 0}, 
{2, 1, "Reduce", "Reduce", "Reduce packing range ", NULL, G_CALLBACK(DecPack), NULL, -2, 1, 0}, 
{2, 3, "View Cell Edges", "View Cell Edges", "Cell Edges On/Off ", "cellon", G_CALLBACK(CellOnOff), "e", -2, 1, 0}, 
{2, 3, "Grow Fragment", "Grow Fragment", "Grow Fragment On/Off ", NULL, G_CALLBACK(GrowOnOff), NULL, -2, 1, 0}, 
{2, 1, "Assemble", "_Assemble", "Connectivity", "regroup", G_CALLBACK(on_assemble), NULL, -2, 1, 0}, 
{2, 1, "Move Atoms", "_Move Atoms", "Move Atoms ", "moveatoms", G_CALLBACK(on_move_atoms), NULL, -2, 1, 0}, 
{1, 1, "Zoom", "Zoom", "Zoom operations", NULL, NULL, NULL, -2, 1, 0}, 
{2, 1, "Zoom in", "Zoom in", "Zoom in", "zoom_in", G_CALLBACK(on_ZoomIn), "Page_Up", -2, 1, 0}, 
{2, 1, "Zoom out", "Zoom out", "Zoom out", "zoom_out", G_CALLBACK(on_ZoomOut), "Page_Down", -2, 1, 0}, 
{2, 1, "Reset Scale", "Reset Scale", "Reset Scale ", "zoom_normal", G_CALLBACK(on_ResetScale), "End", -2, 1, 0}, 
{2, 1, "Reset View", "Reset View", "Reset view ", RESET_PNG, G_CALLBACK(on_ResetView), "Home", -2, 1, 0}, 
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
{2, 3, "Center on map", "Center on map", "Center on Map ", NULL, G_CALLBACK(on_CenterOnMap), NULL, -2, 1, 0},
#endif
{1, 4},
{1, 1, "Rotate", "Rotate", "Rotate ", "rotate", NULL, NULL, -2, 1, 0}, 
{2, 1, "Around X+", "Around X+", "Rotate around X(+)", "xplus", G_CALLBACK(on_Xplus), "<Control>Up", -2, 1, 0}, 
{2, 1, "Around X-", "Around X-", "Rotate around X(-)", "xminus", G_CALLBACK(on_Xminus), "<Control>Down", -2, 1, 0}, 
{2, 1, "Around Y+", "Around Y+", "Rotate around Y(+)", "yplus", G_CALLBACK(on_Yplus), "<Control>Left", -2, 1, 0}, 
{2, 1, "Around Y-", "Around Y-", "Rotate around Y(-)", "yminus", G_CALLBACK(on_Yminus), "<Control>Right", -2, 1, 0}, 
{2, 1, "Around Z+", "Around Z+", "Rotate around Z(+)", "zplus", G_CALLBACK(on_Zplus), "<Control>Page_Up", -2, 1, 0}, 
{2, 1, "Around Z-", "Around Z-", "Rotate around Z(-)", "zminus", G_CALLBACK(on_Zminus), "<Control>Page_Down", -2, 1, 0}, 
{1, 4},
{1, 1, "Label", "Label", "Label", "laboff", NULL, NULL, -2, 1, 0}, 
{2, 3, "Label All Atoms", "All Atoms", "Label All Atoms ", "laboff", G_CALLBACK(LabelsOnOff), NULL, -2, 1, 0}, 
{2, 1, "Delete All Labels", "Delete All Labels", "Delete All Labels", "void", G_CALLBACK(LabelsOff), NULL, -2, 1, 0}, 
{2, 3, "LabelNonH", "except Hydrogens", "Label all atoms except hydrogens", "labh", G_CALLBACK(LabelsHOnOff), NULL, -2, 1, 0}, 
{2, 3, "LabelHeavy", "heavy atoms", "Label heavy atoms only", "labh", G_CALLBACK(LabelsHeavy), NULL, -2, 1, 0}, 
{1, 1, "Label Type", "Label Type", "Label type", "labon", NULL, NULL, -2, 1, 0}, 
{2, 2, "Atom name", "Atom name", "Atom name", NULL, G_CALLBACK(on_label_name), NULL, -2, 1, 0}, 
{2, 2, "Atom species", "Atom species", "Atom species", NULL, G_CALLBACK(on_label_species), NULL, -2, 1, 0}, 
{2, 2, "Atom number", "Atom number", "Atom number", NULL, G_CALLBACK(on_label_number), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "Show-Hide", "Show/Hide", "Show/Hide...", "showhide", NULL, NULL, -2, 1, 0}, 
{2, 2, "Show All", "Show All", "Show all atoms", NULL, G_CALLBACK(on_show_all), NULL, -2, 1, 0}, 
{2, 2, "Hide Selected", "Hide Selected", "Hide selected atoms", NULL, G_CALLBACK(on_hide_selected), NULL, -2, 1, 0}, 
{2, 2, "Hide Unselected", "Hide Unselected", "Hide unselected atoms", NULL, G_CALLBACK(on_hide_unselected), NULL, -2, 1, 0}, 
{2, 2, "Hide Hydrogens", "Hide Hydrogens", "Hide hydrogens", NULL, G_CALLBACK(on_hide_hydrogens), NULL, -2, 1, 0}, 
#ifdef JAV
{1, 4},
{1, 1, "Sequence", "_Sequence", "View Amino Acids Sequence", "sequence", NULL, NULL, -2, 1, 0},
#endif
{1, 4},
{1, 1, "View Plane", "View Plane", "View Plane ", NULL, NULL, NULL, -2, 1, 0}, 
{2, 1, "Normal to a", "Normal to a", "Normal to a ", NULL, G_CALLBACK(on_ViewPlanea), NULL, -2, 1, 0}, 
{2, 1, "Normal to b", "Normal to b", "Normal to b ", NULL, G_CALLBACK(on_ViewPlaneb), NULL, -2, 1, 0}, 
{2, 1, "Normal to c", "Normal to c", "Normal to c ", NULL, G_CALLBACK(on_ViewPlanec), NULL, -2, 1, 0}, 
{2, 1, "Least Squares Plane", "Least Squares Plane", "Least Squares Plane", NULL, G_CALLBACK(on_ViewPlaneLSQ), NULL, -2, 1, 0}, 
{2, 1, "Selected Atoms Plane", "Selected Atoms Plane", "Selected Atoms Plane", NULL, G_CALLBACK(on_ViewPlaneSelected), NULL, -2, 1, 0}, 
{1, 4},
{1, 3, "Polyhedra", "Polyhedra", "Polyhedra On/Off ", "poly", G_CALLBACK(PolyOnOff), NULL, -2, 1, 0}, 
{1, 1, "Polyhedra Properties", "Polyhedra Properties", "Polyhedra Properties ", "advanced", G_CALLBACK(on_PolyhedraProperties), NULL, -2, 1, 0}, 
{1, 4},
{1, 3, "ShowMB", "Show Multiple Bonds", "Show Multiple Bonds", NULL, G_CALLBACK(ShowMB), NULL, -2, 1, 0},
{1, 4},
{1, 1, "Contacts", "Contacts", "Contacts", "contacts", NULL, NULL, -2, 1, 0}, 
{2, 3, "Hydrogen Bonds", "Hydrogen _Bonds", "View Hydrogen Bonds", NULL, G_CALLBACK(HydBondsOnOff), NULL, -2, 1, 0}, 
{2, 3, "Short Contacts", "Short _Contacts", "View Short Contacts", NULL, G_CALLBACK(ShortContOnOff), NULL, -2, 1, 0}, 
{2, 3, "Delete Hanging Contacts", "Delete Hanging Contacts", "Delete Hanging Contacts", NULL, G_CALLBACK(DelHangContOnOff), NULL, -2, 1, 0},
{2, 1, "Edit H-Bonds", "_Edit H-bonds", "Edit Hydrogen Bonds", NULL, G_CALLBACK(on_EditHbonds), NULL, -2, 1, 0}, 
#if !defined(JAV) && !defined(SIR_PGM)
{1, 4},
{1, 1, "Display Fourier maps", "Display Fourier Maps", "Display Fourier Maps", "contour", NULL, NULL, -1, 1, 0},
{2, 3, "Show Fourier Map", "Show Fourier Map", "Show Fourier Map", NULL, G_CALLBACK(call_jav), NULL, 0, 1, 0},
{2, 1, "Compute Fo", "Compute Fo", "Compute Fo", NULL, G_CALLBACK(call_jav), NULL, 1, 1, 0},
{2, 1, "Compute 2Fo - Fc", "Compute 2Fo - Fc", "Compute 2Fo - Fc", NULL, G_CALLBACK(call_jav), NULL, 2, 1, 0},
{2, 1, "Compute Fo-Fc", "Compute Fo-Fc", "Compute Fo-Fc", NULL, G_CALLBACK(call_jav), NULL, 3, 1, 0},
{2, 1, "Compute Fc", "Compute Fc", "Compute Fc", NULL, G_CALLBACK(call_jav), NULL, 4, 1, 0},
#endif
#ifdef JAV
{1, 4},
{1, 3, "Show Toolbars", "Show Toolbars", "Show/Hide Toolbars", NULL, G_CALLBACK(TbOnOff), NULL, -2, 1, 0}, 
#endif
{0, 1, "Tools", "_Tools", "Tools", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Add Hydrogens", "Add _Hydrogens", "Add hydrogens", "hydro_ico", NULL, NULL, -2, 1, 0}, 
{2, 1, "Automatic", "Automatic", "Automatic", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Methine C-H", "Methine C-H", "Methine C-H", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Methylene Group", "Methylene Group", "Methylene Group", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Methyl Group", "Methyl Group", "Methyl Group", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Aromatic C-H", "Aromatic C-H", "Aromatic C-H", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Hydroxyl O-H", "Hydroxyl O-H", "Hydroxyl O-H", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Terminal X=CH2", "Terminal X=CH2", "Terminal X=CH2", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Terminal B-H", "Terminal B-H", "Terminal B-H", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 1, "Acetylenic C-H", "Acetylenic C-H", "Acetylenic C-H", NULL, G_CALLBACK(on_hydro), NULL, -2, 1, 0}, 
{2, 4},
{2, 1, "Normalise Hydrogens", "Normalise Hydrogens", "Normalise hydrogens", NULL, G_CALLBACK(on_norm_hydro), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "Build Bonds", "_Build Bonds", "Connectivity", "skelon", G_CALLBACK(on_buildbonds), NULL, -2, 1, 0}, 
{1, 1, "Bond Settings", "Bond Settings", "Bond Settings", "bondsett", G_CALLBACK(on_bondsetting), NULL, -2, 1, 0}, 
{1, 4},
{1, 1, "Complete", "_Complete", "Complete 6-membered ring", "complete", G_CALLBACK(on_complete), NULL, -2, 1, 0}, 
{1, 1, "Regularize", "_Regularize", "Regularize 6-membered ring", "regularize", G_CALLBACK(on_regularize), NULL, -2, 1, 0}, 
{1, 1, "Enantiomorph", "_Enantiomorph", "Change Enantiomorph", "enan", G_CALLBACK(on_enant), NULL, -2, 1, 0}, 
{1, 1, "Transform", "_Transform", "Transform Model", "transform", G_CALLBACK(on_transform), NULL, -2, 1, 0}, 
{1, -1, "Optimize Geometry", "Optimize Geometry", "Optimize Geometry", NULL, NULL, NULL, -2, 1, 0}, 
{2, 1, "Optimize", "Optimize", "Optimize by molecular mechanics force field", NULL, G_CALLBACK(on_optimize), NULL, -2, 1, 0}, 
{2, 1, "Optimize Selected Atoms", "Optimize Selected Atoms", "Optimize Selected Atoms", NULL, G_CALLBACK(on_optimize), NULL, -2, 1, 0}, 
#ifndef JAV
{1, 4},
{1, 1, "Overlay Structures", "_Overlay Structures", "Overlay structures", "showall", G_CALLBACK(on_overlay), NULL, -2, 1, 0}, 
{1, 1, "Overlay Info", "Overlay Info", "Overlay info", INFO_PNG, G_CALLBACK(on_overlay_info), NULL, -2, 1, 0}, 
{1, 1, "Delete Model", "Delete Model", "Delete Model", "close", NULL, NULL, -2, 1, 0}, 
#endif
{1, 4},
{1, 1, "Centroids", "_Centroids", "Centroids", NULL, G_CALLBACK(on_centroids), NULL, -2, 1, 0}, 
{0, 1, "Info", "_Info", "Info", NULL, NULL, NULL, -2, 1, 0}, 
{1, 1, "Structure", "Structure", "Structure Info", "infostru", G_CALLBACK(StructureInfo), NULL, -2, 1, 0}, 
{1, 1, "List of Atoms", "List of Atoms", "List of Atoms", "numtab", G_CALLBACK(ListAtoms), NULL, -2, 1, 0}, 
{1, 1, "List of Bonds", "List of Bonds", "List of Bonds", "bonddist", G_CALLBACK(ListConn), NULL, -2, 1, 0}, 
{1, 1, "List of Bonds Angles", "List of Bonds Angles", "List of Bonds Angles", "angles", G_CALLBACK(ListAng), NULL, -2, 1, 0}, 
{1, 1, "List of Torsion Angles", "List of Torsion Angles", "List of Torsion Angles", "tangles", G_CALLBACK(ListTors), NULL, -2, 1, 0}, 
{1, 1, "Bar Chart", "Bar Chart", "View Intensities histogram", "barchart", G_CALLBACK(ViewIntensitiesHistogram), NULL, -2, 1, 0}, 
{1, 1, "List of Contacts", "List of Contacts", "List of hydrogen bonds and/or short contacts", "contacts", G_CALLBACK(ListContacts), NULL, -2, 1, 0}, 
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
{1, 1, "Info on map(s)", "Info on map(s)", "View info on map(s) ", "mapinfo", G_CALLBACK(PrintMapInfo), NULL, -2, 1, 0},
#endif
{1, 4},
{1, 1, "Geometry", "_Geometry", "Geometric calculations", "geometry", G_CALLBACK(CalcoliGeometrici), NULL, -2, 1, 0}, 
#ifndef JAV
{1, 1, "Sphere", "_Sphere", "Compute distances around a atom in a spherical volume.", "dist_sfe", G_CALLBACK(on_Sphere), NULL, -2, 1, 0}, 
#else
{0, 1, "Legend", "_Legend", "Manage Legend", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "Add Legend", "Add Legend", "Add Legend", "edit_legend", G_CALLBACK(AddLegend), NULL, -2, 1, 0},
{1, 1, "Delete Legend(s)", "Delete Legend(s)", "Delete Legend(s)", "cancel", G_CALLBACK(DeleteLegend), NULL, -2, 1, 0},
{1, 3, "Show Legend(s)", "Show Legend(s)", "Show Legend(s)", "legenda", G_CALLBACK(ShowHideLegend), NULL, -2, 1, 0},
{0, 1, "Help", "_Help", "Help", NULL, NULL, NULL, -2, 1, 0},
{1, 1, "Content", "_Content", "Help on Content", "help_content", G_CALLBACK(on_Help), NULL, -2, 1, 0},
{1, 1, "Keyboard & Mouse", "_Keyboard & Mouse", "Help on Keyboard and mouse", "keymouse2", G_CALLBACK(open_khelp_jav), NULL, -2, 1, 0},
{1, 1, "Command line options", "Command line _options", "Commad line options", "terminal", G_CALLBACK(open_chelp), NULL, -2, 1, 0},
{1, 1, "About", "_About", "About jav", "ilmabout", G_CALLBACK(open_about_jav), NULL, -2, 1, 0},
{1, 1, "Rendering info", "_Rendering info", "About jav", NULL, G_CALLBACK(about_render), NULL, -2, 1, 0}
#endif
};
static guint n_menu_entries = G_N_ELEMENTS (menu_entries);

static mr_action_entry vtb_entries[] = {
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
{0, 1, "Click", "Click", "Select new center", "mirino", G_CALLBACK(on_clickselect), NULL, -2, 1, 0},
#endif
{0, 3, "SelectOn", "SelectOn", "Selection Mode", "selecton", G_CALLBACK(PointerMode), NULL, 0, 1, 0}, 
{0, -3, "RectSelect", "RectSelect", "Selection Mode", "selecton", G_CALLBACK(PointerMode), NULL, 1, 1, 0},
{0, -3, "MolSelect", "MolSelect", "Selection Mode", "selecton", G_CALLBACK(PointerMode), NULL, 2, 1, 0},
{0, 3, "ManipulationOn", "ManipulationOn", "Manipulation Mode", "selectoff", G_CALLBACK(PointerMode), NULL, 3, 1, 1},
{0, 3, "ZoomOn", "ZoomOn", "Zoom Mode", "preview22", G_CALLBACK(PointerMode), NULL, 4, 1, 0},
{0, 3, "MeasureD", "MeasureD", "Distances", "distances", G_CALLBACK(PointerMode), NULL, 5, 1, 0},
{0, 3, "MeasureA", "MeasureA", "Angles", "angles", G_CALLBACK(PointerMode), NULL, 6, 1, 0},
{0, 3, "MeasureT", "MeasureT", "Torsion Angles", "tangles", G_CALLBACK(PointerMode), NULL, 7, 1, 0},
#ifdef JAV
{0, 6, "Sigma", "Sigma", "Change value of sigma", NULL, G_CALLBACK(on_sigma), NULL, -2, 1, 0},
{0, 6, "Clip", "Clip", "Change value of clip", NULL, G_CALLBACK(on_clip), NULL, -2, 1, 0},
#elif (defined(MAPS) && defined(SIR_PGM)) 
{0, 6, "Sigma", "Sigma", "Change value of sigma", NULL, G_CALLBACK(on_sigma), NULL, -2, 1, 0},
#endif
};
static guint n_vtb_entries = G_N_ELEMENTS (vtb_entries);

static mr_action_entry tb_entries[] = {
#ifdef JAV
{0, 1, "Quit", "Quit", "Exit", "quit", G_CALLBACK(on_Quit), NULL, -2, 1, 0}, 
#endif
{0, 3, "CellOn", "CellOn", "Cell On/Off", "cellon", G_CALLBACK(on_togglecell), NULL, -2, 1, 0}, 
{0, 3, "LabelsOn", "LabelsOn", "Labels On/Off", "labon", G_CALLBACK(on_togglelabels), NULL, -2, 1, 0}, 
{0, 3, "SymmOn", "SymmOn", "Symmetry On/Off", "symmon", G_CALLBACK(on_togglesymm), NULL, -2, 1, 0}, 
{0, 1, "ResetScale", "Reset Scale", "Reset Scale ", "zoom_normal", G_CALLBACK(on_ResetScale), "End", -2, 1, 0}, 
{0, 1, "ResetView", "Reset", "Reset view ", RESET_PNG, G_CALLBACK(on_ResetView), NULL, -2, 1, 0}, 
{0, 1, "Clear Measurements", "Clear Measurements", "Clear distances, angles and torsion angles ", "eraser", G_CALLBACK(on_ClearExtra), NULL, -2, 1, 0}, 
#ifdef JAV
{0, 1, "rx+", "rx+", "Rotate around X(+)", "x+", G_CALLBACK(on_Xplus), NULL, -2, 1, 0},
{0, 1, "rx-", "rx-", "Rotate around X(-)", "x-", G_CALLBACK(on_Xminus), NULL, -2, 1, 0},
{0, 1, "ry+", "ry+", "Rotate around Y(+)", "y+", G_CALLBACK(on_Yplus), NULL, -2, 1, 0},
{0, 1, "ry-", "ry-", "Rotate around Y(-)", "y-", G_CALLBACK(on_Yminus), NULL, -2, 1, 0},
{0, 1, "rz+", "rz+", "Rotate around Z(+)", "z+", G_CALLBACK(on_Zplus), NULL, -2, 1, 0},
{0, 1, "rz-", "rz-", "Rotate around Z(-)", "z-", G_CALLBACK(on_Zminus), NULL, -2, 1, 0},
{0, 1, "xc+", "xc+", "Centre Translation along X+", "xc+", G_CALLBACK(on_movecxplus), NULL, -2, 1, 0},
{0, 1, "xc-", "xc-", "Centre Translation along X-", "xc-", G_CALLBACK(on_movecxminus), NULL, -2, 1, 0},
{0, 1, "yc+", "yc+", "Centre Translation along Y+", "yc+", G_CALLBACK(on_movecyplus), NULL, -2, 1, 0},
{0, 1, "yc-", "yc-", "Centre Translation along Y-", "yc-", G_CALLBACK(on_movecyminus), NULL, -2, 1, 0},
{0, 1, "zc+", "zc+", "Centre Translation along Z+", "zc+", G_CALLBACK(on_moveczplus), NULL, -2, 1, 0},
{0, 1, "zc-", "zc-", "Centre Translation along Z-", "zc-", G_CALLBACK(on_moveczminus), NULL, -2, 1, 0}
#endif
};
static guint n_tb_entries = G_N_ELEMENTS (tb_entries);

#ifdef USE_ACTIONS

static const gchar *menu_info =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='File'>"
#ifdef JAV
"      <menuitem action='Open'/>"
"      <separator />"
"      <menuitem action='Export Structure'/>"
//"      <menuitem action='View Log'/>"
#if 0
"      <menu action='Load Examples'>"
"         <menuitem action='Small molecule'/>"
"         <menuitem action='Macro molecule'/>"
"       </menu>"
#ifndef NDEBUG
"      <menuitem action='Import Example'/>"
"      <menuitem action='Export Example'/>"
#endif
#endif
"      <separator />"
"      <menuitem action='Last Run'/>"
"      <menuitem action='Save Run'/>"
"      <menuitem action='Load Old Run'/>"
#else
"      <menuitem action='Import Structure'/>"
"      <menu action='Import Fragment'>"
"         <menuitem action='ImportTetra'/>"
"         <menuitem action='ImportOcta'/>"
"         <menuitem action='ImportSqP'/>"
"         <menuitem action='ImportIsoAt'/>"
"      </menu>"
"      <separator />"
"      <menuitem action='Export Structure'/>"
#endif
"      <separator/>"
"      <menuitem action='Screenshot'/>"
"      <separator/>"
"      <menuitem action='Export scene'/>"
#ifdef JAV
"      <menuitem action='Import STL'/>"
#endif
"      <separator/>"
#ifdef JAV
"      <menuitem action='Remove'/>"
"      <separator/>"
#endif
"      <menuitem action='Exit'/>"
"    </menu>"
"    <menu name='Modify' action='Modify'>"
"      <menuitem action='Undo'/>"
"      <menuitem action='Redo'/>"
"      <separator/>"
"      <menuitem action='Delete Selection'/>"
"      <menuitem action='Delete Bonds'/>"
"      <placeholder name='Delete All Type ...'/>"
"      <menuitem action='Delete Duplicate Atoms'/>"
"      <separator/>"
"      <placeholder name='Change Species'/>"
"      <menuitem action='Rename'/>"
"      <menuitem action='Renumber'/>"
"      <menuitem action='Sort by Species'/>"
"      <menuitem action='Add Bonds'/>"
"      <separator/>"
//"      <menuitem action='Edit structure'/>"
"      <menu action='Properties'>"
"         <menuitem action='Atom Properties'/>"
"         <menuitem action='Bond Properties'/>"
"         <menuitem action='Angle Properties'/>"
"         <menuitem action='Torsion Properties'/>"
"      </menu>"
#ifndef JAV
"      <separator/>"
"      <menu action='Add fragments'>"
"         <menuitem action='From File'/>"
"         <menuitem action='From SMILES'/>"
"         <menuitem action='Add Tetrahedron'/>"
"         <menuitem action='Add Octahedron'/>"
"         <menuitem action='Add Square Plane'/>"
"         <menuitem action='Add Isolated Atoms'/>"
"         <menuitem action='Duplicate All'/>"
"         <menuitem action='Duplicate Selected Atoms'/>"
"      </menu>"
#endif
"      <separator/>"
"      <placeholder name='Add Atom'/>"
"    </menu>"
"    <menu action='Select'>"
"      <menu action='Selection Mode'>"
"        <menuitem action='Atom'/>"
"        <menuitem action='Rectangular'/>"
"        <menuitem action='Molecule'/>"
"      </menu>"
"      <menuitem action='Zoom Mode'/>"
"      <menuitem action='Manipulation Mode'/>"
"      <separator/>"
"      <menuitem action='Select All'/>"
"      <menuitem action='Select None'/>"
"      <menuitem action='Invert selection'/>"
"      <placeholder name='Select Type ...'/>"
"      <menuitem action='Expand to molecule'/>"
"    </menu>"
"    <menu action='ViewMenu'>"
"      <menuitem action='Preferences'/>"
#ifdef JAV
"      <menuitem action='Colours Preferences'/>"
#endif
#if defined(SIR_PGM) || defined(JAV)
"      <menuitem action='Go to atom'/>"
#endif
"      <separator/>"
"      <menu action='Symmetry'>"
"         <menuitem action='Packing'/>"
"         <menuitem action='Expand'/>"
"         <menuitem action='Reduce'/>"
"         <menuitem action='View Cell Edges'/>"
"         <menuitem action='Grow Fragment'/>"
"         <menuitem action='Assemble'/>"
"         <menuitem action='Move Atoms'/>"
"      </menu>"
"      <menu action='Zoom'>"
"         <menuitem action='Zoom in'/>"
"         <menuitem action='Zoom out'/>"
"         <menuitem action='Reset Scale'/>"
"         <menuitem action='Reset View'/>"
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
"         <menuitem action='Center on map'/>"
#endif
"      </menu>"
"      <menu action='Rotate'>"
"         <menuitem action='Around X+'/>"
"         <menuitem action='Around X-'/>"
"         <menuitem action='Around Y+'/>"
"         <menuitem action='Around Y-'/>"
"         <menuitem action='Around Z+'/>"
"         <menuitem action='Around Z-'/>"
"      </menu>"
"      <separator/>"
"      <menu action='Label'>"
"         <menuitem action='Label All Atoms'/>"
"         <menuitem action='Delete All Labels'/>"
"         <menuitem action='LabelNonH'/>"
"         <menuitem action='LabelHeavy'/>"
"      </menu>"
"      <menu action='Label Type'>"
"      <menuitem action='Atom name'/>"
"      <menuitem action='Atom species'/>"
"      <menuitem action='Atom number'/>"
"      </menu>"
"      <menu action='Show-Hide'>"
"         <menuitem action='Show All'/>"
"         <menuitem action='Hide Selected'/>"
"         <menuitem action='Hide Unselected'/>"
"         <menuitem action='Hide Hydrogens'/>"
"      </menu>"
"      <separator/>"
#ifdef JAV
"      <menuitem action='Clear Measurements'/>"
"      <separator/>"
#endif
"      <menu action='View Plane'>"
"         <menuitem action='Normal to a'/>"
"         <menuitem action='Normal to b'/>"
"         <menuitem action='Normal to c'/>"
"         <menuitem action='Least Squares Plane'/>"
"         <menuitem action='Selected Atoms Plane'/>"
"      </menu>"
"      <menuitem action='Polyhedra'/>"
"      <menuitem action='Polyhedra Properties'/>"
"      <separator/>"
"      <menuitem action='ShowMB'/>"
"      <separator/>"
"      <menu action='Contacts'>"
"         <menuitem action='Short Contacts'/>"
"         <menuitem action='Hydrogen Bonds'/>"
"         <menuitem action='Delete Hanging Contacts'/>"
"         <menuitem action='Edit H-Bonds'/>"
"      </menu>"
#if !defined(JAV) && !defined(SIR_PGM)
"      <separator/>"
"      <menu action='Display Fourier maps'>"
"         <menuitem action='Show Fourier Map'/>"
"         <menuitem action='Compute Fo'/>"
"         <menuitem action='Compute 2Fo - Fc'/>"
"         <menuitem action='Compute Fo-Fc'/>"
"         <menuitem action='Compute Fc'/>"
"      </menu>"
#endif
#ifdef JAV
"      <menu action='Sequence'>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Show Toolbars'/>"
#endif
"    </menu>"
#ifdef JAV
"    <menu action='Legend'>"
"      <menuitem action='Add Legend'/>"
"      <menuitem action='Delete Legend(s)'/>"
"      <menuitem action='Show Legend(s)'/>"
"      <menuitem action='About'/>"
"    </menu>"
#endif
"    <menu action='Tools'>"
"      <menu action='Add Hydrogens'>"
"      <menuitem action='Automatic'/>"
"      <menuitem action='Methine C-H'/>"
"      <menuitem action='Methylene Group'/>"
"      <menuitem action='Methyl Group'/>"
"      <menuitem action='Aromatic C-H'/>"
"      <menuitem action='Hydroxyl O-H'/>"
"      <menuitem action='Terminal X=CH2'/>"
"      <menuitem action='Terminal B-H'/>"
"      <menuitem action='Acetylenic C-H'/>"
"      <separator/>"
"      <menuitem action='Normalise Hydrogens'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Build Bonds'/>"
"      <menuitem action='Bond Settings'/>"
"      <separator/>"
"      <menuitem action='Complete'/>"
"      <menuitem action='Regularize'/>"
"      <menuitem action='Enantiomorph'/>"
"      <menuitem action='Transform'/>"
"      <menu action='Optimize Geometry'>"
"      <menuitem action='Optimize'/>"
"      <menuitem action='Optimize Selected Atoms'/>"
"      </menu>"
#ifndef JAV
"      <separator/>"
"      <menuitem action='Overlay Structures'/>"
"      <menuitem action='Overlay Info'/>"
"      <placeholder name='Delete Model'/>"
#endif
"      <separator/>"
"      <menuitem action='Centroids'/>"
"    </menu>"
"    <menu action='Info'>"
"      <menuitem action='Structure'/>"
"      <menuitem action='List of Atoms'/>"
"      <menuitem action='List of Bonds'/>"
"      <menuitem action='List of Bonds Angles'/>"
"      <menuitem action='List of Torsion Angles'/>"
"      <menuitem action='List of Contacts'/>"
"      <menuitem action='Bar Chart'/>"
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
"      <menuitem action='Info on map(s)'/>"
#endif
"      <separator/>"
"      <menuitem action='Geometry'/>"
#ifndef JAV
"      <menuitem action='Sphere'/>"
#endif
"    </menu>"
#ifdef JAV
"    <menu action='Help'>"
"      <menuitem action='Content'/>"
"      <menuitem action='Keyboard &amp; Mouse'/>"
"      <menuitem action='Command line options'/>"
"      <menuitem action='About'/>"
"      <menuitem action='Rendering info'/>"
"    </menu>"
#endif
"  </menubar>"
"</ui>";
static const gchar *vtb_info =
"<ui>"
"  <toolbar name='VToolBar'>"
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
"    <toolitem action='Click'/>"
#endif
"    <toolitem action='SelectOn'/>"
"    <toolitem action='RectSelect'/>"
"    <toolitem action='ManipulationOn'/>"
"    <toolitem action='ZoomOn'/>"
"    <toolitem action='MeasureD'/>"
"    <toolitem action='MeasureA'/>"
"    <toolitem action='MeasureT'/>"
#if (defined(MAPS) && defined(SIR_PGM)) || defined(JAV)
"    <toolitem action='Sigma'/>"
#endif
#ifdef JAV
"    <toolitem action='Clip'/>"
#endif
"  </toolbar>"
"</ui>";
static const gchar *tb_info =
"<ui>"
"  <toolbar name='HToolBar'>"
#ifdef JAV
"    <toolitem action='Quit'/>"
"    <toolitem action='CellOn'/>"
#else
"    <toolitem action='View Cell Edges'/>"
#endif
"    <toolitem action='LabelsOn'/>"
"    <toolitem action='SymmOn'/>"
#ifdef JAV
"    <toolitem action='Zoom in'/>"
"    <toolitem action='Zoom out'/>"
#endif
"    <toolitem action='Reset Scale'/>"
"    <toolitem action='Reset View'/>"
"    <toolitem action='Clear Measurements'/>"
#ifdef JAV
"    <toolitem action='rx+'/>"
"    <toolitem action='rx-'/>"
"    <toolitem action='ry+'/>"
"    <toolitem action='ry-'/>"
"    <toolitem action='rz+'/>"
"    <toolitem action='rz-'/>"
"    <toolitem action='xc+'/>"
"    <toolitem action='xc-'/>"
"    <toolitem action='yc+'/>"
"    <toolitem action='yc-'/>"
"    <toolitem action='zc+'/>"
"    <toolitem action='zc-'/>"
#endif
"  </toolbar>"
"</ui>";
#endif
