!-----------------------------------------------------------------------
      subroutine EDMdritan(nfree, numBox)


      USE General
      USE Riflessi
      Use Grafici
c     USE Molcom
      USE Param
      USE CowMod
      USE PhaseModule, only : kverboCow

      !
      Use Mappa
      Use MapTest
c     USE StrLogModule
c     USE PlotsData

c     character (len=80)    :: strHead(3),strTitleContour
c     character (len=200)   :: strLogMa4,strTemp
      character (len=200)   :: strLog
      character (len=200)   :: strMaps
c     character (len=200)   :: strTime
c     character (len=200)   :: strBoxTitle
      common /RiduzioneSigmaA/ emmeOld, emmeNew
      common/conue/shi(4),ishi,shi1(4)
!!    common/super4/ncycl4(100),percc4(100),nmaMa4  spostato in MODULE CowMod
      character*80 tirang
      logical convRRfree,convRfree,freerstat,freestat

      integer*8            :: FORTHini, BACKini 
      real, allocatable  ::xinit(:,:,:)
!
      emmeOld = -9999
      emmeNew = 0
!
      if (numBox > 0) then
          Inte = 'Final EDM recycling  '
          call scrper(Inte,0,0)
      endif
!

      convRRfree = .False.
      convRfree = .False.

      IF (.NOT. ALLOCATED(xinit))
     *   ALLOCATE (xinit(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierr)

      xinit(:,:,:)=0.0
      FORTHini = 0
      BACKini = 0 

      wtt_o(:)=wt(:)
      iphi2_o(:)=iphaz(:)

      call prepeqv

      rf1=1.0
      rf2=1.0
      ! backup starting set 
      pesi(:)=wtd(:)
      ifasi(:)=iphad(:)

      !--check number of reflextion to be extended
      nref_phased=count(wt(1:nrefl) > 0.0)
      nref_nophased=nrefl - nref_phased
      ncycle_ext=nint(nref_nophased/1000.)
      nref_unobs=count(inobs(:) > 0)
      nref_nophased_obs=nref_nophased - nref_unobs

      if (QualePgm == SIRPROTPGM) then
        write(lo,'(//,29h  Nr. of phased reflections: ,i6 )')nref_phased
        write(lo,'(35h  Nr. of reflections to be phased: ,i6)')
     *             nref_nophased
        write(ktml,'(29h  Nr. of phased reflections: ,i6 )')nref_phased
        write(ktml,'(35h  Nr. of reflections to be phased: ,i6)')
     *             nref_nophased
      endif


      npunti=np(1)*np(2)*np(3)
      npts=nint(npunti*v_p)

      nprima=1

      rhomax_obs=maxval(rhov(1:nrefl))
     
      ! set valore iniziale per Real-Rfree
      realfree=1.0e6
      if (ifreem == 0) realfree = 0.0
      rfree = 0.0
      if (ifree == 1) then
        rfree = 1.0e6
        free1(1:nrefl) = fovet(1:nrefl) 
      endif

      nmacro=0

 200  nmacro=nmacro+1

      if (nmacro > 1) then
       fovet_mod(:)=fovet(:)
      endif

      if (QualePgm == SIRPROTPGM) then
         write(lo,'(//,2x,a10,1x,i2,1h/,i2)')'MACROCYCLE', nmacro,nmaMa4
         write(ktml,'(/,1x,13h MacroCycle: ,i2,1h/,i2,/)')nmacro,nmaMa4
      endif

      nmiMa=ncycl4(nmacro)
!
      nmicro=0
      Rsir=0.0
      realfreeR2=0.0
      realfreeR4=0.0
      
 300  nmicro=nmicro+1

      Rsir_p=Rsir

 400  continue
      if (ifree > 0) then
         ! selezionare i riflessi per Rfree
         call setfree
         ncf=1
         ncfree=1
         nfree=nfree+1
         call setfreer(ncf,ncfree,nfree)
         do i=1,nrefl
           if (jinc1(i).le.0.0) wt(i)=0.0
         enddo
      endif


      fcoef(:)=wt(:)*fovet_mod(:)

c     FORTH = 0
      call MakeMap(fcoef,iphaz,nrefl,0,xmap,FORTH,BACK)
      call zflush
      call DoSingleIteration()
c     call elimHeavy(elimhe,xmap,ier)
c     if (elimhe > 0) call flatmap(xmap,xmapDif,-3,0.0) ! con mask dall'atomo pesante


      icycl=nmicro

      rmax=0.5/sqrt(rhomax_obs)
      rnrflc=100 + numres(rmax)
      wangmd=131.0
      wangrd=-2.0
      iwp=int(wangmd/100) + 1
      sw=sum(wt(1:nrefl)**iwp)
      Renve=abs(wangrd)*(rnrflc/sw)**0.33*rmax
      Renve=min(Renve,10.0)
      !
      smax=rhomax_obs*4.0

      
      f000_old=f000
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
      call PreMaskSirProt(0,v_p,xenve,FORTHenv,BACKenv)
      call Map2EnveMask(0,smax,v_p,xenve,FORTHenv,BACKenv)
      if (knw > 0) then
        call PreMaskSirProt(1,v_p,xenveT,FORTHenv,BACKenv)
        call Map2EnveMask(1,smax,v_p,xenveT,FORTHenv,BACKenv)
        call mapcorr(xenve,xenveT,corrE)
      endif
      f000=f000_old

      call zflush
      call DoSingleIteration()


       if (knw > 0 .and. kverboCow > 0) then
        strMaps='Mappa oss.'
        call rhostats(xmap,xenve,strMaps)
      endif

      if (ifreem > 0) then
        ! calc rR-free from free-mask (spheres)
        ! put spheres
        call zflush
        call DoSingleIteration()
        call getfreemask(xenve,xinit,np(1),np(2),np(3))
        call zflush
        call DoSingleIteration()
        ! calc. rRfree
        convRRfree=freerstat(xmap,xinit,xenve,rmax,realfree)
        call zflush
        call DoSingleIteration()
      endif
!
      if (ifDsrVLD > 0) then
          ncicliconv = 5
          if (nCallEdm > 1) then
             ncicliconv = 3
             ncicliconv = 5     ! Gianluca 19 dicembre 2013
             ifconv = 4
          else
             ifconv = 1
          endif 
          nmicrox = 15
*            ncicliconv = 5
*            ifconv = 1
      else 
          nmicrox = 10
      endif 
!
      select case (ifconv)
      case (0)
        !senza convergenza, si controlla solo dPHI
        if (nmicro > 2.and.errm12 < 2.0) goto 250
      case (1)
        !
        if (convRRfree) goto 250  ! raggiunto la convergenza
        if (nmicro > 2.and.(errm12 < 2.0.or.nmicro > nmicrox)) goto 250 ! quando Real-Rfree non ha funzionato(!) ! gianluca 04/05/2012
        if (ifDsrVLD > 0) then
            if (nmicro > 2 .and. emmeNew < emmeOld) goto 250 ! quando il valore di <m> diminuisce gianluca 04/05/2012
        endif
        if (knw > 0 .and. kverboCow == 1) then
            write(6,'(a,i4,2f10.3)') 
     *           '<m>Old <m>New ',nmicro, emmeOld, emmeNew
        endif
        emmeOld = emmeNew
      case (2)
        ! con Rfree 
        if (convRfree) goto 250  ! raggiunto la convergenza
      case (3)
        ! "convergenza" con dPHi con ciclo precedente
        if (nmicro > 2.and.errm12 < 2.0) goto 250
      case (4)
        ! stop dopo un numero di cicli definito
        if (nmicro>ncicliconv) goto 250
      end select
      call flatmap(xmap,xenve,iflat,0.0)
      call zflush
      call DoSingleIteration()
      if (nmacro==1) then
       if (ihism > 0) call HM_Flex(xmap,xenve)
       if (kverbo==4) then
         strMaps='Mappa oss. + DM'
         call rhostats(xmap,xenve,strMaps)
        endif
      endif
      call zflush
      call DoSingleIteration()
!
      if (jgamma==1.and.icomb==1.and.nmacro==1) then
       ! calc Fper(coef.random), Foper (coef.oss + Fper)
       ! backup pesi e fasi obs (serve in CalcGamma)
       iphi2_in(:)=iphaz(:)
       wtt_in(:)=wt(:)
       call ObsPerturbation
       ! mappa perturbata
       call MakeMap(foper,iphoper,nrefl,0,xinit,
     *                  FORTHini,BACKini)
c      call elimHeavy(elimhe,xinit,ier)
       if (kverbo==4) then
        strMaps='Mappa (obs+per.)'
        call rhostats(xinit,xenve,strMaps)
       endif
       ! modifica la mappa perturbata
       call flatmap(xinit,xenve,iflat,Xflip)
       if (ihism > 0) call HM_Flex(xinit,xenve)
       ! inv. la mappa pertub
       if (kverbo==4) then
        strMaps='Mappa (obs+per.)'
        call rhostats(xinit,xenve,strMaps)
       endif
c      write(lo,*)'inv. pert. map'
       call zflush
       call DoSingleIteration()
!!gpu  call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACKini)
       call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACKini,
     *                 xinit)
c      ! F ,PHi after the inv. of perturb map
       iphoper(:)=iphaz(:)
       foper(:)=fcvet(:)
      endif

      ! inv. la mappa corrente
      if (nmacro==1) then
!!gpu   call NewInv(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACK)
        call NewInvCuda(iphaz,fcvet,nrefl,np(1),np(2),np(3),BACK,xmap)
      else
        npts1=npts*percc4(nmacro)
        call denhist(1,xmap,xenve,npts1,0)
        call ChangeAndInvMap(xmap,xenve,1,0.0,0,ier)
      endif
     
      if (jgamma==1.and.icomb==1.and.nmacro==1) then
       ! applic. y-correction over fcvet, iphaz
        call CalcGamma(.false.)  
      endif

      if (ifree.eq.1) then
        do i=1, nrefl
         if (jinc1(i).lt.0) free2(i)=fcvet(i)
        enddo
      endif

      call zflush
      call DoSingleIteration()

      if (jsigmaa <=  3) then
       select case (ifExtra)
       case (-1)
          nreflSIGMAA1=nrefl-nrefExt
          nreflSIGMAA2=nrefl
       case (0)
          nreflSIGMAA1=nrefl
          nreflSIGMAA2=nrefl
       case (1)
          nreflSIGMAA1=nrefl
          nreflSIGMAA2=nreflTot
       end select 

       jPrintStat = 0
       if (knw > 0 .and. kverboCow > 0) jPrintStat = 1
       call sigmaAfromSirprot(sigmaAmed,jsigmaa,fovet_mod,sigmav,
     *  fovet_mod,mkang,rhov,epsv,
     *  fcvet,ipub,iphaz,wt,iphad,wtd,
     *  wvar,pesmod,Dluz,e1,e2,
     *  nreflDim,nreflSIGMAA1,nreflSIGMAA2,
     *  icomb,rf1,rf2,jPrintStat)

        !
        call calcFOMs(0)
      endif

      if (ifextref > 0.and. nmicro <=nmiMa) then
c       call ExtendReflections(nmicro,nmiMa,ifextref)
c       call ExtendReflections(nmicro,5,ifextref)
      endif

      if (knw > 0) then
          call esamin(khl,mkang,ipub,iphaz,
     *         nrefl,1,wtt1,wt,errm1,errmw1,nref1,shi)
          iwork1(1:nrefl) = iphaz(1:nrefl)
          izero = 0
          call ShiftPhases(iphaz,shi,izero,nrefl)
          fcoef(:)=fovet(:)*wt(:)
          call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                   FORTH,BACK)
          call mapcorr(xmap,xmapT,corr)
          call mapcorr(xmap,xmodel,corrM)
          iphaz(1:nrefl) = iwork1(1:nrefl)
      endif
      

      nrefPhased=count(wt(1:nrefl) > 0.0)
      pnoPhased=100.*(nrefl-nrefPhased)/float(nrefl)
      ! backup phases and weights corrent cycle
      wtt_o(:)=wt(:)
      iphi2_o(:)=iphaz(:)

      smax=rhomax_obs*4.0
      if (ifree.eq.1) convRfree = freestat(smax,rfree)

      call zflush
      call DoSingleIteration()

      nref1=count(wt(1:nrefl) >0.0)
      if (Rsir_p > 0.0) then
         perRsir=(Rsir-Rsir_p)/Rsir_p
         perRsir=perRsir*100.0
      else
         perRsir=100.0
      endif

      perRsir=min(100.,perRsir)
      perRsir=max(0.0,perRsir)
      
      if (knw > 0) then
        write(lo,3000)nmacro,nmicro,nref1,corr,corrM,corrE,errm1,errmw1,
     *                Rtot,rfree,realfree,errm12
      endif
        
!
      if (numBox > 0) then
          if (ifree.eq.1) then
             write(strLog,3001) nmicro, nmiMa, rfree, realfree, errm12
          else
             write(strLog,3002) nmicro, nmiMa, Rtot, realfree, errm12
          endif
          write(lo,'(a)') strLog(1:Lung(strLog))
          call TestoGR(strLog, -1, 2, numBox)
          inBoxGR(numBox) = inBoxGR(numBox) - 1
          nLinesGR = nLinesGR - 1
          call scrper(Inte,nmicro,nmiMa)
      endif

      nprima=0
      call toflush()

      if (nmicro.lt.nmiMa) goto 300

 250  continue

      if (nmacro.lt.nmaMa4) then
        ! quando ci sono piu' di 1 macrociclo
        iflat=1       ! uso di mask 100/50
        ifextref = 6  ! estendere in funzione di Epp (E2)
        ifconv=0      ! senza un criterio per fermare la procedura
c       ifreem=0      ! senza calcolare Rfree
c       realfree=0.0
        ! scelta riflessi per il MacroCiclo successivo (riflessi iniziali)
        do i=1,nrefl
         if (wtd(i) > 0.0) then
         else
          wt(i)=0.0
         endif
        enddo
        goto 200
      endif

      wtd(:)= wt(:)
      iphad(:)= iphaz(:)

      nCallEdm=nCallEdm+1

      deallocate(xinit, stat = ierr)
!
      if (numBox > 0) then
          inBoxGR(numBox) = inBoxGR(numBox) + 1
          nLinesGR = nLinesGR + 1
      endif
!
      return
c3000 format(2i3,1x,4hFOMs,1x,i6,15(1x,f8.3))
 3000 format(2i3,1x,4hFOMs,1x,i6,12(1x,f8.3))
 3100 format(2x,'Cycle:',i4,' (',i4,')',1x,i6,4(2x,f8.3))
 3001 format('      Cycle: ',i2,'/',i2,
     *        ' Rfree =',f6.3,' R-Rfree=',f6.3,' dphi=',f6.3)
 3002 format('      Cycle: ',i2,'/',i2,
     *        ' Rt=',f6.3,' R-Rfree=',f6.3,' dphi=',f6.3)
      end
!-----------------------------------------------------------------------
      subroutine calcmetric()
      USE General


c Calculate the orthonormal - crystallographic transform
c
      integer i,j,kve
      real a,b,c,alph,beta,gamm,sum,cosas,q123
c
!
!     kve = knw
      kve = 0
!
      do 10 j=1,4
      do 10 i=1,4
      qd(i,j)=0.0
      qt(i,j)=0.0
 10   continue
c
      a=cell(1)
      b=cell(2)
      c=cell(3)
      alph=dtor*cell(4)
      beta=dtor*cell(5)
      gamm=dtor*cell(6)
      sum=0.5*(alph+beta+gamm)
      vol=2.0*a*b*c*
     + sqrt(sin(sum)*sin(sum-alph)*sin(sum-beta)*sin(sum-gamm))
      cosas=(cos(beta)*cos(gamm)-cos(alph))/(sin(beta)*sin(gamm))
c orthogonalisation matrix
      qd(1,1)=a
      qd(1,2)=b*cos(gamm)
      qd(1,3)=c*cos(beta)
      qd(2,2)=b*sin(gamm)
      qd(2,3)=-c*sin(beta)*cosas
      qd(3,3)=c*sin(beta)*sqrt(1.0-cosas**2)
      qd(4,4)=1.0
c and its inverse
      q123=qd(1,1)*qd(2,2)*qd(3,3)
      qt(1,1)=1.0/qd(1,1)
      qt(1,2)=-qd(1,2)*qd(3,3)/q123
      qt(1,3)=(qd(1,2)*qd(2,3)-qd(2,2)*qd(1,3))/q123
      qt(2,2)=1.0/qd(2,2)
      qt(2,3)=-qd(1,1)*qd(2,3)/q123
      qt(3,3)=1.0/qd(3,3)
      qt(4,4)=1.0
c
c     write (lo,4)vol
c4    format (' Unit cell volume:',f10.1)
      if (kve == 1) then
          write (lo,*)'======================================'
          write (lo,1)((qd(i,j),j=1,3),(qt(i,j),j=1,3),i=1,3)
      endif
c Calculate real space metric tensor
      rlm11=qd(1,1)*qd(1,1)+qd(2,1)*qd(2,1)+qd(3,1)*qd(3,1)
      rlm12=2.0*(qd(1,1)*qd(1,2)+qd(2,1)*qd(2,2)+qd(3,1)*qd(3,2))
      rlm13=2.0*(qd(1,1)*qd(1,3)+qd(2,1)*qd(2,3)+qd(3,1)*qd(3,3))
      rlm22=qd(1,2)*qd(1,2)+qd(2,2)*qd(2,2)+qd(3,2)*qd(3,2)
      rlm23=2.0*(qd(1,2)*qd(1,3)+qd(2,2)*qd(2,3)+qd(3,2)*qd(3,3))
      rlm33=qd(1,3)*qd(1,3)+qd(2,3)*qd(2,3)+qd(3,3)*qd(3,3)
      if (kve == 1) then
          write (lo,2)rlm11,rlm22,rlm33,rlm12,rlm13,rlm23
      endif
c Calculate reciprocal space metric tensor
      rcm11=qt(1,1)*qt(1,1)+qt(1,2)*qt(1,2)+qt(1,3)*qt(1,3)
      rcm12=2.0*(qt(1,1)*qt(2,1)+qt(1,2)*qt(2,2)+qt(1,3)*qt(2,3))
      rcm13=2.0*(qt(1,1)*qt(3,1)+qt(1,2)*qt(3,2)+qt(1,3)*qt(3,3))
      rcm22=qt(2,1)*qt(2,1)+qt(2,2)*qt(2,2)+qt(2,3)*qt(2,3)
      rcm23=2.0*(qt(2,1)*qt(3,1)+qt(2,2)*qt(3,2)+qt(2,3)*qt(3,3))
      rcm33=qt(3,1)*qt(3,1)+qt(3,2)*qt(3,2)+qt(3,3)*qt(3,3)
      if (kve == 1) then
          write (lo,3)rcm11,rcm22,rcm33,rcm12,rcm13,rcm23
          write (lo,*)'======================================'
      endif
c
      return
 1    format (' CCP4 Orthogonalisation matrices:',3(/1x,3f8.3,8x,3f8.3))
 2    format (' CCP4 Real space metric tensor:      '/1x,6f9.1)
 3    format (' CCP4 Reciprocal space metric tensor:'/1x,6f9.6)
      end
!-----------------------------------------------------------------------
      subroutine ObsPerturbation
      USE General
      USE Riflessi

      real, allocatable   :: shellTAB(:,:),midpts(:),RES(:),
     *                       sw(:),sfo(:)

      integer,  allocatable   :: RES_TAG(:)


c     write(6,*)'--------------------'
c     write(6,*)'calc pert',nrefl
c     write(6,*)'--------------------'
      df=0.10


      Nbin=30
      Nstat=floor(nrefl/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefl,100))+0.5)
      allocate (RES_TAG(nrefl),shellTAB(Nbin,2),midpts(Nbin),
     *          RES(nrefl),
     *          sw(Nbin),sfo(Nbin), stat=ierr)

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      RES(1:nrefl)=sqrt(rhov(1:nrefl))
      call shells(shellTAB,midpts,RES_TAG,RES,nrefl,Nbin,1)

      sw(:)=0.0
      sfo(:)=0.0

      do i=1,nrefl
       ii=RES_TAG(i)
       eps=epsv(i)
       if (mkang(i)==1) then
        sw(ii)=sw(ii)+1.0
        sfo(ii)=sfo(ii)+fovet_mod(i)**2/eps
       endif
      enddo


      do i=1,Nbin
       sfo(i)=sfo(i)/max(sw(i),0.01)
      enddo

      iy=67543
      ix=iy

      do i=1,nrefl
       ii=RES_TAG(i)
       eps=epsv(i)
       if (mkang(i)==1) then
        fper(i)=df*sqrt(sfo(ii)*eps)
        call randu1(ix,iy,yfl)
        ix=iy
        iphper(i)=nint(yfl*360.0)
       else
        fper(i)=0.0
        iphper(i)=0
       endif
      enddo

      do i=1,nrefl
c      a0=wtd(i)*fop1_0(i)*cos(iphad(i)*dtor)
c      b0=wtd(i)*fop1_0(i)*sin(iphad(i)*dtor)
       a0=wt(i)*fovet_mod(i)*cos(iphaz(i)*dtor)
       b0=wt(i)*fovet_mod(i)*sin(iphaz(i)*dtor)
       a1=fper(i)*cos(iphper(i)*dtor)
       b1=fper(i)*sin(iphper(i)*dtor)
       aa=a0 + a1
       bb=b0 + b1
       args=aa**2 + bb**2
       if (args > 0.0) then
        fase=atan2(bb,aa)*rtod
        fase=mod(fase+3600.,360.)
        iphoper(i)=nint(fase)
        foper(i)=sqrt(aa**2 + bb**2)
       else
        iphoper(i)=0
        foper(i)=0.0
       endif
      enddo

      return
      end
!-----------------------------------------------------------------------
      subroutine CalcGamma(resdep)

      USE General
      USE Symmetry
      USE Riflessi

      logical resdep

      real, allocatable     :: shellTAB(:,:),midpts(:),
     *                       d11(:),d12(:),RES(:)
      integer,  allocatable   :: RES_TAG(:)


c     write(6,*)'--------------------'
c     write(6,*)'calc gamma'
c     write(6,*)'--------------------'


      Nbin=30
      Nstat=floor(nrefl/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefl,100))+0.5)

      allocate (RES_TAG(nrefl),shellTAB(Nbin,2),midpts(Nbin),
     *          RES(nrefl),
     *          d11(0:Nbin),d12(0:Nbin), stat=ierr)

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      RES(1:nrefl)=sqrt(rhov(1:nrefl))
      smax=maxval(RES(1:nrefl)) 

      if (resdep) then
       call shells(shellTAB,midpts,RES_TAG,RES,nrefl,Nbin,1)
       midpts(1:Nbin)=0.5/midpts(1:Nbin)
      else
       Nbin=1
       midpts(1)=0.5/smax
       RES_TAG(1:nrefl)=1
      endif


      d12(:)=0.0
      d11(:)=0.0

      do 200 i=1,nrefl
       eps=epsv(i)*pts
       if (mkang(i)==1) then
        ires=RES_TAG(i)
        a=fper(i)*cos(iphper(i)*dtor)
        b=fper(i)*sin(iphper(i)*dtor)
        a1=foper(i)*cos(iphoper(i)*dtor) - fcvet(i)*cos(iphaz(i)*dtor)
        b1=foper(i)*sin(iphoper(i)*dtor) - fcvet(i)*sin(iphaz(i)*dtor)
        d12(ires)=d12(ires)+a1*a+b1*b
        d11(ires)=d11(ires)+a*a+b*b
        d12(0)=d12(0)+a1*a+b1*b
        d11(0)=d11(0)+a*a+b*b
       endif
 200  continue

      do 300 i=1,nrefl
c      if (wtt_in(i) <=0.0) goto 300
       ires=RES_TAG(i)
       a1=fcvet(i)*cos(iphaz(i)*dtor)
       b1=fcvet(i)*sin(iphaz(i)*dtor)

       a0=wtt_in(i)*fovet_mod(i)*cos(iphi2_in(i)*dtor)
       b0=wtt_in(i)*fovet_mod(i)*sin(iphi2_in(i)*dtor)
c      a0=fop1_0(i)*cos(iphi2_in(i)*dtor)
c      b0=fop1_0(i)*sin(iphi2_in(i)*dtor)

       aa= a1 - d12(ires)/d11(ires) * a0
       bb= b1 - d12(ires)/d11(ires) * b0
       args=aa**2 + bb**2
       if (args > 0.0) then
        fase=atan2(bb,aa)*rtod
        fase=mod(fase+3600.,360.)
        iphaz(i)=nint(fase)
        fcvet(i)=sqrt(aa**2 + bb**2)
       else
        iphaz(i)=0
        fcvet(i)=0.0
       endif

 300  continue

      if (resdep) then
       write (lo,910)
       do i=1,Nbin
        write (lo,920)midpts(i),d12(i)/d11(i)
       enddo   
       write (lo,930)d12(0)/d11(0)
      else
       if (QualePgm == SIRPROTPGM) then
           write (lo,940)d12(1)/d11(1),midpts(1)
           write (ktml,950)d12(1)/d11(1),midpts(1)
       endif
      endif
 910  format(/'=============================',
     +       /,'    Res (A)       Gamma')
 920  format(4x,f8.2,4x,f8.4,
     *       /,'===========================')
 930  format('  Overall value ',f8.4,/)
 940  format(/,2x,'Gamma Correction =',f8.4,' (Res (A):',f8.2,')')
 950  format(7x,'Gamma Correction =',f8.4,' (Res (A):',f8.2,')')

      return
      end
!-----------------------------------------------------------------------
      subroutine calcFOMs(jflag)

      USE General
      USE Symmetry
      USE Mappa
      USE Riflessi
      USE PhaseModule
      USE Param

      common/conue/shi(4),ishi,shi1(4)
      dimension i1(3)
      real, allocatable :: eobs(:),ecalc(:),Psort(:)

      allocate(eobs(nrefl),ecalc(nrefl),Psort(nrefl),stat=ierr)


      if (jflag == 0) then
        work1(1:nrefl)=fovet(1:nrefl)
      else
        work1(1:nrefl)=evet(1:nrefl)
      endif

      sumfo=sum(work1(1:nrefl))
      sumfc=sum(fcvet(1:nrefl))
      scFoFc=(sumfo/sumfc)
      
      sumdif=0.0
      sumfoRid=0.0
      sumRid=0.0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0
      nrefRes=0
      errm12=0.0
      nref12=0
      do 15 i=1,nrefl
       if (wt(i) > 0.0 .and. wtt_o(i) > 0) then
         dif=iphaz(i)-iphi2_o(i)
         dif=cos(dif*dtor)
         dif=acos(dif)*rtod
         if (dif.gt.180.0) dif=360.0-dif
         errm12=errm12+dif
         nref12=nref12+1
       endif
       if (wt(i).le.0.0) goto 15
       fo=abs(work1(i))
       fc=abs(fcvet(i))
       sumdif=sumdif + abs(fo-fc*scFoFc)
       if (evet(i).gt.0.5) then
          sumfoRid=sumfoRid+fo
          sumRid=sumRid + abs( fo-fc*scFoFc )
       endif
       dres=0.5/sqrt(rhov(i))
       if (dres.gt.4.0) then
          vmedt=vmedt + fo
          vmedc=vmedc + fc*scFoFc
          vmedtc=vmedtc + fo * fc*scFoFc
          vmed2t=vmed2t + fo * fo
          vmed2c=vmed2c + fc*scFoFc * fc*scFoFc
          nrefRes=nrefRes+1
       endif

 15   continue

      if (nref12 > 0) errm12=errm12 /float(nref12)

      Rtot=sumdif/sumfo
      Rrid=sumRid/sumfoRid

      vmedt=vmedt/float(nrefRes)
      vmedc=vmedc/float(nrefRes)
      vmedtc=vmedtc/float(nrefRes)
      vmed2t=vmed2t/float(nrefRes)
      vmed2c=vmed2c/float(nrefRes)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corrFoFc=rnum/rden

      Psort(1:nrefl)=work1(1:nrefl)

      sumEo=sum(e1(1:nrefl))
      scEo=sumEo/float(nrefl)
      eobs(:)=e1(:)/scEo

      sumEc=sum(e2(1:nrefl))
      scEc=sumEc/float(nrefl)
      ecalc(:)=e2(:)/scEc

*     calcolo RAT
      call sortall(-1,Psort,nrefl)
      nrefRAT=0.80*(nrefl)
      sogRAT=Psort(nrefRAT)
      sumRc2=0.0
      sumRo2=0.0
      sumw2=0.0
      sumRo4=0.0
      sumw4=0.0
      sumRo2w2=0.0
      nrefObs=0
      nrefCalc=0

      vmedt_f=0.0
      vmedc_f=0.0
      vmedtc_f=0.0
      vmed2t_f=0.0
      vmed2c_f=0.0
      nref_f=0

      vmedt_d=0.0
      vmedc_d=0.0
      vmedtc_d=0.0
      vmed2t_d=0.0
      vmed2c_d=0.0
      nref_d=0

      do i=1,nrefl
        if (work1(i).lt.sogRAT) then
         ! deboli
         nrefCalc=nrefcalc+1
         sumRc2=sumRc2+ecalc(i)**2

         vmedt_d=vmedt_d + eobs(i)
         vmedc_d=vmedc_d + ecalc(i)
         vmedtc_d=vmedtc_d + eobs(i) * ecalc(i)
         vmed2t_d=vmed2t_d + eobs(i) * eobs(i)
         vmed2c_d=vmed2c_d + ecalc(i) * ecalc(i)
         nref_d=nref_d+1
        else
c        if (eobs(i).gt.0.1.and.eobs(i).lt.1.2) then
         if (evet(i).gt.0.1) then
          sumRo2=sumRo2+eobs(i)**2
          sumw2=sumw2+wt(i)**2
          sumRo4=sumRo4+eobs(i)**4
          sumw4=sumw4+wt(i)**4
          sumRo2w2=sumRo2w2+(eobs(i)**2) * (wt(i)**2)
          nrefObs=nrefObs+1
         endif
         !forti
         vmedt_f=vmedt_f + eobs(i)
         vmedc_f=vmedc_f + ecalc(i)
         vmedtc_f=vmedtc_f + eobs(i) * ecalc(i)
         vmed2t_f=vmed2t_f + eobs(i) * eobs(i)
         vmed2c_f=vmed2c_f + ecalc(i) * ecalc(i)
         nref_f=nref_f+1
        endif
      enddo

      vmedRc2=sumRc2/float(nrefCalc)
      vmedRo2=sumRo2/float(nrefObs)
      vmedw2=sumw2/float(nrefObs)
      vmedRo4=sumRo4/float(nrefObs)
      vmedw4=sumw4/float(nrefObs)
      vmedRo2w2=sumRo2w2/float(nrefObs)
      CC1=vmedRo2w2-(vmedRo2*vmedw2)
      CC2= sqrt(vmedRo4-vmedRo2**2) * sqrt(vmedw4-vmedw2**2)
      CC=CC1/CC2
      RAT=CC/vmedRc2

      vmedt_f=vmedt_f/float(nref_f)
      vmedc_f=vmedc_f/float(nref_f)
      vmedtc_f=vmedtc_f/float(nref_f)
      vmed2t_f=vmed2t_f/float(nref_f)
      vmed2c_f=vmed2c_f/float(nref_f)

      vmedt_d=vmedt_d/float(nref_d)
      vmedc_d=vmedc_d/float(nref_d)
      vmedtc_d=vmedtc_d/float(nref_d)
      vmed2t_d=vmed2t_d/float(nref_d)
      vmed2c_d=vmed2c_d/float(nref_d)

      rnum=vmedtc_f - (vmedt_f*vmedc_f)
      rden=sqrt(vmed2t_f-vmedt_f**2) * sqrt(vmed2c_f-vmedc_f**2)
      corrForti=rnum/rden

      rnum=vmedtc_d - (vmedt_d*vmedc_d)
      rden=sqrt(vmed2t_d-vmedt_d**2) * sqrt(vmed2c_d-vmedc_d**2)
      corrDeboli=rnum/rden

      if (icycl==1) then
        corrDeboli1=corrDeboli
        corrForti1=corrForti
        RAT1=RAT
        RSir=0.0
      else
       Rsir=corrForti*RAT*(corrDeboli -corrDeboli1)
       Rsir=Rsir/(corrForti1*RAT1)
      endif
      ! calc. of cfom as for MAD phases
      cfom_FLEX=RAT*corrFoFc/Rtot

      deallocate(eobs,ecalc,Psort,stat=ierr)
      return
      end
!-----------------------------------------------------------------------
      ! sigmaA routine
      ! Dritan : 28/06/2005
c--------------------------------------
      ! input:
      ! jsigma=1  <E2Ec2>
      ! jsigma=2  R(E2Ec2)
      ! jsigma=3  <E2-Ec2>
      ! jsigma=4  nel caso di FreeLunch (jsigma = -4)
      ! jsigma=5,6  nel caso di Fourier differenza
      ! jsigma< 0  Ec instead of Fc
      ! Fo ,sigFo,--> observed data
      ! rho --> (sinT/l)^2
      ! eps
      ! Fop2 & iphi2 wtt --> calculated data  (wtt can be also 1.0)
      ! iphi --> true phase
      ! iphi2o &  wto --> observed phase/weigth for combination (icombPh=1)
      ! nrefl1 --> number of reflection (observed)
      ! nrefSi --> number of reflection (incluse non-observed)
      ! ndim --> dimension for all the arrays
      ! output:
      ! wvar , m(pesMod) and D (Dluz)
      !
      subroutine sigmaAfromSirprot(sigmaAmed, jflag,fop1,sigfo,eobs1,
     *    itype,rho,epsv,fop2,
     *    iphi1,iphi2,wtt,iphi2o,wto,
     *    wvar,pesMod,Dluz,Eop,Ecp,
     *    ndim,nrefl1,nrefSi,icombPh,rf1,rf2,iprint)


      USE General
      USE Symmetry
c
      common /RiduzioneSigmaA/ emmeOld, emmeNew
!
      dimension fop1(ndim),sigfo(ndim),eobs1(ndim),fop2(ndim),
     *          rho(ndim),epsv(ndim),itype(ndim),wtt(ndim)
      dimension iphi1(ndim),iphi2(ndim),iphi2o(ndim)
      dimension Dluz(ndim),wvar(ndim),Eop(ndim),Ecp(ndim)
      dimension pesMod(ndim),wto(ndim)
c     real sim,atanh,siminv


      character *200 strTime
      real,     allocatable   :: RES(:),midpts(:),Eobs(:),Emodi(:)
      real,     allocatable   :: ee(:),sigEobs(:),wtnew(:)
      integer,  allocatable   :: RES_TAG(:),iphinew(:)
      real,     allocatable   :: Eo2Shell(:),Ec2Shell(:),Eo2Ec2Shell(:)
      real,     allocatable   :: Eo4Shell(:),Ec4Shell(:)
      real,     allocatable   :: SIGnShell(:),SIGpShell(:),SIGqShell(:)
      real,     allocatable   :: EpsShell(:),scEo2Shell(:),scEc2Shell(:)
      real,     allocatable   :: SIGMAAShell(:),SIGMAAShellsave(:),
     *                           SIGMAAeShell(:),SIGMAAccShell(:),
     *                           SIGMAAShell_l(:),
     *                           xfit(:),yfit(:),eeShell(:)
      real,     allocatable   :: cosErrShell(:),FacGSIMShell(:),
     *                           cosErrEShell(:),
     *                           cosErroShell(:),cosErrcShell(:),
     *                           cosErr12Shell(:)
      integer,  allocatable   :: nWtnShell(:),nWtoShell(:),
     *                           nWtcShell(:),nWt12Shell(:)
      real,     allocatable   :: wtnewShell(:),DluzShell(:),sig(:),
     *                           DluzShell_l(:),numbShell(:)
      real,     allocatable   :: shellTAB(:,:),wttShell(:),
     *                           sumDiffShell(:),sumFoShell(:),
     *                           rfacShell(:),
     *                           gsimShell(:),wtoShell(:),wtcShell(:)
      real,     allocatable   :: EomEcShell(:),SIGMAAnShell(:)
      real*8,     allocatable   :: r(:),drds(:)
   
      allocate(RES(nrefSi),RES_TAG(nrefSi),Eobs(nrefSi),Emodi(nrefSi),
     *         ee(nrefSi),sigEobs(nrefSi),wtnew(nrefSi),iphinew(nrefSi),
     *         stat=ierr)

      ! x dritan
      kmad=0
      !

c     iprint=1
      jsigmaa=iabs(jflag)

      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=  sigmaA  routine',jflag,icombPh
        write(lo,*)'================================='
      endif

      sigAmed=0.0
      pesMod(:)=0.0
      Dluz(:)=0.0
      wvar(:)=0.0

      Eobs(:)=0.0
      Emodi(:)=0.0
      ee(:)=0.0
      sigEobs(:)=0.0
      wtnew(:)=0.0
      iphinew(:)=0

      RES(1:nrefSi)=sqrt(rho(1:nrefSi))

      Nbin=30
      Nstat=floor(nrefl1/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefl1,100))+0.5)
c

      allocate (Eo2Shell(Nbin),Ec2Shell(Nbin),Eo2Ec2Shell(Nbin),
     *         Eo4Shell(Nbin),Ec4Shell(Nbin),
     *         SIGnShell(Nbin),SIGpShell(Nbin),SIGqShell(Nbin),
     *         EpsShell(Nbin),scEo2Shell(Nbin),scEc2Shell(Nbin),
     *         eeShell(Nbin),midpts(Nbin),SIGMAAShell(Nbin),
     *         SIGMAAShellsave(Nbin),SIGMAAccShell(Nbin),
     *         SIGMAAShell_l(Nbin),xfit(Nbin),yfit(Nbin),
     *         cosErrShell(Nbin),FacGSIMShell(Nbin),
     *         wtnewShell(Nbin),DluzShell(Nbin),DluzShell_l(Nbin),
     *         sig(Nbin),shellTAB(Nbin,2),numbShell(Nbin),
     *         wttShell(Nbin),wtoShell(Nbin),sumDiffShell(Nbin),
     *         sumFoShell(Nbin),rfacShell(Nbin),
     *         cosErrEShell(Nbin),cosErroShell(Nbin),
     *         cosErr12Shell(Nbin),cosErrcShell(Nbin),
     *         nWtnShell(Nbin),nWtoShell(Nbin),
     *         nWtcShell(Nbin),nWt12Shell(Nbin),
     *         gsimShell(Nbin),
     *         SIGMAAeShell(Nbin),wtcShell(Nbin), 
     *         EomEcShell(Nbin), SIGMAAnShell(Nbin),
     *         r(Nbin),drds(Nbin), 
     *         stat=ierr)
c
c

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      call shells(shellTAB,midpts,RES_TAG,RES,nrefl1,Nbin,1) 

      Eo2Shell(:)=0.0
      Ec2Shell(:)=0.0
      Eo4Shell(:)=0.0
      Ec4Shell(:)=0.0
      Eo2Ec2Shell(:)=0.0
      SIGqShell(:)=0.0
      eeShell(:)=0.0
      scEo2Shell(:)=1.0
      scEc2Shell(:)=1.0
      SIGMAAShell(:)=0.0
      SIGMAAccShell(:)=0.0
      SIGMAAShellsave(:)=0.0
      SIGMAAeShell(:)=0.0
      SIGMAAnShell(:)=0.0
      SIGMAAShell_l(:)=0.0
      DluzShell(:)=0.0
      DluzShell_l(:)=0.0
      cosErrShell(:)=0.0
      cosErroShell(:)=0.0
      cosErr12Shell(:)=0.0
      cosErrcShell(:)=0.0
      cosErrEShell(:)=0.0
      FacGSIMShell(:)=0.0
      nWtnShell(:) = 0
      nWtoShell(:) = 0
      nWtcShell(:) = 0
      nWt12Shell(:) = 0
      wtnewShell(:)=0.0
      wttShell(:)=0.0
      wtoShell(:)=0.0
      wtcShell(:)=0.0
      sumDiffShell(:)=0.0
      rfacShell(:)=0.0
      sumFoShell(:)=0.0
      gsimShell(:)=0.0
      EomEcShell(:)=0.0

      ! calc sihP, sigQ & sigN for any shell

      if (iprint==1) then
       write(lo,*)'Nr riflessi obs:',nrefl1
       write(lo,*)'Nr riflessi nobs:',nrefSi - nrefl1
       write(lo,*)'Nr riflessi con Fc >0:',count(fop2(1:nrefSi) > 0.0)
       if (jflag > 0) then
        write(lo,*)'Nr riflessi con Fo >0:',count(fop1(1:nrefl1) > 0.0)
       else
        write(lo,*)'Nr riflessi con Eo >0:',count(eobs1(1:nrefSi) > 0.0)
       endif
       write(lo,*)'Nr riflessi con wt >0:',count(wtt(1:nrefSi) > 0.0)
      endif
      if (jflag > 0) then
c       sumFo=sum(fop1(1:nrefl1))
        sumFo=sum(fop1(1:nrefl1)*fop2(1:nrefSi))
        sumFc=sum(fop2(1:nrefSi)**2)
      else
        sumFo=sum(eobs1(1:nrefl1))
c       sumFo=sum(eobs1(1:nrefl1)*fop2(1:nrefSi))
        sumFc=sum(fop2(1:nrefSi))
      endif
c
      if (kmad == 0) then
            scaleFoFc=sumFo/sumFc
      else
            scaleFoFc = 1.0
      endif

      if (iprint==1) then
        if (jflag > 0) then
          write(lo,*)'scale(Fo,Fc):',scaleFoFc
        else
          write(lo,*)'scale(Eo,Ec):',scaleFoFc
        endif
      endif
      if (jflag > 0) then
        sumFo=sum(fop1(1:nrefl1))
      else
        sumFo=sum(eobs1(1:nrefl1))
      endif
c
c--regolo dumpPartial
c
      dumpPartial = 1.0
      if(jflag==5) then
        rhomax_obs=maxval(rho(1:nrefl1))
        resol=0.5/sqrt(rhomax_obs)
        if(resol>1.2) then
          if(ivolta==1) then
            if(sigmaold<0.50) then
              dumpPartial = 1.1
              if(sigmaold<0.45) dumpPartial = 1.2
            endif
          elseif(ivolta>=2) then
            if(sigmaold<0.50) then
              dumpPartial = 1.1
              if(sigmaold<0.45) dumpPartial = 1.3
            endif
          endif
!--caso di molti atomi dummy nel modello arp/warp (1xyg)
          if(abs(ifDEDM)==2) then 
            if(sigPsigNOld>2.0) then 
              dumpPartial=1.3 
            endif
          endif
          if(iprint==1) then
            write(lo,*) 'dumpPartial A',dumpPartial,jflag,ivolta
          endif
        endif
      endif
c
      if (abs(ifDEDM) > 0) then
        if(sigPsigNOld<0.70) then
          dumpPartial = 1.1
          if(sigPsigNOld<0.60)  dumpPartial = 1.2
          if(sigPsigNOld<0.40)  dumpPartial = 1.3
        endif
        if(ivolta/=0.and.ivolta==nivolta.and.idritanD==0) 
     *          dumpPartial=dumpPartial+0.2 
c    *          dumpPartial=dumpPartial+0.3 
        if(iprint==1) then
          write(lo,*) 'dumpPartial B',dumpPartial,jflag,ivolta
        endif
      endif
c
      if (neutro == 1) dumpPartial =1.0
      SIGnShell(:)=0.0
      SIGpShell(:)=0.0
      numbShell(:)=0.0

      sumDiff=0.0
      do i=1,nrefl1
         ii=RES_TAG(i)
         eps=epsv(i)*pts
         wref=2.0
         if (itype(i) > 1) wref=1.0
         numbShell(ii)=numbShell(ii) + wref
         SIGnShell(ii)=SIGnShell(ii) + wref*((fop1(i)**2)/eps)
         if (jflag > 0) then
           SIGpShell(ii)=SIGpShell(ii) + 
     *          wref*((dumpPartial*fop2(i)**2)/eps)
           sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(fop1(i) - scaleFoFc *fop2(i))
           sumFoShell(ii)=sumFoShell(ii) + fop1(i)
           sumDiff=sumDiff  + abs(fop1(i) - scaleFoFc *fop2(i))
         else
           sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(eobs1(i) - scaleFoFc *fop2(i))
           sumFoShell(ii)=sumFoShell(ii) + eobs1(i)
           sumDiff=sumDiff  + abs(eobs1(i) - scaleFoFc *fop2(i))
         endif

      enddo

      do i=1,Nbin
        SIGpShell(i)=SIGpShell(i)/numbShell(i)
        SIGnShell(i)=SIGnShell(i)/numbShell(i)
      enddo

      !------------------------------
      do i=1,nrefl1
         ii=RES_TAG(i)
         eps=epsv(i)*pts
         if (jflag > 0) then
           Eobs(i)=fop1(i)/(sqrt(eps*SIGnShell(ii)))
           Emodi(i)=fop2(i)/(sqrt(eps*SIGpShell(ii)))
         else
           Eobs(i)=eobs1(i)
           Emodi(i)=fop2(i)
         endif
      enddo

      sumEo=sum(Eobs(1:nrefl1))
      sumEc=sum(Emodi(1:nrefl1))
      scaleEoEc=sumEo/sumEc
   
      if (iprint==1) then
        write(lo,*)'scale(Eo,Ec):',scaleEoEc
      endif

      sumDiffShell(:)=0.0
      sumFoShell(:)=0.0
      sumDiff=0.0
      do i=1,nrefl1
         ii=RES_TAG(i)
         sumDiffShell(ii)=sumDiffShell(ii)  + 
     *           abs(Eobs(i) - scaleEoEc *Emodi(i))
         sumFoShell(ii)=sumFoShell(ii) + Eobs(i)
         sumDiff=sumDiff  + abs(Eobs(i) - scaleEoEc *Emodi(i))
       enddo

       p1=-3.1334
       p2=0.9472
       p3=0.79443

       p1res=-0.12
       p2res=1.54
 
       do i=1, Nbin
        if (sumFoShell(i) > 0.0 ) then
         rfac=sumDiffShell(i)/sumFoShell(i)
         resLimit=0.5/midpts(i)
         resCorrection=1.0
         if (resLimit > 7.0) then
           resCorrection=0.7
         elseif (resLimit < 4.5) then
           resCorrection=1.0
         else
           resCorrection=p1res*resLimit + p2res
         endif
         rfac=rfac*resCorrection
         rfac=min(0.75,rfac)
c        rfac=min(0.55,rfac)
         rfacShell(i)=rfac

c        cosErrEShell(i)=p1*(rfac**2) + p2*rfac + p3 ! originale
         cosErrEShell(i)=1-rfac**2
c        cosErrEShell(i)=wtt(i) ! occhio
         cosErrEShell(i)=max(0.01,cosErrEShell(i))
c        write(6,*) 'ufi',rfac,cosErrEShell(i),rtod*acos(cosErrEShell(i))
        endif
       enddo

      sigPsigN=sum(SIGpShell(:))/sum(SIGnShell(:))
      if (iprint==1) then
        write(lo,*)' <sigN>',sum(SIGnShell(:))/float(Nbin)
        write(lo,*)' <sigP>',sum(SIGpShell(:))/float(Nbin)
        write(lo,*)' <sigP>/<sigN>',sigPsigN
      endif

      ! calc Eo, Ec
      do i=1,nrefl1
       ii=RES_TAG(i)
       eps=epsv(i)*pts
       if (wtt(i) > 0) then
         diffERR=(iphi2(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErrShell(ii)=cosErrShell(ii) + diffERR
       endif
       if (jflag > 0) then
         Eobs(i)=fop1(i)/(sqrt(eps*SIGnShell(ii)))
         Emodi(i)=fop2(i)/(sqrt(eps*SIGpShell(ii)))
       else
         Eobs(i)=eobs1(i)
         Emodi(i)=fop2(i)
       endif
       if (kmad == 0) then
         sigEobs(i)=sigfo(i)/(sqrt(eps*SIGnShell(ii)))
       else
         sigEobs(i)=sigfo(i)  !   per MAD i sigma sono sigma(E)
       endif
       ee(i)=1.0 + sigEobs(i)
       if (jsigmaa == 4) ee(i)=1.0 + (sigEobs(i))**2
       ee(i) = min(ee(i), 1.15) ! occhio da mettere per le piccole?
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+Eobs(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Emodi(i)**2
       Eo4Shell(ii)= Eo4Shell(ii)+Eobs(i)**4
       Ec4Shell(ii)= Ec4Shell(ii)+Emodi(i)**4
       Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + ((Eobs(i)**2)*(Emodi(i)**2))
       EomEcShell(ii)=EomEcShell(ii) + (Eobs(i)-Emodi(i))**2
      enddo

      if (iprint==1) then
        write(lo,*)'<Eo>',sum(Eobs(:))/float(nrefl1)
        write(lo,*)'<Ec>',sum(Emodi(:))/float(nrefl1)
        write(lo,*)'<sigE>',sum(sigEobs(:))/float(nrefl1)
      endif

      ! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell1)
        Eo4Shell(i)=Eo4Shell(i)/float(numbShell1)
        Ec4Shell(i)=Ec4Shell(i)/float(numbShell1)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell1)
        eeShell(i)=eeShell(i)/float(numbShell1)
        cosErrShell(i)=cosErrShell(i)/float(numbShell1)
        EomEcShell(i)=EomEcShell(i)/float(numbShell1)
      enddo

      if (iprint==1) then
        write(lo,*)'<e>o',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>o',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>o',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<(Eo-Ec)2>',sum(EomEcShell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>o',sum(Eo2Ec2Shell(:))/float(Nbin)
c       write(lo,*)'<cos(phi-pub>)',sum(cosErrShell(:))/float(Nbin)
        write(lo,*)'<dphi>',rtod*acos(sum(cosErrShell(:))/float(Nbin))
        write(lo,*)'R(Eo,Ec)',sumDiff/sumEo
      endif

      !scale <Eo2> , <Ec2>, <Eo2Ec2> and calc <sigmaA> for any shell
      scalaEE = 1.0
      if (jsigmaa == 4) scalaEE = eeShell(1)
      do i=1,Nbin
        eeShell(i)=eeShell(i)/scalaEE
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
        Eo4Shell(i)=Eo4Shell(i)/scEo2Shell(i)**2
        Ec4Shell(i)=Ec4Shell(i)/scEc2Shell(i)**2
      enddo

       ! gsim for any shell
      do i=1,nrefl1
        ii=RES_TAG(i)
        ee1=Eobs(i)/sqrt(scEo2Shell(ii))
        ee2=Emodi(i)/sqrt(scEc2Shell(ii))
        gsimShell(ii)=gsimShell(ii) + 2.*ee1*ee2
        aa=12.*sqrt(ee(i))/pi**2
        bb=4.-(pi*sqrt(ee(i)))
        SIGMAAn=aa*(bb -2.*EomEcShell(ii))
        if (SIGMAAn > 0.0) then
          SIGMAAnShell(ii)=SIGMAAnShell(ii) + sqrt(SIGMAAn)
        else
          SIGMAAnShell(ii)=0.0
        endif
      enddo

       do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
          SIGMAAnShell(i)=SIGMAAnShell(i)/float(numbShell1)
       enddo

       rSumSigmaan=sum(abs(SIGMAAnShell(1:Nbin)))

       if (rSumSigmaan > 0.0 ) then
         do ii=1,Nbin
          do i=1,Nbin
           if (SIGMAAnShell(i) < 0.0001) then
             if (i == Nbin) then
               SIGMAAnShell(i)=SIGMAAnShell(i-1)
             elseif (i == 1) then
               SIGMAAnShell(i)=SIGMAAnShell(i+1)
             else
               SIGMAAnShell(i)=0.5*(SIGMAAnShell(i-1) + 
     *              SIGMAAnShell(i+1))
             endif
           endif
          enddo
         enddo
        endif

      do i=1,Nbin
         numbShell1=count(RES_TAG(:) == i)
         gsimShell(i)=gsimShell(i)/float(numbShell1)
         gsimE=besinv(cosErrEShell(i))
         gsimE1=gsimShell(i)
         gg=gsimE1/gsimE
         det=gg**2 + 4.*eeShell(i)
         if (det > 0) then
          siga1=(-gg + sqrt(det))/2.0
          siga2=(-gg - sqrt(det))/2.0
          SIGMAAeShell(i)=siga1
         endif
      enddo
      rSumSigmaae=sum(abs(SIGMAAeShell(1:Nbin)))

      if (jsigmaa /=4) then
c      if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.1) eeShell(1:Nbin)=1.0
       if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.4) eeShell(1:Nbin)=1.0 ! occhio
       do ii=1,Nbin
        do i=1,Nbin
         dif=Eo2Ec2Shell(i) - eeShell(i)
         if (dif < 0.01) then
           if (i == Nbin) then
             Eo2Ec2Shell(i)=Eo2Ec2Shell(i-1)
           elseif (i == 1) then
             Eo2Ec2Shell(i)=Eo2Ec2Shell(i+1)
           else
             Eo2Ec2Shell(i)=0.5*(Eo2Ec2Shell(i-1) + 
     *              Eo2Ec2Shell(i+1))
           endif
         endif
        enddo
       enddo
      endif

      do i=1,Nbin
       if (Eo2Ec2Shell(i) > eeShell(i)) then
         SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-eeShell(i)))
       else
         if (Eo2Ec2Shell(i) > 1.0) then
            SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-1.0))
         else
           SIGMAAShell(i)=0.0
         endif
       endif
       SIGMAAShell(i)=max(0.05,SIGMAAShell(i))
c      write(6,*) 'uffa',i,Eo2Ec2Shell(i),eeShell(i),SIGMAAShell(i)
      enddo

      ! calcolo sigmaA dalla correlazione
      do i=1,Nbin
         numbShell1=count(RES_TAG(:) == i)
         sxy = Eo2Ec2Shell(i)*numbShell1
         sx = Eo2Shell(i)*numbShell1
         sy = Ec2Shell(i)*numbShell1
         sx2 = Eo4Shell(i)*numbShell1
         sy2 = Ec4Shell(i)*numbShell1
         
         sumnum = numbShell1*sxy-sx*sy
         if (sumnum > 0) then
           sumden = sqrt((numbShell1*sx2-sx**2)*(numbShell1*sy2-sy**2))
           SIGMAAccShell(i) = sqrt(sumnum/sumden)
         else
           if (iprint > 0) 
     *         write(lo,*)' CC(Eo2,Ec2) < 0.0 ==> sigmaA = 0.05'
           SIGMAAccShell(i) = 0.05
         endif
      enddo
      if (jsigmaa==1.and.ifDEDM==0) then
        if (sum(Eo2Ec2Shell(1:Nbin))/float(Nbin) < 1.2) then
         SIGMAAShell(1:Nbin) = SIGMAAccShell(1:Nbin)
         write(lo,*)' Cambiato con sigmaCC'
       endif
      endif
      !

      select case (jsigmaa)
      case (1)
       jsigmaaT=1
      case (2)
       if (rSumSigmaae > 0.0) then
         SIGMAAShell(1:Nbin)=SIGMAAeShell(1:Nbin)
         jsigmaaT=2
       else
         jsigmaaT=1
       endif
      case (3)
       if (rSumSigmaan > 0.0) then
         SIGMAAShell(1:Nbin)=SIGMAAnShell(1:Nbin)
         jsigmaaT=3
       else
         jsigmaaT=1
       endif
      case (4)
       jsigmaaT=4
      case (5)
       jsigmaaT=5
      case (6)
       jsigmaaT=6
      end select

      if (jsigmaa/=jsigmaaT) then
         write(lo,*) 'Cambiato da',jsigmaa,' a ',jsigmaaT
      endif

      jsigmaa=jsigmaaT
      
      rSumSigmaa=sum(abs(SIGMAAShell(1:Nbin)))
      averSig=rSumSigmaa/float(Nbin)

c     dmin=0.5/sqrt(rhomax) ! serviva solo per la DEDM sulle strutture ad alta
c                           ! risoluzione non ab initio
c     if(dmin<1.2) averSig=0.0
      if(iprint==1) write(lo,*) 'averSig',averSig

      if (rSumSigmaa < 0.0001) then
       write(lo,*) ' !!!!! errore sum(sigmaA)=0 '
       call cstop(' ')
      endif



      SIGMAAShellsave(1:Nbin) = SIGMAAShell(1:Nbin)


      if(jsigmaa.ne.6) then
      ! sigmaa refinement (max =10 cycle)
      irefCondition = 0
      if (jsigmaa==1.or.
     &         (jsigmaa==5.and.(averSig>0.9.or.
     &   sigPsigN>(1.2/dumpPartial).or.idritan==1))) then 
         SIGMAAShell_l(1:Nbin) = SIGMAAShell(1:Nbin)
         wttShell(:)= 0.0
         do 200 ilimit=1,3
          if(jsigmaa==1) then
            thres=0.001*(ilimit)
           else
            thres=0.1*(ilimit)
           endif
           if(iprint==1) then
             write(lo,*) 'threshold',ilimit,thres
           endif
           do 100 iref=1,10
            if (iprint > 0) write(lo,*)' Cycle:',iref
            r(:)=0.0d0
            drds(:)=0.0d0
            do i=1,nrefl1
             ii=RES_TAG(i)
             en=Eobs(i)
             ep=Emodi(i)
             if (en > 0.0.and.ep > 0.0) then
            x=2.0*en*ep*SIGMAAShell(ii)/(eeShell(ii)-SIGMAAShell(ii)**2)
             dxds=2.0*en*ep*(eeShell(ii)+SIGMAAShell(ii)**2)/
     *           (eeShell(ii)-SIGMAAShell(ii)**2)**2
             if (itype(i)==1) then
              rm=sim(x)
              rmbyx=0.5
              if (x.gt.0.001) rmbyx=rm/x
              r(ii)=r(ii)+2.0d0*dble(SIGMAAShell(ii)-rm*en*ep)
              drds(ii)=drds(ii)+
     +          2.0d0*dble(1.0-en*ep*(1.0-rmbyx-rm**2)*dxds)
             else
              rm=tanh(0.5*x)
              wttShell(ii)=wttShell(ii) + rm
              r(ii)=r(ii)+dble(SIGMAAShell(ii)-rm*en*ep)
              drds(ii)=drds(ii)+dble(1.0-en*ep*0.5*(1.0-rm**2)*dxds)
             endif
           endif
         enddo
       ! update sigmaA
         dsmax=0.0
         do i=1,Nbin
            numbShell1=count(RES_TAG(:) == i)
            if (numbShell1.gt.0) then
              ds=real(r(i)/drds(i))
              SIGMAAShell(i)=SIGMAAShell(i)-ds
              SIGMAAShell(i)=min(SIGMAAShell(i),0.999)
              if (iprint > 0) then
                write(lo,'(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f9.4))')
     *                 i,0.5/midpts(i),midpts(i),numbShell1,
     *                 SIGMAAShell_l(i),ds,SIGMAAShell(i),
     *                 wttShell(i)/numbShell1
              endif
              SIGMAAShell_l(i)=SIGMAAShell(i)
              dsmax=max(abs(ds),dsmax)
            endif
           enddo
           if (dsmax.lt.thres) then 
              irefCondition = 1
              goto 102
           endif
 100    continue
 200    continue
 102    continue

        if (iprint==1) then
          write(lo,*)'sigmaA Cycles:',iref,irefCondition
        endif
        if (irefCondition == 0) then 
          do i=1,Nbin
            SIGMAAShell(i) = SIGMAAShellsave(i)
          enddo
        endif
      endif
      endif
      if(jsigmaa==5) jsigmaa=1
c
      do i=1,Nbin
        SIGMAAShell(i)=min(SIGMAAShell(i),0.999) ! occhio
        SIGMAAShell(i)=max(SIGMAAShell(i),0.05)
      enddo

!giuliana
      nprova=0 
      sigma_med_orig=0
      sigma_med=0   
         scw=0.9 !può variare tra 0.8 e 1.0
         do i=1,Nbin
            sigma_med_orig=sigma_med_orig+SIGMAAShell(i)
c            SIGMAAShell(i) = scw*SIGMAAShell(i)/(1.+midpts(i))
            SIGMAAShell(i) = scw*SIGMAAShell(i)/(1.+midpts(i)**0.75)
            sigma_med=sigma_med+SIGMAAShell(i)
         enddo

        if(nprova==1)
     *    SIGMAAShell(:)=SIGMAAShell(:)* 0.9*sigma_med_orig/sigma_med

      ! linear fit per sigmaA

      mwt=0
      sig(:)=0.0
      nInit=1
      do i=1,Nbin
        if (midpts(i) > 0.9) then
         nInit=i
         exit
        endif
      enddo

c     print*,'nInit=',nInit

      nEnd=1
      NPT=Nbin - nInit + 1 - nEnd
      xfit(1:NPT)=midpts(nInit:Nbin-1)
      yfit(1:NPT)=SIGMAAShell(nInit:Nbin-1)

      call fit(xfit,yfit,NPT,sig,mwt,a,b,siga,sigb,chi2,q)

      if (iprint==1) then
      write(lo,*)'sigmaA linear fitting:'
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'A = ',a,'Uncertainty: ',
     *       siga
      write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'B = ',b,'Uncertainty: ',
     *       sigb
      write(lo,'(1x,t5,a,4x,f10.6)') 'Chi-squared: ',chi2
      write(lo,'(1x,t5,a,f10.6)') 'Goodness-of-fit: ',q
      endif

      do i=1,Nbin
       SIGMAAShell_l(i)=b*midpts(i) + a
       SIGMAAShell_l(i)=min(1.0,SIGMAAShell_l(i)) 

       SIGMAAShell_l(i)=SIGMAAShell(i)   ! linea da commentare per usare linear fit

       SIGMAAShell(i)=SIGMAAShell_l(i)

        FacGSIMShell(i)=SIGMAAShell_l(i)
     *                  /(eeShell(i) -SIGMAAShell_l(i)**2)

        if (a > 0.0 ) then
          DluzShell_l(i)=SIGMAAShell_l(i)/sqrt(a)
          DluzShell_l(i)=min(1.0,DluzShell_l(i))
        else
         DluzShell_l(i)=DluzShell(i)
        endif

        if (jflag > 0) then
          sigNsigP=sqrt(SIGnShell(i)/SIGpShell(i))
          sigNsigP=max(1.0,sigNsigP)
          DluzShell(i)=SIGMAAShell_l(i)*sigNsigP
          DluzShell(i)=min(1.0,DluzShell(i))
          DluzShell(i)=max(0.0,DluzShell(i))
        endif
        DluzShell_l(i)=max(0.0,DluzShell_l(i))
      enddo

      if (ifDsrVLD  >  0) then
!-- PEZZA gianluca 03/05/2012
          if (SIGMAAShell(1) < 0.7 * SIGMAAShell(2)) then
              SIGMAAShell(1) = SIGMAAShell(2)
          endif
      endif

      if (iprint==1) then
        write(lo,*)'<e>n',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>n',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>n',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>n',sum(Eo2Ec2Shell(:))/float(Nbin)
      endif

      sigAmed=sum(SIGMAAShell(:))/float(Nbin)

      ! calc. new weight (modified sim weight using sigmaA)
      sumErr12=0.0
      sumErro=0.0
      sumwto=0.0

      sumErrn=0.0
      sumwtn=0.0

      sumErrc=0.0
      sumwtc=0.0

      sumErrnc=0.0
      sumwtnc=0.0

      sumErren=0.0
      sumwten=0.0

      nwto=0
      nwte=0
      nwtn=0
      nwten=0
      nwtc=0
      nwtnc=0
      cosErrShell(:) = 0.0
c
c--limito i pesi quando faccio la DEDM
c  vale quando faccio la DM di Dritan
c
      rff1=rf1
      rff2=rf2
      if(icombPh==1.and.abs(ifDEDM)>0) then 
        rff2=1.0 
        rff1=0.5 
        rff1=min(rff1,sigPsigNOld)
      endif
c
      do i=1,nrefl1
        ii=RES_TAG(i)

        if (wto(i) > 0) nWtoShell(ii) =  nWtoShell(ii) + 1

        wref=2.0
        if (itype(i) > 1) wref=1.0
        ee1=Eobs(i)
        ee2=Emodi(i)
        gmod=wref*ee1*ee2*FacGSIMShell(ii)
        gmod=max(0.0,gmod)
        if (itype(i)==1) then
c        wtnew(i)=bes(gmod) 
         wtnew(i)=sim(gmod)
        else
         wtnew(i)=tanh(0.5*gmod)
        endif

        wtnew(i)=min(1.0,wtnew(i))
        ! errore fase nuova
        if (wtnew(i) > 0.0) then
         nWtnShell(ii) =  nWtnShell(ii) + 1
         diffERR=(iphi2(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErrShell(ii)=cosErrShell(ii) + diffERR
         if (wto(i) > 0.0) then
          sumErrn=sumErrn + acos(diffERR)*rtod
          sumwtn=sumwtn+wtnew(i)
          nwtn=nwtn+1
         else
          sumErren=sumErren + acos(diffERR)*rtod
          sumwten=sumwten+wtnew(i)
          nwten=nwten+1
         endif
        endif

        wtnewShell(ii)=wtnewShell(ii) + wtnew(i)
        wttShell(ii)=wttShell(ii) + wtt(i)
        wtoShell(ii)=wtoShell(ii) + wto(i)

        gold=0.0
        if (wto(i) > 0) then
          fomo=wto(i)
          ! com con wt/fasi iniziali obs
          if (itype(i)/=1) then
            gold=atanhILM(fomo)
          else
            gold=siminv(fomo)
          endif
        endif
       csum=rff2*gmod*cos(iphi2(i)*dtor) + rff1*gold*cos(iphi2o(i)*dtor)
       ssum=rff2*gmod*sin(iphi2(i)*dtor) + rff1*gold*sin(iphi2o(i)*dtor)
c      csum=rf2*gmod*cos(iphi2(i)*dtor) + rf1*gold*cos(iphi2o(i)*dtor)
c      ssum=rf2*gmod*sin(iphi2(i)*dtor) + rf1*gold*sin(iphi2o(i)*dtor)
        args=csum**2 + ssum**2
        if (args > 0.0 ) then
          fase=atan2(ssum,csum)*rtod
          fase=mod(fase+3600.,360.)
          if (itype(i) > 1) fase = favi(itype(i),fase)
          peso=sqrt(csum**2 + ssum**2)
          if (icombPh==1) then
            iphinew(i)=nint(fase)
            if (itype(i)==1) then
c             pesMod(i)=bes(peso)
              pesMod(i)=sim(peso)
            else
              pesMod(i)=tanh(peso)
            endif
          else
           ! senza combinazione
           iphinew(i)=iphi2(i)
           pesMod(i)=wtnew(i)
          endif
        else
          iphinew(i)=0
          pesMod(i)=0.0
        endif
        wtcShell(ii)=wtcShell(ii) + pesMod(i)
        ! errore fasi obs
        if (wto(i) > 0.0) then
         diffERR=(iphi2o(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErroShell(ii)=cosErroShell(ii) + diffERR
         sumErro=sumErro + acos(diffERR)*rtod
         sumwto=sumwto+wto(i)
         nwto=nwto+1
         if (pesMod(i) > 0) then
           nWt12Shell(ii) =  nWt12Shell(ii) + 1
           diffERR=(iphi2o(i)-iphi2(i)) * dtor
           diffERR=cos(diffERR)
           cosErr12Shell(ii)=cosErr12Shell(ii) + diffERR
           sumErr12=sumErr12 + acos(diffERR)*rtod
         endif
        endif
        ! errore fasi comb
        if (pesMod(i) > 0.0) then
         nWtcShell(ii) =  nWtcShell(ii) + 1
         diffERR=(iphinew(i)-iphi1(i)) * dtor
         diffERR=cos(diffERR)
         cosErrcShell(ii)=cosErrcShell(ii) + diffERR
         if (wto(i) > 0.0) then
          sumErrc=sumErrc + acos(diffERR)*rtod
          sumwtc=sumwtc+pesMod(i)
          nwtc=nwtc+1
         else
          sumErrnc=sumErrnc + acos(diffERR)*rtod
          sumwtnc=sumwtnc+pesMod(i)
          nwtnc=nwtnc+1
         endif
        endif
c       endif
c
c--calcolo il peso per la fourier differenza
c
       var=(ee1**2) * (1.0 -wtnew(i)**2) ! versione best con e
c      var = var + ee2**2 * (1.0 - Dluz(i) **2)
       var=var+sigEobs(i)**2 ! versione best con e
c      var=(fop1(i)**2) * (1.0 -wtnew(i)**2) ! versione con f
c      var=var+sigfo(i)**2 ! versione con f
       if (ifDsrVLD == 0) then
           if (var > 0.0) then
               wvar(i)=(var)**0.3 ! versione best con e
c              wvar(i)=1.0/sqrt(var)  ! versione con f o con e + Dritan
           else
               wvar(i)=0.0
           endif
       endif

c       if (SIGMAAShell(ii) > 0.0) then
c         wvar(i)=wvar(i)*sqrt(SIGMAAShell(ii))
c       endif
cc         Dluz(i)=DluzShell(ii)
c          Dluz(i)=DluzShell_l(ii) ! linea da cambiare occhio

       if (ifDsrVLD > 0) then
           Dluz(i)= eeShell(ii)-1.0
       else
           Dluz(i)=DluzShell_l(ii) ! linea da cambiare occhio
       endif

c         gmod=2.*pesMod(i)*ee1*(2.*pesMod(i)*ee1-Dluz(i)*ee2)
c         gmod=2.*pesMod(i)*ee1-Dluz(i)*ee2
c         ! calc. coef. per fourier di differenza
c         ee1=Eobs(i)/sqrt(scEo2Shell(ii))
c         ee2=Emodi(i)/sqrt(scEc2Shell(ii))
c         aa = pesMod(i) * ee1 - SIGMAAShell(ii) * ee2
c         ! solo per test
c         eobs1(i) = aa
c         eobs1(i) = ee2
c         sigfo(i) = ee1
       if (ifDsrVLD > 0) then
           wvar(i) = SIGMAAShell(ii)
       endif

      enddo

      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        if (numbShell1 > 0) then
          wtnewShell(i)=wtnewShell(i)/float(numbShell1)
          wttShell(i)=wttShell(i)/float(numbShell1)
          wtoShell(i)=wtoShell(i)/float(numbShell1)
          wtcShell(i)=wtcShell(i)/float(numbShell1)
        endif
        if (nWtoShell(i) > 0) 
     *    cosErroShell(i)=cosErroShell(i)/float(nWtoShell(i))
        if (nWtnShell(i) > 0) 
     *        cosErrShell(i)=cosErrShell(i)/float(nWtnShell(i))
        if (nWt12Shell(i) > 0) 
     *        cosErr12Shell(i)=cosErr12Shell(i)/float(nWt12Shell(i))
        if (nWtcShell(i) > 0) 
     *      cosErrcShell(i)=cosErrcShell(i)/float(nWtcShell(i))
      enddo

      if (iprint==1) then
        write(lo,*)'<wvar>',sum(wvar(:))/count(wvar(:) > 0.0)
        write(lo,'(1x,5hShell,1x,3hres,2x,6hsint/l,3x,4hNREF,
     *            2x,8h<Eo2Ec2>,
     *            1x,8hR(Eo,Ec),
     *            1x,8h <Eo-Ec>,
     *            1x,6hsigmaA,1x,
     *            3x,3hm_o,2x,7hcosERRo,
     *            3x,3hm  ,2x,7hcosERR ,
     *            1x,3hm_c,2x,7hcosERRc,
     *            3x,3hD  ,3x,7hD_l    )')
        do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
c         write(51,*)midpts(i),Eo2Ec2Shell(i),eeShell(i),
c    *             sumDiffShell(i)/sumFoShell(i)
c         write(52,*)midpts(i),SIGMAAShell(i),eeShell(i),
c    *        cosErrShell(i),DluzShell(i),DluzShell_l(i),
c    *        wtnewShell(i),SIGMAAShell_l(i),wttShell(i),
c    *        cosErrEShell(i)
           write(lo,1000)i,0.5/midpts(i),midpts(i),
     *                numbShell1,
     *                Eo2Ec2Shell(i),
     *                rfacShell(i),
     *                EomEcShell(i),
c    *                SIGMAAccShell(i),
     *                SIGMAAShell(i),
     *                wtoShell(i),cosErroShell(i),
     *                wtnewShell(i),cosErrShell(i),
     *                wtcShell(i),cosErrcShell(i),
     *                DluzShell(i),DluzShell_l(i),
     *                eeShell(i)
c    *                acos(cosErr12Shell(i))*rtod
      
 1000 format(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f7.4),8(' ',f6.3),2x,f6.2)
        enddo

        nwto1=count(wto(1:nrefl1)>0.0)
        if (nwto1 > 0.0) then
           wtomed=sum(wto(1:nrefl1))/float(nwto1)
        else
           wtomed=0.0
        endif
        nwtn1=count(wtnew(1:nrefl1)>0.0)
        if (nwtn1 > 0.0) then
           wtnmed=sum(wtnew(1:nrefl1))/float(nwtn1)
        else
           wtnmed=0.0
        endif
        nwtc1=count(pesMod(1:nrefl1)>0.0)
        if (nwtc1 > 0.0) then
           wtcmed=sum(pesMod(1:nrefl1))/float(nwtc1)
        else
           wtcmed=0.0
        endif

        write(lo,'(2x,116(1h_))')
        write(lo,'(19x,i6,4(2x,f7.4),8f7.3,2(2x,f6.2))')
     *             nrefl1,
     *             sum(Eo2Ec2Shell(:))/float(Nbin),
     *             sumDiff/sumEo,
     *             sum(EomEcShell(:))/float(Nbin),
     *             sum(SIGMAAShell(:))/float(Nbin),
     *             wtomed,
     *             sum(cosErroShell(:))/float(Nbin),    
     *             wtnmed,
     *             sum(cosErrShell(:))/float(Nbin),    
     *             wtcmed,
     *             sum(cosErrcShell(:))/float(Nbin),
     *             sum(DluzShell(:))/float(Nbin),
     *             sum(DluzShell_l(:))/float(Nbin),
     *             acos(sum(cosErr12Shell(:))/float(Nbin))*rtod,
     *             sumErr12/float(nwto)
        if (nwto > 0) then
          write(lo,*)'  Combination with Initial Phases'
          write(lo,'(2x,8hBefore: ,2x,5hNref=,i6,2x,7h<dphi>=,
     *          f6.2,2x,4h<m>=,f6.3,f6.3)')
     *          nwto,sumErro/float(nwto),sumwto/float(nwto),rff1
        endif
        if (nwtn > 0) then
           write(lo,'(2x,8hAfter:  ,2x,5hNref=,i6,2x,7h<dphi>=,
     *           f6.2,2x,4h<m>=,f6.3,f6.3)')
     *           nwtn,sumErrn/float(nwtn),sumwtn/float(nwtn),rff2
        endif
        if (nwtc > 0) then
            write(lo,'(2x,8hCombine:,2x,5hNref=,i6,2x,7h<dphi>=,
     *          f6.2,2x,4h<m>=,f6.3)')
     *          nwtc,sumErrc/float(nwtc),sumwtc/float(nwtc)
                emmeNew = sumwtc/float(nwtc)
        endif

        if (nwten > 0) then
          write(lo,*)'  Non Combine reflections'
          write(lo,'(10x,5hNref=,i6,2x,7h<dphi>=,f6.2,2x,4h<m>=,f6.3)')
     *               nwten,sumErren/float(nwten),sumwten/float(nwten)
        endif

      if (iprint > 0) then
          write(lo,*)'-----------------------------'
          write(lo,*)'sigmaA calc from:'
          if (jflag > 0) then
            write(lo,*)'|F|'
          else
            write(lo,*)'|E|'
          endif
          select case (jsigmaa)
             case (1)
               write(lo,*)'<Eo2Ec2>'
             case (2)
               write(lo,*)'R(EoEc)'
             case (3)
               write(lo,*)'<Eo-Ec>'
          end select
          sigmaAmed = sum(SIGMAAShell(:))/float(Nbin)
          write(lo,*) 'nrefl',nrefl1
          write(lo,*) '<sigmaA>',sum(SIGMAAShell(:))/float(Nbin)
          write(lo,*) '<m>',sum(pesMod(1:nrefl1))/
     *                 count(pesMod(1:nrefl1)>0.0),
     *                 count(pesMod(1:nrefl1)>0.0)
          write(lo,*) '<cosPHI>',sum(cosErrcShell(:))/float(Nbin)
          write(lo,*) '<dPHI>',rtod*acos(sum(cosErrcShell(:))/
     *                 float(Nbin))
          write(lo,*) '<D>',sum(DluzShell(:))/float(Nbin)
          write(lo,*) '<D>',sum(DluzShell_l(:))/float(Nbin)
          write(lo,*)'-----------------------------'
       endif
      endif
      if(ivolta==0) sigmaold=sum(SIGMAAShell(:))/float(Nbin)

      ! calc. pesi per i riflessi nonosservati
      if (jflag > 0) then
        SIGpMed=eps*sum(SIGpShell(:))/float(Nbin)
      else
        SIGpMed=1.0
      endif
      if (jsigmaa == 4) then
        ! da Rocco
c
c  uso la retta dei minimi quadrati
c
        sumx=0.0
        sumy=0.0
        sumxx=0.0
        sumxy=0.0
        do ii=1,NBin
         x=midpts(ii)
         y=min(SIGMAAShell(ii),0.80)
         sumx=sumx+x
         sumy=sumy+y
         sumxx=sumxx+x*x
         sumxy=sumxy+x*y
        enddo
        delta=Nbin*sumxx-sumx*sumx
        bbterm=(Nbin*sumxy-sumx*sumy)/delta
        aaterm=(sumy*sumxx-sumx*sumxy)/delta
c
        sogsigma=0.80
        sigmaven=sum(SIGMAAShell(:))/float(Nbin)
c
        do i=nrefl1+1,nrefSi
         iu=i-nrefl1
c
c--estrapolo i valori di sigma nel range non misurato
c
         x=sqrt(rho(i))
         sigmaext=aaterm+bbterm*x
! controllo per evitare esalazioni
         sigmaext=min(sigmaext,sogsigma)
         fact=1.0-sigmaext**2
         pesMod(iu) = sqrt(3.0*(Pi/4.0)*fact)
         exxo = sqrt(1.0+sigmaext**2*(fop2(i)**2-SIGpMed))
         if (jflag < 0) then
           fop2(i)=exxo
         else
           Eop(i) = fop2(i)/sqrt(SIGpMed) ! Eesterno
           Ecp(i) = exxo                  ! Eestrapolato
         endif
        enddo
      else
        ! da Dritan
       SIGpMed=sum(SIGpShell(:))/float(Nbin)
       scunobsMed=sum(scEc2Shell(:))/float(Nbin)
       pesmedObs=sum(pesMod(1:nrefl1))/count(pesMod(1:nrefl1) > 0.0)
       pesmedExt1=sum(wto(nrefl1+1:nrefSi))/
     *    count(wto(nrefl1+1:nrefSi) > 0.0)
c     print*,pesmedExt1
       sumcosdiffERRo=0.0
       sumdiffERRo=0.0
       sumcosdiffERR=0.0
       sumdiffERR=0.0
       sumcosdiffERRn=0.0
       sumdiffERRn=0.0
       do i=nrefl1+1,nrefSi

        if (wto(i) > 0.0) then
          diffERR=(iphi2o(i)-iphi1(i)) * dtor
          diffERR=cos(diffERR)
          sumcosdiffERRo=sumcosdiffERRo + diffERR
          diffERR=acos(diffERR)*rtod
          sumdiffERRo=sumdiffERRo + diffERR
        endif

        wref=2.0
        if (itype(i) > 1) wref=1.0
        rx=sqrt(rho(i))
        if (rx > midpts(Nbin)) then
          sigPunobs=SIGpShell(Nbin)
c         sigPunobs=SIGpMed
          scunobs= 1./sqrt(scEc2Shell(Nbin))
        else
          sigPunobs=SIGpMed
          scunobs= 1./sqrt(scunobsMed)
        endif
c       Emodi(i)=fop2(i)/(sqrt(epsv(i)*sigPunobs))
c       Emodi(i)=scunobs*fop2(i)/sqrt(epsv(i)*SIGpMed)
        Emodi(i)=scaleFoFc*fop2(i)/sqrt(epsv(i)*SIGpMed)
        sigmaAunobs=b*sqrt(rho(i)) + a
        sigmaAunobs=min(sigmaAunobs,0.80)
        FacGSIMunobs=sigmaAunobs/1.0 - sigmaAunobs**2
        fact=1.0-sigmaAunobs**2
c       exxo = 0.5*sqrt(pi*fact+(2.0*sigmaAunobs*Emodi(i))**2)
        exxo = 1.0+sigmaAunobs**2*(Emodi(i)**2-1.0)
        var_exxo=sqrt(3.0*(pi/4.0)*fact)
        if (exxo > 0.0) then
         Emodi(i)=sqrt(exxo)
c        gmod=wref*Emodi(i)**2*FacGSIMunobs
c        gmod=2.0*Emodi(i)*Emodi(i)*FacGSIMunobs
         gmod=wref*Emodi(i)
c        gmod=Emodi(i)
         if (itype(i)==1) then
c          wtnew(i)=bes(gmod)
           wtnew(i)=0.5*sim(gmod)
          else
           wtnew(i)=0.5*tanh(0.5*gmod)
          endif
          wtnew(i)=min(1.0,wtnew(i))
          wtnew(i)=max(0.0,wtnew(i))
c         wtt(i)=wtnew(i)
c         Ecp(i)=Emodi(i)
        else
          Emodi(i)=0.0
          wtnew(i)=0.0
c         wtt(i)=0.0
c         Ecp(i)=0.0
        endif
      ! comb. 
        if (wtnew(i) > 0.0) then
          diffERR=(iphi2(i)-iphi1(i)) * dtor
          diffERR=cos(diffERR)
          sumcosdiffERR=sumcosdiffERR + diffERR
          diffERR=acos(diffERR)*rtod
          sumdiffERR=sumdiffERR + diffERR
        endif
       gnew = 0.0
       gold = 0.0
       if (wto(i) > 0.0) then
          gold=besinv(wto(i))
       endif
       if (wtnew(i) > 0.0) then
c         gnew=gold
          gnew=besinv(wtnew(i))
       endif
       csum=0.5*gnew*cos(iphi2(i)*dtor) + 1.5*gold*cos(iphi2o(i)*dtor)
       ssum=0.5*gnew*sin(iphi2(i)*dtor) + 1.5*gold*sin(iphi2o(i)*dtor)
       args=csum**2 + ssum**2
       if (args > 0.0 ) then
          ! comb. moduli
           fop1(i)=(fop1(i) + fop2(i)) * 0.5
          !
          fase=atan2(ssum,csum)*rtod
          fase=mod(fase+3600.,360.)
          if (itype(i) > 1) fase = favi(itype(i),fase)
          peso=sqrt(csum**2 + ssum**2)
c         if (icombPh==1) then
            iphinew(i)=nint(fase)
            if (itype(i)==1) then
c             pesMod(i)=bes(peso)
              pesMod(i)=sim(peso)
            else
              pesMod(i)=tanh(peso)
            endif
          else
           ! senza combinazione
           iphinew(i)=iphi2(i)
           pesMod(i)=wtnew(i)
c         endif
       endif
        diffERR=(iphinew(i)-iphi1(i)) * dtor
        diffERR=cos(diffERR)
        sumcosdiffERRn=sumcosdiffERRn + diffERR
        diffERR=acos(diffERR)*rtod
        sumdiffERRn=sumdiffERRn + diffERR

      enddo
      if (nrefSi > nrefl1) then
         pesmedNobs=sum(pesMod(nrefl1+1:nrefSi))/
     *           count(pesMod(nrefl1+1:nrefSi) > 0.0)
         scPeso=pesmedNobs/pesmedObs

         write(lo,*)'unobs refl.'
         write(lo,*)'nrefl:',nrefSi-nrefl1
         write(lo,*)'<Ec>',sum(Emodi(nrefl1+1:nrefSi))/
     *           count(Emodi(nrefl1+1:nrefSi)>0.0)
         write(lo,*)'<wt>unobs',pesmedNobs,scPeso
         ! per il momneto non gli metto in scala
c        pesMod(nrefl1+1:nrefSi)=pesMod(nrefl1+1:nrefSi)/scPeso
         pesmedNobs=sum(pesMod(nrefl1+1:nrefSi))/
     *           count(pesMod(nrefl1+1:nrefSi) > 0.0)
         write(lo,*)'<wt>unobs',pesmedNobs
         sumdiffERRo=sumdiffERRo/count(wto(nrefl1+1:nrefSi) > 0.0)
         sumdiffERR=sumdiffERR/count(wtnew(nrefl1+1:nrefSi) > 0.0)
         sumdiffERRn=sumdiffERRn/count(pesMod(nrefl1+1:nrefSi) > 0.0)
!        write(lo,*)'<cosPHI>',sumcosdiffERR,sumcosdiffERRn
         write(lo,*)'<dphi>',sumdiffERRo,sumdiffERR,sumdiffERRn
      !
       endif
      endif
     !

      if (jsigmaa /= 4) then
       wtt(1:nrefSi) = pesMod(1:nrefSi)
       iphi2(1:nrefSi) = iphinew(1:nrefSi) 
       ! Ep Epp (x sirProt)
       Eop(1:nrefSi)=Eobs(1:nrefSi)
       Ecp(1:nrefSi)=Emodi(1:nrefSi)
       ! memorizzazione sigmaA in pesMod
       do i=1,nrefl1
         ii=RES_TAG(i)
         pesMod(i) = SIGMAAShell(ii)
       enddo
      endif

      if (iabs(jflag) > 4) then
      ! Test per Fq 
      do i=1,nrefl1
        ii=RES_TAG(i)
        Eop(i) = Eobs(i)/sqrt(scEo2Shell(ii))
        Ecp(i) = Emodi(i)/sqrt(scEc2Shell(ii))
        if(jsigmaa==6) then
           wtt(i)=Dluz(i)
        endif
        Dluz(i)=0.8*SIGMAAShell(ii)
      enddo
      endif

      !

      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=       end sigmaA              ='
        write(lo,*)'================================='
      endif

      deallocate(RES,RES_TAG,Eobs,Emodi,ee,sigEobs,wtnew,stat=ierr)
      deallocate (Eo2Shell,Ec2Shell,Eo4Shell,Ec4Shell,Eo2Ec2Shell,
     *          SIGnShell,SIGpShell,SIGqShell,
     *          EpsShell,scEo2Shell,scEc2Shell,
     *          eeShell,midpts,SIGMAAShell,SIGMAAShellsave,
     *          SIGMAAccShell,SIGMAAShell_l,xfit,yfit,
     *          cosErrShell,FacGSIMShell,
     *          wtnewShell,DluzShell,DluzShell_l,
     *          sig,shellTAB,numbShell,
     *          wttShell,wtoShell,sumDiffShell,
     *          sumFoShell,rfacShell,
     *          cosErrEShell,cosErroShell,cosErr12Shell,cosErrcShell,
     *          gsimShell,
     *          SIGMAAeShell,EomEcShell,SIGMAAnShell,wtcShell, 
     *          r,drds,
     *          stat=ierr)
      return
      end
!-----------------------------------------------------------------------
      subroutine ImproveMapMR
!   --Test per MR
      USE General
      USE Riflessi
      USE Param
      Use Mappa
      Use MappaAutre
      Use MapTest
      character*200 strFile
      real cellOut(6)
      integer nspace, npOut(3)

      strFile = StructureName(1:Lung(StructureName)) //'_mr.map'
      print*,np
      ifail=0
      iprintCCP4=0
      call CCP4MAPIN(strFile, np, npOut, cellOut, nspace, ifail,
     *               iprintCCP4, ier)
      print*,npAutre
c     xmap = xmapAutre
      stop

      return
      end
!-----------------------------------------------------------------------
