typedef struct _IlmGruppa_mrt {
  char szImya[12];
  short iNomer;
} IlmGruppa;

static IlmGruppa ILM_GRUPPY[] = {
  {"p 1        ",    1},
  {"p -1       ",    2},
  {"p 2        ",    3},
  {"p 21       ",    4},
  {"c 2        ",    5},
  {"p m        ",    6},
  {"p c        ",    7},
  {"c m        ",    8},
  {"c c        ",    9},
  {"p 2/m      ",   10},
  {"p 21/m     ",   11},
  {"c 2/m      ",   12},
  {"p 2/c      ",   13},
  {"p 2/n      ",   13},
  {"p 21/a     ",   14},
  {"p 21/c     ",   14},
  {"p 21/n     ",   14},
  {"c 2/c      ",   15},
  {"p 2 2 2    ",   16},
  {"p 2 2 21   ",   17},
  {"p 21 21 2  ",   18},
  {"p 21 21 21 ",   19},
  {"c 2 2 21   ",   20},
  {"c 2 2 2    ",   21},
  {"f 2 2 2    ",   22},
  {"i 2 2 2    ",   23},
  {"i 21 21 21 ",   24},
  {"p m m 2    ",   25},
  {"p m c 21   ",   26},
  {"p c c 2    ",   27},
  {"p m a 2    ",   28},
  {"p c a 21   ",   29},
  {"p n c 2    ",   30},
  {"p m n 21   ",   31},
  {"p b a 2    ",   32},
  {"p n a 21   ",   33},
  {"p n n 2    ",   34},
  {"c m n 2    ",   35},
  {"c m c 21   ",   36},
  {"c c c 2    ",   37},
  {"a m m 2    ",   38},
  {"a b m 2    ",   39},
  {"a m a 2    ",   40},
  {"a b a 2    ",   41},
  {"f m m 2    ",   42},
  {"f d d 2    ",   43},
  {"i m m 2    ",   44},
  {"i b a 2    ",   45},
  {"i m a 2    ",   46},
  {"p m m m    ",   47},
  {"p n n n    ",   48},
  {"p c c m    ",   49},
  {"p b a n    ",   50},
  {"p m m a    ",   51},
  {"p n n a    ",   52},
  {"p m n a    ",   53},
  {"p c c a    ",   54},
  {"p b a m    ",   55},
  {"p c c n    ",   56},
  {"p b c m    ",   57},
  {"p n n m    ",   58},
  {"p m m n    ",   59},
  {"p b c n    ",   60},
  {"p b c a    ",   61},
  {"p n m a    ",   62},
  {"c m c m    ",   63},
  {"c m c a    ",   64},
  {"c m m m    ",   65},
  {"c c c m    ",   66},
  {"c n m a    ",   67},
  {"c c c a    ",   68},
  {"f m m m    ",   69},
  {"f d d d    ",   70},
  {"i m m m    ",   71},
  {"i b a m    ",   72},
  {"i b c a    ",   73},
  {"i m m a    ",   74},
  {"p 4        ",   75},
  {"p 41       ",   76},
  {"p 42       ",   77},
  {"p 43       ",   78},
  {"i 4        ",   79},
  {"i 41       ",   80},
  {"p -4       ",   81},
  {"i -4       ",   82},
  {"p 4/m      ",   83},
  {"p 42/m     ",   84},
  {"p 4/n      ",   85},
  {"p 42/n     ",   86},
  {"i 4/m      ",   87},
  {"i 41/a     ",   88},
  {"p 4 2 2    ",   89},
  {"p 4 21 2   ",   90},
  {"p 41 2 2   ",   91},
  {"p 41 21 2  ",   92},
  {"p 42 2 2   ",   93},
  {"p 42 21 2  ",   94},
  {"p 43 2 2   ",   95},
  {"p 43 21 2  ",   96},
  {"i 4 2 2    ",   97},
  {"i 41 2 2   ",   98},
  {"p 4 m m    ",   99},
  {"p 4 b m    ",  100},
  {"p 42 c m   ",  101},
  {"p 42 n m   ",  102},
  {"p 4 c c    ",  103},
  {"p 4 n c    ",  104},
  {"p 42 m c   ",  105},
  {"p 42 b c   ",  106},
  {"i 4 m m    ",  107},
  {"i 4 c m    ",  108},
  {"i 41 m d   ",  109},
  {"i 41 c d   ",  110},
  {"p -4 2 m   ",  111},
  {"p -4 2 c   ",  112},
  {"p -4 21 m  ",  113},
  {"p -4 21 c  ",  114},
  {"p -4 m 2   ",  115},
  {"p -4 c 2   ",  116},
  {"p -4 b 2   ",  117},
  {"p -4 n 2   ",  118},
  {"i -4 m 2   ",  119},
  {"i -4 c 2   ",  120},
  {"i -4 2 m   ",  121},
  {"i -4 2 d   ",  122},
  {"p 4/m m m  ",  123},
  {"p 4/m c c  ",  124},
  {"p 4/n b m  ",  125},
  {"p 4/n n c  ",  126},
  {"p 4/m b m  ",  127},
  {"p 4/m n c  ",  128},
  {"p 4/n m m  ",  129},
  {"p 4/n c c  ",  130},
  {"p 42/m m c ",  131},
  {"p 42/m c m ",  132},
  {"p 42/n b c ",  133},
  {"p 42/n n m ",  134},
  {"p 42/m b c ",  135},
  {"p 42/m n m ",  136},
  {"p 42/n m c ",  137},
  {"p 42/n c m ",  138},
  {"i 4/m m m  ",  139},
  {"i 4/m c m  ",  140},
  {"i 41/a m d ",  141},
  {"i 41/a c d ",  142},
  {"p 3        ",  143},
  {"p 31       ",  144},
  {"p 32       ",  145},
  {"r 3        ",  146},
  {"p -3       ",  147},
  {"r -3       ",  148},
  {"p 3 1 2    ",  149},
  {"p 3 2 1    ",  150},
  {"p 31 1 2   ",  151},
  {"p 31 2 1   ",  152},
  {"p 32 1 2   ",  153},
  {"p 32 2 1   ",  154},
  {"r 3 2      ",  155},
  {"p 3 m 1    ",  156},
  {"p 3 1 m    ",  157},
  {"p 3 c 1    ",  158},
  {"p 3 1 c    ",  159},
  {"r 3 m      ",  160},
  {"r 3 c      ",  161},
  {"p -3 1 m   ",  162},
  {"p -3 1 c   ",  163},
  {"p -3 m 1   ",  164},
  {"p -3 c 1   ",  165},
  {"r -3 m     ",  166},
  {"r -3 c     ",  167},
  {"p 6        ",  168},
  {"p 61       ",  169},
  {"p 65       ",  170},
  {"p 62       ",  171},
  {"p 64       ",  172},
  {"p 63       ",  173},
  {"p -6       ",  174},
  {"p 6/m      ",  175},
  {"p 63/m     ",  176},
  {"p 6 2 2    ",  177},
  {"p 61 2 2   ",  178},
  {"p 65 2 2   ",  179},
  {"p 62 2 2   ",  180},
  {"p 64 2 2   ",  181},
  {"p 63 2 2   ",  182},
  {"p 6 m m    ",  183},
  {"p 6 c c    ",  184},
  {"p 63 c m   ",  185},
  {"p 63 m c   ",  186},
  {"p -6 m 2   ",  187},
  {"p -6 c 2   ",  188},
  {"p -6 2 m   ",  189},
  {"p -6 2 c   ",  190},
  {"p 6/m m m  ",  191},
  {"p 6/m c c  ",  192},
  {"p 63/m c m ",  193},
  {"p 63/m m c ",  194},
  {"p 2 3      ",  195},
  {"f 2 3      ",  196},
  {"i 2 3      ",  197},
  {"p 21 3     ",  198},
  {"i 21 3     ",  199},
  {"p m 3      ",  200},
  {"p n 3      ",  201},
  {"f m 3      ",  202},
  {"f d 3      ",  203},
  {"i m 3      ",  204},
  {"p a 3      ",  205},
  {"i a 3      ",  206},
  {"p 4 3 2    ",  207},
  {"p 42 3 2   ",  208},
  {"f 4 3 2    ",  209},
  {"f 41 3 2   ",  210},
  {"i 4 3 2    ",  211},
  {"p 43 3 2   ",  212},
  {"p 41 3 2   ",  213},
  {"i 41 3 2   ",  214},
  {"p -4 3 m   ",  215},
  {"f -4 3 m   ",  216},
  {"i -4 3 m   ",  217},
  {"p -4 3 n   ",  218},
  {"f -4 3 c   ",  219},
  {"i -4 3 d   ",  220},
  {"p m 3 m    ",  221},
  {"p n 3 n    ",  222},
  {"p m 3 n    ",  223},
  {"p n 3 m    ",  224},
  {"f m 3 m    ",  225},
  {"f m 3 c    ",  226},
  {"f d 3 m    ",  227},
  {"f d 3 c    ",  228},
  {"i m 3 m    ",  229},
  {"i a 3 d    ",  230}
};
