#ifndef __ILM_H_mrt
#define __ILM_H_mrt

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include <vector>

#include <utils.h>
#include "gtkproject.h"
#include "ilm_defs.h"
#include "project.h"
#include "application.h"
#include "util.h"
#include "ilm_globals.h"

namespace Ilm 
{

  int Main(int argc, char *argv[]);

  bool add_mtz_pair(const char *val, const char *esd, int quale);
  void clear_mtz(int flag);
  void clear_mtzdea(int flag);
  void add_mtz_col(const char *val, int quale);
  void add_mtz_col(const char *val, int quale);
  void update_mtzpage(GtkWidget *dlg);
  void update_deamtzpage(GtkWidget *dlg);
} // namespace Ilm

#endif
