#include <mrconfig.h>
#include <gtkmrcomune.h>

namespace main_app
{
    extern Application TheApp;
}

static GtkWidget *about_contdlg = NULL;

void about_contour (gpointer, gpointer data)
{
    gtkext::AboutItem it;
    GtkWidget *main_window;

    memset(&it, 0, sizeof(gtkext::AboutItem));
    main_window = ( GtkWidget *) data;
    if (about_contdlg == NULL)
    {
       it.title            = DuplicaStringa("About Contour Routine");
       it.image            = DuplicaStringa("contourb.png");
       it.text1            = DuplicaStringa("<span  size=\"medium\">"
                                     "This part of the code is\n"
                                     "based on routines written by\n</span>"
                                     "<span foreground=\"blue\" size=\"x-large\">" 
                                     "Javier Gonzalez-Platas</span>");
       it.browser          = g_strdup_printf("%s", main_app::TheApp.InternetBrowser().c_str());
       about_contdlg       = create_about_dialog(main_window, &it);  
     }

    gtk_widget_show_all (about_contdlg);
    gdk_window_raise (gtk_widget_get_window(about_contdlg));
}
