c----------------------------------------------------------------------
      subroutine rialfnew(sigmp)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
!
c
c   calcola alfest e alfvar per i rifl. forti e deboli
c
      sigm=sigmp
      sigmq=sigmp*sigmp
      q0=0.798
      if (icent.le.0) then
          sigm  = 2.0*sigmp
          sigmq = 2.0*sigmq
          q0 = 0.886
      endif
      id28=2**30
      ssig  = 0.0
c NEW
      D1D = 0.0
      salfe=0.0
      seobs=0.0
      salfe0=0.0
      seobs0=0.0
      ckae=1.0
      ckae0=1.0
c NEW
c calcolo alfest e alfvar per i rifl. forti
      do j= 1,nstr
         if (j > nstrSav) then
             igggg = 1
         endif
         k = iordeTang(j)
         alfvar(k) = 0.0
         alfest(k)=0.0
*        if (j.gt.nstr) go to 350
         ist = 3
         jpqq = 0
         do kcr=1,2
            ist = ist + 1
            li = limref(kcr, k)*ist + 1 + jpqq
            ls = limref(kcr, k+1)*ist   + jpqq
*           if (li.gt.ls) go to 345
            if (li <= ls) then
                do jj= li,ls,ist
                   nn(1) = iph(jj)
                   nn(2) = iph(jj+1)
                   if (ist == 4) then
                       nn(3) = 0
                       a1 = 0.01 * iph(jj+2)
                       ifaz = iph(jj+3)
                   else
                       nn(3) = iph(jj+2)
                       a1 = 0.01 * iph(jj+3)
                       ifaz = iph(jj+4)
                   endif
                   if (nn(2).eq.0) cycle
                   ila = iabs(nn(1))
                   ira = iabs(nn(2))
                   ita = iabs(nn(3))
                   if (kcr.eq.1) then
                       aj = sigm*evet(ila)*evet(ira)
                       is = 1
                       if (a1.lt.0.0) is = -1
                       gj = aj*evet(k)*is
                   else
                       gj = a1
                       aj = sigmq*evet(ila)*evet(ira)*evet(ita)
                   endif
                   seobs = seobs+evet(k)
                   if (icent.gt.0) then
                       if (kcr.eq.1) then
                           t2 = tanh(gj)
                       else
                           t2 = tanh(gj*0.5)
                       endif
                       alfest(k) = alfest(k)+aj*t2
                       alfvar(k) = alfvar(k)+aj*aj*(1.0-t2*t2)
                   else
                       t2 = bes(gj)
                       alfest(k) = alfest(k)+aj*t2
                       alfvar(k) = alfvar(k)+aj*aj*(1.0-t2*(1.0/gj+t2))
                   endif
                enddo
            endif
            jpqq = jpq
         end do
c
         alfest(k) = abs(alfest(k))
         alfvar(k) = abs(alfvar(k))
         salfe = salfe+alfest(k)
         ssig  = ssig  + alfvar(k)
         alfvar(k) = sqrt(alfvar(k))
      enddo
      if (seobs.gt.0.0) ckae = salfe/seobs
c calcolo alfest e alfvar per i rifl. deboli
c
c -----
c     call sub. lettura lista 9 : psizero
c -----
      iall = 1
      ndim = 3*npsi
      if (npsi.gt.0) then
         iprea=0
            n=0
            j=1
            do i=1,num0
               psicode(i)=0
               alfest0(i)=0.0
               alfvar0(i)=0.0
               lim0n(i)=0
            enddo
            do i=2,npsi
com            iniz=iph0n(i)/id28
               n=n+1
com            if(iniz.eq.0) goto 1120
               if (iph0n(i).gt.0) cycle
               j=j+1
               lim0n(j)=n
            enddo
            j=j + 1
            lim0n(j)=n
c -----
            n0 = nrefl + 1
            do 360 i=1,num0
               n0=n0-1
               psicode(i)=n0
               li=lim0n(i) + 1
               ls=lim0n(i+1)
               if (ls.lt.li ) goto 360
               do 355 j=li,ls
com                  iph0n(j)=mod(iph0n(j),id28)
                  iph0n(j)=iabs(iph0n(j))
                  call unpak3Sir(iph0n(j),k1,k2,ifaz)
                  ka1=iabs(k1)
                  ka2=iabs(k2)
                  aj=sigm*evet(ka1)*evet(ka2)
                  alfvar0(i) = alfvar0(i) + aj * aj
                  seobs0=seobs0+evet(n0)
  355          continue
               ssig=ssig+alfvar0(i)
               if(alfvar0(i).lt.0.0) then
                  go to 360
               endif
               alfvar0(i)=sqrt(alfvar0(i))
               alfest0(i)=alfvar0(i)*q0
               salfe0=salfe0+alfest0(i)
  360      continue
      endif
      if(seobs0.gt.0.0) ckae0=salfe0/seobs0
c
!     write(6,666)
! 666 format('FOMs   mabs alcomb  psico R(x,y) cphase  cfom  nund  err.        
!    *w-err.  enan  trial')
c
*     do i= 1,nstr
*        write(6,*) i,evet(i),alfvar(i),alfest(i)
*     enddo
*     do i= 1,nzro
*        write(6,*) i,alfvar0(i),alfest0(i)
*     enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine prtfom(ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!-- 
      character cbuff*93
      dimension zero(6)
      real, allocatable::prtvet(:)
!
!     kverboSav = kverbo
!     kverbo = 1
      istep = 11
      istep = 12
      if (ifCombinedFom == 0) then
          lungs = MaxToStore
          if (ifPatt /= 0) then
              lungs = MaxRun
          endif
      else
          if (ifPatt == 0) then
              lungs = MaxToStore
          else
              lungs = MaxRun
          endif
      endif
      idim = lungs * istep
      allocate (prtvet(idim), stat=ier)
      if (ier.ne.0) print *, 'allocate REFLE in newenve error'
!
      if (knw > 0 .and. erm1min < 999) then
          write(lo,'(/,a,f6.2,a,f8.0,/)') ' ERRORE MINIMO =',erm1min, ! dedi
     *                                    '   nel trial ',setmin
      endif
!      if (nfoml.ne.0) then
!          write(lo,9025) nfoml
!      endif
! 9025 format(7x, 'The number of sets rejected with small eFom is ',i4)
      zero(:) = 0.0
      nwro=0
      iploe=0
      inund=0
c-- transfer fom's values in prtvet to sort them
      k=0
      do i=1, lungs
         do j=1,10
            k=k+1
            prtvet(k)=fomrt(i,j)
         enddo
         k=k+1
*gl*     prtvet(k)=xshuttle(i)
         prtvet(k) = i 
         k=k+1
         if (ifOldFoms == 0) then
             prtvet(k)=0
         else
             prtvet(k)=psivet(i)
         endif
      enddo
      LenStore = k
      jump=-5
      iniz=1
      if (kverbo /= 0) then
          write(lo,*) 'XXXXXXXXXXXXXX'
          iniz = 1
          ifin = istep
          do i=1,lungs
             write(lo,'(11f8.3,i5)') 
     *            (prtvet(j),j=iniz,ifin-1),nint(prtvet(ifin))
             iniz = iniz + istep
             ifin = ifin + istep
          enddo
      endif
      iniz = 1
      call sortz_dyn(prtvet,idim,iniz,lungs,istep,jump)
      if (kverbo /= 0) then
          write(lo,*) 'XXXXXXXXXXXXXX'
          iniz = 1
          ifin = istep
          do i=1,lungs
             write(lo,'(11f8.3,i5)') 
     *            (prtvet(j),j=iniz,ifin-1),nint(prtvet(ifin))
             iniz = iniz + istep
             ifin = ifin + istep
          enddo
      endif
!
      k=0
      l=0
      do i=1, lungs
         l=l+1
         k=k+5
         cfom(l)=prtvet(k)
         k=k+6
         ipos(l)=nint(prtvet(k))
         k=k+1
      enddo
      if (ifCombinedFom == 1 .or. kmad /= 0) then  !120105
          k = 0
          l = 0
          do i=1, lungs
             l = l + 1
             k = k + 5
             prtvet(k) = cfom(l)
             k = k + 6
             k = k + 1
          enddo
!
          do i = 1, lungs
!gl!         call snr16(i, figMer, tmpwt, iphazo)
             call PutGetInitialPhases(2, i, figMer, tmpwt, iphazo)
             do j=1, lungs
                if (ipos(j) == i) then
                    figMer(5) = cfom(j)
                    exit
                endif
             enddo
!gl!         call snw16(i, figMer, tmpwt, iphazo)
             call PutGetInitialPhases(1, i, figMer, tmpwt, iphazo)
             if (figMer(5) < f18mn) then
                 f18mn = figMer(5)
             endif
             if (figMer(5) > f18mx) then
                 f18mx = figMer(5)
             endif
          enddo
      endif
!
      if (jpfile == 0) then !!!! pezza per direttiva recycle

      if (knw == 0) then
          if (ifTang == 1) write(lo,620)
      endif
      if (ifOldFoms == 1) then
          if (f18mx < 0.0) then
              write (lo,730) (zero(i),i=1,6),
     *                       (zero(i),i=1,6)
          else
              write (lo,730) f1mn,f15mn,f14mn,f16mn,f17mn,f18mn,
     *                       f1mx,f15mx,f14mx,f16mx,f17mx,f18mx
          endif
          if (knw == 0) then
              write(lo,735)
          else
              write(lo,736)
          endif
      else
          if (knw == 1) then
              if (f18mx.lt.0.0) then
                  write (lo,630) (zero(i),i=1,6),
     *                           (zero(i),i=1,6)
              else
                 if (kmad == 1) then
                    write (lo,629) ff1mn,ff3mn,ff4mn,ff5mn,
     *                             ff1mx,ff3mx,ff4mx,ff5mx
             end if
          endif
      endif
          if (kmad > 0) then
              if (knw == 0) then
!gl               write(lo,620) ! dedi
                  write(lo,635)
              else
                  write(lo,620) ! dedi
                  write(lo,636)
              endif
          else
              if (knw == 0) then
                  if (ifTang == 1) write(lo,635)
              else
                  write(lo,636)
              endif
          endif
      endif
          k=0
          do i=1, MaxToStore
             jj=i
             if (knw == 1) then
                 cbuff = ' '
             else
                 if (mod(jj,3) == 1) then 
                     cbuff = ' '
                 endif
             endif
             psicom=prtvet(k+12)
             inuk=0
             if (prtvet(k+6).ge.nstr/2) then
                inund=inund+1
                inuk=1
                do kk=k+1,k+5
                   prtvet(kk)=zero(1)
                end do
                prtvet(k+7)=zero(1)
                prtvet(k+8)=zero(1)
                prtvet(k+11)=zero(1)
             endif
             nund=int(prtvet(k+6))
             iitrial=nint(prtvet(k+10))
             if (ifOldFoms == 0) then
                 if (knw.eq.0) then
                    if (mod(jj,3) == 1) then
                        write(cbuff(1:27),650) jj,iitrial,prtvet(k+5)
                    elseif (mod(jj,3) == 2) then
                        write(cbuff(28:47),650) jj,iitrial,prtvet(k+5)
                    else
                        write(cbuff(55:74),650) jj,iitrial,prtvet(k+5)
                    endif
                 else
                    write(cbuff,655) jj,iitrial,
     *                             prtvet(k+1),
     *                             (prtvet(kk),kk=k+3,k+5),nund,
     *                             (prtvet(kk),kk=k+7,k+8)
                 endif
             else
                 if (knw == 0) then
                     write(cbuff,750) jj,iitrial,
     *                  (prtvet(kk),kk=k+1,k+2),psicom,
     *                  (prtvet(kk),kk=k+3,k+5),nund
                 else
                     write(cbuff,750) jj,iitrial,
     *                  (prtvet(kk),kk=k+1,k+2),psicom,
     *                  (prtvet(kk),kk=k+3,k+5),nund,
     *                  (prtvet(kk),kk=k+7,k+8)
                 endif
             endif
             if (inuk.eq.1) then      !!!   ?????   !!!!
                 nwro=nwro+1
                 if (knw.eq.1) then
                     cbuff(64:67)='(**)'
                 else
                     if (mod(jj,3) == 1) then
                         cbuff(31:34)='(**)'
                     else 
                         cbuff(75:78)='(**)'
                     endif 
                 endif
             endif
             if (knw.eq.1) then
                 lb = Lung(cbuff)
                 write(lo,'(a)') cbuff(1:lb)
             else
                if (mod(jj,3) == 0 .or.
     *             (mod(MaxToStore,3) == 1 .and. jj == MaxToStore) .or.
     *             (mod(MaxToStore,3) == 2 .and. jj == MaxToStore)) then
                    lb = Lung(cbuff)
cdedi               write(lo,'(a)') cbuff(1:lb)
                    if (ifTang == 1) write(lo,'(a)') cbuff(1:lb)
                endif
             endif
             k=k+istep
          end do
*     endif   !(kmad > 0)
**    endif
!
      if (inund.ge.lungs .and. neutro /= 2) then     ! PROVA gianluca 6/10/06
          write(lo,710)
          write(Msg,720)
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
      endif

      endif

  620 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++')
  629 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++'
     * ,//14x,'  mabs  R(x,y) eFom  cFom      '
     * ,/10x,'min',
     * 4f7.3,/,10x,'max',4f7.3)
  630 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++'
     * ,//14x,'  mabs  alcomb pscomb R(x,y) cphase  cfom      '
     * ,/10x,'min',
     * 6f7.3,/,10x,'max',6f7.3)
c 635 format(///,' ',3('Set  (Trial)   eFom',8x),/)
  635 format(/,' ',3('Set  (Trial)   eFom',8x),/)
  636 format(///,' ','Set  (Trial)',1x,'  mabs  R(x,y)  eFom   cFom',
     *       2x,'nund',2x,'error  w-err',/)
  638 format(f4.1,' (*)')
  650 format(i4,'  (',i5,')',f7.3)
  655 format(' ',i3,'  (',i5,')',4f7.3,i5,1x,2f7.2)
  710 format(//,2x,'(**)  ***  warning  ***   the number of',
     *   ' undetermined phases is too hight',//)
  720 format('The number of undetermined phases is too hight ',
     *       'for this block. Program skips to the next one.')
!
  730 format(/// 10x,'+++++++++++++  Figures  of  merit  ++++++++++++'
     * ,//14x,'  mabs  alcomb pscomb R(x,y) cphase  cfom      '
     * ,/10x,'min',
     * 6f7.3,/,10x,'max',6f7.3)
  735 format(///1h ,       'set  (trial)',1x,'  mabs  alcomb pscomb R(x,
     *y) cphase  cfom',3x,'nund',/)
  736 format(///1h ,       'set  (trial)',1x,'  mabs  alcomb pscomb R(x,
     *y) cphase  cfom',2x,'nund',2x,'error  w-err',/)
  750 format(1h ,i3,'  (',i5,')',6f7.3,i5,1x,2f7.2)
      nset=lungs
      nset = MaxToStore
!gl!  call ysup16(cfom,ipos,nset)
      call UpdateInitialPhases(cfom, ipos, nset)
      if (ier.eq.-1) then
          call Cancella(15)
          call Cancella(16)
      endif
!
      deallocate (prtvet, stat=ier)
!
!     kverbo = kverboSav
      return
      end
c-----------------------------------------------------------------------
      subroutine absnew()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
      USE Psi0Stuff
!
      common /a2003/ aMabsNew,alf2003,ald2003,D1N,D1D,aMabsDD
c
c vettore utilizzato per memorizzare il numero di tripletti per riflesso
      dimension ntrr(4000),eec(4000)
!psie      
!psie      dimension ntrr(12000),eec(12000)
c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     rewind 22
C     do i = 1,nstr
C        read(22,*) iphaz(i),wt(i)
C     enddo
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!pgMAD150206
      if (kmad.eq.0 .or. kmad.eq.1) then
!pgMAD150206
          zeroA = 0.000001
          zeroB = 0.0
          zeroC = 0.00001
      else
          zeroA = 0.1
          zeroB = 0.1
          zeroC = 0.01
      endif
c NEW inizial. variabili calcolo coeff. di correlaz. (1/8/91)
      alf2003 = 0.0
      psi2003 = 0.0
      ald2003 = 0.0

      seec=0.0
      seeo=0.0
      see0=0.0
      seo0=0.0
      scon=0.0
      ecm=0.0
      eom=0.0
      ccorc=0.0
      ccoro=0.0
      scor1=0.0
      scor2=0.0
      scor3=0.0
      rcarl1=0.0
      rcarld1=0.0
c
      denMabNew=0.0
c
c    calcolo  absfom , resid  ed error
      q1=0.798
      q4=0.968
      id28=2**30
      error=0.
      errpes=0.
      anum=0.
      nundet=0
      salf=0.0
      salfe=0.0
      salfer=0.0
      dalfa=0.0
      dalf1=0.0
      dalf2=0.0
      dalf3=0.0
      absfom=0.0

      D1N = 0.0

      ssigt=ssig
c
      anumw=0.
      dpsa=0.0
      dps1=0.0
      dps2=0.0
      dps3=0.0
      if (icent.le.0) then
          sigmp = 2.0*sigm
          sigmq = 2.0*sigm*sigm
      else
          sigmp = sigm
          sigmq = sigm * sigm
      endif
      do k=1,nstr
         ntrr(k)=0
         eec(k)=0
         wt(k)=abs(wt(k))
         alphaVet(k)=0.0
c
         kcr = 1
         li = limref(kcr,k)*4 + 1
         ls = limref(kcr,k+1)*4
         if (li.gt.ls) then
             nundet = nundet + 1
             go to 6500
         endif
c
         if (wt(k).le.zeroB) then
            nundet = nundet + 1
            iphaz(k)=0
            wt(k)=0.0
         else
            sang = 0.0
            cang = 0.0
            ist = 4
            kcr = 1      ! triplets only
            li = limref(kcr,k)*ist + 1
            ls = limref(kcr,k+1)*ist  
            do jj = li,ls,ist
               nn(1) = iph(jj)
               nn(2) = iph(jj+1)
               nn(3) = 0
               a1 = 0.01 * iph(jj+2)
               ifaz = iph(jj+3)
               a1 = abs(a1)
               ila = iabs(nn(1))
               ira = iabs(nn(2))
               if (wt(ila).gt.zeroA.and.wt(ira).gt.zeroA) then
                  ip = isign(iphaz(ila),nn(1)) 
     *               + isign(iphaz(ira),nn(2))
     *               +  15*ifaz
                  a1 = sigmp*evet(ila)*evet(ira)
                  ip = mod(ip+36000,360) + 1
                  sang = sang + a1 * sint(ip)
                  cang = cang + a1 * cost(ip)
               endif
            end do
            if (mkang(k).ne.1) then
               idv = 15*mod(iabs(mkang(k))-1,12) + 1
               t2 = sang*sint(idv) + cang*cost(idv)
               sang = t2*sint(idv)
               cang = t2*cost(idv)
            end if
            if(abs(sang).lt.0.1e-15) sang = 0.0
            if(abs(cang).lt.0.1e-15) cang = 0.0
            alphaVet(k) = sqrt( sang*sang + cang*cang )
            anum = anum + 1.
         end if
         ntrr(k) = limref(1,k+1)-limref(1,k) ! +limref(2,k+1)-limref(2,k)
         salf = salf + alphaVet(k)
c
c MABS calcolata solo sui riflessi fasati
c
         if(wt(k).gt.zeroB) then
            salfe = salfe + alfest(k)
         end if
c
         if (knw.gt.0 .and. wt(k).gt.zeroB) then
             salfer = salfer + alphaVet(k)
             ip = iabs(ipub(k) - iphaz(k))
             delta = min0(ip,360-ip)
             error = error + delta
             errpes = errpes + delta * alphaVet(k)
          endif
 6500    continue
      end do
c
c-- undetermined phases number too high
c
      if (nundet.ge.(nstr/2). and. neutro /= 2) then     ! PROVA gianluca 6/10/06
          almed = 0.0
*NEW*
          error  = erore
          errpes = erorepes
*NEW*
          return
      endif
c NEW introduco ciclo sui rifl. deboli
      if (ifOldFoms == 1) then
          if (num0 > 0) then
              do k=1,num0
                 alpha0(k)=0.0
                 ntr0(k)=0.0
                 ee0(k)=0.0
c test per riconoscere i rifl. senza tripl. psi-0
                 if (alfest0(k) < 0.000001 .and. 
     *               alfvar0(k) < 0.000001) cycle
                 li=lim0n(k)+1
                 ls=lim0n(k+1)
                 if (li > ls) cycle
                 sang = 0.0
                 cang = 0.0
                 do j=li,ls
*                   iph0n(j)=mod(iph0n(j),id28)
                    call unpak3Sir(iph0n(j),k1,k2,ifaz)
                    ila = iabs(k1)
                    ira = iabs(k2)
                    if (iphaz(ila) == 0 .or. iphaz(ira) == 0) cycle
                    ip = isign(iphaz(ila),k1) + isign(iphaz(ira),k2)
     *                 +  15*ifaz
                    arg = float(ip) * dtor
                    a1 = sigmp * evet(ila) * evet(ira)
                    sang = sang + a1 * sin(arg)
                    cang = cang + a1 * cos(arg)
                 enddo
                 kk=psicode(k)
                 if (mkang(kk) /= 1) then
                     idv  = 15 * mod(iabs(mkang(kk))-1, 12)
                     arg  = float(idv) * dtor
                     t2   = sang * sin(arg) + cang * cos(arg)
                     sang = t2 * sin(arg)
                     cang = t2 * cos(arg)
                 endif
                 if (abs(sang).lt.0.1e-15) sang=0.0
                 if (abs(cang).lt.0.1e-15) cang=0.0
                 alpha0(k) = sqrt( sang*sang + cang*cang )
                 anumw = anumw+1.
                 ntr0(k) = ls - li + 1
              enddo
          endif
      endif
!
      absfom=0.0
      if(salfe.gt.0.0001) then
         absfom = salf / salfe
      end if

      do k=1,nstr
         eec(k)=0.0
         if (ntrr(k).ne.0 .and. wt(k).ge.zeroC) then
!
!--        rescaling of alpha
!--          alpha = alfa calcolato dalla tangente
!--          alfest = alfa stimato dai G
!--          alfvar = alfa random
!
            eec(k) = alphaVet(k) / ntrr(k)
            if (absfom .gt. 0.0001) then
               alphaVet(k) = alphaVet(k) / absfom
            end if
            seec = seec + eec(k)
            seeo = seeo + evet(k)
            dalf2 = dalf2 + (alfest(k)-alphaVet(k))
     *                    * (alfest(k)-alphaVet(k))
            if (alfvar(k) .ge. 0.0001) then
               davi = (alfest(k) - alphaVet(k)) / alfvar(k)
               dalf3 = dalf3 + abs( davi )
               davi = davi * davi
               dalfa = dalfa + davi
               dalf1 = dalf1 + abs(davi - 1.0)
            end if
         end if
      end do
      if (salfer .gt. 0.00001) then
         errpes = errpes / salfer
      end if
!
      if (ifOldFoms == 1) then
          if (num0 > 0) then
              do k=1,num0
                 ee0(k)=0.0
                 if (ntr0(k) == 0) cycle
                 ee0(k)=alpha0(k)/ntr0(k)
                 see0=see0+ee0(k)
                 seo0=seo0+evet(psicode(k))
!
                 dps2 = dps2 + (alfest0(k) - alpha0(k))
     *                       * (alfest0(k) - alpha0(k))
                 if (alfvar0(k).lt.0.0001) cycle
                 dpsi=(alfest0(k)-alpha0(k))/alfvar0(k)
                 dps3 = dps3 + abs( dpsi )
                 dpsi=dpsi*dpsi
                 dpsa=dpsa+dpsi
                 dps1=dps1+abs(dpsi-1.0)
              enddo
          endif
! NEW calcolo coeffic. di correlaz. tra Ecalc ed Eobs (1/8/'91)
          ww0 = 1.0
          if (absfom > 0.0001) then
              ww0 = 1.0 / absfom
          endif
          dps3 = dps3 * ww0
          dpsa = dpsa * ww0
          dps1 = dps1 * ww0
          dps2 = dps2 * ww0
! NEW calcolo coeffic. di correlaz. tra Ecalc ed Eobs (1/8/'91)
      endif
!
      scon = anum + anumw
      if (scon.gt.0.1) then
          ecm = (seec + see0) / scon
          eom = (seeo + seo0) / scon
      endif
      do k=1,nstr
         if (ntrr(k) > 0) then
             ccorc = eec(k) - ecm
             ccoro = evet(k) - eom
             scor1 = scor1 + ccorc * ccoro
             scor2 = scor2 + ccorc * ccorc
             scor3 = scor3 + ccoro*ccoro
             eec(k) = alphaVet(k) / (ckae * ntrr(k))
             rcarl1 = rcarl1 + abs(evet(k) - eec(k))
             rcarld1 = rcarld1 + evet(k)
         endif
      end do
      if (ifOldFoms == 1) then
          if (num0 > 0) then
              do k=1,num0
                 if (ntr0(k) == 0) cycle
                 ccorc  = ee0(k)-ecm
                 ccoro  = evet(psicode(k))-eom
                 scor1  = scor1+ccorc*ccoro
                 scor2  = scor2+ccorc*ccorc
                 scor3  = scor3+ccoro*ccoro
                 ee0(k) = alpha0(k)/(ckae0*ntr0(k))
                 rcarl1 = rcarl1+abs(evet(psicode(k))-ee0(k))
                 rcarld1= rcarld1+evet(psicode(k))
              enddo
          endif
      endif
!
      coeco=-9999
      if (scor2*scor3 .gt. 0) then
         coeco = scor1 / sqrt(scor2*scor3)
      end if
      if (rcarld1.gt.0.0) then
         rcarl1 = rcarl1 / rcarld1
      end if
c
c++++++++++++++++
c calcolo le sommatorie complessive (forti + deboli)
      anumt = anum + anumw
      if(anumt.gt.0.1) anumt=1.0/anumt
      alfp1 = (dalf3 + dps3) * anumt
      alfp3 = (dalfa + dpsa) * anumt
      alfp4 = (dalf1 + dps1) * anumt

      alfp2 = 0.00001
      if (ssigt.gt.0.0001) then
         alfp2=(dalf2+dps2)/ssigt
      end if
c
c valori passati alla nuova fomsp comprendenti le vecchie alcom e psicom
      resid  = alfp2
      almed  = alfp1
      al2    = alfp3
      al2m1  = alfp4
      if (anum.gt.0.1) then
         anum=1.0 / anum
      end if
      error  = error * anum
*NEW*
      error  = erore
      errpes = erorepes
*NEW*
!
      return
      end
c----------------------------------------------------------------------
      subroutine fomsp(nuset, reje)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
c
      common /a2003/ aMabsNew,alf2003,ald2003,D1N,D1D,aMabsDD
      character*10 reje
!     equivalence (iyzz,figMer(11))
!     equivalence (npuntEquiv,jjpunt(4001))
c
      jSkipTrial = 0
*     nuset = numbrun
c
      if (ifOldFoms == 0) then
          if (kmad.eq.0) then        !!!!  da rivedere .....
              coeco = coms
              if (ksize.le.3) then
                  coms  = FOMs(1,4)
             else
                coms  = FOMs(1,4)
             endif                   !!!!  .... fino a qui
             crel = 0.0
          else
             crel = FOMs(1,4)
             call norm_fom()
          endif
      else
          call OldFoms()
      endif
      if (coms.gt.f18mx) f18mx= coms
      if (coms.lt.f18mn) f18mn= coms

  586 continue
      SetsStored=SetsStored+1
      if (nuset.le.MaxRun) cfomx=f18mx

      reje = '        '     !120105

      if (jSkipTrial.eq.0) then
          if (SetsStored == MaxToStore .and. ifCombinedFom == 1) then
              fomrtN(MaxToStore, 1:6) = fomBuff(1:6)
              if (MaxToStore > 1) then
                  call CombinaFom(1)
                  coms = Foms(1,4)
              endif
          endif
          if (ifCycTang > 1) then
              nsind = trial_pert
          else
              if (SetsStored.le.MaxToStore) then
                  nsind=SetsStored
                  if (SetsStored.eq.1) then
                      aminco=9999.0
                  endif
                  if (coms.lt.aminco) aminco=coms
              else
                  aminco=fomrt(1,5)
                  nsmin=1
                  do idn=2,MaxToStore
                     if (fomrt(idn,5).lt.aminco) then
                         aminco=fomrt(idn,5)
                         nsmin=idn
                     endif
                  enddo
                  nsind=nsmin
                  reje = '        '
                  if (coms.lt.aminco) then     !<<<<<<<<<<!
                      nfoml=nfoml+1
                      reje = 'Rejected'
                      jSkipTrial = 1
                  endif
              endif
          endif
      endif
     
      if (jSkipTrial.eq.0) then
          if (nundet >=  nstr/2) then
              coms = 0.0
          endif
          fomrt(nsind, 1) = absfom  !<  mabs
          if (ifOldFoms == 0) then
              fomrt(nsind, 2) = 0.0 !alcom
          else
              fomrt(nsind, 2) = alcom
          endif
          fomrt(nsind, 3) = coeco   !<  R(x,y)
          fomrt(nsind, 4) = crel    !<  early fom
          fomrt(nsind, 5) = coms    !<  combinata normalizzata
          fomrt(nsind, 6) = nundet
          fomrt(nsind, 7) = erore
          fomrt(nsind, 8) = erorepes
          fomrt(nsind, 9) =  0            !   enan
          fomrt(nsind,10) = numbrun  !nuset
          psivet(nsind)=psicom
!
          if (ifCombinedFom == 1) then
              fomrtN(nsind, 1:6) = fomBuff(1:6)
          endif
!
          iyrandEquiv=iyrand
          nurec=nsind
          do j=1,10
             figMer(j)=fomrt(nsind,j)
          end do

!  prova per il miglioramento di nstr fasi via psi0
!               izero = 0
!               ifmin = 1
!               nbru = -33
!               call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
!               do i=1, nstr
!                  write(55,'(i6,f10.7)') iphaz(i),wt(i)
!               enddo


!gl!      call snw16(nurec,figMer,wt,iphaz)
          call PutGetInitialPhases(1, nurec, figMer, wt, iphaz)
      else
         SetsStored = SetsStored - 1
      endif

      percdet= float((nstr-nundet)) / float(nstr)

      if (kmad == 0) then
          stampa(3) = fomBuff(6)
          stampa(4) = fomBuff(4)
          stampa(5) = fomBuff(5)
          stampa(  7) = coms
      else
          stampa( 1)=coms
          stampa( 2)=nuset
          stampa( 3)=absfom
          if (ifOldFoms == 0) then
              stampa( 4)= 0 !alcom
              stampa( 5)= 0 !psicom
          else
              stampa( 4)= alcom
              stampa( 5)= psicom
          endif
!         stampa( 6)=coeco
!               stampa( 6)=aMabsNew   !  MABS new
                stampa( 6)=aMabsDD    !  MABS new Sum(D1alpha) / Sum(D1alfest)
!         stampa( 7)=coms
                stampa( 7)=coms      ! sara' sostituito da NUM new (RAT)
      endif
      stampa( 8)=percdet
      stampa( 9)=error
      stampa(10)=errpes
      stampa(11)=0.0
      stampa(12)=0.0
      stampa(13)=0.0
      stampa(14)=0.0
!     write(6,666) absfom ,alcom ,psicom ,coeco ,crel ,coms ,nundet
!    *             ,error ,errpes ,enan ,nuset, reje
! 666 format('FOMs',6f7.3,i5,2f6.2,f7.3,i5,2x,a8)
      return
      end
!-----------------------------------------------------------------------
      subroutine OldFoms()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!
      integer nq1(1), nq2(1), nq3(1)  ! quartetti enantiomorfi: da sistemare
!
      jall = 0
      coms=0.0
      al2m1=al2m1/attl2
      almed=almed/attl3
      alcom=0.25*(sqrt(al2)+sqrt(al2m1)+sqrt(resid)
     1         +      almed)
      if (absfom.gt.f1mx) f1mx=absfom
      if (absfom.lt.f1mn) f1mn=absfom
      if (resid .gt.f2mx) f2mx=resid
      if (resid .lt.f2mn) f2mn=resid
      if (al2  .gt.f21mx) f21mx=al2
      if (al2  .lt.f21mn) f21mn=al2
      if (al2m1.gt.f22mx) f22mx=al2m1
      if (al2m1.lt.f22mn) f22mn=al2m1
      if (almed.gt.f23mx) f23mx=almed
      if (almed.lt.f23mn) f23mn=almed
      if (alcom.gt.f13mx) f13mx=alcom
      if (alcom.lt.f13mn) f13mn=alcom
      foms1 = 0.0
      foms2 = 0.0
      fomqn = 0.0
      sgtot = 0.0
c
c  *******     negative quartet f.o.m.   *******
c
      fqnnum = 0.0
      fomqn  = 0.0
      sgq    = 0.0
c
      gmqn = 0.0
      nqn = 0
      if (nquar > 0) then
          do i=1,nquar
             call unpak3Sir(iqu1(i),k1,k2,ifaz)
             call unpak3Sir(iqu2(i),k3,k4,ifaz)
             call unpak3Sir(iqu3(i),k5,k6,ifaz)
             ka1=iabs(k1)
             ka2=iabs(k2)
             ka3=iabs(k3)
             ka4=iabs(k4)
             g=abs(float(k6)*0.01)
             if (iphaz(ka1).eq.0.or.iphaz(ka2).eq.0.or.
     *           iphaz(ka3).eq.0.or.iphaz(ka4).eq.0) cycle
             iarg = isign(iphaz(ka1),k1) + 
     *              isign(iphaz(ka2),k2) +
     1              isign(iphaz(ka3),k3) +
     *               isign(iphaz(ka4),k4) + 15 * ifaz
             arg=float(iarg)*dtor
             fomqn=fomqn - g*cos(arg)
             sgq=sgq + g * bes(g)
c
             gmqn=gmqn+g
             nqn=nqn+1
c
          enddo
          fqnnum=fomqn
          sgtot=sgtot + sgq
          if (sgq > 0.00001) then
              fomqn=fomqn/sgq
          endif
      endif
      if (fomqn.gt.f5mx) f5mx=fomqn
      if (fomqn.lt.f5mn) f5mn=fomqn
c
c  *******   psi-zero  f.o.m.    *******
c  -------   psi0, rpsi-1, rpsi-2, abspsi   -----------
c
c nuova procedura - psicom compresa in alcom
      rpsi1=0.0
      rpsi2=0.0
      abspsi=0.0
      fomps0=0.0
      psicom=0.0
c
c-new vecchio calcolo psicom - non inclusa in cfom
c
!orig sigm=sigmp
!orig if (icent.le.0) sigm=2.0*sigmp
      sigmaOld=sigm
      if (icent.le.0) sigmaOld=2.0*sigm
      id28=2**30
      attps1=0.215
      attps2=0.736
      attps3=1.0
      attps4=0.886
      if (num0 >0) then
          s1=0.0
          s2=0.0
          do i=1,num0
             li=lim0n(i) + 1
             ls=lim0n(i+1)
             if (ls < li) cycle
             t1=0.0
             t2=0.0
             t4=0.0
             do j=li,ls
*               iph0n(j)=mod(iph0n(j),id28)
                call unpak3Sir(iph0n(j),k1,k2,ifaz)
                ka1=iabs(k1)
                ka2=iabs(k2)
                if(iphaz(ka1).eq.0.or.iphaz(ka2).eq.0) cycle
                iarg=isign(iphaz(ka1),k1) + isign(iphaz(ka2),k2) +
     *           ifaz*15
                arg = float(iarg) * dtor
                ee=evet(ka1)*evet(ka2)
                t3=sigmaOld*ee
                t4=t4 + t3*t3
                t1=t1 + t3*cos(arg)
                t2=t2 + t3*sin(arg)
             enddo
             t11=sqrt(t1*t1 + t2*t2)
             t4=sqrt(t4)
             s1=s1 + t11
             s2=s2 + t4
             t3=0.0
             if (t4.gt.0.0001) t3=t11/t4
             s10=t3*t3
             t1=0.886
             if (icent.gt.0) t1=0.798
             rpsi1=rpsi1+(t3-t1  )*(t3-t1  )
             rpsi2=rpsi2+abs(s10  -1.0)
             abspsi=abspsi + s10
          enddo
          t3=1.0/float(num0)
          rpsi1=rpsi1  * t3 / attps1
          rpsi2=rpsi2  * t3 / attps2
          abspsi=abspsi * t3
          if (abs(s2).gt.0.0001) fomps0=s1/(s2*attps4)
          if (absfom.gt.0.001) then
              psicom = 0.25 * ( fomps0 + sqrt( rpsi1 )
     1               + sqrt( rpsi2 ) + sqrt( abspsi )) / absfom
          else
              psicom = 0.0
          endif
c-endnew
      endif
      if (fomps0.gt.f7mx) f7mx=fomps0
      if (fomps0.lt.f7mn) f7mn=fomps0
      if (rpsi1.gt.f10mx) f10mx=rpsi1
      if (rpsi1.lt.f10mn) f10mn=rpsi1
      if (rpsi2.gt.f11mx) f11mx=rpsi2
      if (rpsi2.lt.f11mn) f11mn=rpsi2
      if (abspsi.gt.f12mx) f12mx=abspsi
      if (abspsi.lt.f12mn) f12mn=abspsi
!
! *****    negative triplets  f.o.m.    *****
!
      fomntr=0.0
      ftrnum=0.0
      sgt=0.0
      if (ntrn >0) then
          do i=1,ntrn
             call unpak3Sir(negt1(i),k1,k2,ifaz)
             call unpak3Sir(negt2(i),k3,k4,ifaz)
             ka2=iabs(k2)
             ka3=iabs(k3)
             g=k4*0.01
             ga=abs(g)
             if (iphaz(k1).eq.0.or.iphaz(ka2).eq.0.or.
     *           iphaz(ka3).eq.0) cycle
             iarg=iphaz(k1)+isign(iphaz(ka2),k2)+isign(iphaz(ka3),k3)
     *        + 15*ifaz
             arg = float(iarg) * dtor
             fomntr=fomntr -ga*cos(arg)
             sgt=sgt+ ga *bes(ga)
c
             gmqn=gmqn+ga
             nqn=nqn+1
c
          enddo
          ftrnum=fomntr
          sgtot=sgtot + sgt
          if (sgt > 0.00001) then
              fomntr = fomntr / sgt
          endif
      endif
      if (fomntr.gt.f6mx) f6mx=fomntr
      if (fomntr.lt.f6mn) f6mn=fomntr
      if (nqn.gt.0) then
          gmqn=gmqn/nqn
          wqtn=sqrt(bes(gmqn))
      else
          wqtn=0.0
      endif
!
!  *******  enantiomorph sensitive  f.o.m. ' s
!
      fents=0.0
      fenqs=0.0
      gfx=0.1
      ren1=0.0
      gents=0.0
      ren2=0.0
      genqs=0.0
!
!-- skip if space group is centrosymmetric  ----
!
      if (icent == 0) then
!
!  +++++++     triplet  f.o.m.' s    +++++++
!
          if (nen > 0) then
              n=0
              do i=1,nen
                 call unpak3Sir(nent1(i),k1,k2,ifaz)
                 call unpak3Sir(nent2(i),k3,k4,ifaz)
                 ka2=iabs(k2)
                 ka3=iabs(k3)
                 if (iphaz(k1).eq.0.or.iphaz(ka2).eq.0.or.
     *              iphaz(ka3).eq.0) cycle
                 iarg = iphaz(k1)+isign(iphaz(ka2),k2)
     *                 +isign(iphaz(ka3),k3) + 15*ifaz
                 arg = float(iarg) * dtor
                 fents=fents + abs(cos(arg))
                 n=n + 1
              enddo
              if (n > 0) then
                  ren1=float(n)*gfx
                  gents=fents*gfx
                  s1=1.0/float(n)
                  fents=fents*s1
              endif
          endif
          if (fents.gt.f8mx) f8mx=fents
          if (fents.lt.f8mn) f8mn=fents
!
!  +++++++     quartet  f.o.m.' s    +++++++
!
          if (nqen > 0) then
              n=0
              do i=1,nqen
                 call unpak3Sir(nq1(i),k1,k2,ifaz)
                 call unpak3Sir(nq2(i),k3,k4,ifaz)
                 call unpak3Sir(nq3(i),k5,k6,ifaz)
                 ka1=iabs(k1)
                 ka2=iabs(k2)
                 ka3=iabs(k3)
                 ka4=iabs(k4)
                 if (iphaz(ka1).eq.0.or.iphaz(ka2).eq.0.or.
     *               iphaz(ka3).eq.0.or.iphaz(ka4).eq.0) cycle
                 iarg = isign(iphaz(ka1),k1) + isign(iphaz(ka2),k2) +
     1                  isign(iphaz(ka3),k3) + isign(iphaz(ka4),k4) + 
     *                  15*ifaz
                 arg=float(iarg) * dtor
                 fenqs=fenqs + abs(sin(arg))
                 n=n + 1
              enddo
              if (n > 0) then
                  ren2=float(n)*gfx
                  genqs=fenqs*gfx
                  s1=1.0/float(n)
                  fenqs=fenqs*s1
              endif
          endif
          if (fenqs.gt.f9mx) f9mx=fenqs
          if (fenqs.lt.f9mn) f9mn=fenqs
      endif
      if (sgtot.gt.0.00001) coms = (fqnnum + ftrnum  ) / sgtot
      if (jall.eq.1)
     *write(lo,2220) numbrun,fqnnum,sgq,ftrnum,sgt,gents,ren1,genqs,ren2
 2220 format(1x,i4,4(2x,2f8.2))
c--
      den12=ren1+ren2
      enan=0.0
      if (abs(den12).gt.0.00001) enan=(gents+genqs)/den12
!
! ======= compute  combined  f.o.m.
!
      if (f1mn.gt.1.0e+19) f1mn=0.0
      if (f2mn.gt.1.0e+19) f2mn=0.0
      if (f21mn.gt.1.0e+19) f21mn=0.0
      if (f22mn.gt.1.0e+19) f22mn=0.0
      if (f23mn.gt.1.0e+19) f23mn=0.0
      if (f3mn.gt.1.0e+19) f3mn=0.0
      if (f4mn.gt.1.0e+19) f4mn=0.0
      if (f5mn.gt.1.0e+19) f5mn=0.0
      if (f6mn.gt.1.0e+19) f6mn=0.0
      if (f7mn.gt.1.0e+19) f7mn=0.0
      if (f8mn.gt.1.0e+19) f8mn=0.0
      if (f9mn.gt.1.0e+19) f9mn=0.0
      if (f10mn.gt.1.0e+19) f10mn=0.0
      if (f11mn.gt.1.0e+19) f11mn=0.0
      if (f12mn.gt.1.0e+19) f12mn=0.0
      if (f13mn.gt.1.0e+19) f13mn=0.0
      if (f1mx.lt.-1.0e+19) f1mx=0.0
      if (f2mx.lt.-1.0e+19) f2mx=0.0
      if (f21mx.lt.-1.0e+19) f21mx=0.0
      if (f22mx.lt.-1.0e+19) f22mx=0.0
      if (f23mx.lt.-1.0e+19) f23mx=0.0
      if (f3mx.lt.-1.0e+19) f3mx=0.0
      if (f4mx.lt.-1.0e+19) f4mx=0.0
      if (f5mx.lt.-1.0e+19) f5mx=0.0
      if (f6mx.lt.-1.0e+19) f6mx=0.0
      if (f7mx.lt.-1.0e+19) f7mx=0.0
      if (f8mx.lt.-1.0e+19) f8mx=0.0
      if (f9mx.lt.-1.0e+19) f9mx=0.0
      if (f10mx.gt.1.0e+19) f10mx=0.0
      if (f11mx.gt.1.0e+19) f11mx=0.0
      if (f12mx.gt.1.0e+19) f12mx=0.0
      if (f13mx.gt.1.0e+19) f13mx=0.0
      if (jall.eq.1)
     *write(lo,510) f1mn,f23mn,f2mn,f21mn,f22mn,f3mn,f4mn,f5mn,f6mn,
     * f7mn,f12mn,f11mn,f10mn,f8mn,f9mn,
     *              f1mx,f23mx,f2mx,f21mx,f22mx,f3mx,f4mx,f5mx,f6mx,
     * f7mx,f12mx,f11mx,f10mx,f8mx,f9mx
  510 format(/// 30x,'++++++++++  figures  of  merit  ++++++++++'//
     *8x,'mabs ',' nalf(1)',' nalf(2)',' nalf(3)',' nalf(4)','    ss1 ',
     *'    ss2 ','    nqu ','    ntr ','  nps(0)','  nps(1)','  nps(2)',
     *'  nps(3)','   entr ','   enqu ',
     * //,' min',15f8.3/,' max',15f8.3)
      if (jall.eq.1) write (lo,530)
  530 format(///' trial',2x,'mabs ',
     *           ' nalf(1)',' nalf(2)',' nalf(3)',' nalf(4)','    ss1 ',
     *'    ss2 ','    nqu ','    ntr ','  nps(0)','  nps(1)','  nps(2)',
     *'  nps(3)','   entr ','   enqu ',/)
      if (jall.eq.1)
     *write(lo,550) numbrun,absfom,almed,resid,al2,al2m1,
     * foms1,foms2,fomqn,fomntr,fomps0,abspsi,
     * rpsi2,rpsi1,fents,fenqs
  550 format(1x,i3,17f8.3)
      if (nundet >= (nstr/2) ) then
          alcom=0.0
          psicom=0.0
          crel=0.0
          coms=0.0
      else
          crel=coms
          if (alcom.gt.0.8) then
              arg=( alcom  -0.8 )**1.5
              if (arg.gt.87.0) then
                  alcom=0.0
              else
                  alcom=exp( -arg )
              endif
          else
              alcom=1.0
          endif
c-
          if (psicom.gt.0.8) then
              psicom=exp( -(( psicom -0.8 )**1.5))
          else
              if (num0.eq.0) then
                  psicom=0.0
              else
                  psicom=1.0
              endif
          endif
c-
          if (nphas > 0) then
              if (crel.gt.0.00001.or.crel.lt.-0.00001) then
                  if (crel.lt.1.2) then
                      crel =exp( -(( 1.2 - crel  )**1.5))
                  else
                      crel=1.0
                  endif
              endif
          endif
          if (alcom.gt.f15mx) f15mx=alcom
          if (alcom.lt.f15mn) f15mn=alcom
          if (psicom.gt.f14mx) f14mx=psicom
          if (psicom.lt.f14mn) f14mn=psicom
          if (coeco.gt.f16mx) f16mx=coeco
          if (coeco.lt.f16mn) f16mn=coeco
          if (crel.gt.f17mx) f17mx=  crel
          if (crel.lt.f17mn) f17mn=  crel
          swwn=1.0/(1.0+wqtn)
          coms=swwn*( crel*wqtn + alcom )
          if (coms.gt.f18mx) f18mx= coms
          if (coms.lt.f18mn) f18mn= coms
          enan=asin(enan)*rtod
      endif
      FOMs(1,4) = coms
!
      return
      end
!-----------------------------------------------------------------------
      subroutine norm_fom()
      USE General
      USE Symmetry
      USE PhaseModule
!
!          CALCOLO NUOVA COMBINATA: MABS + R(X,Y) + eFOM

      noset = min(SetsStored, MaxToStore)
      do i=1,noset
         if ( fomrt(i,1) < ff1mn) ff1mn = fomrt(i,1)
         if ( fomrt(i,1) > ff1mx) ff1mx = fomrt(i,1)
         if ( fomrt(i,3) < ff3mn) ff3mn = fomrt(i,3)
         if ( fomrt(i,3) > ff3mx) ff3mx = fomrt(i,3)
         if ( fomrt(i,4) < ff4mn) ff4mn = fomrt(i,4)
         if ( fomrt(i,4) > ff4mx) ff4mx = fomrt(i,4)
      end do
      if ( absfom < ff1mn) ff1mn = absfom
      if ( absfom > ff1mx) ff1mx = absfom
      if ( coeco < ff3mn) ff3mn = coeco
      if ( coeco > ff3mx) ff3mx = coeco
      if ( crel < ff4mn) ff4mn = crel
      if ( crel > ff4mx) ff4mx = crel

      ff5mx=-1.0e+20
      ff5mn=1.0e+20
      do i=1,noset
         amabsnorm = (fomrt(i,1)-ff1mn) / (ff1mx-ff1mn)
         coeconorm = (fomrt(i,3)-ff3mn) / (ff3mx-ff3mn)
         eFomnorm = (fomrt(i,4)-ff4mn) / (ff4mx-ff4mn)
         if (anat <= 0) then                                  !120105
            fomrt(i,5) = (amabsnorm + coeconorm + eFomnorm) / 3.
         else
!pgMAD170206
!            fomrt(i,5) = (amabsnorm + eFomnorm) / 2.
         end if
         if (fomrt(i,5) < ff5mn) ff5mn = fomrt(i,5)
         if (fomrt(i,5) > ff5mx) ff5mx = fomrt(i,5)
      enddo
!pgMAD200206
!      if (noset > 0) then
         if (anat <= 0) then                                  !120105
            amabsnorm = (absfom-ff1mn) / (ff1mx-ff1mn)
            coeconorm = (coeco-ff3mn) / (ff3mx-ff3mn)
            eFomnorm = (crel-ff4mn) / (ff4mx-ff4mn)
            coms = (amabsnorm + coeconorm + eFomnorm) / 3.
         else
!pgMAD170206
!            coms = (amabsnorm + eFomnorm) / 2.
            coms = crel
         end if
!pgMAD200206
!      else
!         coms = 1.
!      end if
      if (coms < ff5mn) ff5mn = coms
      if (coms > ff5mx) ff5mx = coms

!      write(lo,' ')
!      do i=1,noset
!         write(lo,100)i,fomrt(i,1),fomrt(i,3),fomrt(i,4),fomrt(i,5)
!      end do
!      write(lo,' ')
!      write(lo,100)nuset,absfom,coeco,crel,coms
!      write(lo,150) ff1mn,ff3mn,ff4mn,ff5mn
!      write(lo,160) ff1mx,ff3mx,ff4mx,ff5mx
!  100 format(i3,') ',4f7.3)
!  150 format('min  ',4f7.3)
!  160 format('max  ',4f7.3)

      return
      end
c-----------------------------------------------------------------------
      subroutine fomspinit
      USE General
      USE PhaseModule
!
      integer, allocatable :: imat(:,:)
      integer              :: imat0(1)
!
!-- initialize max and min for figures of merit
!     ....  per absfom
      f1mx=-1.0e+20
      f1mn=1.0e+20
c     ....  per resid
      f2mx=-1.0e+20
      f2mn=1.0e+20
c     ....  per al2
      f21mx=-1.0e+20
      f21mn=1.0e+20
c     ....  per al2m1
      f22mx=-1.0e+20
      f22mn=1.0e+20
c     ....  per almed
      f23mx=-1.0e+20
      f23mn=1.0e+20
c     ....  per ss1
      f3mx=-1.0e+20
      f3mn=1.0e+20
c     ....  per ss2
      f4mx=-1.0e+20
      f4mn=1.0e+20
c     ....  per nquest
      f5mx=-1.0e+20
      f5mn=1.0e+20
c     ....  per ntrest
      f6mx=-1.0e+20
      f6mn=1.0e+20
c     ....  per psi-0
      f7mx=-1.0e+20
      f7mn=1.0e+20
c     ....  per ensintr
      f8mx=-1.0e+20
      f8mn=1.0e+20
c     ....  per ensinqu
      f9mx=-1.0e+20
      f9mn=1.0e+20
c     ....  per rpsi0-1
      f10mx=-1.0e+20
      f10mn=1.0e+20
c     ....  per rpsi0-2
      f11mx=-1.0e+20
      f11mn=1.0e+20
c     ....  per abspsi0
      f12mx=-1.0e+20
      f12mn=1.0e+20
c     ....  per alcom
      f13mx=-1.0e+20
      f13mn=1.0e+20
c     ....  per psicom
      f14mx=-1.0e+20
      f14mn=1.0e+20
c     ....  per alcom normalizzata
      f15mx=-1.0e+20
      f15mn=1.0e+20
c     ....  per coeff. di correlazione
      f16mx=-1.0e+20
      f16mn=1.0e+20
c     ....  per cphase
      f17mx=-1.0e+20
      f17mn=1.0e+20
c     ....  per cfom
      f18mx=-1.0e+20
      f18mn=1.0e+20
c     ....  per MAD fig. of mer.
      ff1mx=-1.0e+20
      ff1mn=1.0e+20
      ff3mx=-1.0e+20
      ff3mn=1.0e+20
      ff4mx=-1.0e+20
      ff4mn=1.0e+20
      ff5mx=-1.0e+20
      ff5mn=1.0e+20
!
      sigm = s3s2
!
! *********************************************************
!
!  lettura file relazioni
!
! *********************************************************
      if (ifOldFoms == 1) then

          go to 111

          nen = 0
          iprea = 0
! -----
!     call sub. lettura lista 20 : quartetti negativi
! -----
          if (lfw > 0) then
              ipre = -1
              iDim = 1
              call sflxx(ipre,20,nqua,nqua,nxxd,nxxe,iccd,
     *                   iAll,imat0,iDim)
              iAll = 1
              iDim = 7 * nqua
              ALLOCATE (imat(7,nqua), stat = ierr)
              if (ierr.ne.0) then
                  write(lo,*) 'imat Allocation error'
                  call cstop(' ')
              endif
              call sflxx(iprea,20,nqua,nqua,nxxd,nxxe,iccd,
     *                   iAll,imat,iDim)
              nquar=min0(750,nqua)
              do i=1,nquar
                 iqu1(i)=imat(1,i)
                 iqu2(i)=imat(2,i)
                 iqu3(i)=imat(3,i)
              enddo
              DEALLOCATE (imat, stat = ierr)
          endif
! -----
!     call sub. lettura lista 11 : tripletti enantiomorfi
! -----
          ndim = max0(nen, ntrn)
          if (ndim > 0) then
              ALLOCATE (imat(3,1:ndim), stat = ierr)
              if (ierr.ne.0) then
                 write(lo,*) 'imat Allocation error'
                 call cstop(' ')
              endif

              if (lfw > 0) then
                  iAll = 0
                  iDim = 3 * nen
                  call sflxx(iprea,11,nen,nen,idm1,idm2,idm3,
     *                       iAll,imat,iDim)
                  do i=1,nen
                     nent1(i)=imat(1,i)
                     nent2(i)=imat(2,i)
                  enddo
              endif
! -----
!     call sub. lettura lista 10 : tripletti negativi
! -----
              if (lfw > 0) then
                  iAll = 0
                  iDim = 3 * ntrn
                  call sflxx(iprea,10,nxxa,ntrn,idm1,idm2,idm3,
     *                       iAll,imat,iDim)
                  do i=1,ntrn
                     negt1(i)=imat(1,i)
                     negt2(i)=imat(2,i)
                  enddo
              endif
              DEALLOCATE (imat, stat = ierr)
          endif
!
          nphas = ntrn + nquar

  111     continue

          attl2 = 0.968
          attl3 = 0.798
      endif
!

      return
      end
c-----------------------------------------------------------------------
      subroutine punts1()
      USE General
      USE Riflessi
      USE PhaseModule
c
      dimension jhk(3)
!     equivalence (npuntEquiv, jjpunt(4001))
c
      do i=1,nstr
         do j=1,3
            jhk(j) = khl(j,i)
         enddo
         ks=modulo_sir(jhk)
         if (ks.eq.0) then
             npuntEquiv=npuntEquiv+1
             jjpunt(npuntEquiv)=i
!            write(6,*) 'punts1',npuntEquiv,i,jhk,ipub(i)
         endif
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FOM_Early(corre)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
c
c-- fomBuff(1) = fomrtN(trial,1) = Fom sui tripletti
c-- fomBuff(2) = fomrtN(trial,2) = RES su numbLSQ
c-- fomBuff(3) = fomrtN(trial,3) = RES su weak
c-- fomBuff(4) = fomrtN(trial,4) = numeratore di WEFom
c-- fomBuff(5) = fomrtN(trial,5) = denominatore di WEFom
c-- fomBuff(6) = fomrtN(trial,6) = RAT

      Fom_TripM = 0.0

      if (ksize.le.3.and.kmad.eq.0.or.ifMDM == 1) then
          call Calcola_FOM_Small(corre)
          FOMs(1,4) = FOMs(2,4)
          return
      endif

      if (kmad == 0) then
          if (ifPatt == 0) then
              if (jpfile == 0) then
                   call FomTrip_Tang()
                   fomBuff(1) = Fom_TripM
              else
                   fomBuff(1) = 0
              endif
              if (ksize > 3 .and. Fom_TripM < 0) then
                  FOMs(1,4) = 0.0
                  FOMs(2,4) = 0.0
                  return
              endif 
          endif 
      endif

      do i=1,nrefl
         tmpwt(i) = wt(i)      ! memorizzo i pesi di tangente
         fcoef(i) = evet(i) * wt(i)
      enddo
c
      jpatt = 0
      call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
      invflag = 2
      call InvMap(khl,mkang,iwork2,fcvet,nrefl)
 
      chope = 2.0
      iAll = 1
      call CalcolaPesi_Old(nrefl,nrefl,chope,iAll)

c-FOM dopo la tangente
      call Fom_WE(numbLSQ,rlar,rsma,wefom,wefomnum,wefomden)

      if (kmad == 0) then
          fomBuff(2) = rlar
          fomBuff(3) = rsma
          fomBuff(4) = wefomnum
          fomBuff(5) = wefomden
!
          iflg = 2
          call Fom_CC_Lib(numbLSQ,CC,iflg)
          call Fom_EC2_Lib(numbLSQ,EC2,sgmin)
          if (EC2.gt.sgmin) then
              RAT = CC / EC2
          else
              RAT = CC / sgmin
          endif
          if (lasts >= 2) then
              RAT = resm 
          endif
          fomBuff(6) = RAT
          call CombinaFom(0)
          FOMs(2,4) = RAT
c-ULTIM
c         if (knw /= 0) then
c             kstp = 1
c             call Calcola_CC_Mappa(nstr,corre,kstp,2,ier)
c             write(lo,9) numbrun,RAT,wefom,wefomnum,1./wefomden,corre
c             write(lo,69) numbrun,ncicloEDM,(FOMs(1,j),j=1,4)
c         endif
          corre = 0.0
c-ULTIM
      else
          FOMs(1,1) = wefomnum
          FOMs(1,2) = wefomden
          FOMs(1,3) = 0.0
          FOMs(1,4) = wefom
          corre = 0.0               !120105
      endif
!
      wt(1:nrefl) = tmpwt(1:nrefl)
      if (kverbo.gt.0.and.kmad.ne.0) then
          write(lo,69) numbrun,cicloEDM,(FOMs(1,j),j=1,4)
      endif
  9   format(' Trial',i6,' RAT & WEFOMs',4f7.3,
     *       ' Initial CC_Map = ',f6.3)
 69   format(' Trial',i6,i4,' FOMs',4f10.3)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_WE(numbLSQ,rlar,rsma,wefom,wefomnum,wefomden)
      USE General
      USE Riflessi
!
!---- calcola figure di merito dopo la tangente
!
      tmpwto    = 0.
      ntmpwt    = 0
      tmpwden   = 0.
      ntmpwtden = 0
      wrlar     = 0.
      wdenlar   = 0.
      wrsma     = 0.
      wdensma   = 0.

      if (kmad == 0) then
          sgmin = 0.1
      else
          sgmin = 0.0
      endif

      do i=1,nrefl

         if (i.le.numbLSQ) then
             tmpwto  = tmpwto + wt(i)*fcvet(i)
             ntmpwt  = ntmpwt + 1
             wrlar   = wrlar + abs(fcvet(i)-evet(i))
             wdenlar = wdenlar + evet(i)
         else
            if (evet(i).gt.sgmin) then
                eveti = evet(i)
            else
                eveti = sgmin
            endif
            tmpwden   = tmpwden + wt(i)*fcvet(i)
            ntmpwtden = ntmpwtden + 1
            wrsma     = wrsma + abs(fcvet(i)-eveti)
            wdensma   = wdensma + eveti
         endif
 
      enddo

      rsma     = (1./(wrsma / wdensma))
      rlar     = (1./(wrlar / wdenlar))
      wefomnum = tmpwto / float(ntmpwt)
      wefomden = tmpwden / float(ntmpwtden) + sgmin
      wefom    = wefomnum / wefomden
      
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_Lib(numbLSQ,CC,iflg)
      USE General
      USE Riflessi
      USE PhaseModule, only : ifVLD
!
!---- calcola il CC tra Eo**2 e wt**2 
!     iflg = 0  uso tutti gli Eo (nrefl) 
!     iflg = 1  uso solo il 70% degli Eo sino alla risoluzione voluta
!     iflg = 2  uso solo gli Eo con modulo compreso tra sgmin sgmax

      resol = resm
      rhosog = (0.5 / resol) **2

      sumWT2     = 0.0
      sumEo2     = 0.0
      sumWT2Eo2  = 0.0
      sumWT4     = 0.0
      sumEo4     = 0.0

      ncont  = 0
 
      sgmin = 0.1
c     sgmin = 1.2
      sgmax = 100.
      do i=1,nrefl
         icc = 1
         if(iflg.eq.0) then
             if(rhov(i).gt.rhosog) then
                 icc = 0
             endif
         elseif (iflg.eq.1) then
             if(rhov(i).gt.rhosog.
     *         or.i.gt.numbLSQ) then
                 icc = 0
             endif
         elseif(iflg.eq.2) then
             if(evet(i).lt.sgmin.or.evet(i).gt.sgmax.
     *          or.rhov(i).gt.rhosog.
     *          or.i.gt.numbLSQ) then
                 icc = 0
             endif
         endif
         if (wt(i) < 0.00001) then
             icc = 0
         endif
c
         if (icc.eq.1) then
             ncont = ncont + 1

             Eo2 = evet(i)**2
             Eo4 = evet(i)**4
             WT2 = wt(i)**2
             WT4 = wt(i)**4
 
             sumWT2Eo2 = sumWT2Eo2 + WT2 * Eo2
             sumWT2    = sumWT2    + WT2
             sumEo2    = sumEo2    +       Eo2
             sumWT4    = sumWT4    + WT4
             sumEo4    = sumEo4    +       Eo4

         endif
 
      enddo

      if (ncont.gt.0) then
          sumWT2Eo2 = sumWT2Eo2 / ncont
          sumWT2    = sumWT2    / ncont
          sumEo2    = sumEo2    / ncont
          sumWT4    = sumWT4    / ncont
          sumEo4    = sumEo4    / ncont
   
          arg  = sumWT2Eo2 - (sumWT2 * sumEo2)
          den1 = sumWT4 - (sumWT2**2)
          den2 = sumEo4 - (sumEo2**2)
          if (den1.gt.0.00001.and.den2.gt.0.00001) then
              den  = sqrt(den1) * sqrt(den2)
          else
              den = 0.0
          endif
      else
          den = 0.0
      endif
c
      if (abs(den).gt.0.00001) then
          rap = arg / den
      else
          rap = -99.9 !0.0
      endif

          CC = rap

      return
      end

c_LIB
c-----------------------------------------------------------------------
      subroutine Fom_EC2_Lib(numbLSQ,EC2,sgmin)
      USE General
      USE Riflessi
!
!---- calcola il valormedio per Ec**2 (per il 30% dei riflessi piu' deboli)
!
      sumEc2   = 0.0
      ncont = 0
      sgmin = 0.1
!
      do i=numbLSQ+1,nrefl
         if (evet(i).gt.sgmin) then
             ncont = ncont + 1
             Ec2   = fcvet(i)**2
             sumEc2   = sumEc2   + Ec2
         endif
      enddo
!
      if (ncont.gt.0) then
          EC2    = sumEc2   / ncont
      else
          EC2 = 0.0
      endif
      if( EC2 > 1.0 ) EC2 =  0.5

      return
      end
c-----------------------------------------------------------------------
      subroutine FomTrip_Tang()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
c
      dimension ifa(3)
c
      if (nsym.eq.1.and.icent.eq.0) then
          Fom_TripM = 99.9
          return
      endif

      Fom_TripM = 0.0
      ntotrip = 0
      ntotripM = 0
      sumcos  = 0.
      gmassi  = 0.
      
      do 3500 ll= 1,nstr
         k=iordeTang(ll)

C    INSERIRE CONTROLLO Se il riflESSO E' STATO FASATO
         if (abs(wt(k)).lt.0.1)    goto 3500

         ist = 3
         jpqq = 0
         sogwt = 0.1
         do kcr=1,1   !2
            ist = ist + 1
            li=limref(kcr,k)*ist+1 + jpqq
            ls=limref(kcr,k+1)*ist + jpqq
            if(li.le.ls) then
               do 3400 jj= li,ls,ist
                  numi=0
                  w=wt(k)
                  ip=0
                  nn(2)=0
                  ifa(2)=0
                  nn(3)=0
                  ifa(3)=0
                  ir = iph(jj)
                  ira = iabs(ir)
                  il = iph(jj+1)
                  ila = iabs(il)
                  if ( kcr.eq.1) then
                     if(abs(wt(ira)).lt.sogwt .or.
     *                  abs(wt(ila)).lt.sogwt)    goto 3400
                  else
                     it = iph(jj+2)
                     ita = iabs(it)
                     if(abs(wt(ira)).lt.0.1 .or.
     *                  abs(wt(ila)).lt.0.1 .or.
     *                  abs(wt(ita)).lt.0.1)    goto 3400
                  end if
                  numi = numi+1
                  nn(numi) = ir
                  w = w*wt(ira)
                  ifa(numi) = iphaz(ira)
                  numi = numi+1
                  nn(numi) = il
                  w = w*wt(ila)
                  ifa(numi) = iphaz(ila)
                  ip=isign(ifa(1),nn(1))
                  ip=ip+isign(ifa(2),nn(2))
                  if ( kcr.eq.1) then
                     a1 = iph(jj+2)*0.01
                     ifaz = iph(jj+3)
                  else
                     numi = numi+1
                     nn(numi) = it
                     w = w*wt(ita)
                     ifa(numi) = iphaz(ita)
                     a1 = iph(jj+3)*0.01
                     ifaz = iph(jj+4)
                     ip=ip+isign(ifa(3),nn(3))
                  end if
                  aa1=abs(w)
                  ip=ip+15*ifaz+36000
                  ip= mod(ip,360)+1
                  gbes=abs(a1)
                  if(gbes.gt.gmassi) gmassi = gbes
c                 aa1=aa1*gbes
                  ee=aa1        ! attendibilita' (G) pesata

c       CALCOLO FASE STIMATA TRIPLETTO

                  iphistim = iphaz(k) - ip
                  faserad     = float(iphistim)*dtor 
                  cosfase  = cos(faserad)
                  if (cosfase.gt.0.) then
                     ntotripM = ntotripM + 1
                     sumcos = sumcos + cosfase
                  else
                     ntotrip = ntotrip + 1
                  endif

 3400          continue
            end if
            jpqq = jpq
         end do

 3500 continue
      ntot = ntotripM+ntotrip
c     Fom_TripM = float(ntotripM)/10000.
      if(no(nk).lt.20) then
          Fom_TripM = float(ntotripM)/float(ntot)
      else
          Fom_TripM = float(ntotripM)/10000.
      endif
!      if (ksize > 3 .and. float(ntotripM)/float(ntot).gt.0.99) then
!          Fom_TripM = -9999.
!      endif
! 
      return
      end
c---------------------------------------------------------------------
      subroutine FomTrip_Patt()
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseStuff
      USE PhaseModule
c
      dimension ifa(3)
!
!-- PROVA --!
**    call VaiInP1()
!-- PROVA --!
c-ULTIM
!     if (nsym.eq.1.and.icent.eq.0) then
!         Fom_TripM = 99.9
!         return
!     endif
c-ULTIM

      Fom_TripM = 0.0
      ntotrip = 0
      ntotripM = 0
      sumcos  = 0.
c-ULTIM
      sumgibes  = 0.
      sumcos1  = 0.
c-ULTIM
      
      do 3500 ll= 1,nstr
         k=iordeTang(ll)
         sogwt = 0.1
c-ULTIM
c        if (abs(wt(k)).lt.0.1) cycle
         if (abs(wt(k)).lt.sogwt) cycle

         ist = 3
         jpqq = 0
         do kcr=1,1   !2
            ist = ist + 1
            li=limref(kcr,k)*ist+1 + jpqq
            ls=limref(kcr,k+1)*ist + jpqq
            if(li.le.ls) then
               do 3400 jj= li,ls,ist
                  numi=0
                  w=wt(k)
                  ip=0
                  nn(2)=0
                  ifa(2)=0
                  nn(3)=0
                  ifa(3)=0
                  ir = iph(jj)
                  ira = iabs(ir)
                  il = iph(jj+1)
                  ila = iabs(il)
                  if ( kcr.eq.1) then
                     if(abs(wt(ira)).lt.sogwt .or.
     *                  abs(wt(ila)).lt.sogwt)    goto 3400
                  else
                     it = iph(jj+2)
                     ita = iabs(it)
                     if(abs(wt(ira)).lt.0.1 .or.
     *                  abs(wt(ila)).lt.0.1 .or.
     *                  abs(wt(ita)).lt.0.1)    goto 3400
                  end if
                  numi = numi+1
                  nn(numi) = ir
                  w = w*wt(ira)
                  ifa(numi) = iphaz(ira)
                  numi = numi+1
                  nn(numi) = il
                  w = w*wt(ila)
                  ifa(numi) = iphaz(ila)
                  ip=isign(ifa(1),nn(1))
                  ip=ip+isign(ifa(2),nn(2))
                  if ( kcr.eq.1) then
                     a1 = iph(jj+2)*0.01
                     ifaz = iph(jj+3)
                  else
                     numi = numi+1
                     nn(numi) = it
                     w = w*wt(ita)
                     ifa(numi) = iphaz(ita)
                     a1 = iph(jj+3)*0.01
                     ifaz = iph(jj+4)
                     ip=ip+isign(ifa(3),nn(3))
                  end if
                  aa1=abs(w)
                  ip=ip+15*ifaz+36000
                  ip= mod(ip,360)+1
                  gbes=abs(a1)
c-ULTIM
c                 if(gbes.gt.gmassi) gmassi = gbes
c-ULTIM
c                 aa1=aa1*gbes
                  ee=aa1        ! attendibilita' (G) pesata

c       CALCOLO FASE STIMATA TRIPLETTO

                  iphistim = iphaz(k) - ip
                  faserad     = float(iphistim)*dtor 
                  cosfase  = cos(faserad)
                  sogcosfase=0.
c-ULTIM
                  sumcos = sumcos +
     *                      aa1*gbes**1*(cosfase-bes(aa1*gbes))**2
                  sumgibes = sumgibes + aa1*gbes
c                 if (cosfase>sogcosfase) then
c                      sumcos1 = sumcos1 +
c    *                      aa1*gbes**1*(cosfase)**2
c                 endif
c-ULTIM
                  if (cosfase>sogcosfase) then
                     ntotripM = ntotripM + 1
c-ULTIM
c                    sumcos = sumcos + cosfase
c-ULTIM
                  else
                     ntotrip = ntotrip + 1
                  endif

 3400          continue
            end if
            jpqq = jpq
         end do

 3500 continue
      ntot = ntotripM+ntotrip
c-ULTIM
      if(no(nk).lt.20) then
         Fom_TripM=sumgibes/sumcos
         if(ksize>4.and.jsys>1.and.LowRes==0) Fom_TripM=sumcos/sumgibes
c        Fom_TripM = float(ntotripM)/float(ntot)
      else
          Fom_TripM = float(ntotripM)/10000.
      endif
      if (jsys == 1) Fom_TripM = 10000./float(ntotripM)
c-ULTIM
      return
      end
c---------------------------------------------------------------------
      subroutine Calcola_FOM_Lib(iact)   ! RAT 
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
      USE Param, only : f000

      character tirang * 11
      character ttirang * 80
!
*     common / prova/ iesFom
!
!-- iact = 0  - non richiama Calcola_CC_EoEc
!-- iact = 1  -     richiama Calcola_CC_EoEc
!
      kve = 0   ! 1

      iesFom = 1
      f000_sav = f000
      waveare_sav = waveare
      exposigma_sav = exposigma
!
      if (ifREMO == 1) numbLSQ = 0.7 * nrefl
!

      f000 = 0

      worko(:) = fcvet(:)
      tmpwt(:) = wt(:)
      fcoef(:) = 0.0
      do i=1,nrefl
         fcoef(i) = evet(i) * wt(i)
      enddo

      if(kve>0) then
         izero = 0
         ifmin = 1
         nbru = -1111
         call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
         tirang = 'FinalFom WT'
         ipher = 1
         call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
      endif 
    
      invflag = 1
      percMap = 0.035
      jpatt = 0
      call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)

      if (kve > 0) then
          call maxmin3d(denmin,denmax,avden,stden,npunt,0)
          if (knw == 1) then
              write(6,*) 'denmin FFom',denmin,denmax,avden,stden
          endif
      endif
!
! --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
!
      fcvet(:) = 0.0
      tmp_ec(:) = 0.0
      call InvMap(khl,mkang,iwork2,fcvet,nrefl)
      tmp_ec(:) = fcvet(:)
*     do i=1, nrefl
*        write(6,*) i,iwork2(i),fcvet(i)
*     enddo
!
      if (iact == 1) then
          call Calcola_CC_EoEc(0)
      endif
!
      ifSigmaA = 0
      chope = 2.0
      if (ksize > 3 .and. (ifVLD == 0 .or. ifRemo==1)) then
         numbDyn = nrefl
         numberToUse = nrefl
         if (LowRes == 0) then
             call Weights_Calculation_HIGH(numbDyn,numberToUse,
     *                                  chope,correl,ifBreak)
         else
             call Weights_Calculation_LOW(numbDyn,numberToUse,
     *                                  chope,correl,ifBreak)
         endif
      else
         iAll  =  1
         call CalcolaPesi(nrefl,nrefl,chope,iAll)
      endif
!

!!!!  tmp_ec(:) = fcvet(:)

      if(kve>0) then
         izero = 0
         ifmin = 1
         nbru = -2222
         call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
         tirang = 'FinalFom WT'
         ipher = 1
         call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
      endif
!
!--- fcvet = Ecal, wt = nuovo peso , iwork2 = nuova fase
!
      iflg = 2
      call Fom_CC_Lib(numbLSQ,CC,iflg)
      FOMs(2,2) = CC

      call Fom_EC2_Lib(numbLSQ,EC2,sgmin)
      FOMs(2,3) = EC2
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,3) = sgmin
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif
c_LIB
      if (kverbo > 0) then
         write(lo,9) numbrun,Iterazione,nMacroAppl,CC,EC2,FOMs(2,4)
      endif
  9   format(' Trial',i6,2i4,' RAT-FOMs',3f10.3)

c ??? devo ancora calcolare la correlazioe EoEc ??? 
c     wt(:) = tmpwt(:)
c     fcvet(:) = worko(:)
c     waveare = waveare_sav
c     exposigma = exposigma_sav
 
!!!   call Calcola_Fom_Shelx()
      if (iact == 1) then
!!!!!!!   call Calcola_CC_EoEc(0)
          FOMs(2,1) = CCEoEc(1)
      else
          FOMs(2,1) = -99.9
      endif

          figuracce(2,1) = FOMs(2,2)  !num Rat
          figuracce(2,2) = FOMs(2,3)  !denom Rat
          figuracce(2,3) = FOMs(2,4)  !RAT
          figuracce(2,4) = fig_CC(1)  !CC all
          figuracce(2,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
          figuracce(2,6) = fig_CC(2)  !CC lage
          figuracce(2,7) = fig_CC(4)  !CC weak
          figuracce(2,8) = fig_CC(4) * 3 !cc weak * 3

 
      wt(:) = tmpwt(:)
      fcvet(:) = worko(:)
      f000 = f000_sav
      waveare = waveare_sav
      exposigma = exposigma_sav
 
      return
      end
c-----------------------------------------------------------------------
      subroutine CombinaFom(iAction)
      USE General
      USE PhaseModule
!
!-- iAction = 1  compute average values and normalize FOM's
!-- iAction = 0  normalize single trial
!
      if (jpfile /= 0) then
          return
      endif
      if (iAction == 0) then
          if (averlar > 0.0) then
              call CombinaUnaFom(0)
          else
              FOMs(1,4) = fomBuff(6) ! RAT
          endif
      else
          sumrlar  = 0.0
          sumrsma  = 0.0
          sumrat   = 0.0
          sumwe    = 0.0
          sumwenum = 0.0
          sumweden = 0.0
          summaxM  = 0.0
          scrlar = 0.0
          scrsma = 0.0
          scwe = 0.0
          scwenum = 0.0
          scweden = 0.0
          scrat = 0.0
          scmaxM = 0.0

          do i = 1,MaxToStore

             Fom_TripM = fomrtN(i, 1) 
             rlar      = fomrtN(i, 2) 
             rsma      = fomrtN(i, 3) 
             wefomnum  = fomrtN(i, 4) 
             wefomden  = fomrtN(i, 5) 
             RAT       = fomrtN(i, 6) 
             wefom     = wefomnum / wefomden
    
             sumrlar   = sumrlar  + rlar
             sumrsma   = sumrsma  + rsma
             sumwe     = sumwe    + wefom
             sumwenum  = sumwenum + wefomnum
             sumweden  = sumweden + 1./wefomden
             sumrat    = sumrat   + RAT
             summaxM   = summaxM  + Fom_TripM

          enddo

          xsac = MaxToStore
 
          averlar  = sumrlar  / xsac
          aversma  = sumrsma  / xsac
          avewe    = sumwe    / xsac
          avewenum = sumwenum / xsac
          aveweden = sumweden / xsac
          averat   = sumrat   / xsac
          avemaxM  = summaxM  / xsac

          do i = 1, MaxToStore
             Fom_TripM = fomrtN(i, 1) 
             rlar      = fomrtN(i, 2) 
             rsma      = fomrtN(i, 3) 
             wefomnum  = fomrtN(i, 4) 
             wefomden  = fomrtN(i, 5) 
             RAT       = fomrtN(i, 6) 
             wefom     = wefomnum / wefomden

             scrlar  = scrlar  + (rlar - averlar)**2
             scrsma  = scrsma  + (rsma - aversma)**2
             scwe    = scwe    + (wefom - avewe)**2
             scwenum = scwenum + (wefomnum - avewenum)**2
             scweden = scweden + (1./wefomden - aveweden)**2
             scrat   = scrat   + (RAT - averat)**2
             scmaxM  = scmaxM  + (Fom_TripM - avemaxM)**2
          enddo

          denom = xsac - 1.
 
          stdrlar  = sqrt(scrlar  / denom)
          stdrsma  = sqrt(scrsma  / denom)
          stdwe    = sqrt(scwe    / denom)
          stdwenum = sqrt(scwenum / denom)
          stdweden = sqrt(scweden / denom)
          stdrat   = sqrt(scrat   / denom)
          stdmaxM  = sqrt(scmaxM  / denom)
          f18mn  =  9999
          f18mx  = -9999
          fomBestE = - 9999.9
          do i = 1, MaxToStore
             fomBuff(1:6) = fomrtN(i, 1:6) 
             call CombinaUnaFom(i)
             fomrt(i, 5) = FOMs(1,4)
             if (FOMs(1,4) > fomBestE) then
                 fomBestE = FOMs(1,4)
             endif
          enddo
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine CombinaUnaFom(jj)
      USE General
      USE PhaseModule
      USE RfacMatrixModule
c
      Fom_TripM = fomBuff(1) 
      rlar      = fomBuff(2) 
      rsma      = fomBuff(3) 
      wefomnum  = fomBuff(4) 
      wefomden  = fomBuff(5) 
      RAT       = fomBuff(6) 
      wefom     = wefomnum / wefomden

      if (stdrlar.gt.0.) then
          rlarnor = (rlar-averlar)/stdrlar
      else
          rlarnor = 0.0
      endif
      if (stdrsma.gt.0.) then
          rsmanor = (rsma-aversma)/stdrsma
      else
          rsmanor = 0.0
      endif
!     write(lo,*) 'N-R',rlarnor,rsmanor

      if (stdwe.gt.0.) then
          wenor = (wefom-avewe)/stdwe
      else
          wenor = 0.0
      endif
      if (stdwenum.gt.0.) then
          wenumnor = (wefomnum-avewenum)/stdwenum
      else
          wenumnor = 0.0
      endif
      if (stdweden.gt.0.) then
          wedennor = (1./wefomden-aveweden)/stdweden
      else
          wedennor = 0.0
      endif
!     write(lo,*) 'N-W',wenor,wenumnor,wedennor

      if (stdrat.gt.0.) then
          ratnor = (RAT-averat)/stdrat
      else
          ratnor = 0.
      endif
!     write(lo,*) 'N-RAT',ratnor

      if (stdmaxM.gt.0.) then
          axnorM = (Fom_TripM-avemaxM)/stdmaxM
      else
          axnorM = 0.
      endif
!     write(lo,*) 'N-TRIP',axnorM

c_ calcola combined fom

      if(ratnor.gt.0) then
         FOMs(1,1) = 0.
      else
         FOMs(1,1) = -10.
      endif

      if (ifPatt == 1) then
          if (axnorM.gt.0) then
              FOMs(1,2) = axnorM
          else
              FOMs(1,2) = 0.
          endif
      else
          if (axnorM.gt.-0.667) then
              FOMs(1,2) = 0.
          else
              FOMs(1,2) = -10.
          endif
      endif

c-- Define WE_Fom

      if(rsmanor.lt.0.0) then
         if(rlarnor.lt.0.0) then
            FOMs(1,3) = wenumnor
         else
            FOMs(1,3) = wenor
         endif
      else
          FOMs(1,3) = wedennor
      endif
      if(iwei.eq.0) FOMs(1,3) = wenor
!
!---  Define CFom
!
      if (ifPatt == 1) then
         if (FOMs(1,2)>0) then
             FOMs(1,4) = abs(FOMs(1,3))+FOMs(1,2)
         else
             FOMs(1,4) = FOMs(1,3)
         endif
      else
          FOMs(1,4) = FOMs(1,2) + FOMs(1,3)
      endif
      if (jj > 0) then
          RfacMatrix(2,jj,jBlock) = FOMs(1,4)
      endif
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_FOM_Small(corre)
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param, only: ifExtra
!
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
      integer cicliFour
      real m2,coef2,sum_num,sum_den

!
! -- prova nuova FOM
!
        if (ifFomNew == 1) then
            call Calcola_FOM_Small_New(corre)
c           call Calcola_FOM_Alfa_New(corre)
c           call Calcola_FOM_Alfa(corre)
            return
        endif 

        if (ifFomNew == 2) then
           sum_num = 0 .0
           sum_den = 0 .0

           do i = 1,nstr  !nrefl
c             m2 = wt(i)**2.
c             coef2 = evet(i)**2.
              m2 = wt(i)
              coef2 = evet(i)
              sum_num = sum_num + (m2 * coef2)
              sum_den = sum_den + (coef2)
           enddo

           FOMs(2,1) = -99.99
           FOMs(2,2) = sum_num
           FOMs(2,3) = sum_den
           FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
           if (knw /= 0 .and. ifTime == 0) then
               kstp = 1
               call Calcola_CC_Mappa(nstr,corre,kstp,2)
               write(lo,8) numbrun,FOMs(2,2:4),corre
           endif
  8   format(' Trial #',i6,'   NEW-FOMs',3f10.3,
     *       '  Initial CC_Map = ',f6.3)

           return
        endif 

!
! -- prova nuova FOM
!
c
c-dedi  -- per girare in continuo con la strategia per il singolo trial
c
      foper(:) = 0.0
      fcoef(:) = evet(:) * wt(:)
      tmpwt(:) =   wt(:)
      jwork1(:) =  iphaz(:)

      invflag = 1
      if (ifMDM == 1) then
          percMap = 0.015
          jpatt = 0
          nnstr = nstr
          call MakeMap(fcoef, iphaz, nnstr, jpatt, xmap,
     *                FORTH, BACK)
c
c --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
c    
          call InvMap(khl,mkang,iwork2,fcvet,nrefl)
      
          ifSigmaA = 0
          chope = 2.0
          iAll  =  1
          call CalcolaPesi(nrefl,nrefl,chope,iAll)
          fcoef(:) = evet(:) * wt(:)
          invflag = 1
          percMap = 0.035
          jpatt = 0
          nnstr = nrefl
          call MakeMap(fcoef, iwork2, nnstr, jpatt, xmap,
     *                FORTH, BACK)
      else
          percMap = 0.035
          jpatt = 0
          nnstr = nstr
          call MakeMap(fcoef, iphaz, nnstr, jpatt, xmap,
     *                FORTH, BACK)
      endif
c
c --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
c
      call InvMap(khl,mkang,iwork2,fcvet,nrefl)
c
!
      ifSigmaA = 0
      chope = 2.0
*     iAll  = -1 ! pesi di tangente
      iAll  =  1 
c     call CalcolaPesi_Old(nrefl,nrefl,chope,iAll)
      call CalcolaPesi(nrefl,nrefl,chope,iAll)
!

 
*     if (ifGedm == 1) then
*         call FomGedm
*     endif
c
c--- fcvet = Ecal, wt = nuovo peso , iwork2 = nuova fase

      do j = 1,2
         iflg = j
         call Fom_CC_Lib(numbLSQ,CC,iflg)
         FOMs(2,j) = CC
      enddo

      call Fom_EC2_Lib(numbLSQ,EC2,sgmin)
      FOMs(2,3) = EC2
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif
c_LIB
! - new - tiene conto della % di undet.
!     percdet= float((nstr-nundet)) / float(nstr)
!     FOMs(2,4) = percdet * FOMs(2,4)
!
      if (knw /= 0 .and. ifTime == 0) then
          kstp = 1
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
          write(lo,9) numbrun,CC,EC2,FOMs(2,4),corre
      endif
  9   format(' Trial #',i6,'   RAT-FOMs',3f7.3,
     *       '  Initial CC_Map = ',f6.3)
 
      iphaz(:) =  jwork1(:)
      wt(:)  = tmpwt(:)

!!!   call Calcola_Fom_Shelx()

!     call Calcola_CC_EoEc(0)

      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_FOM_Small_New(corre)
      USE General
      USE Riflessi
      USE PhaseModule
      USE Mappa
      USE Param, only: ifExtra
!
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
      integer cicliFour
      real m2,coef2,sum_num,sum_den

!
! -- prova nuova FOM
!
c
c-dedi  -- per girare in continuo con la strategia per il singolo trial
c
      foper(:) = 0.0
      fcoef(:) = evet(:) * wt(:)
      tmpwt(:) =   wt(:)
      jwork1(:) =  iphaz(:)

      invflag = 1
      percMap = 0.035
      jpatt = 0
      nnstr = nstr
      call MakeMap(fcoef, iphaz, nnstr, jpatt, xmap,
     *                FORTH, BACK)
c
c --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
c
      call InvMap(khl,mkang,iwork2,fcvet,nrefl)
c
!
      ifSigmaA = 1
      chope = 2.0
      iAll  =  1 
      call CalcolaPesi(nrefl,nrefl,chope,iAll)
!
c     work1(1:nrefl) = wt(1:nrefl)
c     call sortall(-1,work1,nrefl)
c     sog = work1(numbLSQ)
c     do i = 1,nrefl !best numbLSQ
c        if (wt(i).lt.sog) wt(i) = 0.0
c     enddo
!
      sum_num = 0 .0
      sum_den = 0 .0

      do i = 1,numbLSQ !nrefl   !nstr  !numbLSQ
         m2 = wt(i)
         coef2 = evet(i)
         sum_num = sum_num + (m2 * coef2)
         sum_den = sum_den + (coef2)
      enddo

      FOMs(2,1) = -99
c     FOMs(2,2) = sum_num
c     FOMs(2,3) = sum_den
c     FOMs(2,4) = FOMs(2,2) / FOMs(2,3)

! - new - stile RAT
      FOMs(2,2) = sum_num / sum_den
      call Fom_EC2_Lib(numbLSQ,EC2,sgmin)
      FOMs(2,3) = EC2
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif
! - new - stile RAT
 
! - new - tiene conto della % di undet.
!     percdet= float((nstr-nundet)) / float(nstr)
!     FOMs(2,4) = percdet * FOMs(2,4)
!
      iphaz(:) =  jwork1(:)
      wt(:)  = tmpwt(:)

      if (knw /= 0 .and. ifTime == 0) then
          izero = 0
          ifmin = 0
          nbru = -33
          call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
          kstp = 1
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
          write(lo,8) numbrun,FOMs(2,2:4),corre
      endif

  8   format(' Trial #',i6,'   NEW-FOMs',3f10.3,
     *       '  Initial CC_Map = ',f6.3)

      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_FOM_Alfa_New(corre)
      USE General
      USE Riflessi, only: wt,evet
      USE PhaseModule
      USE Psi0Stuff
      real :: m2
!
! -- prova nuova FOM : sum(alfaVet) o sum(alphap) 
!
      corre = -9.999
      sommAlfa = 0.0
      sommAlfa0 = 0.0

! -- calcolo la sommatoria sull'alfa  (NSTR)
      nntr = 0
      do i= 1, nstr
         if (alpha_str(i) > 0.00001) nntr = nntr + 1
         sommAlfa = sommAlfa + alpha_str(i)
      enddo

! -- calcolo la media sull'alfaPsi0  (NZRO)
      nnp0 = 0
      do i= 1, nzro
         if (alphapsi0(i) > 0.00001) nnp0 = nnp0 + 1
         sommAlfa0 = sommAlfa0 + alphapsi0(i)
      enddo
      aveAlfa0 = sommAlfa0/float(nnp0) 
      aveAlfa0 = aveAlfa0**0.4 
CCC   aveAlfa0 = sommAlfa0/float(nzro) 


      sum_num = 0 .0
      sum_def = 0 .0
      do i = 1,nstr  !nrefl
         m2 = wt(i) !  **2.
         coef2 = evet(i) ! **2.
         sum_num = sum_num + (m2 * coef2)
         sum_def = sum_def + coef2
      enddo

  
      FOMs(2,1) = 999
      FOMs(2,2) = sum_num / sum_def
      FOMs(2,3) = aveAlfa0

      if (knw /= 0 .and. ifTime == 0) then
          kstp = 1
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
      endif

      FOMs(2,4) = FOMs(2,2) / FOMs(2,3)

      if (knw == 1) then
          write(lo,19) numbrun,Foms(2,2:),corre
      else
          write(lo,29) numbrun,Foms(2,2:)
      endif

 19   format(' Trial #',i6,' AlfaN-FOMs',3f12.3,
     *       '  Initial CC_Map = ',f6.3)
 29   format(' Trial #',i6,' AlfaN-FOMs',3f12.3)

      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_FOM_Alfa(corre)
      USE General
      USE PhaseModule
      USE Psi0Stuff
!
! -- prova nuova FOM : sum(alfaVet) o sum(alphap) 
!
      corre = -9.999
      sommAlfa = 0.0
      sommAlfa0 = 0.0

! -- calcolo la sommatoria sull'alfa  (NSTR)
      nntr = 0
      do i= 1, nstr
c        if (alphaVet(i) > 0.00001) nntr = nntr + 1
c        sommAlfa = sommAlfa + alphaVet(i)
         if (alpha_str(i) > 0.00001) nntr = nntr + 1
         sommAlfa = sommAlfa + alpha_str(i)
      enddo

! -- calcolo la media sull'alfaPsi0  (NZRO)
      nnp0 = 0
      do i= 1, nzro
c        if (alphap(i) > 0.00001) nnp0 = nnp0 + 1
c        sommAlfa0 = sommAlfa0 + alphap(i)
         if (alphapsi0(i) > 0.00001) nnp0 = nnp0 + 1
         sommAlfa0 = sommAlfa0 + alphapsi0(i)
      enddo
      aveAlfa0 = sommAlfa0/float(nnp0) 
  
      FOMs(2,1) = sommAlfa
      FOMs(2,2) = sommAlfa0
      FOMs(2,3) = aveAlfa0
      if (knw /= 0 .and. ifTime == 0) then
          kstp = 1
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
      endif

c     FOMs(2,4) = FOMs(2,1) / (FOMs(2,2) * 100)
      FOMs(2,4) = FOMs(2,1) / (FOMs(2,3) * 10000)
c     FOMs(2,4) = FOMs(2,2) 

      if (knw == 1) then
          write(lo,19) numbrun,FOMs(2,1),nstr,nntr,
     *                 FOMs(2,2),nzro,nnp0,Foms(2,3:4),corre
      else
          write(lo,29) numbrun,FOMs(2,1),nstr,nntr,
     *                 FOMs(2,2),nzro,nnp0,Foms(2,3:4)
      endif

 19   format(' Trial #',i6,'  Alfa-FOMs',2(f12.3,2i6),2f12.3,
     *       '  Initial CC_Map = ',f6.3)
 29   format(' Trial #',i6,'  Alfa-FOMs',2(f12.3,2i6),2f12.3)

      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_CC_EoEc(iAction)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
!
*     dimension fig_CC(15)
!
!-- iAction = 0 -- solo CC
!-- iAction = 1 -- Mappa, Inversione e CC
!
      fig_CC(:) = 0.0

      if (iAction == 1) then 
          do i=1,numbLSQ
             fcoef(i) = evet(i) * wt(i)
          enddo

          jpatt = 0
          call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
!
          invflag = 1
          percMap = 0.035
          call InvMap(khl,mkang,iwork2,fcvet,nrefl)
!
          iAll = -1
          call CalcolaPesi(nrefl,nrefl,chope,iAll)  !applico HM
      endif 

      do iflg = 1,4
         call Fom_CC_EoEc(numbLSQ,CC,iflg)
         fig_CC(iflg) = CC
      enddo

 111  format(' Trial',i6,2i4,' FOM_CC   =',3f9.3)

      fig_CC( 5) = fig_CC(1) + fig_CC(4)
      fig_CC( 6) = fig_CC(2) + fig_CC(4)
      fig_CC( 7) = fig_CC(1) + fig_CC(4)*2.
      fig_CC( 8) = fig_CC(2) + fig_CC(4)*2.
      fig_CC( 9) = fig_CC(1) + fig_CC(4)*3.
      if (ifMDM == 0) then
         fig_CC(10) = fig_CC(2) + fig_CC(4)*3.
      else
         fig_CC(10) = fig_CC(2)
      end if
      CCEoEc(1)  =  fig_CC( 1) 
      if (ifVLD == 0 .and. ifDsrVLD == 1) then
          CCEoEc(2)  =  fig_CC(2)  ! solo CC large
      else
          CCEoEc(2)  =  fig_CC(10)
      endif
! 
 10   format (5x,' EC2s = ',f8.3,5x,' EC2w = ',f8.3,/,
     *        5x,' EC3w = ',f8.3,5x,' EC4w = ',f8.3)
 20   format(' Trial',i6,2i4,' CC_EoEc',4f8.3)
 30   format(' Trial',i6,' Diff CC_EoEc',6f8.3)
 40   format(' Trial',i6,2i4,' Diff CC_EoEc',6f8.3)
 50   format(' Trial',i6,2i4,' Res_EoEc',4f8.3)
 
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_EoEc(numbLSQ,CC,iflg)
      USE General
      USE Riflessi

c---- calcola il CC tra Eo e Ec

!
!     iflg = 1  tutti gli Eo (nrefl) 
!     iflg = 2  70% degli Eo
!     iflg = 3  70% degli Eo con modulo compreso tra sgmin sgmax
!     iflg = 4  30% degli Eo piu' bassi

      sgmin = 0.1
      sgmax = 1.2

      sumEc     = 0.0
      sumEo     = 0.0
      sumEoEc   = 0.0
      sumEc2    = 0.0
      sumEo2    = 0.0

      ncont  = 0
 
      do i=1,nrefl
         icc = 1
         if (iflg.eq.2) then
             if(i.gt.numbLSQ) then
                 icc = 0
             endif
         elseif(iflg.eq.3) then
             if(evet(i).lt.sgmin.or.evet(i).gt.sgmax.
     *          or.i.gt.numbLSQ) then
                 icc = 0
             endif
         elseif(iflg.eq.4) then
             if(i.le.numbLSQ) then
                 icc = 0
             endif
         endif

         if (icc.eq.1) then
             ncont = ncont + 1

             Eo  = evet(i)
             Eo2 = evet(i)**2
             Ec  = fcvet(i)
             Ec2 = fcvet(i)**2
 
             sumEoEc = sumEoEc + Eo * Ec
             sumEo   = sumEo   + Eo
             sumEo2  = sumEo2  + Eo2
             sumEc   = sumEc   +      Ec
             sumEc2  = sumEc2  +      Ec2

         endif
 
      enddo

      if (ncont.gt.0) then
          sumEoEc = sumEoEc / ncont
          sumEo   = sumEo   / ncont
          sumEo2  = sumEo2  / ncont
          sumEc   = sumEc   / ncont
          sumEc2  = sumEc2  / ncont
   
          arg  = sumEoEc - (sumEo * sumEc)
          den1 = sumEc2 - (sumEc**2)
          den2 = sumEo2 - (sumEo**2)
          if (den1.gt.0.00001.and.den2.gt.0.00001) then
              den  = sqrt(den1) * sqrt(den2)
          else
              den = 0.0
          endif
      else
          den = 0.0
      endif
!
      if (den.gt.0.00001) then
          rap = arg / den
      else
          rap = 0.0
      endif

      CC = rap

      return
      end
!------------------------------------------------------------------------------
      subroutine FomGedm()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
!
      integer cicliGEdm, numb(5), Batch, nBatch, nGedm
      character*11 tirang
      real, allocatable :: EobsEp(:), wtSav(:), fcoefSav(:), fcPrec(:)
      real, allocatable :: wtNew(:), wtSSav(:), wtHis(:)
      integer, allocatable :: puntatore(:), mkangSav(:)
!
      numberToUse = numbLSQ
!
      allocate (EobsEp(1:numberToUse), stat = ierr)
      allocate (wtSav(1:numberToUse), stat = ierr)
      allocate (puntatore(1:numberToUse), stat = ierr)
      allocate (fcoefSav(1:numberToUse), stat = ierr)
      allocate (fcPrec(1:numberToUse), stat = ierr)
      allocate (wtNew(1:numberToUse), stat = ierr)
      allocate (wtSSav(1:numberToUse), stat = ierr)
      allocate (wtHis(1:numberToUse), stat = ierr)
      allocate (mkangSav(1:numberToUse), stat = ierr)
      fcPrec(:) = 0.0
!
!-- condizioni iniziali
!
      nGedm = numbLSQ / 4
      mkangSav(1:numberToUse) = mkang(1:numberToUse)
      wt_in(1:numberToUse) = fcvet(1:numberToUse)
      nBatch = 1
      cicliGEdm = 6
      chope = 0.5
      numb(1) = nGedm
      numb(2) = 2 * numb(1)
      numb(3) = 3 * numb(1)
!
         EobsEp(:) = 0.0
         fcPrec(:) = -99
!
         do i=1, numberToUse
            ecvet(i) = fcvet(i)
            if (ecvet(i) > 4.5) then
                ecvet(i) = 4.5
            endif
            pesMod(i) = 2.0 * evet(i) * ecvet(i)
         enddo

         jwork1(1:numberToUse) = iphaz(1:numberToUse)
!
         wtSav(1:numberToUse) = wt(1:numberToUse)
         wtHis(1:numberToUse) = wt(1:numberToUse)
         call SwitchRestorePattersonSpaceGroup(1)
         mkang(1:numberToUse) = 1
         jpatt = 1
!
         do Batch=1,nBatch
!
!-- selezione riflessi
!
            worko(1:numberToUse) = evet(1:numberToUse) 
     *                           * ecvet(1:numberToUse)
            call sortall(-1, worko, numberToUse)
            numsel = numb(Batch)
            sogliaE = worko(numsel)
            worko(1:numberToUse) = evet(1:numberToUse) 
     *                           * ecvet(1:numberToUse)
            n = 0
            do i=1, numberToUse
               if (worko(i) > sogliaE) then
*                  if (EobsEp(i) < 0.5) then
                   if (fcPrec(i) < 0.0) then
                       EobsEp(i) = 1.0
                       n = n + 1
                   else
                       EobsEp(i) = 0.0
                   endif
               endif
            enddo
!
            do i=1, numberToUse
               if (fcPrec(i) < 0.0) then
                   X = pesMod(i)
                   w = bes(X)
                   fcoef(i) = X * w * EobsEp(i)
               else
                   Q = fcPrec(i)
                   call CalcolaXw(Q, X, w)
                   fcoef(i) = X * w
               endif
               fcoefSav(i) = fcoef(i)
            enddo
!
            do ncy =1, cicliGEdm / Batch
!
               jpatt = 1
               iphaz(:) = 0
       
               call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                      FORTH,BACK)
!-- deprime il massimo all'origine
               if (ncy == 1) then
                   call RiduciOrigine(1)
               endif
               invflag = 1
               invflag = 3
               if (LowRes == 0) then
                   percMap = 0.25
                   percMap_n = 0.07
               else
                   percMap = 0.35
                   percMap_n = 0.15
               endif
               percMap = 0.25
               percMap_n = 0.15
               percMap_n = 0.30
               percMap_n = 0.07
               percMap_n = 0.05
               percMap_n = 0.01
               call InvMap(khl, mkang, iphaz, fcvet, numberToUse)
!
!-- Histogram Matching
!
               n = 0
               do i=1, numberToUse
                  if (EobsEp(i) > 0.5) then
                      n = n + 1
                      work1(n) = fcvet(i)
                      work2(n) = fcoefSav(i)
                      puntatore(n) = i
                  endif
               enddo
               nwizm1 = 15
               nden =  nstr / 10
               nden =  nstr / 20
               nsip1 = n / nden
               nsip1 = min(nsip1,498)
               call HistogramMatch(work1,work2,n,nsip1,nwizm1,1)
               do i=1, n
                  j = puntatore(i)
                  fcvet(j) = work1(i)
               enddo
!
               do i=1, numberToUse
                  if (fcPrec(i) > 0.0) then
                      Q = fcPrec(i)
                      call CalcolaXw(Q, X, w)
                      fcoef(i) = X ! * w
                  elseif (EobsEp(i) > 0.5) then
                      Q = fcvet(i)
                      call CalcolaXw(Q, X, w)
                      if (iphaz(i) > 90) then
                          w = 0.2
                      endif
                      if (w < 0.2) w=0.2
                      fcoef(i) = X  !* w
                  else
                      w = 0
                      fcoef(i) = 0.0
                  endif
                  wtNew(i) = w
               enddo
        
!
               wtHis(1:numberToUse) = wtNew(1:numberToUse)
               ifFom = 1
c              call RicalcolaPesi_GEDM(numberToUse, fcvet, EobsEp, 
               call RicalcolaPesi_CMAP(numberToUse, fcvet, EobsEp, 
     *                  puntatore, wtHis, work1, ifMod, ifFom)
!
               do i=1, numberToUse
                  fcoef(i) = fcoef(i) * wtHis(i)
               enddo
            enddo

            do i=1, numberToUse
               if (EobsEp(i) > 0.5) then
                   fcPrec(i) = fcvet(i)
                   wtSav(i) = wtNew(i)
               endif
            enddo


         enddo
!
         call SwitchRestorePattersonSpaceGroup(2)
         mkang(1:numberToUse) = mkangSav(1:numberToUse)
   
         iphaz(1:numberToUse) = jwork1(1:numberToUse)
         wt(1:numberToUse) = wtSav(1:numberToUse)
!
         izero = 0
         ifmin = 1
         nbru = -33
         call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
         errFin = erore
         errFinPes = erorepes
*        jpatt = 0
*        call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,FORTH,BACK)
*        kstp = 0
*        call Calcola_CC_Mappa(numberToUse,correl,kstp,2)
*        write(lo,10) nnnn,correl, errFin, errFinPes
!
      deallocate (EobsEp, wtSav, puntatore, fcoefSav, fcPrec, 
     *            wtNew, wtSSav, wtHis, mkangSav, stat = ierr)

      fcvet(1:numberToUse) = wt_in(1:numberToUse)
!
      return
   10 format(/,i5,' GEDM  MODULE FINAL CC_MAP =',f7.3,' ERR ',
     *       f5.2,' (',f5.2,')')
   99 format(5x,'CICLO GEDM = ',i8)
  100 format(/,' ',15('-'),' Mappa Fourier # ',i2,' CC_MAP=',f6.3,
     *         ' ',15('-'),/)
  210 format('X*D1(X) ',i3)
  220 format('WT      ',i3)
  230 format('WT Mod  ',i3)
      end
!-----------------------------------------------------------------------
      subroutine InitFinalFom()
      USE General
      USE Riflessi
      USE PhaseModule
!
      iyrandSav = iyrand
      iphaz(:) = 0.0
      wt(:) = 0.0
      call FindSeed(1)
      sigm=s3s2

     
!         ifInvar = 0

      if (ifInvar == 1) then
         inffom = 1
         call RandomPhases(inffom)
          wt(nstr+1:)=0.0
          irefin(1:nstr)=0.0
          if (ifMDM == 0) then
             call weitan(0, nstr)
          else
             call weitan_MDM(0, nstr)
          end if
          do i = 1,nstr
            if (wt(i).lt.0.000001) then
               alphaVet(i) = 0.0
            endif
          enddo
          nperc = nstr*0.1
          WtRef = 0.3
          call RiscalAlfa(nstr,nperc,WtRef)
      endif   ! NEW
      if (ifInvar /= 1 .or. sum(wt(1:nstr)) < 0.01) then  ! NEW
!NEW  else
          do i = 1,nstr
            iordeTang(i) = i
          enddo
          inffom = 1
          call RandomPhases(inffom)
          call RandomWeights()
          wt(nstr+1:)=0.0
      endif
c
c--calcolo il valore di riferimento per la FinalFom
c
!
      figuracce(:,:) = 0.0
!
      call Calcola_FOM_Lib(1)
      fomold(1)  = CCEoEc(1)
      fomold(2)  = CCEoEc(2)
      fomold(3)  = FOMs(2,4)
      if (knw == 1) write(6,*) 'FOMOLD',fomold

      figuracce(1,1) = FOMs(2,2)  !num Rat
      figuracce(1,2) = FOMs(2,3)  !denom Rat
      figuracce(1,3) = FOMs(2,4)  !RAT
      figuracce(1,4) = fig_CC(1)  !CC all
      figuracce(1,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
      figuracce(1,6) = fig_CC(2)  !CC lage
      figuracce(1,7) = fig_CC(4)  !CC weak
      figuracce(1,8) = fig_CC(4) * 3 !cc weak * 3

      if (knw > 0 .or. kverbo > 0) then
          write(6,10) figuracce(1,1:3)
          write(6,20) figuracce(1,4:5)
          write(6,30) figuracce(1,6:8)
      endif

      sogFinalFom = 2.0
      stopFinalFom = 1.0
      FFomStopPGM = 99.9

    
!     fomold(2)  = 0.0
!     write(6,*) 'FOMOLD dopo',fomold

      iyrand = iyrandSav
      iphaz = 0.0
      wt = 0.0
      call UpdateReflInfo
!
 10   format(' Initial numRAT,denomRAT,RAT   ',3f10.5)
 20   format(' Initial CCall ,Combined       ',2f10.5)
 30   format(' Initial CClarge,CCweak,3CCweak',3f10.5)
      return
      end
!-----------------------------------------------------------------------
      subroutine InitFinalFom_New()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
      USE VLDmod

!
!--calcolo il valore di riferimento per la FinalFom
!
      implicit none
      common /anna2/ipr
      real    :: chope, correl
      real    :: CC1,CC2, Reffe1,Reffe2
      real    :: NewRat_FFom, fomold_NewRat
      integer :: nuset, izero, ifmin, jpatt, ifBreak
      integer :: i,ipr,Azione
!
!-- Vecchie inizializzazioni di Liberato per articolo su Sir2007 
!
      if (ifDsrVLD == 0) then

         if (ffomReq /= -99) then
             sogFinalFom = ffom
         else
           if (ksize < 4) then
                 sogFinalFom = 2.0
           else 
             if (LowRes == 0) then
                if (resm < 1.0 .and. v_p > 0.8) then
                     sogFinalFom = 2.0
                elseif(resm < 1.0 .and. v_p < 0.8) then
                  if(iwei==0) then
                     sogFinalFom = 2.7
                  else
                     sogFinalFom = 2.0
                  endif
                else
                    sogFinalFom = 1.4
                  if(ksize>5) sogFinalFom = 1.9
                endif
             else
                if (no(nk) < 20) then
                   sogFinalFom = 1.00
                   if(is3s2<1400) sogFinalFom = 0.5
                else
                   if(resm<sogResEff) then
                       sogFinalFom = 2.0
                       if(no(nk)>40) sogFinalFom=1.0
                   else
                       sogFinalFom = 1.5
                       if(ksize==4) sogFinalFom=1.0
                   endif
                endif
             endif
             if(resm>sogResEff+0.1) then
               sogFinalFom=sqrt(anat/1000.0)*min(1.5/ResEff,0.78)
               sogFinalFom=max(sogFinalFom,0.7)!liberato2009
             endif
             if(ksize==7) then
               sogFinalFom = 4.0
               if(is3s2<3500.and.no(nk)>=20) sogFinalFom = 5.0
                  if(LowRes==1) then
                     sogFinalFom = 2.0
                     if(ResEff>sogResEff.or.Complet<0.99) then
                      sogFinalFom=sqrt(anat/1000.0)*min(1.5/ResEff,0.78)
                     endif
                  endif
             endif
           endif
         endif

      endif


      ipr = 0   ! per sigma_G2
      fomold(:)  = 0.0
      iyrandSav = iyrand
      iyrand = 67543
      call RandomPhases_VLD
      call Calcola_FOM_Lib(1)
!     if (ksize > 3 .and. ifVLD == 0) then
!         call Fom_CC_Fofc(nrefl,CC1,Reffe1)
!         call Fom_CC_Fofc(numbLSQ,CC2,Reffe2)
!     else
          CC1 = 0.0
          CC2 = 0.0
          Reffe1 = 0.99
          Reffe2 = 0.99
!     endif

      fomold(1)  = CCEoEc(1)
      fomold(2)  = CCEoEc(2)
      fomold(3)  = FOMs(2,4)

          numrat_first = FOMs(2,2)

!     fomold(4)  = FOMs(2,3)   !CC1
!     fomold(5)  = CC2

! --  NewRat
      Azione = 0
      fomold_NewRat = NewRat_FFom(Azione)
      fomold(5) = fomold_NewRat
!

      if (knw == 1) write(6,*) 'FOMOLD',fomold(1:3),fomold(5)

      figuracce(1,1) = FOMs(2,2)  !num Rat
      figuracce(1,2) = FOMs(2,3)  !denom Rat
      figuracce(1,3) = FOMs(2,4)  !RAT
      figuracce(1,4) = fig_CC(1)  !CC all
      figuracce(1,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
      figuracce(1,6) = fig_CC(2)  !CC lage
      figuracce(1,7) = fig_CC(4)  !CC weak
      figuracce(1,8) = fig_CC(4) * 3 !cc weak * 3

      if (knw == 1) then
          if (ifVLD == 0) then
              write(6,10) figuracce(1,1:3)
              write(6,35) figuracce(2,4), figuracce(2,6)
c             write(6,40) CC1,Reffe1,CC2,Reffe2
          else
              if (kverbo_pg > 0) then
                  write(6,10) figuracce(1,1:3)
                  write(6,20) figuracce(1,4:5)
                  write(6,30) figuracce(1,6:8)
              endif
          endif
      endif

! calcolo fasi e pesi random per FFom casuale di confronto
c     FFomRif = 0.0

          if (ksize <= 3) then

              sogFinalFom = 2.0
              stopFinalFom = 1.0
              FFomStopPGM = 99.9

          else

              if (LowRes == 0) then

                  sogFinalFom = 1.0
!                 sogFFomRif = 1.7
!                 stopFinalFom = 2.1  ! prova per nuovo PGM
                  sogFFomRif = 1.9
                  stopFinalFom = 3.0 !3.3  ! prova per nuovo PGM
    
              else

                  sogFinalFom = 1.0  !2./3.
!                 sogFFomRif = 1.7
!                 stopFinalFom = 2.1  ! prova per nuovo PGM
                  sogFFomRif = 1.9  
                  stopFinalFom = 3.0 !3.3 ! prova per nuovo PGM

              endif

          endif
! - per non bloccare il PGM in base alla FFom di default
         if (ffomReq /= -99) then
             FFomStopPGM = ffom
         else
             FFomStopPGM = stopFinalFom
         endif


      FFomRif   = sogFFomRif
      stopFFom  = stopFinalFom

      xmap(:,:,:) = 0.0
      iyrand = iyrandSav
      iphaz = 0.0
      wt = 0.0
      call UpdateReflInfo

 10   format(' Initial numRAT,denomRAT,RAT   ',3f10.5)
 20   format(' Initial CCall ,Combined       ',2f10.5)
 30   format(' Initial CClarge,CCweak,3CCweak',3f10.5)
 35   format(' Initial CCall , CClarge        ',2f10.5)
 40   format(' Initial CC_FoFc, Rf        ',4f10.5)

 100   format(' Random numRAT, denomRAT, RAT   ',3f10.5)
 200   format(' Random CCall , Combined        ',2f10.5)
 300   format(' Random CClarge, CCweak, 3CCweak',3f10.5)
 350   format(' Random CCall , CClarge        ',2f10.5)
 400   format(' Random numFFom,denomFFom,diffCC',3f10.5)
 500   format(' Random FFom0, FFom, sogFFom    ',3f10.5)

!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom(init)
      USE General
      USE PhaseModule

      real :: NewFFom0, NewFFom
      real :: fuffi
!
!--nuovo calcolo di FinalFom
!
      call Calcola_FOM_Lib(1)


      fuffi = FOMs(2,4)
*     FOMs(2,4) = numrat_first * (FOMs(2,4) / FOMs(2,2))

c     write(6,*) 'Rat_old, Rat_new',numrat_first, FOMs(2,2)
c     write(6,*) 'Rat_old, Rat_new',fuffi, FOMs(2,4)
c     write(6,*) 'fomold(4), FOMs(2,3)',fomold(4), FOMs(2,3)
!     if (ksize > 3 .and. ifVLD == 0) then
!         call Fom_CC_Fofc(nrefl,CC1,Reffe1)
!         call Fom_CC_Fofc(numbLSQ,CC2,Reffe2)
c         coeFFom = CC1 / fomold(4)
!     else
          CC1 = 0.0
          CC2 = 0.0
          Reffe1 = 0.99
          Reffe2 = 0.99
          coeFFom = 1.0
!     endif
!
      diffCC = CCEoEc(2)-fomold(2)
      if (ifDsrVLD == 1 .and. diffCC > 0.00001) then
          diffCC = diffCC ** 0.5
      endif
      FinalFom0 = CCEoEc(1)*FOMs(2,4)*diffCC/(fomold(1)*fomold(3))
      if (ifDsrVLD == 1) FinalFom0 = FinalFom0 / 2.  !vers. Annamaria
      FinalFom  = FinalFom0 / sogFinalFom
c     NewFFom0 = CCEoEc(1)*fomold(4)*diffCC/(fomold(1)*FOMs(2,3))
c     NewFFom = NewFFom0 / 2
c     NewFFom = NewFFom0 / sogFinalFom
c     write(6,*) 'NewFFom0, NewFFom',NewFFom0, NewFFom
!     
      figuracce(2, 9) = CCEoEc(1)*FOMs(2,4)
      figuracce(2,10) = fomold(1)*fomold(3)
      figuracce(2,11) = diffCC
      figuracce(2,12) = FinalFom0
      figuracce(2,13) = FinalFom
      figuracce(2,14) = FFomRif
      figuracce(2,15) = stopFinalFom

      if (knw == 1) then
          if (init == 1) then
              write(6,100) figuracce(2,1:3)
              write(6,300) figuracce(2,4), figuracce(2,6)
              write(6,400) figuracce(2,9:11)
              write(6,500) figuracce(2,12:15)!,NewFFom
!             write(6,700) CC1,Reffe1,CC2,Reffe2
          else 
              if (ifPostDSR == 0) then
                  if (ifReduced == 0) then
                      write(6,10) figuracce(2,1:3)
                      write(6,30) figuracce(2,4), figuracce(2,6)
                      write(6,40) figuracce(2,9:11)
                      write(6,50) figuracce(2,12:15)!,NewFFom
!                     write(6,70) CC1,Reffe1,CC2,Reffe2
                  else
                      write(6,11) figuracce(2,1:3)
                      write(6,31) figuracce(2,4), figuracce(2,6)
                      write(6,41) figuracce(2,9:11)
                      write(6,51) figuracce(2,12:15)!,NewFFom
!                     write(6,71) CC1,Reffe1,CC2,Reffe2
                  endif
              else
                  write(6,12) figuracce(2,1:3)
                  write(6,32) figuracce(2,4), figuracce(2,6)
                  write(6,42) figuracce(2,9:11)
                  write(6,52) figuracce(2,12:15)!,NewFFom
!                 write(6,72) CC1,Reffe1,CC2,Reffe2
              endif
          endif
      endif
!
 10   format(' Current numRAT, denomRAT, RAT   ',3f10.5)
!20   format(' Current CCall , Combined        ',2f10.5)
!30   format(' Current CClarge, CCweak, 3CCweak',3f10.5)
 30   format(' Current CCall, CClarge          ',2f10.5)
 40   format(' Current numFFom,denomFFom,diffCC',3f10.5)
 50   format(' Current FFom0, FFom, FFomRif, stopFFom ',5f10.5)
 70   format(' Current CC_FoFc, Rf        ',4f10.5)

 11   format(' Relax numRAT, denomRAT, RAT   ',3f10.5)
!21   format(' Relax CCall , Combined        ',2f10.5)
!31   format(' Relax CClarge, CCweak, 3CCweak',3f10.5)
 31   format(' Relax CCall, CClarge          ',2f10.5)
 41   format(' Relax numFFom,denomFFom,diffCC',3f10.5)
 51   format(' Relax FFom0, FFom, FFomRif, stopFFom ',5f10.5)
 71   format(' Relax CC_FoFc, Rf        ',4f10.5)

 12   format(' PostDsr numRAT, denomRAT, RAT   ',3f10.5)
!22   format(' PostDsr CCall , Combined        ',2f10.5)
!32   format(' PostDsr CClarge, CCweak, 3CCweak',3f10.5)
 32   format(' PostDsr CCall, CClarge          ',2f10.5)
 42   format(' PostDsr numFFom,denomFFom,diffCC',3f10.5)
 52   format(' PostDsr FFom0, FFom, FFomRif, stopFFom ',5f10.5)
 72   format(' PostDsr CC_FoFc, Rf        ',4f10.5)

 100  format(' Random numRAT, denomRAT, RAT   ',3f10.5)
!200  format(' Random CCall , Combined        ',2f10.5)
!300  format(' Random CClarge, CCweak, 3CCweak',3f10.5)
 300  format(' Random CCall, CClarge          ',2f10.5)
 400  format(' Random numFFom,denomFFom,diffCC',3f10.5)
 500  format(' Random FFom0, FFom, FFomRif, stopFFom ',5f10.5)
 700  format(' Random CC_FoFc, Rf        ',4f10.5)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom2(init)
      USE General
      USE PhaseModule

      real :: numFom, denomFom
      real :: dumpFFom0, dumpFFom
      real :: FFom_1, FFom_2
      real :: NewRat_FFom
      integer :: Azione
      

      ipr = knw 
!
!--nuovo calcolo di FinalFom
!
      numFom = CCEoEc(1)*CCEoEc(2)*FOMs(2,4) 
      denomFom = fomold(1)*fomold(2)*fomold(3)
      FFom_1 = numFom / denomFom

      dumpFFom0 = CCEoEc(1)

      if (CCEoEc(1) > 0.00001) then
          dumpFFom = sqrt(CCEoEc(1))
      else
          dumpFFom = 0.001
      endif 

c     if (CCEoEc(1) > fomold(1)) then
!         dumpFFom = (CCEoEc(1) - fomold(1)) / fomold(1)
!         dumpFFom = (CCEoEc(2) - fomold(2)) / fomold(2)
c         dumpFFom = (CCEoEc(1) - fomold(1)) / (1.0-fomold(1))
!         dumpFFom = (CCEoEc(2) - fomold(2)) / (1.0-fomold(2))
c     else
c         dumpFFom = 0.001
c     endif 

!     FFom_2 = FFom_1 *  dumpFFom0
      FFom_2 = FFom_1 *  dumpFFom
!
      Azione = 1
      fom_NewRat = NewRat_FFom(Azione)
      FOMs(2,5) = fom_NewRat
!

!     
      if (ipr == 1) then
          if (init == 1) then
              write(6,100) CCEoEc(1:2),FOMs(2,4)
              write(6,200) fomold(1:3)
              write(6,300) numFom, denomFom, CCEoEc(1)
!             write(6,400) FFom_1, FFom_2
              write(6,500) FFom_1, FFom_2, dumpFFom
              write(6,400) FFom_2, fom_NewRat
          else 
              if (ifPostDSR == 0) then
                  if (ifReduced == 0) then
                      write(6,10) CCEoEc(1:2),FOMs(2,4)
                      write(6,20) fomold(1:3)
                      write(6,30) numFom, denomFom, CCEoEc(1)
!                     write(6,40) FFom_1, FFom_2
                      write(6,50) FFom_1, FFom_2, dumpFFom 
                      write(6,40) FFom_2, fom_NewRat, erore, erorepes
                  else
                      write(6,11) CCEoEc(1:2),FOMs(2,4)
                      write(6,21) fomold(1:3)
                      write(6,31) numFom, denomFom, CCEoEc(1)
!                     write(6,41) FFom_1, FFom_2
                      write(6,51) FFom_1, FFom_2, dumpFFom 
                      write(6,41) FFom_2, fom_NewRat
                  endif
              else
                  write(6,12) CCEoEc(1:2),FOMs(2,4)
                  write(6,22) fomold(1:3)
                  write(6,32) numFom, denomFom, CCEoEc(1)
!                 write(6,42) FFom_1, FFom_2
                  write(6,52) FFom_1, FFom_2, dumpFFom 
                  write(6,42) FFom_2, fom_NewRat
              endif
          endif
      endif
!
      FinalFom = FFom_2
!

 10   format(' Current CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 20   format(' Current CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 30   format(' Current numFOM, denomFOM, CC  ',3f10.5)
!40   format(' Current FFom1, FFom2',2f10.5)
c40   format(' Current FFom2, NewRat',2f10.5)
 40   format('   DSR   FFom2, NewRat, MPE',2f10.5,2f7.2)
 50   format(' Current FFom1, FFom2, dumpFFom',3f10.5)

 11   format(' Relax CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 21   format(' Relax CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 31   format(' Relax numFOM, denomFOM, CC  ',3f10.5)
!41   format(' Relax FFom1, FFom2',2f10.5)
 41   format(' Relax FFom2, NewRat',2f10.5)
 51   format(' Relax FFom1, FFom2, dumpFFom',3f10.5)

 12   format(' PostDSR CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 22   format(' PostDSR CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 32   format(' PostDSR numFOM, denomFOM, CC  ',3f10.5)
!42   format(' PostDSR FFom1, FFom2',2f10.5)
 42   format(' PostDSR FFom2, NewRat',2f10.5)
 52   format(' PostDSR FFom1, FFom2, dumpFFom',3f10.5)

 100  format(' Random CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 200  format(' Random CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 300  format(' Random numFOM, denomFOM, CC  ',3f10.5)
!400  format(' Random FFom1, FFom2',2f10.5)
 400  format(' Random FFom2, NewRat',2f10.5)
 500  format(' Random FFom1, FFom2, dumpFFom',3f10.5)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_Fofc(ifin,CC,Reffe)
      USE General
      USE Riflessi

c---- calcola il CC tra Fo e Fc  (da Ec dopo HM su Eo)

!
      call E2F_and_R_OBS(ifin,Reffe)
!
      sumFc     = 0.0
      sumFo     = 0.0
      sumFoFc   = 0.0
      sumFc2    = 0.0
      sumFo2    = 0.0

      ncont  = 0
 
      do i=1,ifin
         ncont = ncont + 1

         Fo  = fovet(i)
         Fo2 = fovet(i)**2
         Fc  = worko(i)
         Fc2 = worko(i)**2
 
         sumFoFc = sumFoFc + Fo * Fc
         sumFo   = sumFo   + Fo
         sumFo2  = sumFo2  + Fo2
         sumFc   = sumFc   +      Fc
         sumFc2  = sumFc2  +      Fc2

      enddo

      if (ncont.gt.0) then
          sumFoFc = sumFoFc / ncont
          sumFo   = sumFo   / ncont
          sumFo2  = sumFo2  / ncont
          sumFc   = sumFc   / ncont
          sumFc2  = sumFc2  / ncont
   
          arg  = sumFoFc - (sumFo * sumFc)
          den1 = sumFc2 - (sumFc**2)
          den2 = sumFo2 - (sumFo**2)
          if (den1.gt.0.00001.and.den2.gt.0.00001) then
              den  = sqrt(den1) * sqrt(den2)
          else
              den = 0.0
          endif
      else
          den = 0.0
      endif
!
      if (den.gt.0.00001) then
          rap = arg / den
      else
          rap = 0.0
      endif

      CC = rap

      return
      end
!------------------------------------------------------------------------------
      subroutine E2F_and_R_OBS(ifin,Reffe)
c
      USE General
      USE Symmetry
      USE Riflessi
!
!-- trasformo gli E calcolati in F calcolati
!
      worko(:) = 0.0
      sumfo = 0.0
      sumfc = 0.0
      do i=1, ifin
         ec    = fcvet(i)
         ec2   = ec * ec
         rho   = rhov(i)
         eps   = epsv(i)
         multi = mult(i)
         sinth = 100.0 * sqrt(rho)
         ind   = max0( 2, int(sinth + 1.5) )
         frac  = sinth - float( ind - 1 )
         bf    = 0.5 * ( giw(ind+1) - giw(ind-1) )
         af    = bf + giw(ind-1) - giw(ind)
         sigma = af * frac * frac + bf * frac + giw(ind)
         denor = sc * exp( 2.0 * bt * rho )
         fo    = sqrt( ec2 * pts * eps * sigma / denor )
         worko(i) = fo
         sumfo = sumfo + fovet(i)
         sumfc = sumfc + worko(i)
!        risol = 0.5 / sqrt(rho)

*        write(6,100) i,ind,fcvet(i),wt(i),risol,eps,pts,giw(ind),
*    *                af,bf,bt
  100    format(i5,')',i8,9f9.3)
      enddo
      scala = sumfc / sumfo
      sumfo = 0.0
      sumdf = 0.0
      do i=1, ifin
         scaled_fo = scala * fovet(i)
         sumfo = sumfo + scaled_fo
         sumdf = sumdf + abs( worko(i) - scaled_fo )
      enddo
      Reffe = sumdf / sumfo
!
      return
      end
!-----------------------------------------------------------------------
!  FOMS per PostMR
!-----------------------------------------------------------------------
      subroutine InitFinalFom_PostMR()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
      USE VLDmod

!
!--calcolo il valore di riferimento per la FinalFom
!
      implicit none
      common /anna2/ipr
      real    :: chope, correl
      real    :: NewRat, fomold_NewRat
      integer :: nuset, izero, ifmin, jpatt, ifBreak
      integer :: i,ipr,Azione

      ipr = 0   ! per sigma_G2
      fomold(:)  = 0.0
!
! calcolo fasi e pesi random per FFom casuale di confronto
!
      iyrandSav = iyrand
      iyrand = 67543
      call RandomPhases_VLD
!
      call Calcola_FOM_Lib(1)

      fomold(1)  = CCEoEc(1)
      fomold(2)  = CCEoEc(2)
      fomold(3)  = FOMs(2,4)

      if (knw == 1) write(6,*) 'FOMOLD',fomold(1:3)

      figuracce(1,1) = FOMs(2,2)  !num Rat
      figuracce(1,2) = FOMs(2,3)  !denom Rat
      figuracce(1,3) = FOMs(2,4)  !RAT
      figuracce(1,4) = fig_CC(1)  !CC all
      figuracce(1,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
      figuracce(1,6) = fig_CC(2)  !CC lage
      figuracce(1,7) = fig_CC(4)  !CC weak
      figuracce(1,8) = fig_CC(4) * 3 !cc weak * 3

      if (knw == 1) then
              write(6,10) figuracce(1,1:3)
              write(6,35) figuracce(2,4), figuracce(2,6)
c             write(6,40) CC1,Reffe1,CC2,Reffe2
      endif

         sogFinalFom = 1.0
         sogFFomRif = 1.9
         stopFinalFom = 3.0 
    
! - per non bloccare il PGM in base alla FFom di default
         if (ffomReq /= -99) then
             FFomStopPGM = ffom
         else
             FFomStopPGM = stopFinalFom
         endif


      FFomRif   = sogFFomRif
      stopFFom  = stopFinalFom

      xmap(:,:,:) = 0.0
      iyrand = iyrandSav
      iphaz = 0.0
      wt = 0.0
      call UpdateReflInfo

! --  NewRat
      Azione = 0 
      fomold_NewRat = NewRat(Azione)
      fomold(5) = fomold_NewRat
!

 10   format(' Initial numRAT,denomRAT,RAT   ',3f10.5)
 20   format(' Initial CCall ,Combined       ',2f10.5)
 30   format(' Initial CClarge,CCweak,3CCweak',3f10.5)
 35   format(' Initial CCall , CClarge        ',2f10.5)
 40   format(' Initial CC_FoFc, Rf        ',4f10.5)

!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom2_PostMR(init)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom_PostMR(init)
      USE General
      USE PhaseModule

      real :: numFom, denomFom
      real :: dumpFFom0, dumpFFom
      real :: FFom_1, FFom_2
      real :: NewRat_FFom
      integer :: Azione

      ipr = knw 
!
!--nuovo calcolo di FinalFom
!
      call Calcola_FOM_Lib(1)
!
      numFom = CCEoEc(1)*CCEoEc(2)*FOMs(2,4) 
      denomFom = fomold(1)*fomold(2)*fomold(3)
      FFom_1 = numFom / denomFom

      dumpFFom0 = CCEoEc(1)

      if (CCEoEc(1) > 0.00001) then
          dumpFFom = sqrt(CCEoEc(1))
      else
          dumpFFom = 0.001
      endif 

!     FFom_2 = FFom_1 *  dumpFFom0
      FFom_2 = FFom_1 *  dumpFFom
!     
!
! --  NewRat
      Azione = 1
      fom_NewRat = NewRat_FFom(Azione)
      FOMs(2,5) = fom_NewRat
!
      if (ipr == 1) then
          if (init == 1) then
              write(6, 50) figuracce(2,1:3)
              write(6,100) CCEoEc(1:2),FOMs(2,4)
              write(6,200) fomold(1:3)
              write(6,300) numFom, denomFom, CCEoEc(1)
              write(6,400) FFom_1, FFom_2, dumpFFom
              write(6,450) FFom_2, fom_NewRat
          else 
              write(6, 5) figuracce(2,1:3)
              write(6,10) CCEoEc(1:2),FOMs(2,4)
              write(6,20) fomold(1:3)
              write(6,30) numFom, denomFom, CCEoEc(1)
              write(6,40) FFom_1, FFom_2, dumpFFom 
              write(6,45) FFom_2, fom_NewRat, erore, erorepes
          endif
      endif
!
      FinalFom = FFom_2
!


  5   format(' Current numRAT, denomRAT, RAT_cur   ',3f10.5)
 10   format(' Current CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 20   format(' Current CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 30   format(' Current numFOM, denomFOM, CC  ',3f10.5)
 40   format(' Current FFom1, FFom2, dumpFFom',3f10.5)
c45   format(' Current FFom2, NewRat',2f10.5)
 45   format(' REFMAC  FFom2, NewRat, MPE',2f10.5,2f7.2)


  50  format(' Random numRAT, denomRAT, RAT_cur   ',3f10.5)
 100  format(' Random CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 200  format(' Random CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 300  format(' Random numFOM, denomFOM, CC  ',3f10.5)
 400  format(' Random FFom1, FFom2, dumpFFom',3f10.5)
 450  format(' Random FFom2, NewRat'23f10.5)
!
      return
      end
!-----------------------------------------------------------------------
!  Nuova Fom per Rotazione (costo = FFom)
!-----------------------------------------------------------------------
      subroutine InitFinalFom_MR()
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
      USE VLDmod

!
!--calcolo il valore di riferimento per la FinalFom
!
      implicit none
      common /anna2/ipr
      real    :: chope, correl
      integer :: nuset, izero, ifmin, jpatt, ifBreak
      integer :: i,ipr
!
      ipr = 0   ! per sigma_G2
      fomold(:)  = 0.0
      call Calcola_FOM_MR(1)
 
      do i = 1,2
         sum_term(i) = 0.0
         if (CCEoEc(i) < 0.00001) then 
             sum_term(i) = 0.01 + abs(CCEoEc(i))
             CCEoEc(i) = CCEoEc(i) + sum_term(i)
         endif
      enddo

      fomold(1)  = CCEoEc(1)
      fomold(2)  = CCEoEc(2)
      fomold(3)  = FOMs(2,4)

      if (knw == 1) write(6,*) 'FOMOLD',fomold(1:3)

      figuracce(1,1) = FOMs(2,2)  !num Rat
      figuracce(1,2) = FOMs(2,3)  !denom Rat
      figuracce(1,3) = FOMs(2,4)  !RAT
      figuracce(1,4) = fig_CC(1)  !CC all
      figuracce(1,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
      figuracce(1,6) = fig_CC(2)  !CC lage
      figuracce(1,7) = fig_CC(4)  !CC weak
      figuracce(1,8) = fig_CC(4) * 3 !cc weak * 3

      if (kverbo == 1) then
          write(6,10) figuracce(1,1:3)
          write(6,35) figuracce(2,4), figuracce(2,6)
      endif

! calcolo fasi e pesi random per FFom casuale di confronto

         sogFinalFom = 1.0
         sogFFomRif = 1.9
         stopFinalFom = 3.0 
    
! - per non bloccare il PGM in base alla FFom di default
         if (ffomReq /= -99) then
             FFomStopPGM = ffom
         else
             FFomStopPGM = stopFinalFom
         endif


      FFomRif   = sogFFomRif
      stopFFom  = stopFinalFom

 10   format(' Initial numRAT,denomRAT,RAT   ',3f10.5)
 20   format(' Initial CCall ,Combined       ',2f10.5)
 30   format(' Initial CClarge,CCweak,3CCweak',3f10.5)
 35   format(' Initial CCall , CClarge        ',2f10.5)
 40   format(' Initial CC_FoFc, Rf        ',4f10.5)

!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom_MR(nusol,iact,fom_costo,prt_fom)
      USE General
      USE PhaseModule
      USE RemoModule

      real :: numFom, denomFom
      real :: dumpFFom0, dumpFFom, dumpFF
      real :: FFom_1, FFom_2
      real::fom_costo,prt_fom(5)
      integer :: nusol, neg_costo, neg_FFom1

!     iact = 1   ! Rotazione
!     iact = 2   ! Traslazione

      ipr = kverbo 
c     ipr = 1000 
      fomold(:)  = 1.0
      neg_costo = 0
      neg_FFom1 = 0
!
!--nuovo calcolo di FinalFom
!
      if (iact == 1) then
          call Calcola_FOM_MR_NEW(iact)   
!!!       call Calcola_FOM_MR_NEW2(iact)   
      else
          call Calcola_FOM_MR_NEW(iact)   
!!!       call Calcola_FOM_MR_NEW2(iact)   
      endif
!

      FFom_1 = FOMs(2,4)

      if (fom_costo < 0.00001) then
          neg_costo = 1
      endif
      if (FFom_1 < 0.00001) then
          neg_FFom1 = 1
      endif
   
      FFom_2 = FFom_1 * fom_costo

      if (neg_costo == 1 .and. neg_FFom1 == 1) then
          FFom_2 =  - FFom_2 * 1
      endif
!
      prt_fom(1) = FOMs(2,2)
      prt_fom(2) = FOMs(2,3)
      prt_fom(3) = FOMs(2,4) !FFom_1
      prt_fom(4) = fom_costo
      prt_fom(5) = FFom_2 
!     
      if (ipr == 1) then
          write(6, 5) figuracce(2,1:3)
          write(6,15) figuracce(1,1:3)
          write(6,10) CCEoEc(1:2),FOMs(2,4)
          write(6,20) fomold(1:3)
          write(6,30) numFom, denomFom
          write(6,40) FFom_1, FFom_2, dumpFF 
      endif

      if (ipr == 1000) then
c     if (iact == 2) then
          write(6,50) nusol,prt_fom
      endif
!
      FinalFom = FFom_2
!

  5   format(' Current numRAT_cur, denomRAT_cur, RAT_cur   ',3f10.5)
 15   format(' Current numRAT_ini, denomRAT_ini, RAT_ini   ',3f10.5)
 10   format(' Current CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 20   format(' Current CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 30   format(' Current numFOM, denomFOM ',2f10.5)
 40   format(' Current FFom1, FFom2, dumpFF',3f10.5)
 50   format(' nRAT, dRAT, RAT, costo, Fom',i8,5f13.5)

!
      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_FOM_MR(iact)   ! RAT 
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
      USE Param, only : f000
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution

!      iact = 1  FOM Rotazione
!      iact = 2  FOM Traslazione
!
!--calcolo della FOM 
!
      character ttirang * 80
!
      kve = 0

      iesFom = 1
!     waveare_sav = waveare
!     exposigma_sav = exposigma

  
      if (iact == 1) then
          numbSel = nreflSelRot * 0.7
      else
          numbSel = nreflSelTra * 0.7
      endif

      call Calcola_CC_EoEc_MR(iact,numbSel)
!
      chope = 2.0
      call CalcolaPesi_MR(iact,chope)
!

      iflg = 2
      call Fom_CC_MR(iact,numbSel,CC,iflg)
      FOMs(2,2) = CC

      call Fom_EC2_MR(iact,numbSel,EC2,sgmin)
      FOMs(2,3) = EC2
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,3) = sgmin
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif
c_LIB
c     if (kverbo > 0) then
c        write(lo,9) CC,EC2,FOMs(2,4)
c     endif
  9   format(' RAT-FOMs',3f10.3)


      FOMs(2,1) = CCEoEc(1)

          figuracce(2,1) = FOMs(2,2)  !num Rat
          figuracce(2,2) = FOMs(2,3)  !denom Rat
          figuracce(2,3) = FOMs(2,4)  !RAT
          figuracce(2,4) = fig_CC(1)  !CC all
          figuracce(2,5) = fig_CC(10) !comb  = CC large + 3 * CC weak
          figuracce(2,6) = fig_CC(2)  !CC lage
          figuracce(2,7) = fig_CC(4)  !CC weak
          figuracce(2,8) = fig_CC(4) * 3 !cc weak * 3

 
!     waveare = waveare_sav
!     exposigma = exposigma_sav
 
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_MR(iact,numbSel,CC,iflg)
      USE General
      USE Riflessi
      USE PhaseModule, only : ifVLD
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!

!
!---- calcola il CC tra Eo**2 e wt**2 
!     iflg = 0  uso tutti gli Eo (nrefl) 
!     iflg = 1  uso solo il 70% degli Eo sino alla risoluzione voluta
!     iflg = 2  uso solo gli Eo con modulo compreso tra sgmin sgmax

      resol = resm
      rhosog = (0.5 / resol) **2

      sumWT2     = 0.0
      sumEo2     = 0.0
      sumWT2Eo2  = 0.0
      sumWT4     = 0.0
      sumEo4     = 0.0

      ncont  = 0
 
      sgmin = 0.1
c     sgmin = 1.2
      sgmax = 100.

      if (iact == 1) then
          numb = nreflSelRot
      else
          numb = nreflSelTra
      endif

      do i=1,numb
         if (iact == 1) then
             EObs = ModuliSel(2,i)
         else
             EObs = workRenor2(i)
         endif
         icc = 1
         if (iflg.eq.1) then
             if(i.gt.numbSel) then
                 icc = 0
             endif
         elseif(iflg.eq.2) then
             if(EObs.lt.sgmin.or.EObs.gt.sgmax.
     *          or.i.gt.numbSel) then
                 icc = 0
             endif
         endif
         if (wt(i) < 0.00001) then
             icc = 0
         endif
c
         if (icc.eq.1) then
             ncont = ncont + 1

             Eo2 = EObs**2
             Eo4 = EObs**4
             WT2 = wt(i)**2
             WT4 = wt(i)**4
 
             sumWT2Eo2 = sumWT2Eo2 + WT2 * Eo2
             sumWT2    = sumWT2    + WT2
             sumEo2    = sumEo2    +       Eo2
             sumWT4    = sumWT4    + WT4
             sumEo4    = sumEo4    +       Eo4

         endif
 
      enddo

      if (ncont.gt.0) then
          sumWT2Eo2 = sumWT2Eo2 / ncont
          sumWT2    = sumWT2    / ncont
          sumEo2    = sumEo2    / ncont
          sumWT4    = sumWT4    / ncont
          sumEo4    = sumEo4    / ncont
   
          arg  = sumWT2Eo2 - (sumWT2 * sumEo2)
          den1 = sumWT4 - (sumWT2**2)
          den2 = sumEo4 - (sumEo2**2)
          if (den1.gt.0.00001.and.den2.gt.0.00001) then
              den  = sqrt(den1) * sqrt(den2)
          else
              den = 0.0
          endif
      else
          den = 0.0
      endif
c
      if (abs(den).gt.0.00001) then
          rap = arg / den
      else
          rap = -99.9 !0.0
      endif

          CC = rap

      return
      end

c_LIB
c-----------------------------------------------------------------------
      subroutine Fom_EC2_MR(iact,numbSel,EC2,sgmin)
      USE General
      USE Riflessi
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!

!
!---- calcola il valormedio per Ec**2 (per il 30% dei riflessi piu' deboli)
!
      sumEc2   = 0.0
      ncont = 0
      sgmin = 0.1
!
      if (iact == 1) then
          numb = nreflSelRot
      else
          numb = nreflSelTra
      endif
!
      do i=numbSel+1,numb
c        if (ModuliSel(1,i).gt.sgmin) then
             ncont = ncont + 1
             if (iact == 1) then
                 Ec2   = ModuliSel(1,i)**2
             else
                 Ec2   = workRenor1(i)**2
             endif
             sumEc2   = sumEc2   + Ec2
c        endif
      enddo
 
      if (ncont.gt.0) then
          EC2    = sumEc2   / ncont
      else
          EC2 = 0.0
      endif
!     if( EC2 > 1.0 ) EC2 =  0.5
      EC2 =  EC2 * 0.5

      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_CC_EoEc_MR(iact,numbSel)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!
*     dimension fig_CC(15)

      fig_CC(:) = 0.0

      do iflg = 1,4
         call Fom_CC_EoEc_MR(iact,numbSel,CC,iflg)
         fig_CC(iflg) = CC
      enddo

 111  format(' Trial',i6,2i4,' FOM_CC   =',3f9.3)

      fig_CC( 5) = fig_CC(1) + fig_CC(4)
      fig_CC( 6) = fig_CC(2) + fig_CC(4)
      fig_CC( 7) = fig_CC(1) + fig_CC(4)*2.
      fig_CC( 8) = fig_CC(2) + fig_CC(4)*2.
      fig_CC( 9) = fig_CC(1) + fig_CC(4)*3.
      if (ifMDM == 0) then
         fig_CC(10) = fig_CC(2) + fig_CC(4)*3.
      else
         fig_CC(10) = fig_CC(2)
      end if
      CCEoEc(1)  =  fig_CC( 1) 
      CCEoEc(2)  =  fig_CC(2)  ! solo CC large
!Old  CCEoEc(2)  =  fig_CC(10)
! 
 10   format (5x,' EC2s = ',f8.3,5x,' EC2w = ',f8.3,/,
     *        5x,' EC3w = ',f8.3,5x,' EC4w = ',f8.3)
 20   format(' Trial',i6,2i4,' CC_EoEc',4f8.3)
 30   format(' Trial',i6,' Diff CC_EoEc',6f8.3)
 40   format(' Trial',i6,2i4,' Diff CC_EoEc',6f8.3)
 50   format(' Trial',i6,2i4,' Res_EoEc',4f8.3)
 
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_EoEc_MR(iact,numbSel,CC,iflg)
      USE General
      USE Riflessi
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!


c---- calcola il CC tra Eo e Ec

!
!     iflg = 1  tutti gli Eo (nrefl) 
!     iflg = 2  70% degli Eo
!     iflg = 3  70% degli Eo con modulo compreso tra sgmin sgmax
!     iflg = 4  30% degli Eo piu' bassi

      sgmin = 0.1
      sgmax = 1.2

      sumEc     = 0.0
      sumEo     = 0.0
      sumEoEc   = 0.0
      sumEc2    = 0.0
      sumEo2    = 0.0

      ncont  = 0
 
      if (iact == 1) then
          numb = nreflSelRot
      else
          numb = nreflSelTra
      endif

      do i=1,numb
         if (iact == 1) then
             ECal = ModuliSel(1,i)
             EObs = ModuliSel(2,i)
         else
             ECal = workRenor1(i)
             EObs = workRenor2(i)
         endif
         icc = 1
         if (iflg.eq.2) then
             if(i.gt.numbSel) then
                 icc = 0
             endif
         elseif(iflg.eq.3) then
             if(EObs.lt.sgmin.or.EObs.gt.sgmax.
     *          or.i.gt.numbSel) then
                 icc = 0
             endif
         elseif(iflg.eq.4) then
             if(i.le.numbSel) then
                 icc = 0
             endif
         endif

         if (icc.eq.1) then
             ncont = ncont + 1

             Eo  = EObs
             Eo2 = EObs**2
             Ec  = ECal
             Ec2 = ECal**2
 
             sumEoEc = sumEoEc + Eo * Ec
             sumEo   = sumEo   + Eo
             sumEo2  = sumEo2  + Eo2
             sumEc   = sumEc   +      Ec
             sumEc2  = sumEc2  +      Ec2

         endif
 
      enddo

      if (ncont.gt.0) then
          sumEoEc = sumEoEc / ncont
          sumEo   = sumEo   / ncont
          sumEo2  = sumEo2  / ncont
          sumEc   = sumEc   / ncont
          sumEc2  = sumEc2  / ncont
   
          arg  = sumEoEc - (sumEo * sumEc)
          den1 = sumEc2 - (sumEc**2)
          den2 = sumEo2 - (sumEo**2)
          if (den1.gt.0.00001.and.den2.gt.0.00001) then
              den  = sqrt(den1) * sqrt(den2)
          else
              den = 0.0
          endif
      else
          den = 0.0
      endif
!
      if (den.gt.0.00001) then
          rap = arg / den
      else
          rap = 0.0
      endif

      CC = rap

      return
      end
!------------------------------------------------------------------------------
      subroutine CalcolaPesi_MR(iact,chope)
      USE General
      USE Riflessi
      USE HistoStuff
      USE RemoModule
      USE PhaseModule
      USE Param
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!
! -- PESI CON PROCEDURA CLASSICA (SIM like)
!

      if (iact == 1) then
          numb = nreflSelRot
      else
          numb = nreflSelTra
      endif

c     goto 100
c----   pesi: HM tra 2 sets di dati
          do i=1,numb
             if (iact == 1) then
                 work1(i) = ModuliSel(1,i)**2  ! ECalc ; Emod in uscita
                 work2(i) = ModuliSel(2,i)**2  ! EObs
             else
                 work1(i) = workRenor1(i)**2  ! ECalc ; Emod in uscita
                 work2(i) = workRenor2(i)**2  ! EObs
             endif
          enddo
          if (ksize == 1) then
              nwizm1=10  ! micro
          elseif(ksize < 3) then
c         elseif(ksize <= 3) then    ! da provare
              nwizm1=15  ! small / medium
          else
              nwizm1=25  ! proteins  -  da provare con routine generalizzata
          endif
!         nden =  nstr / 10
          nden =  nwizm1 * 2
          nsip1 = numb / nden
          nsip1 = min(nsip1,498)
          call HistogramMatch(work1,work2,numb,nsip1,nwizm1,1)
          work2(1:numb) = work1(1:numb)
!finemerge!
!
 100  continue
      nopeso = 0

      do i=1,numb
         ec2i = work2(i)

         if (iact == 1) then
c            ec2i = ModuliSel(1,i)  !da provare
             EObs = ModuliSel(2,i)
         else
c            ec2i = workRenor1(i)   !da provare
             EObs = workRenor2(i)
         endif

         if (ec2i.gt.0.00001) then
             ECal = sqrt(ec2i)
         else
             ECal = 0.0
         endif
         SimW = chope * EObs * ECal
         gSim =  bes( SimW )
         gSim = min(gSim,1.0)
         wt(i) = gSim
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FinalFom_MR_NEW(nusol,iact,fom_costo,prt_fom)
      USE General
      USE PhaseModule
      USE RemoModule

      real :: numFom, denomFom
      real :: dumpFFom0, dumpFFom, dumpFF
      real :: FFom_1, FFom_2
      real::fom_costo,prt_fom(5)
      integer :: nusol, neg_costo, neg_FFom1

!     iact = 1   ! Rotazione
!     iact = 2   ! Traslazione

      ipr = kverbo 
c     ipr = 1000 
      fomold(:)  = 1.0
      neg_costo = 0
      neg_FFom1 = 0
!
!--nuovo calcolo di FinalFom
!
      call Calcola_FOM_MR_NEW2(iact)   
!

      FFom_1 = FOMs(2,4)

      FFom_2 = FFom_1 

!
      prt_fom(1) = FOMs(2,2)
      prt_fom(2) = FOMs(2,3)
      prt_fom(3) = FOMs(2,4) !FFom_1
      prt_fom(4) = fom_costo
      prt_fom(5) = FFom_2 
!     
      if (ipr == 1) then
          write(6, 5) figuracce(2,1:3)
          write(6,15) figuracce(1,1:3)
          write(6,10) CCEoEc(1:2),FOMs(2,4)
          write(6,20) fomold(1:3)
          write(6,30) numFom, denomFom
          write(6,40) FFom_1, FFom_2, dumpFF 
      endif

c     if (ipr == 1000) then
c         write(6,50) nusol,prt_fom
c         write(6,60) nusol,FOMs(2,2:4) 
c     endif
!
      FinalFom = FFom_2
!

  5   format(' Current numRAT_cur, denomRAT_cur, RAT_cur   ',3f10.5)
 15   format(' Current numRAT_ini, denomRAT_ini, RAT_ini   ',3f10.5)
 10   format(' Current CCall_cur, CClarge_cur, RAT_cur   ',3f10.5)
 20   format(' Current CCall_ini, CClarge_ini, RAT_ini   ',3f10.5)
 30   format(' Current numFOM, denomFOM ',2f10.5)
 40   format(' Current FFom1, FFom2, dumpFF',3f10.5)
 50   format(' nRAT, dRAT, RAT, costo, Fom',i8,5f10.5)
 60   format(' nRAT, dRAT, RAT ',i8,3f10.5)

!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FOM_MR_NEW(iact)   ! RAT 
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
      USE Param, only : f000
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution

!      iact = 1  FOM Rotazione
!      iact = 2  FOM Traslazione
!
!--calcolo della FOM 
!
      character ttirang * 80
!
      kve = 0
c     sgmin = 0.001
      sgmin = 0.1
      iesFom = 1
  
      if (iact == 1) then
          call Fom_EC2_MR_ROT(Ec2s,Ec2w)
      else
c         percSel =  0.7
c         call Fom_EC2_MR_NEW(iact,percSel,Ec2s,Ec2w)
          percSel =  0.30
!!!!!     call Fom_EC2_MR_MOD(iact,percSel,Ec2s,Ec2w)
          call Fom_EC2_MR_MOD2(iact,percSel,Ec2s,Ec2w)
      endif

      FOMs(2,2) = Ec2s
      FOMs(2,3) = Ec2w
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,3) = sgmin
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif

c     write(6,9) FOMs(2,2:4)
  9   format(' RAT-FOMs',3f10.3)


      FOMs(2,1) = -99

      figuracce(2,1) = FOMs(2,2)  !num Rat
      figuracce(2,2) = FOMs(2,3)  !denom Rat
      figuracce(2,3) = FOMs(2,4)  !RAT
      figuracce(2,4:8) = -99

      return
      end
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      subroutine Calcola_FOM_MR_NEW2(iact)   ! RAT 
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
      USE Param, only : f000
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution

!      iact = 1  FOM Rotazione
!      iact = 2  FOM Traslazione
!
!--calcolo della FOM 
!
      character ttirang * 80
!
      kve = 0
c     sgmin = 0.001
      sgmin = 0.1
      iesFom = 1
  
      percSel =  0.30
      call Fom_EC2_MR_MOD2(iact,percSel,Ec2s,Ec2w)

      FOMs(2,2) = Ec2s
      FOMs(2,3) = Ec2w
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,3) = sgmin
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif


      FOMs(2,1) = -99

      figuracce(2,1) = FOMs(2,2)  !num Rat
      figuracce(2,2) = FOMs(2,3)  !denom Rat
      figuracce(2,3) = FOMs(2,4)  !RAT
      figuracce(2,4:8) = -99

c     write(6,9) FOMs(2,2:4)
  9   format(' MR_NEW2-FOMs',3f10.3)

      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_EC2_MR_MOD2(iact,percSel,Ec2s,Ec2w)
      USE General
      USE Symmetry
      USE Riflessi
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!
! --  Routine Corretta con sort su vettore Eobs
!
!---- calcola il valore medio per Ec**2 
!     (per percSel dei riflessi osservati piu' forti e 
!          percSel dei riflessi osservati piu' deboli)
!
c     write(124,100) 
c     write(125,100) 

      peso = 0 
      sogH   = 0.0
      sogL   = 0.0
      sumEc2w   = 0.0
      sumEc2s   = 0.0
      sumEc2w   = 0.0
      nconts = 0
      ncontw = 0
!
      work1(:) = 0.0
      work2(:) = 0.0
      if (iact == 1) then
          numb = nreflSelRot
          work1(1:numb) = ModuliSel(1,1:numb)  ! Ec
          work2(1:numb) = ModuliSel(2,1:numb)  ! Eo
      else
          numb = nreflSelTra
          work1(1:numb) = workRenor1(1:numb)  ! Ec
          work2(1:numb) = workRenor2(1:numb)  ! Eo
      endif

      numbSelH = numb * percSel
      numbSelL = numb * (1.0 - percSel)
      call sortall(-1,work2,numb)
      sogH = work2(numbSelH)
      sogL = work2(numbSelL)

      do i=1,numb
         j = k_mem(i)
         peso = nsym/epsv(j)
         if (ModuliSel(2,i).ge.sogH) then
             nconts = nconts + 1
             Ec2s   = work1(i)**2 
c            Ec2s   = Ec2s * peso
c            write(124,123) 
c    +             i,j,(ModuliSel(2,i)),work1(i),Ec2s,epsv(j),peso
             sumEc2s   = sumEc2s   + Ec2s
         else if (ModuliSel(2,i).le.sogL) then
             ncontw = ncontw + 1
             Ec2w   = work1(i)**2
c            Ec2w   = Ec2w * peso
c            write(125,123) 
c    +             i,j,(ModuliSel(2,i)),work1(i),Ec2w,epsv(j),peso
             sumEc2w   = sumEc2w   + Ec2w
         endif
      enddo
!

      if (nconts.gt.0) then
          Ec2s    = sumEc2s   / nconts
      else
          Ec2s = 0.0
      endif
      if (ncontw.gt.0) then
          Ec2w    = sumEc2w   / ncontw
      else
          Ec2w = 0.0
      endif

100   format(/,80('-'))
123   format(2i8,5f10.3)

      return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine Fom_EC2_MR_NEW(iact,percSel,Ec2s,Ec2w)
      USE General
      USE Riflessi
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!

!
!---- calcola il valore medio per Ec**2 
!     (per il 70% dei riflessi piu' forti e il 30% dei riflessi piu' deboli)
!
      sumEc2s   = 0.0
      sumEc2w   = 0.0
      nconts = 0
      ncontw = 0
!
      if (iact == 1) then
          numb = nreflSelRot
          numbSel = nreflSelRot * percSel
      else
          numb = nreflSelTra
          numbSel = nreflSelTra * percSel
      endif
!
      do i=1,numb
         if (i <= numbSel) then
             nconts = nconts + 1
             if (iact == 1) then
                 Ec2s   = ModuliSel(1,i)**2
             else
                 Ec2s   = workRenor1(i)**2
             endif
             sumEc2s   = sumEc2s   + Ec2s
         else
             ncontw = ncontw + 1
             if (iact == 1) then
                 Ec2w   = ModuliSel(1,i)**2
             else
                 Ec2w   = workRenor1(i)**2
             endif
             sumEc2w   = sumEc2w   + Ec2w
         endif
      enddo
 
      if (nconts.gt.0) then
          Ec2s    = sumEc2s   / nconts
      else
          Ec2s = 0.0
      endif
      if (ncontw.gt.0) then
          Ec2w    = sumEc2w   / ncontw
      else
          Ec2w = 0.0
      endif

!?!   Ec2w =  Ec2w * 0.5

      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_EC2_MR_MOD(iact,percSel,Ec2s,Ec2w)
      USE General
      USE Riflessi
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!

!
!---- calcola il valore medio per Ec**2 
!     (per percSel dei riflessi piu' forti e percSel dei riflessi piu' deboli)
!

      sumEc2s   = 0.0
      sumEc2w   = 0.0
      nconts = 0
      ncontw = 0
!
      if (iact == 1) then
          numb = nreflSelRot
          work1(1:numb) = ModuliSel(1,1:numb)
      else
          numb = nreflSelTra
          work1(1:numb) = workRenor1(1:numb)
      endif

c     call sortall(-1,work1,numb)

      numbSel = numb * percSel
      numbDif = numb - numbSel

!

      do i=1,numb
         if (i <= numbSel) then
             nconts = nconts + 1
             Ec2s   = work1(i)**2
             sumEc2s   = sumEc2s   + Ec2s
         elseif (i > numbDif) then
             ncontw = ncontw + 1
             Ec2w   = work1(i)**2
             sumEc2w   = sumEc2w   + Ec2w
         endif
      enddo
 
      if (nconts.gt.0) then
          Ec2s    = sumEc2s   / nconts
      else
          Ec2s = 0.0
      endif
      if (ncontw.gt.0) then
          Ec2w    = sumEc2w   / ncontw
      else
          Ec2w = 0.0
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_EC2_MR_ROT(Ec2s,Ec2w)
      USE General
      USE Riflessi
!
      USE RuotaRiflessi
      USE riflessi_c
      USE RemoModule
      USE TraslaSolution
!

!
!---- calcola il valore medio per Ec**2 
!     (per i riflessi Ec2 > 1.35 e i riflessi Ec2 < 0.7)
!

      sumEc2s   = 0.0
      sumEc2w   = 0.0
      nconts = 0
      ncontw = 0
!
      do i=1,nreflSelRot
         ec2 = ModuliSel(1,i)**2
!!!!     ec2 = ModuliSel(2,i)**2
         eo2 = ModuliSel(2,i)**2
         if (eo2 < 7.0 )then
             if(ec2 > 1.35) then
                nconts = nconts + 1
                sumEc2s   = sumEc2s   + ec2
             elseif (ec2 < 0.7) then
                ncontw = ncontw + 1
                sumEc2w   = sumEc2w   + ec2
             endif
         endif
      enddo
!
 
      if (nconts.gt.0) then
          Ec2s    = sumEc2s   / nconts
      else
          Ec2s = 0.0
      endif
      if (ncontw.gt.0) then
          Ec2w    = sumEc2w   / ncontw
      else
          Ec2w = 0.0
      endif

      return
      end
c-----------------------------------------------------------------------
      real function NewRat(Azione)
      USE General
      USE Riflessi
      USE Mappa
!
      implicit none
      integer :: i, k, n, nR1, nR2, jpatt, Azione
      real    :: percR1, percR2, medR1, medR2, somma, costante, NewRat0
      common /NewRatCommon/ NewRat0
!
!-- Azione = 0 calcola il valore iniziale della FOM
!-- Azione = 1 calcola il valore attuale della FOM
!
!!! usa il tipo e la % di inversione della mappa decisi fuori della function !!!
!
      percR1 = 1.0/3.0
      percR2 = 1.0/3.0
      nR1 = percR1 * float(nrefl)
      nR2 = percR2 * float(nrefl)
      k = nrefl - nR2 + 1
      n = nrefl
!
      if (Azione == 0) then
          medR1 = sum(evet(1:nR1)**2) / float(nR1)
          medR2 = sum(evet(k:nrefl)**2) / float(nR2)
          medR2 = 0.189
          NewRat0 =  medR1 / medR2
      else
          tmpwt(1:nrefl) = wt(1:nrefl)
          fcoef(1:nrefl) = evet(1:nrefl)*wt(1:nrefl)
          jpatt = 0
          call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
          call InvMap(khl,mkang,jwork1,worko,n)
          wt(1:nrefl) = tmpwt(1:nrefl)
          somma = sum(worko(1:nrefl)**2)
          costante = float(nrefl) / somma
          do i=1, nrefl
             worko(i) = sqrt(costante * worko(i)**2)
             if (worko(i) > 4) then
                 worko(i) = 4
             endif
          enddo
!
          medR1 = sum(worko(1:nR1)**2) / float(nR1)
          medR2 = sum(worko(k:nrefl)**2) / float(nR2)
      endif
!
      NewRat =  (medR1 / medR2) / NewRat0
!
      return
      end
!-----------------------------------------------------------------------
      real function NewRat_FFom(Azione)
      USE General
      USE Riflessi
!
      implicit none
      integer :: i, k, n, nR1, nR2, jpatt, Azione
      real    :: percR1, percR2, medR1, medR2, somma, costante, NewRat0
      common /NewRatCommon/ NewRat0
!
!-- Azione = 0 calcola il valore iniziale della FOM
!-- Azione = 1 calcola il valore attuale della FOM
!
!!! usa il tipo e la % di inversione della mappa decisi fuori della function !!!
!
      percR1 = 1.0/3.0
      percR2 = 1.0/3.0
      nR1 = percR1 * float(nrefl)
      nR2 = percR2 * float(nrefl)
      k = nrefl - nR2 + 1
      n = nrefl
!
      if (Azione == 0) then
          medR1 = sum(evet(1:nR1)**2) / float(nR1)
          medR2 = sum(evet(k:nrefl)**2) / float(nR2)
          medR2 = 0.189
          NewRat0 =  medR1 / medR2
          NewRat_FFom = 0
      else
          somma = sum(tmp_ec(1:nrefl)**2)
          costante = float(nrefl) / somma
          do i=1, nrefl
             worko(i) = sqrt(costante * tmp_ec(i)**2)
             if (worko(i) > 4) then
                 worko(i) = 4
             endif
          enddo
!
          medR1 = sum(worko(1:nR1)**2) / float(nR1)
          medR2 = sum(worko(k:nrefl)**2) / float(nR2)
          NewRat_FFom =  (medR1 / medR2) / NewRat0
      endif
!
!
      return
      end
!-----------------------------------------------------------------------
