c------------------------------------------------------------------
      subroutine WriteMTZContOld()
      USE General
!
      write(lo,90) 
      write(lo,100) MTZfile(1:lung(MTZfile))
      write(lo,110) MTZSubrVers 
      write(lo,120) nreflMTZ
      write(lo,130) MTZ_Num_Col
      write(lo,140)

      write(ktml,'("<b>")') 
      write(ktml,100) MTZfile(1:lung(MTZfile))
      write(ktml,'("</b>")') 
      write(ktml,110) MTZSubrVers 
      write(ktml,120) nreflMTZ
      write(ktml,130) MTZ_Num_Col
      write(ktml,140)


      do i=1,MTZ_Num_Col
       ii = MTZlookup(i)
       write(lo,150) ii,tipo_colonne(ii),Lab_Col(ii),MTZranges(1:2,ii)
       write(ktml,150)i,tipo_colonne(ii),Lab_Col(ii),MTZranges(1:2,ii)
      enddo
      write(lo,90) 
      write(ktml,'("<br><br>")') 
!
      return
   90 format(' ',78('-'))
  100 format(' MTZ file ',a,/,
     *       ' Summary of content:')
  110 format('   Software version  : ',a)
  120 format('   Reflexions stored : ',i6)
  130 format('   Number of columns : ',i6)
  140 format('   Column# Type   Label',35x,'Min.',11x,'Max.')
  150 format('  ',i5,6x,a1,4x,a30,2f15.3)
      end
c------------------------------------------------------------------
      subroutine WRITEMTZ(jflag,ilist,numsetMTZ)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule

      dimension vet(64),ivet(64)
      real, allocatable     ::  hkl(:,:)
      character*500, strLabel
      equivalence (vet(1),ivet(1))


C Max number of labels
      integer maxlab
      parameter (maxlab = 200)
C Max number of symmetry operations
      integer MAXSYM
      parameter (MAXSYM = 192)

!g    INTEGER I,J,MTZOUT,NLPRGO,NSYM,NSYMP,NSPGR,ISORT(5),NREFW
      INTEGER I,J,MTZOUT,NLPRGO,     NSYMP,NSPGR,ISORT(5),NREFW
      INTEGER NSYMTZ
      REAL WAVELENGTH,CELL_MTZ(6),RSYM(4,4,MAXSYM),ADATA(MAXLAB)
      real celltemp(13)

      CHARACTER TITLE*80,CRYSTALNAME*20,PROJECTNAME*20,
     +   DATASETNAME*20,
     +   LSPRGO(MAXLAB)*30,CTPRGO(MAXLAB)*1,
     +   LSPRGI(MAXLAB)*30,CTPRGI(MAXLAB)*1,
     +   XNAME(MAXLAB)*20,PNAME(MAXLAB)*20,DNAME(MAXLAB)*20,
     +   LTYPE*1,SPGRNAM*10,PGNAM*10

      Character SPGRNAM_temp*16,filename*200,strCol*30,strKoti*30
!
!-- ASU
!
      INTEGER NSPGRP_MASTER,   NLAUE_MASTER,
     +        NSYMP_MASTER,    NSYM_MASTER
      CHARACTER NAMSPG_MASTER*10, PGNAME_MASTER*10,LATTYP_MASTER*1
      REAL    RSYMT_MASTER,    RSYM_MASTER
!
      COMMON /ATSYM/  RSYM_MASTER(4,4,MAXSYM),
     +                RSYMT_MASTER(4,4,MAXSYM),
     +                NSYM_MASTER,
     +                NSYMP_MASTER,
     +                NSPGRP_MASTER,
     +                NLAUE_MASTER
      COMMON /ATSYM_CHAR/ NAMSPG_MASTER, PGNAME_MASTER, LATTYP_MASTER
      integer hkli(3), hklo(3)
!
!-- ASU
!

      DATA WAVELENGTH /0.0/
      DATA PROJECTNAME /'ILMILIONE'/
      DATA LSPRGO /'H','K','L','F','SIGF',195*' '/
      DATA CTPRGO /'H','H','H','F','Q',195*' '/
      DATA LSPRGI /'H','K','L','F','SIGF',195*' '/
      DATA CTPRGI /'H','H','H','F','Q',195*' '/
      DATA NSPGR /0/
C Sort on H K L
      DATA ISORT /1,2,3,0,0/

c     if (ilist <=0 ) return

      write(lo,*)
      write(lo,*)
      write(lo,*)'===================================='
      write(lo,*)'       MTZ FILE OUTPUT              '
      write(lo,*)

      write(ktml,*)
      write(ktml,*)'____________________________________'
      write(ktml,*)'       MTZ FILE OUTPUT              '
      write(ktml,*)

      if (ilist == 16) then
*gl*     call ysfl16(FomsFineDSR,iposFineDSR,nset)
         call LoadInitialPhases(FomsFineDSR, iposFineDSR, nset)
      else if (ilist == 17) then
*gl*     call sfl17()
         call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                        nsetFinalPhases)
         nset = nSetsFineDSR 
      else
         nset = 1
      endif

      if (nset <= 0) then
        write(lo,*)'Non sets in the list:',nset
      else
c       write(lo,*)'Number of set in the list:',ilist,nset
      endif


c     NLPRGO  =     6              +      4*nset
c            H K L F SIGF R-free      W, PHI, HLA, HLB, HLC, HLD
      NLPRGO=5 + 6*nset
      ! per FreeLunch:
      if (jflag == 3 ) NLPRGO=6 + 10*nset ! F_FL,sigF_FL,wF_FL,wE_Fl,W,PHI,HLA,HLB,HLC,HLD
      !
      if (knw > 0 ) then
        NLPRGO=NLPRGO + 1
        LSPRGO(6)='PUB'
        CTPRGO(6)='P'
      endif

      icol=5 + knw
      
      if (jflag < 2 ) then
        do iset=1,nset
          if (ilist==16) then
            nono=iposFineDSR(iset)
*gl*        call snr16(nono,fom,pesi,ifasi)
            call PutGetInitialPhases(2, nono, fom, pesi, ifasi)
            isetTrial=abs(fom(10))
          else
            nono=iposFineDSR(iset)
*gl*        call snr17o(nono,fom,pesi,ifasi)
            call GetFinalPhases(nono, fom, pesi, ifasi)
            isetTrial=abs(fom(10))
          endif

          icol=icol + 1
          CTPRGO(icol)='P'
          strCol='PHI_'
          k=Lung(strCol)
          write(strKoti,'(i4)')iset
          call NoBlanks(strKoti, nkot)
          strCol=strCol(1:k) // strKoti(1:nkot)
          write(strKoti,'(i4)')isetTrial
          call NoBlanks(strKoti, nkot)
          k=Lung(strCol)
          strCol=strCol(1:k) //'_' // strKoti(1:nkot)
          k=Lung(strCol)
          LSPRGO(icol)=strCol(1:k)

          icol=icol + 1
          CTPRGO(icol)='W'
          strCol='WT_'
          k=Lung(strCol)
          write(strKoti,'(i4)')iset
          call NoBlanks(strKoti, nkot)
          strCol=strCol(1:k) // strKoti(1:nkot)
          write(strKoti,'(i4)')isetTrial
          call NoBlanks(strKoti, nkot)
          k=Lung(strCol)
          strCol=strCol(1:k) //'_' // strKoti(1:nkot)

          k=Lung(strCol)
          LSPRGO(icol)=strCol(1:k)

          icol=icol + 1
          CTPRGO(icol)='A'
          strCol='HLA_'
          k=Lung(strCol)
          write(strKoti,'(i4)')iset
          call NoBlanks(strKoti, nkot)
          strCol=strCol(1:k) // strKoti(1:nkot)
          write(strKoti,'(i4)')isetTrial
          call NoBlanks(strKoti, nkot)
          k=Lung(strCol)
          strCol=strCol(1:k) //'_' // strKoti(1:nkot)
          k=Lung(strCol)
          LSPRGO(icol)=strCol(1:k)

          icol=icol + 1
          CTPRGO(icol)='A'
          strCol='HLB_'
          k=Lung(strCol)
          write(strKoti,'(i4)')iset
          call NoBlanks(strKoti, nkot)
          strCol=strCol(1:k) // strKoti(1:nkot)
          write(strKoti,'(i4)')isetTrial
          call NoBlanks(strKoti, nkot)
          k=Lung(strCol)
          strCol=strCol(1:k) //'_' // strKoti(1:nkot)
          k=Lung(strCol)
          LSPRGO(icol)=strCol(1:k)

          icol=icol + 1
          CTPRGO(icol)='A'
          strCol='HLC_'
          k=Lung(strCol)
          write(strKoti,'(i4)')iset
          call NoBlanks(strKoti, nkot)
          strCol=strCol(1:k) // strKoti(1:nkot)
          write(strKoti,'(i4)')isetTrial
          call NoBlanks(strKoti, nkot)
          k=Lung(strCol)
          strCol=strCol(1:k) //'_' // strKoti(1:nkot)
          k=Lung(strCol)
          LSPRGO(icol)=strCol(1:k)

          icol=icol + 1
          CTPRGO(icol)='A'
          strCol='HLD_'
          k=Lung(strCol)
          write(strKoti,'(i4)')iset
          call NoBlanks(strKoti, nkot)
          strCol=strCol(1:k) // strKoti(1:nkot)
          write(strKoti,'(i4)')isetTrial
          call NoBlanks(strKoti, nkot)
          k=Lung(strCol)
          strCol=strCol(1:k) //'_' // strKoti(1:nkot)
          k=Lung(strCol)
          LSPRGO(icol)=strCol(1:k)
        enddo
      else if (jflag == 2) then
          icol=icol + 1
          CTPRGO(icol)='P'
          LSPRGO(icol)='PHI_EDM'
          icol=icol + 1
          CTPRGO(icol)='W'
          LSPRGO(icol)='WT_EDM'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLA_EDM'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLB_EDM'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLC_EDM'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLD_EDM'
      else if (jflag == 3) then
          icol=icol + 1
          CTPRGO(icol)='F'
          LSPRGO(icol)='F_FL'
          icol=icol + 1
          CTPRGO(icol)='Q'
          LSPRGO(icol)='SIGF_FL'
          icol=icol + 1
          CTPRGO(icol)='F'
          LSPRGO(icol)='FWT'
          icol=icol + 1
          CTPRGO(icol)='F'
          LSPRGO(icol)='EWT'
          icol=icol + 1
          CTPRGO(icol)='P'
          LSPRGO(icol)='PHI_FL'
          icol=icol + 1
          CTPRGO(icol)='W'
          LSPRGO(icol)='WT_FL'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLA_FL'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLB_FL'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLC_FL'
          icol=icol + 1
          CTPRGO(icol)='A'
          LSPRGO(icol)='HLD_FL'
      endif
!
      icol=icol + 1
      CTPRGO(icol)='I'
!     LSPRGO(icol)='R-free-flags'
      LSPRGO(icol)='FreeR_flag'
      NLPRGO = icol
!

      write(TITLE,'(20a4)')itle
      CELL_MTZ(1:6)=cell(1:6)

      select case (ianom)
      case (3)
        DATASETNAME='MIR'
      case (6)
        DATASETNAME='MAD'
      case (9)
        DATASETNAME='MIRAS'
      end select

      CRYSTALNAME = StructureName(1:Lung(StructureName))
      call ucase(CRYSTALNAME)

      filename = StructureName(1:Lung(StructureName))
      k=Lung(filename)

      if (jflag == 0) then
        filename=filename(1:k) //'_phase.mtz'
        write(jlog,'("<br><br><b> File in MTZ format after phasing",
     *     " procedure: </b>",a)') filename(1:Lung(filename))
      else if(jflag == 1) then
        filename=filename(1:k) //'_edm.mtz'
        write(jlog,'("<br><br><b> File in MTZ format after EDM",
     *     " procedure: </b>",a)') filename(1:Lung(filename))
        kk=len_trim(DATASETNAME)
        DATASETNAME=DATASETNAME(1:kk) //'-FLEX (EDM)'
      else if(jflag == 2) then
        filename=filename(1:k) //'_edm.mtz'
        write(jlog,'("<br><br><b> File in MTZ format after EDM",
     *     " procedure: </b>",a)') filename(1:Lung(filename))
        DATASETNAME='FLEX - EDM'
      else if(jflag == 3) then
        filename=filename(1:k) //'_flunch.mtz'
        write(jlog,'("<br><br><b> File in MTZ format after FreeLunnch",
     *     " procedure: </b>",a)') filename(1:Lung(filename))
        DATASETNAME='FREE LUNCH UP TO EXT. RES. DATA'
      endif

      strLabel = ' '
      do i = 1, icol
         strLabel = strLabel(1:Lung(strLabel)) //" "// 
     *              LSPRGO(i)(1:Lung(LSPRGO(i)))
      enddo
      call OneBlankOnly(strLabel)
      strLabel = " Column Label:  "  //strLabel(1:Lung(strLabel))
      write(jlog,'(a)')strLabel(1:Lung(strLabel))

      strLabel = ' '
      do i = 1, icol
         strLabel = strLabel(1:Lung(strLabel)) //"   "// 
     *              CTPRGO(i)(1:Lung(CTPRGO(i)))
      enddo
      strLabel = " Column Type:  "  //strLabel(1:Lung(strLabel))
      write(jlog,'(a,"<br>")')strLabel(1:Lung(strLabel))

      write(lo,'(11h Filename: ,a)')filename(1:Lung(filename))
      write(ktml,'(11h Filename: ,a)')filename(1:Lung(filename))

C CCP4 initialisations
c     call ccpfyp
C MTZ-specific initialisations
      call mtzini

      MTZOUT = 1

C Open mtz file
      call lwopen(MTZOUT,filename(1:Lung(filename)))

C Write title to MTZ header
      call lwtitl (MTZOUT,TITLE,0)

C Write cell to MTZ header
      call lwcell(MTZOUT,CELL_MTZ)

C *** For CCP4 5.0 libraries
C Store the crystal, project and dataset names plus
C associated data in the mtz header:
      call lwidx(MTZOUT,PROJECTNAME,CRYSTALNAME,DATASETNAME,
     +     CELL_MTZ,WAVELENGTH)

C Store the column labels in the mtz header:
C Simpler alternative to LKYOUT/LWASSN
      call lwclab(MTZOUT,LSPRGO,NLPRGO,CTPRGO,0)

C *** For CCP4 5.0 libraries
C Associate columns with crystals and datasets
      do i=1,NLPRGO
        xname(i) = CRYSTALNAME
        dname(i) = DATASETNAME
      enddo
      call lwidasx(MTZOUT,NLPRGO,XNAME,DNAME,0)

C Get symmetry info from file SYMOP (default set by ccp4.setup)
C on channel 24
c     Buffer1 = 'SYMINFO=' // syminfo
c     call SirSetEnv(Buffer1)
c     CALL MSYMLB(24,NSPGR,SPGRNAM,PGNAM,NSYMP,NSYM,RSYM)
!-- Get symmetry info from file SYMOP (syminfo.lib - Env. Var. CLIBD)
      call SpaceGroupCCP4(NSPGR,SPGRNAM,PGNAM,NSYMP,NSYMTZ,RSYM,LTYPE)

C Store the symmetry in the mtz header:
      call lwsymm (MTZOUT,NSYMTZ,NSYMP,RSYM,LTYPE,NSPGR,SPGRNAM,PGNAM)

C Store program details in history header:
      call lwhstl (MTZOUT, ' ')

C  Store sort order to be used
      CALL LWSORT(MTZOUT,ISORT)

c     call xfl06
C   Loop over ouput reflections
      nreflMTZ=nrefl
      if (jflag == 3 ) nreflMTZ=nreflTot

      allocate (hkl(NLPRGO,nreflMTZ),stat=ierr)

!
!-- Put reflections (h,k,l and phases) into asymmetric unit defined in ASUSET
!
!
!-- ASU
!
 
      NAMSPG_MASTER = SPGRNAM
      NSPGRP_MASTER = NSPGR
      PGNAME_MASTER = PGNAM
      NSYM_MASTER   = NSYMTZ
      RSYM_MASTER   = RSYM
      CALL ASUSET(NAMSPG_MASTER,   NSPGRP_MASTER,
     +            PGNAME_MASTER,   NSYM_MASTER,
     +            RSYM_MASTER,     NSYMP_MASTER,
     +            NLAUE_MASTER,    .FALSE.)


      isegnoASU = 1 
      do i=1,nreflMTZ
       hkl(1:3,i)=khl(1:3,i)
!
       hkli(1:3) = nint(hkl(1:3,i))
       call asuput(hkli, hklo, isym)
       lsym = (isym-1)/2 + 1
c      hkl(1:3,i) = hklo(1:3)
!

       hkl(4,i)=fovet(i)
       hkl(5,i)=sigmav(i)
       if (i > nrefl) then
         hkl(4,i)=-999.0
         hkl(5,i)=-999.0
       endif
       if (knw > 0) then
         hkl(6,i)=ipub(i)
         phase_in = hkl(6,i)
         call asuphp(hklo, lsym, isegnoASU, phase_in, phase_out)
c        hkl(6,i) = phase_out
       endif

      enddo

      NREFW = nreflMTZ
      write(lo,'(20h Number of Columns =,i5)')NLPRGO
      write(lo,'(24h Number of Reflections =,i6)')NREFW
      write(ktml,'(20h Number of Columns =,i5)')NLPRGO
      write(ktml,'(24h Number of Reflections =,i6)')NREFW

      icol=5 + knw

      if (iphase == 0) then
         do iset=1,nset
          pesi(:)=0.0
          ifasi(:)=0
          if (ilist==16) then
            nono=iposFineDSR(iset)
*gl*        call snr16(nono,fom,pesi,ifasi)
            call PutGetInitialPhases(2, nono, fom, pesi, ifasi)
          else
            nono=iposFineDSR(iset)
*gl*        call snr17o(nono,fom,pesi,ifasi)
            call GetFinalPhases(nono, fom, pesi, ifasi)
          endif
          if (jflag == 3 ) then
           ! FLUNCH
           icol=icol +1
           hkl(icol,1:nreflMTZ)=fovet(1:nreflMTZ)  ! F_fl
           icol=icol +1
           hkl(icol,1:nreflMTZ)=sigmav(1:nreflMTZ) ! sigma_Fl
           icol=icol +1
           hkl(icol,1:nreflMTZ)=fcvet(1:nreflMTZ)  ! F * wt
           icol=icol +1
           hkl(icol,1:nreflMTZ)=emod(1:nreflMTZ)   ! E * wt
          endif

          do jj = 1, nreflMTZ
            phase_in = ifasi(jj)
            call asuphp(hklo, lsym, isegnoASU, phase_in, phase_out)
c           ifasi(jj) = phase_out
          enddo

          icol=icol +1
          hkl(icol,1:nreflMTZ)=ifasi(1:nreflMTZ)
          icol=icol +1
c         do ii=1,nreflMTZ
c          if (pesi(ii) < 0.001) pesi(ii)=0.0
c         enddo
          hkl(icol,1:nreflMTZ)=pesi(1:nreflMTZ)
          ! calc. coef. HL
          call hlconv(pesi,ifasi,work1,work2,fcoef,ecoef)
          icol=icol +1
          hkl(icol,1:nreflMTZ)=work1(1:nreflMTZ)
          icol=icol +1
          hkl(icol,1:nreflMTZ)=work2(1:nreflMTZ)
          icol=icol +1
          hkl(icol,1:nreflMTZ)=fcoef(1:nreflMTZ)
          icol=icol +1
          hkl(icol,1:nreflMTZ)=ecoef(1:nreflMTZ)
         enddo
      else
         if (jflag == 3 ) then
           icol=icol +1
           hkl(icol,1:nreflMTZ)=fovet(1:nreflMTZ)  !F_fl 
           icol=icol +1
           hkl(icol,1:nreflMTZ)=sigmav(1:nreflMTZ) ! Sigma_fl
           icol=icol +1
c          hkl(icol,1:nreflMTZ)=wt(1:nreflMTZ)*fovet(1:nreflMTZ)
           hkl(icol,1:nreflMTZ)=fcvet(1:nreflMTZ) ! F_fl * wt
           icol=icol +1
           hkl(icol,1:nreflMTZ)=emod(1:nreflMTZ)  ! E_fl * wt
         endif
         ifasi(1:nreflMTZ) = iphaz(1:nreflMTZ)
         do jj = 1, nreflMTZ
            phase_in = ifasi(jj)
            call asuphp(hklo, lsym, isegnoASU, phase_in, phase_out)
c           ifasi(jj) = phase_out
         enddo
         icol=icol +1
         hkl(icol,1:nreflMTZ)=ifasi(1:nreflMTZ)
!
         icol=icol +1
c        do ii=1,nreflMTZ
c         if (wt(ii) < 0.001) wt(ii)=0.0
c        enddo
         hkl(icol,1:nreflMTZ)=wt(1:nreflMTZ)
         ! calc. coef. HL
         call hlconv(wt,ifasi,work1,work2,fcoef,ecoef)
         icol=icol +1
         hkl(icol,1:nreflMTZ)=work1(1:nreflMTZ)
         icol=icol +1
         hkl(icol,1:nreflMTZ)=work2(1:nreflMTZ)
         icol=icol +1
         hkl(icol,1:nreflMTZ)=fcoef(1:nreflMTZ)
         icol=icol +1
         hkl(icol,1:nreflMTZ)=ecoef(1:nreflMTZ)
       endif
!
!-- rfree
!
       hkl(NLPRGO,1:nreflMTZ) = rfree1(1:nreflMTZ)
!
c      do i = 1, nnreflMTZ
c            hkli(1:3) = nint(hkl(1:3,i))
c            if (INASU(hkli, NLAUE_MASTER) == 0) then
c                call cstop('INASU error')
c            endif
c       enddo
!


      DO I = 1,NREFW

C  Initialise ADATA with Missing Number Flags
        CALL EQUAL_MAGIC(MTZOUT,ADATA,NLPRGO)

C  Fill in data columns where possible (all in this simple e.g.)
c       adata(1:NLPRGO)=hkl(1:NLPRGO,i)

        adata(1:3)=hkl(1:3,i)
        if (hkl(4,i) > -998.0) then
           adata(4:5)=hkl(4:5,i)
        endif

        adata(6:NLPRGO)=hkl(6:NLPRGO,i)

C  Write out reflection
        call lwrefl (MTZOUT, adata)

      ENDDO

C Close mtz file, print full header:
!mr   call lwclos (MTZOUT, 3)
C Close mtz file, no  header:
      call lwclos (MTZOUT, 0)

c     call ccperr(0,'Normal termination')


      write(lo,*)
      write(lo,*)'   END MTZ FILE OUTPUT              '
      write(lo,*)'===================================='
      write(lo,*)

      write(ktml,*)
      write(ktml,*)'       END MTZ FILE OUTPUT          '
      write(ktml,*)'____________________________________'
      write(ktml,*)

      deallocate (hkl, stat=ierr)
      return

      end
!---------------------------------------------------
