C-- SIR code for phase                           Release 88.12
      subroutine contan(ier)
c -----
c           routine  tangente con :  struttura parziale
c                                    fasi pseudo-random
c                                    tangente formula pesata
c -----                              19/06/1987
      USE General
      character cff
      character *200 strTime
      character Numdigit*13
      common /cifre/ Numdigit
      dimension mat(3,1)
c
      call RoutineHeader('Phase Routine','05.12')
      write(lo,10)
   10 format(/,20x,'***   converge / diverge  section   ***',/)

      call outFrag(0, 0, 0)
      call AllocaPhase(1)

      if (InfoOK(7)==0) call LeggiRiflessiSP
      ! controllare
      jderi=1
      !
      call conver_tangen


      call AllocaPhase(2)
      call LeggiRiflessiSP ! x forse itype e' stato camb. nel phase

!
      call PreparaIph(0, 0, 0, 0, mat, 0)
!
      if (ier.lt.0) return

      strTime='Phase'
      call CPUTIMEtot(strTime)
      return
      end
c----------------------------------------------------------------------
      subroutine conver_tangen
      USE General
      USE Symmetry
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule
      USE PhaseModule
c
      dimension eni1(4),lin1(4,6)


      integer hmax
      dimension par(12)
*     data par/5.5,4.7,3.2,2.6,2.4,2.2,2.1,2.0,1.9,1.8,1.7,1.7/

      par(1:12) = (/5.5,4.7,3.2,2.6,2.4,2.2,2.1,2.0,1.9,1.8,1.7,1.7/)
      ier = 0

      call conver(nb,nrel1,ns1mx,sogs2,ilist,jplot,
     *            rag,nusx,iy,ier,par,jrej)
      if (ier.lt.0) return
      call histor(5,1,ier)
      if (ier.lt.0) return
      call punts1

c     print*,'tangent'
      call tangen(nb,nrel1,ns1mx,sogs2,ilist,jplot,
     *            rag,nusx,iy,ier,par,inpfas)
      if (ier.lt.0) return
      return
      end
c----------------------------------------------------------------------
      subroutine conver(nb,nrel1,ns1mx,sogs2,ilist,jplot,
     *                  rag,nusx,iy,ier,par,jrej)
    

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE PhaseModule
      USE ListeXX

      common /unp/ hmax,kmax,lmax,iplan,irang,iplan2
c
      common /setinf17/nset17,nset17m,iloop,numbset
      common /cris/ numcri,jcran,maxtri,nstart,muset
      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset
      common /use1/ symb(12),symbo(5000),nusy(5000),inperm(12)
      common /use2/ ipigin(3)
      integer symb,hmax,igin(3),igin2(3)
      dimension eni1(4),lin1(4,6),bility(50)
      dimension par(12),ielim(5000), mat(3,1)
      equivalence (ielim(1),symbo(1))

c
CCCCC vec(x)=amin1(x*(x+0.4807)/((x+0.8636)*x+1.3943),1.0)
c
      sqp4=atan(1.)
      z(:)=0.
      zp(:)=0.
      zph(:)=0.
      alfran(:)=0.
      alfest(:)=0.
      wt(:)=0.
      limref(1)=0
      n2cp = 0
      ifou = 0
c  *********************************************************************
c   lettura informazioni strutturali
c  *********************************************************************
c -----
c     call srlin (39,lsn,lfw,llw,lpb,ll)
c     if (lfw.gt.0) call sfl39
c -----
c     call sub. per lettura lista 2 : simmetria
c -----
*gl*  call yfl02  !!gl
c -----
c     call sub. per lettura preambolo lista 7
c -----
*gl*  call xfl06
      call LoadReflInfo

      hmax=ihmx(1)
      kmax=ihmx(2)
      lmax=ihmx(3)
      call musym()

      ier=0
      call dirpha (nlist,nsymb,gqmin,sogs2,ns1mx,inpori,
     * inpena,inpfas,igin,ipigin,iperm,inperm,nspec,
     * ilist,jplot,rag,iy,nusx,
     * ier,jrej)

      if (ier.lt.0) return
!
c
c -----
c     call sub. lettura lista 22 : seminvarianti a una fase
c -----
c     call sub. lettura lista 8 : tripletti positivi
c -----
*gl*  iprea=-1
*gl*  call srlin (8,lsn,lfw,llwxx,lpbxx,llxx)
      lfw = InfoOK(8)
      if (lfw <= 0) then
          write(lo,5818)
          ier=-1
          return
      endif
*gl*  iDim = 3 * ntrip
*gl*  call sflxx(iprea,8,nxxd,nxxe,numbPhase,ipten,igm,1,imat,iDim)
      numbPhase = NRefPos
      igm = iGmPos
      nxxe = NSigPos
! dritan : 11/09/2006
      numcri=numbPhase-4
!
      if (nxxe.le.0) then
          write(lo,5818)
          ier=-1
          return
      endif
      ntrip = NSigPos
      if (sogs2.eq.0) sogs2=igm*0.001
 5818 format(' No triplets calculated.',
     *       ' Try using more active reflections.')

      nelim=0
c **********************************************************************
c   chiamata subroutine  eliminazione doppie informazioni
c **********************************************************************
c     call elim (sogs2,ielim,nelim,ns1mx,numb)

c **********************************************************************
c   j = puntatore  nel vettore iph
      j=1
c   k = puntatore nel vettore iorde
      k=1
c **********************************************************************
c  lettura completa degli ns1 seminv. a una fase
c **********************************************************************
c -----
c     call sub. lettura lista 22 : seminvarianti a una fase
c -----
      ns1=0
      iprea=0
      ns1p=0
c    pongo  in  nsig1 = numero  di  ss1
 2051 nsig1=k-1

      k2=k-1
c   nsigm1  =  k2  numero di sigma1 + fasi note
      nsigm1= k2
c -----
c     call sub. lettura lista 23 : seminvarianti a due fasi
c -----
      n2cp =0
      nse2c=0
      is2=sogs2*100
c ---------------------------------------------------------------
c     call sub. lettura lista 8 : tripletti positivi
c -----
*gl*  iprea=0
*gl*  iDim = 3 * ntrip
*gl*  call sflxx(iprea,8,nxxa,ntrip,numbPhase,ipten,igm,1,imat,iDim)
      ja=0
      do 2224 i=1,ntrip
*gl*     call unpak3 (imat(2,i),n3,ia,ishift)
         call unpak3 (Lista08(2,i),n3,ia,ishift)
         ja=ja+1
         iee(ja)=Lista08(1,i)
         iee1(ja)=Lista08(2,i)
 2224 continue
      ntrip=ja
      write(6,*) ' Tripletti positivi =',ntrip
      if (nneg.eq.0) go to 2230
c
c ---    NEW NEW NEW  aggiungo ad iee/iee1 i tripletti negativi
c ---    NEW NEW NEW  invertendo il valore del delta-shift
c
*gl*  call srlin (10,lsn,lfw,llw,lpb,ll)
      lfw = InfoOK(10)
      if (lfw > 0) then
*gl*      iDim = 3 * ntrneg
*gl*      call sflxx(iprea,10,nxxa,ntrn,idm1,idm2,idm3,1,imat,iDim)
          ja=ntrip
          do 2226 i=1,ntrn
*gl*      call unpak3 (imat(2,i),n3,ia,ishift)
          call unpak3 (Lista10(2,i),n3,ia,ishift)
          ia=-ia
          ja=ja+1
          ishift =mod(ishift+12 ,24)
          idm1=((n3+2048)*4096+ia+2048)*32+ishift+1
          iee(ja)=Lista10(1,i)
          iee1(ja)=idm1
 2226     continue
          ntrip=ja
      endif
                      write(6,*) ' Tripletti totali   =',ntrip
c ---    NEW NEW NEW
 2230 continue
      
c     icocc=1
c     call refsto(icocc)

      iorde(:) = 0

      nt=0
      if(ntrip.eq.0) goto 11

*---------------------------------------------------------------------
 8770 do 10 i = 1,ntrip
      call unpak3 (iee(i),n1,n2,ifaz)
      call unpak3 (iee1(i),n3,ia,ifaz)
      nn1=n1
      nn2=iabs(n2)
      nn3=iabs(n3)
      ifaz1=ifaz*15
c  calcolo fase vera del tripletto per struttura nota
      if (knw.eq.1)  then
                       ifa1=ipub(nn1)
                       ifa2=ipub(nn2)
                       ifa3=ipub(nn3)
                       iphi=ifa1+isign(ifa2,n2)+isign(ifa3,n3)+ifaz1
                       iphi=mod(iphi+36000,360)
                       if(iphi.eq.0) iphi=360
                       costru=cos(iphi*dtor)
                       endif
      if(nelim.eq.0) goto 9
      irel=i+6000
      do 8 i1=1,nelim
      if(irel.ne.ielim(i1)) goto 8
      arg= ia *0.01
      if (iprin.eq.1) write(lo,7) i,n1,n2,n3,arg
    7 format(/,'  sigma2 relation eliminated ',i5,
     *3(i8,')'),f10.2)
      goto 10
    8 continue
    9 nt=nt+1
        if(icent.gt.0) ia=2*ia
        if(ia.gt.2047) ia=2047
      iph(j) = ((n1+2048)*4096+n2+2048)*32
      iph(j+1) = ((n3+2048)*4096 + ia + 2048)*32 + ifaz + 1
      j = j + 2
 10   continue
c
      nq=0  ! no quart. negativi

  11  continue
c
c ---   new new new
c
c =============== numero totale di relazioni considerate ===========
      nrel = nt
      nrel1 = j-1
      write(lo,6020) nrel,nt,nrel1, numbPhase
6020  format(///,' num.tot.  num.sigma2.',
     *'',/,2x,i6,7x,i6,7x,i6,5x,i6,//)
c
c   preparation of pointers table
c
      nb1 = numbPhase + 1

      limref(:) = 0
      limi1(:) = 0

      j = 1
      do 120 i = 1,nrel
      nn(:)=0
      call depacc (0,j,a,ifaz,iw)
      j = j + iw
      do 110 kk = 1,4
      if(nn(kk).eq.0) go to 110
      n1=iabs(nn(kk))+1
      limref(n1) = limref(n1) + 1
110   continue
120   continue


      do 130 i = 1,numbPhase
      limref(i+1) = limref(i+1) + limref(i)
      limi1(i+1) = limref(i+1)
130   continue

      limi1(1) = 0
c
c  storage of the no. of relations for a given reflexion
      j = 1
      do 150 i = 1,nrel
      nn(:)=0
      call depacc (0,j,a,ifaz,iw)
      do 140 kk = 1,4
       if(nn(kk).eq.0) go to 140
       ind=iabs(nn(kk))
       limi1(ind) = limi1(ind) + 1
       ind1= limi1(ind)
       nbinv(ind1) = j
140   continue
      j = j+iw
150   continue
      
      ntota=0
      do 300 i=1,numbPhase
      n1=0
      n2=0
      lm=limref(i)+1
      ls=limref(i+1)
      if(lm.gt.ls) goto 300
      do 220 ii=lm,ls
      ind=nbinv(ii)
      call depacc (0,ind,a1,ifaz,iw)
      if (iw.eq.2) then
                   n1=n1+1
                  else
                   n2=n2+1
                  endif
  220 continue
      ntota=ntota+n2
c--stampa per nr. dei relazioni per riflesso
CCC    write (lo,280) i,lm,ls,n1,n2
  280 format(2x,i5,')',5x,4i8)
  300 continue

      call newpsi1
c
c  chiamata  subroutine group e azzeramento vettore iz
c
      iz(:)=0

      call group

      if (norigin.eq.0) go to 904

  904 nlist=iabs(nlist)

      do 910 i=1,4
  910 nant(i)=0
      if (inpori.ne.0) go to 914
      do 912 i=1,3
  912 igin(i)=0

  914 continue
 6965 do 354 i=1,numbPhase
  354 if(wt(i).ne.0.) mkang(i)=-mkang(i)
 6021 format(4(i4,')',i3,2f10.5))
      if(inpena.ne.0) nant(1)=inpena
      k1=0
      if(inpori.eq.0) goto 1104
c  variazione  per controllare se i riflessi dati per origine sono accet
      if(iprin.eq.2) write(lo,6969) igin,ipigin
6969  format(5x,'igin', 3i6,'   ipigin',3i6)
      do 1004 i=1,numbPhase
      if(zph(i).ne.0.) goto 1004
      do 1002 jc=1,norigin
      if ( i.eq.igin(jc) ) goto 1004
 1002 continue
      mkang(i)=-mkang(i)
 1004 continue
      do 1005 jc=1,3
 1005 igin2(jc)=igin(jc)
      call origin(jump,0,1,0,igin2)
      if(iprin.eq.2) write(lo,8875) jump,norigin,nral,igin2,k
      if(jump.eq.0) goto 1008
      write(lo,1006)
 1006 format(//5x,' ****  warning  :  input reflexions',
     * ' do not properly fix the origin  ****'/)
 1008 do 1009 i=1,numbPhase
      if(zph(i).ne.0.) goto 1009
      mkang(i)=-mkang(i)
 1009 continue
      if(iprin.eq.2) write(lo,6021) (i,mkang(i),zp(i),
     * zph(i),i=1,numbPhase)
      go to 1106
 1104 do 1105i=1,3
 1105 igin(i)=0
 1106 n=0
      if (jtabl.eq.0) go to 909
      if (knw.eq.0) write(lo,905)
      if (knw.ne.0) write(lo,907)
  905 format(////47x,26htable of estimated alpha's//
     * 4(29h  code  h   k   l    e  alpha)//)
  906 format(4(i4,')',3i4,f6.2,f6.1))
  907 format(////47x,26htable of estimated alpha's//
     * 3(41h   code   h   k   l    e   phi   alpha   )//)
  908 format(3(i6,')',3i4,f6.2,i5,1x,f9.3))
  909 continue
      sumalp=0.
      ii=1
      do 1150 i=1,numbPhase
      zi=0.
      alf1=0.
      call inter(ii,i,alf1)
      zi=abs(zi)
      alf1=abs(alf1)
      alfa=zi
      n=n+1
      line(n,1)=i
      enil(n,1)=evet(i)
      line(n,2:4)=khl(1:3,i)
      bility(n)=alfa
      if(knw.ne.0) iphh(n)=ipub(i)
      alfest(i)=alf1
      if(knw.eq.0) goto 1120
      if(n.lt.3) goto 1130
      if (jtabl.ne.0) write(lo,908) ((line(n,l),l=1,4),enil(n,1),
     * iphh(n),bility(n),n=1,3)
      n=0
      goto 1130
 1120 continue
      if(n.lt.4) go to 1130
      if (jtabl.ne.0) write(lo,906) ((line(n,l),l=1,4),enil(n,1),
     *bility(n),n=1,4)
      n=0
 1130 sumalp=sumalp+alfa
      z(i)=zi
 1150 continue
c  calcolo di alfastimato e alfarandom per figure di merito
      alra=0.
      sumalf=0.
      do 1151 i=1,numbPhase
      alfran(i)=sqrt(alfran(i))
      sumalf=sumalf+alfest(i)
 1151 alra=alra+alfran(i)
      if(n.eq.0) go to 1152
      if(knw.eq.0.and.jtabl.ne.0)
     *write(lo,906)((line(m,l),l=1,4),enil(m,1),bility(m),m=1,n)
      if(knw.ne.0.and.jtabl.ne.0)
     * write(lo,908) ((line(m,l),l=1,4),enil(m,1),iphh(m),
     * bility(m),m=1,n)
 1152 continue
      
c ************************************************************
c
c   definizione  peso  iniziale  sulla base del valore di alfa estimato
c
c  *********************************************************************
      jcc=0
c     if (jcc.eq.0) goto 25901
      ii=5
 2572 do 2574  i=1,numbPhase
      alfran(i)=0.
      alfest(i)=0.
c       riscalamento   alfa  iniziale
      z(i)=z(i)/2
 2574 wt(i)=bes(z(i))
      sumalp=0
      do 2580 i=1,numbPhase
      zi=0.
      alf1=0.
c     call inter(iph,nbinv,ii,i,alf1)
      call inter(ii,i,alf1)
      zi=abs(zi)
      alf1=abs(alf1)
      z(i)=zi
      alfest(i)=alf1
      if(alfest(i).lt.0.0 .or. z(i).lt.0.0) write(lo,*) ' ii=',
     *ii,i,alfest(i),z(i)
      sumalp=sumalp+zi
 2580 continue
      alra=0.
      sumalf=0.
      do 2588 i=1,numbPhase
      alfran(i)=sqrt(alfran(i))
      sumalf=sumalf+alfest(i)
 2588 alra=alra+alfran(i)
      jcc=jcc+1
      if(jcc.eq.1) goto 2572
 2590 if(iprin.eq.2)write(lo,4020)(i,z(i),zp(i),mkang(i),wt(i),
     * i=1,numbPhase)
c    ridefinisco zp e z per i seminvarianti ad una fase
      do 3000 i=1,numbPhase
      if(mkang(i).gt.0) goto 3000
      if(wt(i).eq.0) goto 2995
      zp(i)=zph(i)
      z(i)=0.0
      goto 3000
 2995 zp(i)=0.0
 3000 continue
      if(iprin.eq.2) write(lo,4010)
 4010 format(//,' contenuto dei vettori  z  e  zp ',//)
      if(iprin.eq.2) write(lo,4020) (i,z(i),zp(i),mkang(i),wt(i),
     1i=1,numbPhase)
 4020 format(1h ,3(i4,')',2e12.3,i4,f5.2))
      nelim = numbPhase
c
c   eliminazione riflessi con alfa debole
c
      alfmin=sumalp/(4.*numbPhase)
      a2=alfmin
      ii=4
      do 1155 i=1,numbPhase
      z(i)=abs(z(i))
      if(mkang(i).lt.0) goto 1155
c     if(wt(i).ne.0) go to 1155
      if(z(i).gt.a2) goto 1155
      if((z(i)+0.1).lt.0.) go to 1155
      mkang(i)=-mkang(i)
      mkang(i)=mkang(i)-20
      iorde(nelim) = i
      nelim = nelim -1
c     call inter(iph,nbinv,ii,i,alf1)
      call inter(ii,i,alf1)
 1155 continue
      do 1156 i=1,numbPhase
      if(mkang(i).gt.0) goto  1156
      if(zp(i).gt.0)  goto 1156
      wt(i)=0
 1156 continue
      if(iprin.eq.2) write(lo,4030)
 4030 format(//,'  contenuto dei vettori z  e  zp dopo aver',
     * '  eliminato i riflessi con alfa troppo basso '//)
      if(iprin.eq.2) write(lo,4020) (i,z(i),zp(i),mkang(i),wt(i),
     * i=1,numbPhase)
         icontr=0
          if (nsymb.gt.nelim) then
                                nsymb=nelim
                                icontr=1
                                go to 1240
                             endif
c     ngenRefl contiene il numero inziale di riflessi di tipo
c     generale scelti per la definizione dell'origine
      nord=0
      do 1158 i=1,numbPhase
 1158 symbo(i)=1.0e+20
      ngenRefl=nral
      if(inpori.ne.0) goto 1240
      ial =1
 1160 larn=-nral
      call origin(jump,0,ial,0,igin)
      if(iprin.eq.2) write(lo,8875) jump,norigin,nral,igin,k
 8875 format(' jump=',i4,i6,i6,' igin=',3i8,10x,'  k  ',i8)
      if(larn.gt.0) goto 1162
      if(jump.eq.0) goto 1240
 1162 if(nral.eq.norigin)go to 1220
      nral=nral+1
      go to 1160
 1220 norigin=0
      write(lo,1225)
 1225 format(/,' ****  warning : the origin can not be fixed correctly',
     1'  ****')
   
      nsymb=nsymb+2
      nsymb=min0(nsymb,12)
          if (nsymb.gt.nelim) then
                                nsymb=nelim
                                icontr=1
                               else
                                if (jcran.eq.0) write(lo,1226)
                               endif
 1226 format(/,' **** the number of selected symbols will be increased',
     1'  ****')
 1240 call histor(3,nsymb,ier)
      if(ier.lt.0) return
      call con2 (nb,nrel1,ns1mx,sogs2,ilist,jplot,icontr,
     *           rag,nusx,iy,ier,k2,nsigm1,igin,
     *           nsymb,nelim,ngenRefl,nsig1,iperm,inpori,inpena,
     *           nspec,inpfas,nrel,par)
      return
      end
c----------------------------------------------------------------------
      subroutine con2(nb,nrel1,ns1mx,sogs2,ilist,jplot,icontr,
     *           rag,nusx,iy,ier,k2,nsigm1,igin,
     *           nsymb,nelim,ngenRefl,nsig1,iperm,inpori,inpena,
     *           nspec,inpfas,nrel,par)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE PhaseModule

      common /unp/ hmax,kmax,lmax,iplan,irang,iplan2
      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset
      common /use1/ symb(12),symbo(5000),nusy(5000),inperm(12)
      common /use2/ ipigin(3)
      common /cris/ numcri,jcran,maxtri,nstart,muset


      character rescha(13)*9,linex(5000)*9,iblc
      integer symb,hmax,igin(3)
      dimension par(12),ielim(5000)
      equivalence (ielim(1),symbo(1))
      data klist/0/, numph/5000/
      data iblc/' '/
      data rescha/'   any   ','         ','  30,210 ','  45,225 ',
     *'  60,240 ','         ','  90,270 ','         ',' 120,300 ',
     *' 135,315 ',' 150,330 ','         ','   0,180 '/
c   ==========================================================
c   ricerca  alfa minimo
c  ===========================================================
c     iprin=2
      read(iblc,'(a1)') ibl
      linex(:)='         '
      do 1158 i=1,numbPhase
 1158 symbo(i)=1.0e+20
      nord=0
 1240 do 1230 j=1,numbPhase
      if(mkang(j).lt.0) goto 1230
      if(wt(j).eq.0.and.mkang(j).lt.0) goto 1230
      wt(j)=bes(z(j))
 1230 continue
 1242 alfmin=1.0e10
      do 1270 j=1,numbPhase
      if(mkang(j).lt.0) go to 1270
      if(z(j).eq.-1.)go to 1270
      alfa=z(j)
      if(alfa.ge.alfmin)go to 1270
      i=j
      alfmin=alfa
 1270 continue
      if(alfmin.gt.0.9e10)go to 1320
      nord=nord+1
      mkang(i)=mkang(i)+20
      mkang(i)=-mkang(i)
c     test per vedere se un riflesso e' stato scelto
c     precedentemente per origine
      do 1280 j=1,3
      if(igin(j).eq.i)go to 1290
 1280 continue
      go to 1295
 1290 if(inpori.ne.0) goto 1295
      larn=-nral
      ial=1
      call origin(jump,0,ial,0,igin)
      if(iprin.eq.2) write(lo,8875) jump,norigin,nral,igin,k
 8875 format(' jump=',i4,i6,i6,' igin=',3i8,10x,'  k  ',i8)
      if(jump.eq.0)go to 1295
      iorde(k)=i
      k=k+1
      mkang(i)=mkang(i)+20
      mkang(i)=-mkang(i)
      z(i)=-1.0
      j=mkang(i)-1
      if(mod(j,12).eq.0)  j=24
      zp(i)=j*15
      goto 1240
c    memorizzazione per scelta simboli
 1295 symbo(i)=10.0*alfmin/float(nord)
      nusy(i)=i
      ii=2
c    scrittura mappa di convergenza
      if(iprin.eq.2) write(lo,1301) i,alfmin,mkang(i)
 1301 format(3x,i5,f10.2,i5)
      iorde(nelim) = i
      nelim = nelim -1
c     call inter(iph,nbinv,ii,i,alf1)
      alf1=0.0  ! dritan
      call inter(ii,i,alf1)
      alf1=abs(alf1)
      z(i)=abs(z(i))
      if(alfest(i).lt.0.0 .or. z(i).lt.0.0) write(lo,*) ' ii=',
     *ii,i,z(i)
      go to 1240
c  ==================================================
 1320 continue
      if(k.eq.(k2+norigin+1)) goto 1165
      do 1163 j=1,norigin
      k1in=k2+1
      k1f=k-1
      do 1161 jcc=k1in,k1f
      if(iorde(jcc).ne.igin(j)) goto 1161
      goto 1163
 1161 continue
      iorde(k)=igin(j)
      k=k+1
      i=igin(j)
      z(i)=-1.
      jc=mkang(i)-1
      if(mod(jc,12).eq.0) jc=24
      zp(i)=jc*15
 1163 continue
 1165 continue
      if(inpori.eq.0) go to 6982
      do 6981 jcr = 1,norigin
      j = igin(jcr)
      zp(j) = ipigin(jcr)
      mkang(j) = -mkang(j)
 6981 continue
 6982 jdv = 0
      jvd = 0
      if(nant(1).ne.0) jdv=1
      do 6984 jcr = 1,norigin
      j = igin(jcr)
      if(iabs(mkang(j)).eq.1) jvd = jvd+1
      if(jvd.le.ngenRefl) go to 6984
      jdv = jdv+1
      nant(jdv) = j
      zp(j) = 45.0
 6984 continue
c
c--   routine per definizione simboli ed
c--   eventuali riflessi da permutare
c
      lcc=1
 6998 call sortco (symbo,nusy,numbPhase)
      if (nspec.eq.0) go to 7014
      j=0
      do 7008 l=1,numbPhase
      ljc=mkang(nusy(l))
      if (iabs(ljc).eq.21) go to 7008
 7007 j=j+1
      if (j.gt.nspec) go to 7009
      inperm(j)=nusy(l)
 7008 continue
 7009 do 7012 l=1,nspec
      symb(lcc)=inperm(l)
 7012 lcc=lcc+1
 7014 iperm=iperm+nspec
      if (lcc.gt.nsymb) go to 8659
      do 1337 l=1,numbPhase
 8866 if(lcc.gt.nsymb) goto 8659
      symb(lcc)=nusy(l)
      lcc=lcc+1
 1337 continue
 8659 k1=lcc-1
      nral=0
      do 8655 i=1,k1
      mkk=iabs(mkang(symb(i))) - 20
      if(mkk.eq.1) nral=nral+1
 8655 continue
      nsymb=k1
      if(iprin.eq.2) write(lo,4060)
 4060 format(//,'  contenuto dei vettori  z  e  zp dopo',
     * '  la scelta dello  starting set ',//)
      if( iprin.eq.2) write(lo,4020) (i,z(i),zp(i),mkang(i),wt(i),
     * i=1,numbPhase)
 4020 format(1h ,3(i4,')',2e12.3,i4,f5.2))
      if(nelim.eq.0) nelim=1
      do 7070 l = nelim,numbPhase
      do 7068 i = 1,nsymb
      if (symb(i).eq.iorde(l)) go to 7069
7068  continue
      go to 7070
7069  iorde(l) = -100
7070  continue
      jdv = numbPhase
      do 7090 l = nelim,numbPhase
      jcr = numbPhase - l + nelim
      if(iorde(jcr).lt.0) go to 7090
      iorde(jdv) = iorde(jcr)
      jdv = jdv - 1
7090  continue
c  come per i riflessi dell'origine il tipo di riflesso
c  mkg per i seminvarianti deve essere positivo
c  k2  =  numero di seminvarianti ad una fase considerati
      if(k2.eq.0) go to 4054
      do 4052 l=1,k2
      ind=iorde(l)
 4052 mkang(ind)=-mkang(ind)
 4054 if(k1.eq.0) go to 1323
      do 1322 l=1,k1
      iorde(k)=symb(l)
 1322 k=k+1
 1323 nbset=k-1
 1319 if (iprin.eq.2)
     *    write(lo,4065) nbset,k2,norigin, (iorde(i),i=1,numbPhase)
 4065 format(//,'  ntot. riflessi nello starting set  =',i4,2i4,
     * //,' contenuto del vettore iorde prima della mappa',
     * /,30(20i4,/))
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (jcran.ne.0) then
                        inn1=k2+norigin+1
                        iff1=inn1+numcri-1
                        iff1=min0(999,iff1)
                        nbset=iff1
                        nsymb=iff1-inn1
                      endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (icontr.eq.1) norigin=0
      do 1325 k1=1,nbset
      i=iorde(k1)
      line(k1,1)=i
      line(k1,5)=iabs(mkang(i))
      if(line(k1,5).gt.20) line(k1,5)=line(k1,5)-20
      write(linex(k1),4056) rescha(line(k1,5))
 4056 format(a9)
      line(k1,5)=ibl
      enil(k1,1)=evet(i)
      line(k1,2:4)=khl(1:3,i)
      iphh(k1)=zp(i)

 1325 continue
c   k1 = sigma1 + origine + simboli
      k1=nbset
      l=k2+1
c  l1= sigma1 + origine
      l1 = k2+norigin
c  k2 = fasi note
      l2=l1+1
      if(norigin.eq.0) goto 1372
      write(lo,1331)
 1331 format(//,5x,'origin fixing reflexion(s)',/)
      write(lo,1328)
 1328 format(30x,'code   h   k   l    e          ph.rest.      phi'/)
      write(lo,1330)((line(n,k),k=1,4),enil(n,1),linex(n),iphh(n),
     * n=l,l1)
 1330 format(30x,4i4,f6.2,7x,a9,4x,i6)
 1372 if(l1.eq.norigin) go to 1340
      if(nsig1.eq.0) goto 1327
      write(lo,1332)
 1332 format(//,5x,33hone-phase s.s. phases used       /)
      write(lo,1328)
      write(lo,1339)((line(n,k),k=1,4),
     * enil(n,1),linex(n),iphh(n),line(n,5),n=1,nsig1)
 1339 format(30x,4i4,f6.2,7x,a9,4x,i6,a1)
 1327 if(nsig1.eq.k2) goto 1340
      nsig1=nsig1+1
      write(lo,1326)
 1326 format(//,5x,25hknown phases used        /)
      write(lo,1328)
 1338 format(30x,'code   h   k   l    e          ph.rest. ',
     * '      phi    alfa     '/)
      write(lo,1330)((line(n,k),k=1,4),enil(n,1),linex(n),
     *iphh(n),n=nsig1,k2)
 1369 format(30x,4i4,f6.2,7x,a9,5x,i6,a1,1x,f6.2)
 1340 if(l2.gt.k1) go to 1350
c **********************************************************************
c     determinazione ordine di apparizione dei riflessi
c **********************************************************************
 1350 continue
      k2=1
      do 1416 j=1,numbPhase
c   controllo se si   tratta di un seminvariante a una fase
      if (z(j).lt.0.and.zp(j).ne.0) go to 1410
      if(mkang(j).le.0) go to 1415
 1410 mkang(j)=-mkang(j)
      go to 1416
 1415 z(j)=0.
      zp(j)=0.
      mkang(j)=mkang(j)+20
 1416 continue
c  per i simboli pongo il valore di zp = -99
      if(l2.gt.k1) go to 1424
      do 1423 j=l2,k1
      ind= iorde(j)
 1423 zp(ind)=-99.
 1424 continue
      do 7005 j=1,numbPhase
      iz(j)=0
 7005 mkang(j)=-mkang(j)
      if(iprin.eq.2) write(lo,4020) (jcris,z(jcris),zp(jcris),
     * mkang(jcris),wt(jcris),jcris=1,numbPhase)
c **********************************************************************
c     costruzione vettore  iz
c     per i riflessi dello  s.s. : origine + simboli
c     si pone  wt = 1.
c **********************************************************************
      do 7040 j=1,numbPhase
      if(z(j).eq.0.) go to 7010
c *********    origine    **********************************************
      iz(j)=ifix(zp(j)+.5) *1000+200
      wt(j) = 1.0
      goto 7040
c *********    sigma1 & fasi note   ************************************
 7010 if(zp(j)) 7020,7030,7015
 7015 iz(j)= ifix(zp(j)+.5)*1000 +ifix(abs(wt(j))*100.+.5)
      go to 7040
c *********    simboli   ***********************************************
 7020 iz(j) = -1
      wt(j) = 1.0
      goto 7040
 7030 iz(j)=-100
 7040 continue
c *****************************************************************
        if(iprin.eq.2) write(lo,7045)(jcris,iz(jcris),wt(jcris),
     * jcris=1,numbPhase)
 7045 format(4(i4,')',i8,f5.2))
      if(nant(1).eq.0) goto 7050
      n1=iabs(nant(1))
      if(iz(n1).ge.-1) goto 7050
      iz(n1) =-1
7050  continue

      do 8980 j=nbset+1,numbPhase
 8980  iorde(j)=0

      if(inpena.eq.0) goto 8985
      if(inpena.ne.iabs(nant(1))) goto 8985
      l1in=l1+1
      do 8981 jcdv=l1in,nbset
      if(inpena.eq.iorde(jcdv)) goto 8985
 8981 continue
      iorde(nbset+1) = inpena
      wt(inpena)=1.
c  pesaggio per enantiomorfo diverso per weight procedure
      wt(inpena)=100.
      if(iabs(mkang(inpena)).eq.1) wt(inpena) = 5.5
 8985 continue
      if (icent.lt.0) then
      write(lo,8986)
 8986 format(//,5x,'enantiomorph fixed by space group ',/)
                     else
                      if(nant(1).eq.0)  go to 7060
                      ns = iabs(nant(1))
                      eenan=evet(ns)
                      nh=khl(1,ns)
                      nk=khl(2,ns)
                      nl=khl(3,ns)
                      write(lo,7055) ns,nh,nk,nl,eenan
                    endif
 7055 format(//,5x,'enantiomorph fixing reflexion ',//,
     *         30x,'code   h   k   l    e',//,30x,4i4,f6.2)
7060  continue
      
c***********************************************************************
c     inizio  mappa  di  divergenza
c***********************************************************************
      do 1427 j=1,numbPhase
 1427 mkang(j)=-mkang(j)
      i=iorde(1)
      mkang(i)=-mkang(i)
      ii=3
      lcri=k1
      k=2
      do  1425 j=1,numbPhase
      do  1422 j1=1,nbset
      if(j.eq.iorde(j1)) goto 1425
 1422 continue
      wt(j)=0.0
 1425 continue
      do 1431 j=1,numbPhase
      j1=iorde(j)
      if(j1.eq.0)  goto 1432
      if(j1.eq.iabs(nant(1)).and.wt(j1).ne.1.)goto 1431
      if(zp(j1).ne.(-99.)) goto 1420
c *** wt(j1) = 100.
      if(iabs(mkang(j1)).ne.1) goto 1419
      wt(j1)=par(nral)
      goto 1431
 1419 wt(j1)=100.
      goto 1431
 1420 iwt=mod(iz(j1),1000)
      if(iwt.gt.100) goto 1426
      wt(j1)=-1
      goto 1431
 1426 wt(j1)=100.
 1431 continue
 1432 continue
      do 1445 j=1,numbPhase
      if(wt(j).le.1) goto 1440
      wt(j)=bes(wt(j))
      goto 1445
 1440 if(wt(j).ge.0) goto 1445
      iwt = mod (iz(j),1000)
      wt(j) = iwt * 0.01
 1445 continue
 1430 i=iorde(k)
      mkang(i)=-mkang(i)
      n0=0
      n=0
      n1=0
c     call inter(iph,nbinv,ii,i,alf1)
      call inter(ii,i,alf1)
      z(i)=abs(z(i))
      alf1=abs(alf1)
      k=k+1
      if(k.ge.numph) go to 1580
      if(iorde(k))1580,1580,1430
 1580 amax=0.
      if(icontr.eq.1) go to 1705
      if(nlist.eq.0) goto 1590
      if(klist.ne.0)go to 1590
      klist=1
 1590 do 1600 i=1,numbPhase
      if(mkang(i).gt.0) go to 1600
      alfa=z(i)*z(i)
      if(alfa.lt.amax)go to 1600
      amax=alfa
      iorde(k)=i
 1600 continue
      amax=sqrt(amax)
c   stampa relazioni seminvarianti a due fasi
      if (nlist.eq.0) go to 1605
      if (n0.eq.0) go to 1595
      m1=0
      m=min0(n0,5)
      write(lo,1602) ((ibu(l,j),j=1,2),bu(l),l=1,m)
 1602 format(35x,5(i6,')',i4,f6.2))
 1594 if(m.eq.n0) go to 1595
      n0=n0-5
      m1=m1+5
      m=min0(n0,5)
      m11=m1+1
      m1m=m1+m
      write(lo,1602) ((ibu(l,j),j=1,2),bu(l),l=m11,m1m)
      go to 1594
c  stampa delle relazioni di invarianti a tre fasi
 1595 if (n.eq.0) go to 1596
      m1=0
      if (knw.eq.0) m=min0(n,4)
      if (knw.ne.0) m=min0(n,3)
      if (knw.ne.0)
     *write(lo,1601) ((ibufr(l,j),j=1,3),(bufr(l,jc),jc=1,2),l=1,m)
      if (knw.eq.0)
     *write(lo,1603)((ibufr(l,j),j=1,3),bufr(l,1),l=1,m)
 1601 format(36x,3(2(i5,')'),i4,2f6.2,2x))
 1597 if (m.eq.n) go to 1596
      if (knw.eq.0) go to 1608
      n=n-3
      m1=m1+3
      m=min0(n,3)
      goto 1609
 1608 n=n-4
      m1=m1+4
      m=min0(n,4)
 1609 m11 = m1+1
      m1m = m1+m
      if (knw.ne.0)
     *write(lo,1601) ((ibufr(l,j),j=1,3),(bufr(l,jc),jc=1,2),l=m11,m1m)
      if (knw.eq.0)
     *write(lo,1603) ((ibufr(l,j),j=1,3),bufr(l,1),l=m11,m1m)
      go to 1597
c   stampa delle relazioni di quartetto
 1596 if (n1.eq.0) go to 1605
      m1=0
 1598 m=min0(n1,3)
      m11 = m1+ 1
      m1m = m1 + m
      write(lo,1599) ((ibuf(l,j),j=1,4),buf(l),l=m11,m1m)
 1599 format(36x,3(3i5,i4,f6.2))
      if (m.eq.n1) go to 1605
      m1=m1+3
      n1=n1-3
      go to 1598
 1603 format(36x,4(2(i5,')'),i4,f6.2))
 1605 if(k.lt.numbPhase) go to 1610
c +++++++++++++++++++++++++++++++++++++++++++++++++++++
      ind = iorde(k)
      mkang(ind)=-mkang(ind)
      do 1604 i=1,numbPhase
      if(mkang(i).gt.0) go to 1604
      k=k+1
      iorde(k)=i
 1604 continue
 1705 nb=limref(numbPhase+1)
c   per i seminvarianti a una fase il peso wt e posto negativo
      if(nsigm1.eq.0) go to 5530
      do 5500 i=1,nsigm1
      ind=iorde(i)
 5500 wt(ind)=-wt(ind)
 5530 continue
 5535 nin=nbset+1
      do 5550 i=nin,numbPhase
      ind=iorde(i)
      zp(ind)=0
 5550 continue
      if(iprin.eq.2) write(lo,4023) (iorde(jcris),jcris=1,numbPhase)
      if(iprin.eq.2) write(lo,4022) (limref(jcris),jcris=1,numbPhase)
 4022 format(12(10i10,/))
 4023 format(30(20i4,/))
      if(iprin.eq.2) write(lo,4028) (jcris,zp(jcris),alfest(jcris),
     *  iz(jcris),wt(jcris),jcris=1,numbPhase)
 4028 format(1h ,2(i4,')',2e12.3,i8,f5.2))
      return
 1610 i=iorde(k)
      wate=1.0
      if(amax.lt.5.) wate=0.15*amax+0.25
      wt(i)=amax1(wate,0.15)
      if(k.gt.nlist+nbset)go to 1430
      i1=khl(1,i)
      i2=khl(2,i)
      i3=khl(3,i)
      write(lo,1620) i,i1,i2,i3,amax,wt(i)
 1620 format(2h -,2i6,2i5,2f10.2)
      go to 1430
      end
c     -----------------------------------------------------------------
      subroutine unpacc(ind,ih,ik,il)
c   unpack indices with  lk paking constants (big list index)
      common /unp/ hmax,kmax,lmax,iplan,irang,iplan2
      integer hmax
      ind1 = ind + iplan2
      ih = ind1/iplan
      iau = mod(ind1,iplan)
      ik = iau/irang - kmax
      il = mod(iau,irang) - lmax
      return
      end
c----------------------------------------------------------------------
      subroutine inter(ii,i,alf1)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule

      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset

c
      vec(x)=amin1(x*(x+0.4807)/((x+0.8636)*x+1.3943),1.0)
c
      lm=limref(i)+1
      ls=limref(i+1)
      if(lm.gt.ls) go to 3300
      nv=0
      do 3100 j=lm,ls
      ind = nbinv(j)
      call depacc (i,ind,a1,ifaz,iw)
      ila=iabs(nn(1))
      ira=iabs(nn(2))
      ita=iabs(nn(3))
      w=1.0
      go to (3038,3020,3010,3020,3020),ii
c ordine di apparizione nella mappa di divergenza  ii = 3
 3010 w=wt(i)
      ix=0
      do 3015 jj=1,3
      ira=iabs(nn(jj))
      if(nn(jj).eq.0) go to 3015
      if(mkang(ira))3011,3011,3014
 3011 ix=ix+1
      ila=ira
      go to 3015
 3014 w=w*wt(ira)
 3015 continue
      if(ix-1)3080,3035,3100
 3020 do 3025 jj=1,3
      if(nn(jj).eq.0) go to 3025
      ila=iabs(nn(jj))
      if(iabs(mkang(ila)).gt.20) goto 3100
      w=w*wt(ila)
 3025 continue
      goto 3039
 3035 if(k.gt.lcri) goto 3039
      do 3036 jc=1,lcri
      if(ila.eq.iorde(jc)) goto 3100
 3036 continue
 3038 gbes = abs(a1)
      eee = gbes * w
corig vec1 = bes(eee)
      vec1 = bes(a1*w)
      goto 3040
 3039 gbes = abs(a1)
      a1 = bes(a1)
      eee = a1 * w
      vec1 = gbes
 3040 vec2 = vec1 * eee
      go to (3060,3050,3045,3050,3060),ii
 3045 continue
      z(ila)=z(ila)+vec2
      go to 3100
 3050 do 3055 jj=1,3
      if(nn(jj).eq.0) go to 3055
      ira=iabs(nn(jj))
      if(mkang(ira).lt.0) goto 3055
      if(z(ira).lt.0.) go to 3055
      z(ira)=z(ira)-vec2
 3055 continue
      if(ii.ne.2) goto 3100
      if(iprin.lt.1) goto 3100
      if(nv.ge.80) goto 3100
      nv=nv+1
      do 3056 jj=1,2
 3056 ibuf(nv,jj)= nn(jj)
      buf(nv)=gbes
      ibuf(nv,3)=ifaz
      go to 3100
 3060 zi=zi+vec2
corig if (iw.eq.3.or.nn(2).eq.0)  goto 3100
      if (nn(2).eq.0)  goto 3100
      alf1=alf1+vec2
c  incremento alfarandom di ogni riflesso
      alfran(i)=alfran(i)+a1**2
c ======================================================
      go to 3100
c sortie des resultats
 3080 if(k.gt.nlist+nbset) go to 3100
      if(nn(2).ne.0) go to 3085
      if(n0.ge.80) go to 3100
      n0=n0+1
      ibu(n0,1) = nn(1)
      ibu(n0,2)=ifaz
      bu(n0)=a1
      go to 3100
 3085 if(nn(3).ne.0) go to 3090
      if(n.ge.80) go to 3100
      n=n+1
      ibufr(n,1) =nn(1)
      ibufr(n,2)= nn(2)
      ibufr(n,3)= ifaz
c  calcolo coseno reale e coseno calcolato
      if(knw.eq.0) goto 3087
      isi1=isign(1,nn(1))
      nn1=iabs(nn(1))
      isi2=isign(1,nn(2))
      nn2=iabs(nn(2))
      ip=ipub(i)-isi1*ipub(nn1)-isi2*ipub(nn2) -ifaz*15
      cosc=vec(a1)
      cosr=cos(ip/57.29578)
      bufr(n,1)=abs(cosc-cosr)
      bufr(n,2)=a1
      goto 3100
 3087 continue
      bufr(n,1)=a1
      go to 3100
 3090 if(n1.ge.80) go to 3100
      n1=n1+1
      ibuf(n1,1)=nn(1)
      ibuf(n1,2)=nn(2)
      ibuf(n1,3)=nn(3)
      ibuf(n1,4)=ifaz
      buf(n1)=a1
c ===============================================
 3100 continue
      if(ii.ne.2) goto 3300
c  scrittura mappa di convergenza
      if(iprin.ne.2) goto 3300
      if(nv.gt.0)
     1write(lo,3105) ((ibuf(kv,lv),lv=1,3),buf(kv),kv=1,nv)
 3105 format((20x,4(2i5,i4,f7.2,3x)))
 3300 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine depacc (i,ind,a,ifaz,iw)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule

      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset

c **********  icod = 0  relazione  di tripletto
c **********  icod = 1  relazione di seminvariante
      icod=0
      do 10 j = 1,4
10    nn(j) = 0
      call unpak3(iph(ind),nn(1),nn(2),ifaz)
      iw = 1
      if(ifaz.lt.0) go to 20
c     one-phase  seminvariant
         write(lo,100) ind,nn(1),nn(2),iph(ind),ifaz
  100  format(' error in subroutine depacc',3i6,i20,i4)
         call cstop(' ')
20    call unpak3 (iph(ind+1),nn(3),nn(4),ifaz)
      iw = 2
      if(ifaz.lt.0) go to 30
      a= 0.01*nn(4)
      nn(4) = 0
c+++++if(ind.le.2*ntrip) go to 40
c   sostituito controllo sul primo codice del secondo campo di iph =
c  =  nn(3)  minore di 700 implica che la relazione e di tripletto
c  maggiore di  700 la relazione e seminvarianti
c  per i seminvarianti a due fasi nn(3) rappresenta
c la fase della relazione in gradi - campo inutile
          if(nn(3).le.5000) go to 40
c   two-phase seminvariant
      icod=1
      nn(3) = 0
      go to 40
c   quartets (this is a french quartet)
30    call unpak3(iph(ind+2),l,m,ifaz)
      iw = 3
      a = 0.01*m
c  relationship solution in terms of i
40    if(i.eq.0) return
      do 50 j = 1,4
      if(iabs(nn(j)).eq.i) go to 60
50    continue
      write(lo,55)i,nn
55    format (5x,'*****error in subroutine  depacc ******',i5,3x,4i5)
      ier = 1111
      
60    isi = isign(1,nn(j))
      j1 = 1
      do 70 jcris = 1,4
      if(jcris.eq.j) go to 70
      nn(j1) = nn(jcris)*(-isi)
      j1 = j1+1
70    continue
      ifaz = ifaz*(-isi)
      if(ifaz.lt.0) ifaz=ifaz+24
      if(icod.eq.1) nn(2)=0
      nn(4) = 0
      return
      end
c ------------------------------------------------------------------
c     determine space group type according to the categories of hauptman
c     & karle,  acta cryst. (1956) 9, 45  and  acta cryst. (1959) 12, 93
c     and karle & hauptman,  acta cryst. (1961) 14, 217,  given only the
c     general equivalent positions and lattice type  -  gives  necessary
c     information on number and  type  of  reflexions  used  for  origin
c     definition, seminvariant modulus & reduced indices for  reflexions
c     routine will handle 230 space groups in the standard  orientations
c     including alternative settings as in international tables volume 1
c     determine  also  the  phase   restrictions  for   all   reflexions
c     test  whether  the  enantiomorph  is  fixed  by  the  space  group
      subroutine group

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule

      common /local/ ind(3),khl1(4)
c
      common /unp/ hmax,kmax,lmax,iplan,irang,iplan2
      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset

      integer hmax

c     * * * * * * * * * * * * * * * * ** * * * * * * * * * * * * * * * *
c     initialize parameters
      nral = 0
      do 1000 i=1,3
      modul(i) = 2
 1000 continue
c     it = 3  tests for z in 1st coord. of general equivalent  positions
c     -  gives rhombohedral or cubic
c     it = 2  tests for y in 1st coord. - gives tetragonal, hexagonal or
c     trigonal
      do 1060 ii=1,2
      it = 4 - ii
      do 1040 j=1,nsym
      if (iabs(ismat(1,1,j)) - it) 1020,1500,1020
 1020 if (iabs(ismat(2,1,j)) - it) 1040,1500,1040
 1040 continue
 1060 continue
c     space group must be triclinic,  monoclinic  or  orthorhombic
c     three reflexions are normally required for origin definition
      norigin = 3
      if (icent) 1080,1080,1160
c     determine  seminvariant  modulus vector (modul) and number of axes
c     along  which the  origin  position is infinitely  variable  (nral)
 1080 nral = 3
      do 1140 i=1,3
      modul(i) = 1000
      do 1100 j=1,nsym
      if (ismat(1,i,j)) 1120,1100,1100
 1100 continue
      go to 1140
 1120 modul(i) = 2
      nral = nral - 1
 1140 continue
c     check for centred lattice
 1160 go to (1380,1260,1180,1220,1380,1320,1380), latt
c     b centred lattice  -  test for b2  or  bm, bb
 1180 if (nral.le.1) goto 1380
      ii= 2
      modul(3) = 1000
      go to 1280
c     c centred lattice  -  test for c2  or  cm, cc
 1220 if(nral.le.1) goto 1380
      modul(2) = 1000
 1260 ii = 3
c     a centred lattices, bm, bb, cm, cc
c     determine reduced indices for all reflexions
 1280 do 1300 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro (ind(1),ind(2),ind(3))
      mkg(i)=512*(mod(ind(1),modul(2))+256)+mod(ind(ii),modul(3))+256
 1300 continue
      go to 2000
c     f centred lattice - test point group symmetry around (1/4,1/4,1/4)
c     to detect f222 if space group is non-centrosymmetric
 1320 if (icent.gt.0) goto 1980
      call test9(1,1,1,4,mm)
      if (mm.eq.0) goto 1960
c     triclinic, monoclinic & orthorhombic except a centred, bm,bb,cm,cc
c     determine reduced indices for all reflexions
 1380 do 1400 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro ( ind(1),ind(2),ind(3))
      mkg(i)=262144*mod(ind(1),modul(1))+512*(mod(ind(2),modul(2)
     1  ) + 256) + mod(ind(3),modul(3)) + 256
 1400 continue
      go to 2000
c     space group must be tetragonal, trigonal, hexagonal or cubic
 1500 if (icent) 1520,1520,1640
 1520 if (latt - 1) 1600,1540,1600
c     test whether enantiomorph is fixed by the space group
 1540 do 1560 i=1,nsym
      it = 24.0 * tsmat(3,i) + 0.1
      if (mod(it,12)) 1580,1560,1580
 1560 continue
      go to 1600
c     enantiomorph fixed by space group  -  set flag
 1580 icent = -1
c     is origin position infinitely variable along z
c     set flag (nral) and 3rd component of seminvariant  modulus  vector
 1600 do 1620 i=1,nsym
      if (ismat(1,3,i)) 1640,1620,1620
 1620 continue
c     space group must be 2p20, 3p30, 3p(1)0 or 3p(2)0
      nral = 1
      modul(3) = 1000
c     branch for rhombohedral and cubic
 1640 go to (1940,1660), ii
c     test point group symmetry around (1/2,1/2,0) to detect  tetragonal
 1660 call test9(1,1,0,2,mm)
      if (mm) 1820,1680,1820
c     space group must be tetragonal
c     two reflexions are normally required for origin definition
 1680 norigin = 2
      if (latt.ne.5) goto 1780
c     i centred  tetragonal    -    test  point  group  symmetry  around
c     (0,1/2,1/4)  to  detect  bar 4  axis
      call test9(0,2,1,4,mm)
      if (mm.ne.0) goto 1780
c     space group must be 3p(3)4
      modul(3) = 4
c     determine reduced indices for all reflexions
      do 1740 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro ( ind(1),ind(2),ind(3))
      mkg(i) = mod(2 * ind(2) + ind(3), modul(3)) + 131328
 1740 continue
      go to 2000
c     space group must be 3p(3)0 or 3p(3)2
c     enter here for primitive tetragonal
c     determine reduced indices for all reflexions
 1780 do 1800 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro (ind(1),ind(2),ind(3))
      mkg(i) = 512*(mod(ind(1) + ind(2), modul(2)) + 256) + mod(ind(3),
     1  modul(3)) + 256
 1800 continue
      go to 2000
c     space group must be trigonal or hexagonal
 1820 if (icent) 1840,1840,1900
c     test point group symmetry around (1/3,2/3,0) to detect 3p30 & 3p32
 1840 if (latt - 7) 1850,1900,1900
 1850 call test9(1,2,0,3,mm)
      if (mm) 1900,1860,1900
c     space group must be 3p30 or 3p32
 1860 modul(2) = 3
c     detect 6p6
      if (modul(3).eq.2) goto 1890
c     two reflexions are normally required for origin definition
      norigin = 2
c     determine reduced indices for all reflexions
      do 1880 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro (ind(1),ind(2),ind(3))
      mkg(i) = 512*(mod(ind(1) - ind(2), modul(2)) + 256) + mod(ind(3),
     1  modul(3)) + 256
 1880 continue
      go to 2000
c     one reflexion normally required for origin definition
 1890 norigin=1
      modul(3)=6
c     determine reduced reflexions for all reflexions
      do 1895 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro ( ind(1),ind(2),ind(3))
      mkg(i)=mod(2*ind(1)+4*ind(2)+3*ind(3),modul(3))
 1895 continue
      goto 2000
c     space group must be 3p(1)0, 3p(1)2 or rhombohedral using hexagonal
c     axes
c     one reflexion is normally required for origin definition
 1900 norigin = 1
c     determine reduced indices for all reflexions
      do 1920 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro ( ind(1),ind(2),ind(3))
      mkg(i) = mod(ind(3),modul(3)) + 131328
 1920 continue
      go to 2000
c     space group must be 3p(2)0, 3p(2)2, 3p(2)4 or 4p111
c     test point group symmetry around  (1/4,1/4,1/4)  to detect  3p(2)4
 1940 if (icent) 1950,1950,1980
 1950 if (latt - 7) 1960,1980,1980
 1960 call test9(1,1,1,4,mm)
      if (mm) 1980,1970,1980
 1970 modul(3) = 4
c     one reflexion is normally required for origin definition
 1980 norigin = 1
c     determine reduced indices for all reflexions
      do 1990 i=1,numbPhase
      ind(1:3)=khl(1:3,i)
      call contro ( ind(1),ind(2),ind(3))
      mkg(i) = mod(ind(1) + ind(2) + ind(3), modul(3)) + 131328
 1990 continue
c     calculate phase restrictions on all reflexions
 2000 do 2040 i=1,numbPhase
      mkang(i) = 13
c     alpha(i) = 0.0
c     palf(i) = 0.0
 2040 continue
      if(icent .gt . 0) go to 2240
      do 2200 i=1,numbPhase
      mkang(i) = 1
      ind(1:3)=khl(1:3,i)
      call contro (ind(1),ind(2),ind(3))
c     generate symmetry related reflexions
      do 2180 j=1,nsym
      do 2080 kcb=1,4
      khl1(kcb) = 0
 2080 continue
      do 2140 kcb=1,3
      khl1(4) = khl1(4) + ind(kcb) * int(tsmat(kcb,j) * 12.0 + 0.1)
      do 2120 l=1,2
      m = iabs(ismat(l,kcb,j))
      if (m .ne. 0) khl1(m)=khl1(m) + ind(kcb) * isign(1,ismat(l,kcb,j))
 2120 continue
 2140 continue
c     has friedel opposite been generated
      do 2160 kcb=1,3
      if (ind(kcb) + khl1(kcb)) 2180,2160,2180
 2160 continue
c     yes - phase must be restricted to  pi*khl1(4)/24 or pi*khl1(4)/24+pi
      mkang(i) = mod(khl1(4), 12) + 1
      if (mkang(i) .le. 1) mkang(i) = mkang(i) + 12
      go to 2200
 2180 continue
 2200 continue
      do 2220 i=1,3
      modul(i) = mod(modul(i),1000)
 2220 continue
c     adjust number of origin  defining  reflexions for centred lattices
 2240 go to (2280,2260,2260,2260,2260,2300,2280), latt
c     a, b, c and i centred lattices
 2260 norigin = norigin - 1
 2280 return
c     f centred lattices
 2300 norigin = iabs(norigin - 2)
      return
      end
c     ------------------------------------------------------------------
c     test to see if the point (m1/m4,m2/m4,m3/m4) is a possible  origin
c     position     mm .eq. 0  if yes     mm .ne. 0  if no
c     this routine is written to test  non-centrosymmetric  space groups
c     with p, i and f lattices only
      subroutine test9(m1,m2,m3,m4,knt)
      USE Symmetry
      dimension matrix(3,3)
      do 1220 i=1,nsym
      do 1020 j=1,3
      do 1000 k=1,3
      matrix(j,k) = 0
 1000 continue
      matrix(j,j) = -1
 1020 continue
      do 1080 j=1,2
      do 1060 k=1,3
      m = iabs(ismat(j,k,i))
      if (m) 1060,1060,1040
 1040 matrix(k,m) = matrix(k,m) + isign(1,ismat(j,k,i))
 1060 continue
 1080 continue
      knt = 0
      do 1140 j=1,3
      mm = iabs(mod(matrix(j,1) * m1 + matrix(j,2) * m2 + matrix(j,3) *
     1  m3, m4))
      if (mm) 1140,1140,1100
 1100 if (2 * mm - m4) 1260,1120,1260
 1120 knt = knt + 1
 1140 continue
      if (knt) 1220,1220,1160
 1160 go to (1240,1240,1240,1240,1180,1200,1240), latt
 1180 if (knt - 3) 1240,1220,1240
 1200 if (knt - 2) 1240,1220,1240
 1220 continue
      knt = 0
 1240 return
 1260 knt = 1
      return
      end
c  --------------------------------------------------------------------
      subroutine  contro ( ihh,ikk,ill)
      ihh=iabs(ihh)
      ikk=iabs(ikk)
      ill=iabs(ill)
      return
      end
c   --------------------------------------------------------------------
c     find any norigin reflexions from those available to define the origin
c     routine will handle 230 space groups in the standard  orientations
c     including alternative settings as in international tables volume 1
      subroutine origin(jump,norin,ial,min,igin)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule
c
      common /unp/ hmax,kmax,lmax,iplan,irang,iplan2
      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset

      integer hmax
      dimension igin(3)

c     * * * * * * * * * * * * * * * * ** * * * * * * * * * * * * * * * *
      jump=0
c     origin is defined by space group
      if(norigin.eq.0) return
c     reflexion min must be included in origin
      must=0
      if(min.eq.0) must=-1
      do 900 iii=1,numbPhase
c  *******************************************************************
      i = iii
c     test if reflexion min is in origin defining set
      if(must.eq.1) go to 950
      if(i.eq.min) must=1
c  *******************************************************************
      
  50  if(mkang(i).lt.0) goto 900
c     seminvariant reflexion
  55  if(mkg(i).eq.131328) go to 900
      nral1=0
c     count general reflexions
      if(mkang(i).eq.1) nral1=1
      if(nral1.gt.nral) go to 900
      n1=0
c     count user reflexions requested
c     if(mod(iz(i),1000).eq.200) n1=1
c     if (norin-n1.ge.norigin) go to 900
      call unpack(mkg(i),j1,k1,l1)
      if(norigin.gt.1) go to 100
c     is min included
      if(must.eq.0) go to 900
c     test with origin rules if one reflexion is needed to define origin
c     modulus = (2), (3), (4), (6) or (0)
      if(l1.eq.1) go to 1000
      if(l1.eq.modul(3)-1) go to 1000
      go to 900
  100 ipo=i+1
      if(ipo.gt.numbPhase) go to 900
      do 800 jjj=ipo,numbPhase
c  ********************************************************************
      j = jjj
      if(must.eq.2) go to 900
      if(j.eq.min) must=2
c  ********************************************************************
  150 if(mkang(j).lt.0) goto 800
  155 if(mkg(j).eq.131328) go to 800
      nral2=nral1
      if(mkang(j).eq.1) nral2=nral2+1
      if(nral2.gt.nral) go to 800
      n2=n1
      call unpack(mkg(j),j2,k2,l2)
      if(norigin.gt.2) go to 200
      if(must.eq.0) go to 800
c     test with origin rules if two reflexions are needed
      mdet=k1*l2-k2*l1
      maxm=max0(modul(2),modul(3))
c     modulus = (0,0) or (2,2)
      if(iabs(mdet).eq.1) go to 1000
      if(maxm.eq.0) go to 800
c     modulus = (0,2), (2,0) or (3,0)
      if(mod(mdet,maxm).eq.0) go to 800
c     modulus = (0,2)
      if(modul(2).eq.0.and.jfac(k1,k2,-1000).ne.1) go to 800
c     modulus = (2,0) or (3,0)
      if(modul(3).eq.0.and.jfac(l1,l2,-1000).ne.1) go to 800
      go to 1000
  200 jpo=j+1
      if(jpo.gt.numbPhase) go to 800
      do 700 kkk=jpo,numbPhase
c  *******************************************************************
      kcc = kkk
      if(must.eq.3) go to 800
      if(kcc.eq.min) must=3
c  ******************************************************************
  250 if(mkang(kcc).lt.0) goto 700
  255 if(mkg(kcc).eq.131328) go to 700
      nral3=nral2
      if(mkang(kcc).eq.1) nral3=nral3+1
      if(nral3.gt.nral) go to 700
      n3=n2
      call unpack(mkg(kcc),j3,k3,l3)
      if(must.eq.0) go to 700
c     test with origin rules if three reflexions are needed
      mdet=j1*(k2*l3-k3*l2)-j2*(k1*l3-k3*l1)+j3*(k1*l2-k2*l1)
      maxm=modul(1)+modul(2)+modul(3)
c     modulus = (0,0,0) or (2,2,2)
      if(iabs(mdet).eq.1) go to 1000
      if(maxm.eq.0) go to 700
      if(maxm.eq.2) go to 600
c     modulus = (0,2,2), (2,0,2) or (2,2,0)
      if(mod(mdet,2).eq.0) go to 700
c     modulus = (0,2,2)
      if(modul(1).eq.0.and.jfac(j1,j2,j3).ne.1) go to 700
c     modulus = (2,0,2)
      if(modul(2).eq.0.and.jfac(k1,k2,k3).ne.1) go to 700
c     modulus = (2,2,0)
      if(modul(3).eq.0.and.jfac(l1,l2,l3).ne.1) go to 700
      go to 1000
  600 if(modul(2).ne.2) go to 650
c     modulus = (0,2,0)
      if(k1.eq.1.and.iabs(j2*l3-j3*l2).eq.1) go to 1000
      if(k2.eq.1.and.iabs(j3*l1-j1*l3).eq.1) go to 1000
      if(k3.eq.1.and.iabs(j1*l2-j2*l1).eq.1) go to 1000
      go to 700
c     modulus = (0,0,2)
  650 if(l1.eq.1.and.iabs(j2*k3-j3*k2).eq.1) go to 1000
      if(l2.eq.1.and.iabs(j3*k1-j1*k3).eq.1) go to 1000
      if(l3.eq.1.and.iabs(j1*k2-j2*k1).eq.1) go to 1000
  700 continue
  800 continue
  900 continue
  950 jump=-1
      return
 1000 if(ial.eq.0) return
      l=0
 1050 l=l+1
      igin(l)=i
      if(l.eq.norigin) goto 1300
      if(l.eq.1) i=j
      if(l.eq.2) i=kcc
       go to 1050
 1300 jump=0
      return
      end
c     ------------------------------------------------------------------
c     test for common factor (.gt.1) amongst k,l,n
      function jfac(k,l,n)
      dimension in(3)
      in(1) = k
      in(2) = l
      in(3) = n
      jfac=1
      m = 1000
      j = 0
      do 100 i = 1,3
      if(in(i).eq.0) go to 100
      j = j + 1
      in(j) = in(i)
      m = min0(m,in(j))
100   continue
      if(m.eq.1) return
      do 200 i = 2,m
      do 150 jj = 1,j
      if(mod(in(jj),i).ne.0) go to 200
150   continue
      jfac = i
      go to 300
200   continue
300   return
      end
c-------------------------------------------------------------------
      subroutine tangen(nsrt,nrel,ns1mx,sogs2,ilist,jplot,rag,
     *                 nusx,iy,ier,par,inpfas)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE Grafici
      USE Molcom
      USE PhaseModule

      character*200,strLog

      common /cfomxx/ coms_best,nuset_best
      common /unp/hmax,kmax,lmax,iplan,irang,iplan2
**    common/fom4/attl2,attl3,nqen,nen,ntrneg,ntrpos,ns1,ns2,nquar,
**   * nphas,nfom0,coeco
**    common /psi0/npsi,num0,alfest0(1000),alfvar0(1000),llll(1000),
**   1 lim0n(1001),iph0n(20000)
c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /tables/ stable(500)
      common /mag/ sqp4,sq2pi,mi(15),ms(15),dx,iyyy
c
      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset

      dimension enil1(4)

      common /cris/ numcri,jcran,maxtri,nstart,muset
      common /use2/ ipigin(3)
      integer hmax
      dimension kline(5000),ctable(500),par(12)
      equivalence (stable(91),ctable(1))
c
      icont(1)=0
      icont(2)=3
      icont(3)=996

      do 1480  i=1,450
      stable(i)=sin(dtor * float(i-1))
 1480 continue

      control(:)=1.0
      kdstor(:)=0

      sqp4=sqrt(pi)
      sq2pi=2.0/sqp4
c  *****************************************************
c
c  lettura  relazioni e lettura riflessi
c
c  *****************************************************
      sigm=s3s2
      atoms=(1.0/s3s2)**2.0
      nat=int(atoms+0.05)
      write(lo,10)
   10 format(///,1h ,78('+'),//,20x,
     1 35h***   tangent formula section   ***,/)

*gl*  call xfl06
      call LoadReflInfo

c     icode=2
c     call refsto(icode)
c ---  calcola alfest ed alfvar
c      call rialfnew(icent,sigm,imat,iph,nbinv)
       call rialfnew(sigm)
!
c ------------------------------------------------------------------
c  ************************************************
c  controllo file  relazioni
c  **************************************************
      if(iprin.eq.2)write(lo,20) nant,nrel
   20 format(1h0,//,' nant=',4i4,' nrel=',i6)
      if(iprin.eq.2) write(lo,30) (iorde(jcris),jcris=1,numbPhase)
   30 format(//10x,'  contenuto  vettore  iorde  ',//,30(20i4,/))
      if(iprin.eq.2) write(lo,31) (iz(jcris),jcris=1,numbPhase)
   31 format(//10x,'  contenuto  vettore  iz     ',//,30(10i6,/))
      if(iprin.eq.2) write(lo,4028) (jcris,zp(jcris),alfest(jcris),
     *  iz(jcris),wt(jcris),jcris=1,numbPhase)
 4028 format(1h ,2(i4,'*',2e12.3,i8,f5.2))
c --- estrai i codici dei riflessi che definiscono l'origine e gli altri
c --- riflessi  dello starting  set
      do  550  i= 1,numbPhase
c ---
c --- determina il tipo di riflesso: origine,simbolo,seminv. ad una
c --- fase (codici 1/2/3  rispettivamente)
c ---
      if(zp(i).eq.0)  goto 550
      if(zp(i).gt.0) goto 510
c --- il riflesso e' stato preso come simbolo se zp(i)  lt 0
      ncod=2
      goto  530
c  se zp(i) maggiore di 0 e wt(i) minore di 0 - semin. ad una fase
  510 if(wt(i).lt.0) goto 520
c --- riflesso origine se zp(i)  >  0 e wt(i) >0
      ncod=1
      goto 530
  520 ncod=3
  530 icont(ncod)=icont(ncod)+1
      nco = icont(ncod)
c  nel vettore kdstor() i numeri sequenziali dei riflessi origine - simb
c  seminvarianti  ad una fase
      kdstor(nco)=i
c --- memorizza  la fase
c --- controllando prima se il riflesso e' un simbolo
      if (ncod.eq.2) goto 550
      iphaz(i)=zp(i)
  550 continue
c =======================================================
c
c   scrittura  riflessi
c
c =====================================================
      jj=0
      if (iprin.ne.2) go to 8050
      do 8000 i=1,numbPhase
      jj=jj+1
      line(jj,1)=i
      line(jj,2:4)=khl(1:3,i)
      line(jj,5)=mkang(i)
      line(jj,6)=360
      if(knw.ne.0) line(jj,6)=ipub(i)
      enil1(jj)=evet(i)
      if(jj.lt.3) goto 8000
      write(lo,5005) ((line(ii,ll),ll=1,6),enil1(ii),ii=1,jj)
      jj=0
 5005 format(3(i5,')',3i4,2x,i3,'*',i5,f6.2,2x))
 8000 continue
      if(jj.eq.0) goto 8050
      write(lo,5005) ((line(ii,ll),ll=1,6),enil1(ii),ii=1,jj)
 8050 continue
c==================================================
      nstart=numcri+norigin
      if (nant(1).ne.0) nstart=nstart+1
c==================================================
c  calcola il numero di  simboli da considerare
      nsymb =icont(2)-3
      if(iprin.eq.2) write(lo,7060)icont,nsymb
 7060 format(///,'  icont =',3i6,' nsymb =',i6)
      nral = 0
      ns = 0
      mark = 0
      jj = 0
      ifsal = 0
c        count number of general and special reflexions in starting set
      do 200 i=1,numbPhase
      if(iz(i) + 1) 115 , 150 , 120
c        eliminated reflexions
115   iz(i) = 0
      go to  200
120   iwt = mod(iz(i),1000)
c        iwt .le. 100  known reflexions
      if(iwt-100) 170 , 170 , 130
c        origin fixing reflexion - does it also fix enantiomorph
130   if(iabs(nant(1)).eq.i)  ns = ns + 1
      go to  170
c        starting set reflexion
150   if(mkang(i).eq.1)  go to  160
      iz(i) = -15000*(mod(mkang(i)-1,12)) - 360000
      ns = ns + 1
      if(mark.eq.0) mark = i
      go to  170
160   nral = nral + 1
170   jj = jj + 1
      kline(jj) = i
200   continue
      if(nant(2).gt.0) ns = ns + 1
      if(nant(3).gt.0) ns = ns + 1
c     iy=67543
      nsx=maxtri
      nral=maxtri

265   nuset = 0
      nsxx=nsx
      nsacc=0
      ksacc=0
      jseteq=0
      jumpp=0
      nfom0=0
      write(lo,271) numcri,nsxx
  271 format( 11x,'          the number of random phases is',i5,/,
     *        11x,'      the total number of trials will be',i5)
      if(mxsac.eq.300) mxsac=nsxx
      mxsac=min0(mxsac,300)



c ---
      n=0
      icenti=icent
*gl*  call xfl01     !!gl
*gl*  call yfl02     !!gl
*gl*  call yfl03     !!gl
      icent=icenti
      if (jproc.eq.0) iy=67543
c
c----------------
c      jout=0      shelx standard
c      jout=1      crystals standard
c      jout=2      dmlsq
       jout=0
c
c----------------
c
c ---
      coms=-0.1
      coms_best=-0.1
      nuset_best=1
      if(nsxx.lt.mxsac) mxsac=nsxx
      if(mxsac.le.nsxx) write(lo,274) mxsac
  274 format(10x,'the maximum number of sets stored will be ',i4)

      write(strLog,'(30h Number of trials for phasing:,
     *  i5,2x,1h(,i3,17h will be stored ))')nsxx,mxsac
      if (kscreen > 0) then
       call TestoGR(strLog, -1, 2, 2)
       call zflush
       call DoSingleIteration()
       nLinesGRTrial = nLinesGR
      endif


      lung=mxsac+2*knw*lasts
*gl*  call nfrm16(numbPhase,lung)
      call ManageInitialPhases(1, numbPhase, lung)
*gl*  call ysfl16(cfom,ipos,idum)
      call LoadInitialPhases(cfom, ipos, idum)
c
290   nuset = nuset + 1
      if (coms.gt.fobmin) goto 397
      do 300 i=1,numbPhase
      control(i)=1.0
  300 iphaz(i) = 0
      if(nuset.le.nsx.and.jall.eq.1) write(lo,310) nuset,(kline(i),
     1 i=1,jj)
  310 format(/5x,'trial no.',i4,3x,'starting set phases',3x,20i4/,
     1 12(41x,20i4,/))
    
      xp=0.0  ! dritan
      call weipha(mark,xp,dx,ngenRefl,par)
c  routine definizione set di fasi mediante randu
      if (jcran.eq.1) then
         if (knw==1)write(lo,*) ' iy= ',iy
         maxtri=maxtri-1
         if (maxtri.lt.0) then
             mark=0
         else
            ix=iy
           do 315 i=4,icont(2)-1
               k=kdstor(i)
               if (k.eq.0) go to 316
                  call randu1(ix,iy,yfl)
                  ix=iy
                  iphi=nint(yfl*360.0)
                  if(iabs(mkang(k)).eq.1) go to 314
                  idv = 15*mod(iabs(mkang(k))-1,12)
                  id1 = iabs(idv-iphi)
                  id2 = iabs(idv+180-iphi)
                  id1=min0(id1,360-id1)
                  id2=min0(id2,360-id2)
                  if (id1.lt.id2) then
                     iphi=idv
                  else
                     iphi=idv+180
                  endif
  314            iphi=mod(iphi,360)
                 iphaz(k)=iphi
  315            continue
  316            continue
         endif
*gl*  call pre06
      call UpdateReflInfo
      endif
      if (nsymb.eq.0.and.nuset.eq.1) goto 390
      if (mark.eq.0) go to 400

*---scegliere i riflessi da fasare all'inizio  (50% in funzione di delta)
  390 continue   

      call weitan(ilist,nuset,ifsal,jplot,
     1  ns1mx,sogs2,sigm,mxsaco,nsacc,nena)

      go to 290

  397 write(lo,398) fobmin
  398 format(//,' a set with  cfom greater than',f6.3,' has been found.'
     1      ,//,' the multisolution procedure has been stopped.',//)
      if (nuset.le.mxsac) mxsac=nuset-1-jseteq
  400 continue
      if ((nuset-1-jseteq).lt.mxsac) mxsac=nuset-1-jseteq
      if (ksacc.lt.mxsac) mxsac=ksacc
  403 jumpp=1
      if(knw.eq.0) goto 408
      do 405 i=1,numbPhase
      wt(i)=1.0
      if(ifsal.eq.0) wt(i)=100.
      li=limref(i)+1
      ls=limref(i+1)
      if(li.gt.ls)wt(i)=0.0
      if(ipub(i).eq.0) ipub(i)=360
  405 iphaz(i) = ipub(i)
      if(ifsal.eq.0) then
         mxsac=mxsac+2
      endif
      call weitan(ilist,nuset,ifsal,jplot,
     1  ns1mx,sogs2,sigm,mxsaco,nsacc,nena)
c
      if(ifsal.ne.0) goto 6200
      ifsal = 1
      nuset = nuset + 1
      go to 403
  408 nuset = nuset -1
c ---
 6200 if (knw.eq.1) then
         nsacc=nsacc-2
         mxsac=mxsac-2
      endif
      if (ksacc.lt.mxsac) mxsac=ksacc
      noset=min0(nsacc,mxsac)
c ---
 9014 continue
      if (nfom0.ne.0) write(lo,9020) nfom0
      if (jseteq.ne.0) write(lo,9015) jseteq
 9020 format(7x, 'the number of sets rejected with cfom=0.0 is ',i4)
 9015 format(10x,'the number of equivalent sets rejected is ',i4,//)
      call prtfom(noset,nena,ier)
      return
      end
c----------------------------------------------------------------------
      subroutine prtfom(noset,nena,ier)
      USE General
      USE Riflessi
      USE PhaseData 
      USE PhaseModule

      character*10 seed,cseed,blank10
      common /sup/ ibufr(80,3),bufr(80,2),n,zi,zpi,k,nlist,buf(80),
     *ibuf(80,4),n1,n0,ibu(80,2),bu(80),lcri,
     * nbset
      common /mag/ sqp4,sq2pi,mi(15),ms(15),dx,iyyy

       dimension iph1(500),iph0(20000),iqu1PhPh(20000),
     7 iqu2Ph(20000),
     8 iqu3Ph(20000),nent1(500),nent2(500),nq1(500),nq2(500),nq3(500),
     * iph21(2514),iph22(2514),lim0(300)


      real,  allocatable ::  prvet(:)
      dimension zero(5)
c     equivalence (prvet(1),iprvet(1))
c
      do 10 i=1,5
   10 zero(i)=0.0
      nwro=0
      iploe=0
      inund=0
      blank10='          '
      cseed=blank10
      if (knw.eq.1) noset=noset+2

      idimFOM=noset*16
      allocate (prvet(1:idimFOM),stat=ierr)

c-- transfer fom's values in prtvet to sort them
      k=0
      do 200 i=1,noset

      do 100 j=1,10
      k=k+1
  100 prvet(k)=fomrt(i,j)

      k=k+1
      prvet(k)=psivet(i)
      do 150 j=1,4
      k=k+1
  150 prvet(k)=comb1(j,i)
      k=k+1
c 200 iprvet(k)=i
  200 prvet(k)=i
      jump=-5
      iniz=1
      if (knw.eq.1) then
                      lung=noset-2
                    else
                      lung=noset
                    endif
      istep=16
      call sortz_mem(prvet,iniz,lung,istep,jump)
      k=0
      l=0
      do 300 i=1,noset
      l=l+1
      k=k+5
      cfom(l)=prvet(k)
      k=k+11
c     ipos(l)=iprvet(k)
      ipos(l)=int(prvet(k))
  300 continue
      if (f18mx.lt.0.0) then
                          ier=-1   
                          write (lo,630) (zero(i),i=1,5),
     *                                   (zero(i),i=1,5)
                        else
                          write (lo,630) f1mn,f15mn,f14mn,f16mn,
     *                                   f17mn,f5mn,f18mn,
     *                                   f1mx,f15mx,f14mx,f16mx,
     *                                   f17mx,f5mx,f18mx
                        endif
  630 format(/// 22x,'+++++++++++++  Figures  Of  Merit  ++++++++++++'
     * ,//20x,'  mabs  alcomb  psicom  R(x,y)  cphase  cquart    cfom'
     * ,/11x,'min    ',7f8.3,/,11x,'max    ',7f8.3)
      if (knw.eq.0) then 
                      write(lo,635)
                    else
                      write(lo,636)
                    endif
  635 format(///1h ,'set  (trial)',3x,'  mabs   alcomb  psicom',
     * 2x,'R(x,y)  cphase     cfom',3x,'nundet',/)
  636 format(///1h ,'set  (trial)',3x,'  mabs   alcomb  psicom',
     * 2x,'R(x,y)  cphase     cfom',3x,'nundet',
     * 4x,'error1 (w-erro1)    error2 (w-error2)',/)
 9014 continue
      k=0
      do 690 i=1,noset
      jj=i
      inuk=0
      if(prvet(k+6).ge.numbPhase/2) then
                                 inund=inund+1
                                 inuk=1
                                 do 680 kk=k+1,k+6
  680                            prvet(kk)=zero(1)
                               endif 
      nund=int(prvet(k+6))
      itrial=nint(prvet(k+10))
      seed=blank10
      psicom=prvet(k+11)

      if (knw.eq.1) then
          write(lo,"(3(' ',f5.2))")(shif(ipos(jj),idri),idri=1,3)
      endif

      !write(lo,*)(prvet(k+idr),idr=12,15)

      if(knw.eq.0)write(lo,650)jj,itrial,(prvet(kk),kk=k+1,k+2),
     *                         psicom,(prvet(kk),kk=k+3,k+4),
     *                         prvet(k+5),nund
      if(knw.eq.1)write(lo,650)jj,itrial,(prvet(kk),kk=k+1,k+2),
     *                         psicom,(prvet(kk),kk=k+3,k+4),
     *                         prvet(k+5),nund,
     *                         error1(ipos(jj),1),error1(ipos(jj),2),
     *                         error2(ipos(jj),1),error2(ipos(jj),2)
      enan=prvet(k+9)
      if( abs(enan) .lt. 0.0001 ) enan=99.0
      if(enan.lt.30.0.and.nena.ge.70) then
         iploe=1
         if(knw.eq.1) then
            write (lo,638) enan
         else
            write (lo,639) enan
         endif
      endif
      if (inuk.eq.1) then
                       nwro=nwro+1
                       if(knw.eq.1) then
                                      write (lo,648)
                                    else
                                      write (lo,649)
                                    endif
                     endif
  638 format(1h+,102x,f4.1,' (*)')
  639 format(1h+, 82x,f4.1,' (*)')
  648 format(1h+,102x,'(**)')
  649 format(1h+,82x,'(**)')
  650 format(1h ,i3,'  (',i5,')',2x,6f8.3,2x,i4,1x,4f10.2)
      k=k+istep
  690 continue
      if (nwro.eq.lung) ier=-1
      if (iploe.gt.0) then
          write(lo,700)
      endif
      if (inund.gt.0) then
          write(lo,710)
          if (ier.eq.-1) write(lo,720)
      endif
  700 format(//,12x,'(*)   ***  warning  ***   possible loss of enantiom
     *orph. The written figure is the average value',/,38x,
     *'of the enantiomorph sensitive triplet and quartet phase values.'
     *,//)
  710 format(//,11x,'(**)  ***  warning  ***   the number of',
     *   ' undetermined phases is too hight',//)
  720 format(//,11x,'      ***   error   ***   all sets',
     *   ' have undetermined phases. Sir stops',//)

      lung=lung+2*knw*lasts
*gl*  call ysup16(cfom,ipos,lung)
      call UpdateInitialPhases(cfom, ipos, lung)
      if (ier.eq.-1) then
          call Cancella(15)
          call Cancella(16)
      endif
      deallocate (prvet,stat=ierr)
      return
      end
c --------------------------------------------------------------------
      subroutine weitan(ilist,nuset,ifsal,jplot,
     1 ns1mx,sogs2,sigm,mxsaco,nsacc,nena)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule
c
      common /unp/ hmax,kmax,lmax,iplan,irang,iplan2
      common /tables/ stable(500)
      common /cris/ numcri,jcran,maxtri,nstart,muset
      common/conue/ shi(4)
      integer nile(120),ichdv(3)
      integer hmax
      dimension enil1(4)
      dimension ctable(500),linex(20),enix(20),ifa(3)
      character tirang(2)*11, ichdvc*3
      equivalence (stable(91),ctable(1))
      data ichdvc /' *+'/
c+++++++++++ segnala  nel vettore  irefin() i riflessi con fase nota
c+++++++  considera i riflessi origine ed i simboli
c
      read(ichdvc,'(3a1)') ichdv(1:3) 
      subtr=0.0
      inord=0
      soglow=0.5
      sogalf=10.0
      numb85=nint(0.85*numbPhase)
      zer=0.1e-10
      numb2=0.0
      do 1550 i=1,numbPhase
c        wtt1(i)=0.0
         segni1(i)=0.0
         irefin(i)=0.
         alpha(i)=0.
         ianto(i)=0
         rho1=rhov(i)
         if (ifsal.ne.0) then
           ianto(i)=1
         endif
 1550 continue
      if (ifsal.ne.0)  goto 6000
      if (jcran.eq.1) then
          do 60 i=1,3
            jj=kdstor(i)
            if (jj.ne.0) ianto(jj)=1
   60     continue
          if (nant(1).ne.0) ianto(iabs(nant(1)))=1
      endif
      if(knw.eq.0) goto 100
      if (nant(1).eq.0) go to 90
      ns=iabs(nant(1))
      if(ipub(ns).gt.180) iphaz(ns)=iphaz(ns)+180
      iphaz(ns)=ipub(ns)
   90 if (norigin.eq.0) go to 100
      do 10000 i=1,3
        jj=kdstor(i)
        if(jj.eq.0) goto 100
10000 iphaz(jj)=ipub(jj)
  100 continue
      if (jcran.ne.1) then
      else
c===============================================================
c     questa parte serve a (non) fissare origine etc.
c     ponendo irefin   =   ( 0 )    1
          if (norigin.ne.0) then
             do 608 i=1,3
                jj=kdstor(i)
                if(jj.ne.0) irefin(jj)=1
  608        continue
          endif
      endif
c===============================================================
      if (nant(1).ne.0) irefin(iabs(nant(1)))=1
      if (knw.ne.0.and.jplot.ne.0) then
         do 2430 i = 1,13
 2430    nile(i) = (i-1)*10
         write(lo,2450) (nile(i),i=1,13)
      endif
 2450 format(/1x,13i10/' cyc(nrfl)',12('i    .    '),'i')
      ncycl = 0
      do 610 i=1,numbPhase
c       iorde(i)=i
        if(jcran.eq.1.and.wt(i).le.1.00) go to 610
        alpha(i)=abs(wt(i))
        wt(i)=bes(alpha(i))*sign(1.0,wt(i))
  610 continue
      ifin=0
      salf=0.
      if (jcran.eq.1) then
         alpham=200000
CCC      nnn=nstart
         nnn=numbPhase
      else
         alpham = 25.
         alphsav = 25.
         nnn= min0(100,numbPhase)
      endif
      if (muset.eq.nuset) write(lo,1318)
c     if (nuset.eq.2) write(lo,1318)
     *   (iorde(i),ipub(iorde(i)),iphaz(iorde(i)),wt(iorde(i)),
     *    irefin(iorde(i)),
     *    i=1,nstart)
 1318 format(4(i5,1h),2i4,' ',f5.2,i2,4x))
      if (jall.eq.0) goto  2990
      j=0
      do  650 i=1,numbPhase
      if (iz(i) .eq. 0) go to  650
      j = j + 1
      linex(j) = iphaz(i)
      enix(j) = wt(i)
      if (j .lt. 20) go to  650
      write(lo,1320) (linex(k),k=1,j)
 1320 format(41x,20i4)
      write(lo,1325) (enix(k),k=1,j)
 1325 format(41x,20f5.2)
      j = 0
  650 continue
      if(j .gt. 0) write(lo,1320) (linex(k),k=1,j)
      if(j .gt. 0) write(lo,1325) (enix(k),k=1,j)
 2990 ncycl = ncycl + 1

      alphmax=0.0
      sumalf= salf
      salf  = 0.0
      numb1 = 0
      error = 0.0
      dalfa = 0.0
      tom   = 0.0
      jcon=0

      do 3500 ll= 1,nnn
      k=iorde(ll)
      if(k.lt.0) go to 3500
      if((ifin.eq.0).and.(irefin(k).ne.0) ) go to 3500
      alfmed=0.0
      varian=0.0
      jcon=jcon+1
      li=limref(k)+1
      ls=limref(k+1)
      if(li.gt.ls) go to 3500
      cang=0.
      sang=0.
      cangb=0.
      sangb=0.
      can=0.
      san=0.
      jcris=0
      do 3400 jj= li,ls
      ind=nbinv(jj)
      iphind=iph(ind)
      iphnd1=iph(ind+1)
      numi=0
      w=1
      ip=0
      nn(2)=0
      ifa(2)=0
      nn(3)=0
      ifa(3)=0
      iw=2
      ir=iphind/131072-2048
      ira=iabs(ir)
      if(ira.eq.k) goto 3021
      if(abs(wt(ira)).lt.0.1) goto 3400
      numi=numi+1
      nn(numi)=ir
      w=w*wt(ira)
      ifa(numi)=iphaz(ira)
      goto 3022
 3021 isi=isign(1,ir)
 3022 ir=mod(iphind,131072)/32-2048
      ira=iabs(ir)
      if(ira.eq.k) goto 3018
      if(abs(wt(ira)).lt.0.1) goto 3400
      numi=numi+1
      nn(numi)=ir
      w=w*wt(ira)
      ifa(numi)=iphaz(ira)
      goto 3019
 3018 isi=isign(1,ir)
 3019 ir=iphnd1/131072-2048
      ira=iabs(ir)
c     if(ira.ge.700) goto 3017
      if(ira.eq.k) goto 3016
      if(abs(wt(ira)).lt.0.1) goto 3400
      numi=numi+1
      nn(numi)=ir
      w=w*wt(ira)
      ifa(numi)=iphaz(ira)
      goto 3017
 3016 isi=isign(1,ir)
 3017 ifaz=mod(iphnd1,32)-1
 3030 nn(1)=-nn(1)*isi
      nn(2)=-nn(2)*isi
      ip=isign(ifa(1),nn(1))
      ip=ip+isign(ifa(2),nn(2))
      ifaz=-ifaz*isi
      if(ifaz.lt.0) ifaz=ifaz+24
      aa1=abs(w)
      nn2=iabs(nn(1))
      nn3=iabs(nn(2))
      a1=(mod(iphnd1,131072)/32-2048)*0.01
      if(a1.gt.6.) a1=6.0
      if(a1.lt.-6.) a1=-6.0
      jcris=jcris+1
      ip=ip+15*ifaz+36000
      ip= mod(ip,360)+1
      gbes=abs(a1)
      a1=bes(gbes)
      aa1=aa1*abs(a1)
      ee=besinv(aa1)
      sang=sang+ee*stable(ip)
      cang=cang+ee*ctable(ip)
      san=san+gbes*stable(ip)
      can=can+gbes*ctable(ip)
      alfmed=alfmed+gbes*a1
      d1=bes(gbes)
      ee=gbes
      d2=1-(2./ee)*d1
      costa=1+d2-2.*(d1*d1)
      varian=varian+gbes*gbes*costa
 3400 continue


c
c-- introduce psi-zero in tangent formula
c
      if (nnn.eq.numbPhase) then
        call newpsi(nuset,k,san,can,sang,cang,sangb,cangb,
     *              subtr,nn0,tnd,alpham)
        subtr=0.0
      endif
      if(mkang(k).eq.1) go to 3418
      idv = 15*mod(iabs(mkang(k))-1,12) + 1
      t2 = sang*stable(idv) + cang*ctable(idv)
      sang = t2*stable(idv)
      cang = t2*ctable(idv)
      t2 = san*stable(idv) + can*ctable(idv)
      san = t2*stable(idv)
      can = t2*ctable(idv)
c
 3418 if(abs(sang).lt.zer.and.abs(cang).lt.zer) go to 3500
      if(abs(san).lt.zer.and.abs(can).lt.zer) go to 3500
      alfa = sang*sang + cang*cang
      if(alfa.lt.zer) goto 3500
c
      alfsp = san*san + can*can
      alpha(k)=alfa
      aiu=sqrt(alfsp)
      phaz=rtod*atan2(sang,cang)
      ip=phaz+sign(0.5,phaz)
      ip=mod(ip+3600,360)
      if(ip.eq.0) ip=360
      iphaze=ip
      wh=1.
      expo=1.
      alfmed=abs(alfmed)
    
      if(alpha(k).gt.alphmax) alphmax=alpha(k)
      if(alpha(k).lt.alpham) go to 3500
      aiuto=sqrt(alpha(k))
      if(alpha(k).lt.alpham) go to 3500
      wt(k)=bes(aiuto)
      ianto(k)=1
      iphaz(k)=iphaze
      if (nuset.eq.muset) then
c     if (nuset.eq.2) then
         delta1=float(iphaz(k)-ipub(k)) * dtor
         delta1=atan2(sin(delta1),cos(delta1))
         kdiff=nint(delta1*rtod+3600)
         kdiff=mod(kdiff,360)
         if (kdiff.gt.180) kdiff=360-kdiff
         varsq=sqrt(varian)
         soglia=sqrt(alpham)
         sqalfa=sqrt(alfa)
         sqalfk=sqrt(alpha(k))
         write(lo,3457) k,jcris,ipub(k),iphaz(k),kdiff,sqalfa,aiu,
     *                  alfmed,varsq,wh,aiuto,wt(k),soglia,sqalfk
c        stop
 3457 format(' code,jcris =',2i4,' fasi ',3i4,
     * ' ',4f9.2,f9.4,4f9.2)
         write(lo,3458) varian
 3458 format(13x,16x,6x,12x,9x,' ',7f9.2)
      endif
      numb1=numb1+1
      salf=salf+alpha(k)
      if (knw.ne.0) then
         snn = sqrt(alpha(k))
         tom = tom + snn
         icb = iabs(iphaz(k)-ipub(k))
         icb = min0(icb,360-icb)
         css = icb
         error = error + css
         dalfa = dalfa + snn*css
      endif
 3500 continue
      if (nnn.eq.numbPhase) then
          ipr=0
          call newpsi4(nuset,ipr)
      endif
      if (numb1.gt.0) error = error/float(numb1)
      if (tom.gt.0.0001) dalfa = dalfa/tom
      if (knw.ne.0.and.jplot.ne.0) then
         do 3503 k = 1,120
 3503       nile(k) = ichdv(1)
         ip = error+0.5
         if (ip.le.0) ip = 1
         if (ip.gt.120) ip = 120
         nile(ip) = ichdv(2)
         ip = dalfa+0.5
         if(ip.le.0) ip = 1
         if(ip.gt.120) ip = 120
         nile(ip) = ichdv(3)
         write(lo,3505) ncycl,numb1,nile
      endif
3505  format(1x,i3,' (',i3,')-',120a1)
      if (nuset.eq.muset) then
c       error=min(errm1,errm2)
c       dalfa=min(errmpes1,errmpes2)
        soglia=sqrt(alpham)
        soglix=sqrt(alphmax)
        write(lo,9000) ncycl,nnn,soglia,error,dalfa,numb1,soglix
      endif
 9000 format(' ncycl=',i5,' nnn=',i5,' alpham=',f8.3,' error=',f8.3,
     1  ' w-error=',f8.3,' det.phases=',i7,' max alfa=',f10.3)
c
      if (jcran.eq.1.and.ncycl.eq.1) then
         alpham=alphmax
         alphsav=alphmax
      endif
      cut= 0.65 * alpham
      alpham=amax1(cut,0.05)
      if (ifin.eq.1) go to 3525
      if (jcran.ne.0) then
          if (alpham.gt.soglow.and.nnn.ne.numbPhase) go to 2990
      endif
      if (alpham.gt.1.5) go to 2990
      if(nnn-numbPhase) 3520,3524,3520
 3520 nnn=numbPhase
c
      ipr=0
      call newpsi4(nuset,ipr)
c
c===============================================================
c               questa parte serve a (non) fissare origine etc.
c               ponendo irefin   =   ( 0 )    1
c
      if (jcran.eq.1) then
          do 3523 i=1,3
             jj=kdstor(i)
             if(jj.ne.0) irefin(jj)=0
 3523     continue
          if(nant(1).ne.0) irefin(iabs(nant(1)))=0
          do 3527 i=1,numbPhase
             wt(i)=wt(i)*ianto(i)
             iphaz(i)=iphaz(i)*ianto(i)
             ianto(i)=0
 3527     continue
      endif
c=======================================================
CCC   alpham=25.
      alpham=alphsav
      go to 2990
 3524 continue
c  considero tutti i riflessi e faccio il controllo su sumalf
 3525 if (salf.le.0.0001) go to 9001
      if((salf-sumalf)/salf-0.02) 9001,9001,2990
 9001 if(ifin.eq.1) go to 3530
      do 3528 ll=1,numbPhase
         if(abs(wt(ll)).lt.0.1) go to 3528
         if(irefin(ll).ne.0) go to 3526
         irefin(ll)=1
         go to 3528
 3526    irefin(ll)=2
 3528 continue
      ifin=1
      go to 2990
c   fine loop per raffinamento tangente
3530  continue
c ---     calcolo  absfom , resid  ed error
 6000 continue
      if (nuset.eq.muset)
     *   write(lo,3434) (k,ipub(k),iphaz(k),wt(k),irefin(k),
     *   ianto(k),sqrt(alpha(k)),k=1,numbPhase)
 3434 format(4(i4,1h),2i5,f8.2,2i2,f8.2,4x))
*-------------------------------------------------------------------------
*------eliminare dalle f.o.m's i riflessi con alpha piu basso.
      if (ifsal.eq.0) then
          do i=1,numbPhase
             wt(i)=wt(i)*ianto(i)
             alpha(i)=alpha(i)*ianto(i)
             iphaz(i)=iphaz(i)*ianto(i)
          enddo
      endif
*-------------------------------------------------------------------------
 3537 call absnew(nuset,sigm)
      if (knw.eq.1) then
         call esamin(khl,mkang,ipub,iphaz,numbPhase,1,wtt1,wt,
     *               error,errpes,nref1,shi)
      endif

 3540 call fomsp(nuset,ns1mx,sogs2,sigm,
     * mxsaco,nsacc,nena,shi)


      if (knw.eq.1.and.jall.eq.1) 
     *   write(lo,3590) nuset,error,errpes,nundet
 3590 format(1h0,4x,'trial no.',i4,3x,'error =',f7.2,' weighted error ='
     1 ,f7.2,' undetermined phases =',i4//)
      if (knw.eq.0.and.jall.eq.1)
     * write(lo,3595) nuset,nundet
 3595 format(1h0,4x,'trial no.',i4,3x,' undetermined phases =',i4//)
      if(ilist.eq.0) goto 5050
      if(nset.eq.0) goto 3620
      do 3600 jcris=1,nset
      if(nuset.eq.isetPhase(jcris)) goto 3620
 3600 continue
      goto 5050
 3620 continue
      write(lo,4956)
4956  format(' ',4('   code    h   k  l  phi alpha'))
      jj=0
      do 5040 ll= 1 ,numbPhase
      jj=jj+1
      line(jj,1)=ll
      line(jj,2:4)=khl(1:3,ll)
      line(jj,5)=iphaz(ll)
      enil1(jj)=alpha(ll)
      if(jj.lt.4) goto5040
      write(lo,5005) ((line(i,j),j=1,5),enil1(i),i=1,4)
5005   format(4(i7,3i4,i5,f6.1))
      jj=0
5040  continue
      if (jj.eq.0) go to 5050
      write(lo,5005)((line(ii,ll),ll=1,5),enil1(ii),ii=1,jj)
5050  continue
      return
      end
c ----------------------------------------------------------------------
      subroutine weipha(mark,xp,dx,ngenRefl,par)

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseData
      USE PhaseModule

      dimension linex(20), par(12)
      common /cris/ numcri,jcran,maxtri,nstart,muset
c     * * * * * * * * * * * * * * * * ** * * * * * * * * * * * * * * * *
      nan = iabs(nant(1))
 1000 mark = 0
c     generate next set of phases for starting point
      if (nral .eq. 1) go to 1010
      xp = xp - dx
      if (xp.gt.(-720.1)) goto 1006
      xp = xp + 360.0
      go to 1010
 1006 mark = 1
 1010 do 1200 i=1,numbPhase
      izt = iabs(iz(i))
      if (iz(i)) 1100,1020,1040
c     unknown phase
 1020 wt(i) = 0.0
      iphaz(i)=0
      go to 1200
c     origin fixing or known phase
 1040 iwt=iz(i)-1000*(iz(i)/1000)
      if (iwt.lt.100) goto 1060
c   riflessi  per  origine
      wt(i) = 100.
      goto 1180
 1060 wt(i)=besinv(float(iwt))
      go to 1180
c     has starting set phase been incremented
 1100 if (mark) 1170,1120,1170
 1120 if (mkang(i).eq.1) go to 1170
      iz(i) = iz(i) - 180000
      if(iz(i)+720000) 1140,1140,1160
 1140 iz(i)=iz(i)+360000
      go to 1170
 1160 mark = 1
 1170 if(mkang(i).ne.1) go to 1175

      wt(i)=0.80
      iphaz(i) = amod((float(iz(i))*xp), 360.0) + 0.5
      go to 1190
c    simbolo speciale  wt = 5.5
 1175 continue
      wt(i)=0.25
CDRI  wt(i)=0.80
 1180 iphaz(i) = mod(iabs(iz(i)/1000), 360)
 1190 if (iphaz(i) .eq. 0) iphaz(i) = 360
c    simboli wt = 5.0
 1200 continue
      if (jcran.eq.1) goto 1220
 1220 if (mark) 1230,1230,1270
 1230 if (icent.eq.1) go to 1360
      j=2+icent
      do 1240 i=j,4
      if (nant(i)) 1240,1360,1250
 1240 continue
      go to 1360
 1250 do 1260 k=j,i
      nant(k) = -nant(k)
      n1 = iabs(nant(k))
      iz(n1) = -(iz(n1) - 200) + 360200
      iphaz(n1) = mod(iabs(iz(n1)/1000), 360)
 1260 continue
      mark = 1
c     output starting point
 1270 if (jall.eq.0) goto 1360
      j=0
      do 1340 i=1,numbPhase
      if (iz(i) .eq. 0) go to 1340
      j = j + 1
      linex(j) = iphaz(i)
      if (j .lt. 20) go to 1340
      write(lo,1320) (linex(k),k=1,j)
 1320 format(41x,20i4)
      j = 0
 1340 continue
      if(j .gt. 0) write(lo,1320) (linex(k),k=1,j)
 1360 return
      end
c -------------------------------------------------------------------
      subroutine vonmis(g,iteta,iy)
c  -----  following statements are data generale specific
cdg   real*8 random,uu1,uu2,uu3
c  -----
c
c ---  generatore di numeri random secondo vonmises
c
      dpi=8*atan(1.)
      pi=4*atan(1.)
      rtod=360./dpi
      tau=1.+4*g*g
      tau=1.+sqrt(tau)
      ro=(tau-sqrt(2*tau))/(2*g)
      r=(1+ro*ro)/(2*ro)
      call i0(g,ris)
      an=dpi*ris
      amin=exp(-g)/an+0.0001
      amax=exp(g)/an-0.0001
   40 continue
      ix=iy
      call randu1(ix,iy,u1)
      ix=iy
      call randu1(ix,iy,u2)
      ix=iy
      call randu1(ix,iy,u3)
c  -----  following statements are data generale specific
cdg   uu1=random(iy)
cdg   u1=sngl(uu1)
cdg   uu2=random(iy)
cdg   u2=sngl(uu2)
cdg   uu3=random(iy)
cdg   u3=sngl(uu3)
c  -----
      z=cos(pi*u1)
      f=(1+r*z)/(r+z)
      c=g*(r-f)
      if(c*(2-c)-u2.gt.0)goto 45
      if(alog(c/u2)+1-c.lt.0) goto 40
45    teta=sign(1.,u3-0.5)*acos(f)
      iteta=rtod*teta
      return
      end
c ----------------------------------------------------------------
!       subroutine i0(x,ri0)       ! SPOSTATA in util2006.f
! c ---
! c ---        compute the modified bessel function i of order zero
! c---
!       ri0=abs(x)
!       if(ri0-3.75)1,1,2
!     1 z=x*x*7.111111e-2
!       ri0=((((( 4.5813e-3*z+3.60768e-2)*z+2.659732e-1)*z+1.206749e0)*z
!      1+3.089942e0)*z+3.515623e0)*z+1.
!       return
!     2 z=3.75/ri0
!       ri0= exp(ri0)/sqrt(ri0)*((((((((3.92377e-3*z-1.647633e-2)*z
!      1+2.635537e-2)*z-2.057706e-2)*z+9.16281e-3)*z-1.57565e-3)*z
!      2+2.25319e-3)*z+1.328592e-2)*z+3.989423e-1)
!       return
!       end
c-----------------------------------------------------------------------
      subroutine dirpha (nlist,nsymb,gqmin,sogs2,ns1mx,inpori,
     * inpena,inpfas,igin,ipigin,iperm,inperm,nspec,
     * ilist,jplot,rag,iy,nusx,
     * ier,jrej)

      USE General
      USE Symmetry
      USE PhaseModule

      character line*80,dire*40,diret*80
      character Numdigit*13
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /cifre/ Numdigit
c
      common /mag/ sqp4,sq2pi,mi(15),ms(15),dx,iyyy
      common /cris/ numcri,jcran,maxtri,nstart,muset
      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *          alphap(6000),ktheta(6000),a0est(6000),a0var(6000)
c
      common /origins/nox,noy,noz
      integer igin(3),ipigin(3),inperm(12)
      dimension vet(40),ivet(40)


*gl*  call xfl06
      call LoadReflInfo
      numbPhase=nstr
c -----
c-- set default values

      iynew=0
      iydef = -1
      dx=0
      icum=0
      knewpsi=1
      nneg=1
      nngq=0
      jproc=0
      jrej=1
      muset=-1
      jcran=1
      maxtri=100
      numcri=numbPhase-4
      nqq=0
      iwrit=0
      nlist=0
      gqmin=99.
      sogs2=0.
      ns1mx=3
      lasts=0
      if (knw.eq.1) lasts=1
      iprin=0
      inpori=0
      inpena=0
      inpfas=0
      iperm=0
      nspec=0
      norig=0
      jtabl=0
      nusx=100
      rag=1.4
cdri  fobmin=0.95
      fobmin=1.0
      do 5 i=1,3
      igin(i)=0
    5 ipigin(i)=0
c--
      ilist=0
      jall =0
      jplot=0
      nset=0
      cutpa=0.05
      gminpa=4.0
      do 7 jcris=1,20
    7 isetPhase(jcris)=0

      nsymb=5
      mxsac=10
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:3).eq.'end') go to 100
      if (dire(1:4).eq.'seed')  then
          if (iv.ne.1) go to 8000
          iynew = ivet(1)
          jproc=1
          go to 100
          endif
      if (dire(1:4).eq.'nops')  then
          knewpsi=0
          go to 100
          endif
      if (dire(1:4).eq.'nneg')  then
          nneg=0
          go to 100
          endif
      if (dire(1:4).eq.'proc')  then
          jproc=1
          go to 100
          endif
      if (dire(1:3).eq.'set')  then
          if (iv.ne.1) go to 8000
          muset=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'maxt')  then
          if (iv.eq.0) go to 8000
          maxtri=ivet(1)
          if (maxtri < 0 ) maxtri= 60
          if (iv > 1) then
             mxsac=ivet(2)
             if (mxsac < 0 ) mxsac= 60
          endif
          go to 100
          endif
      if (dire(1:4).eq.'nqua') then
          if (iv.ne.0) go to 8000
          nqq=-1
          go to 100
          endif
      if (dire(1:4).eq.'rand') then
          if (iv.gt.1) go to 8000
          if (iv.eq.1.and.ivet(1).gt.0) numcri=ivet(1)
          if (numcri.gt.numbPhase-4) numcri=numbPhase-4
          jcran=1
          go to 100
          endif
      if (dire(1:4).eq.'orig') then
          if (iv.eq.0) go to 8000
          if (mod(iv,2).ne.0) go to 8000
          inpori=1
          norig=iv/2
          do 110 i=1,norig
          j2=i*2
          j1=j2-1
          igin  (i)=ivet(j1)
  110     ipigin(i)=ivet(j2)
          go to 100
          endif
      if (dire(1:4).eq.'list') then
          if (iv.ne.1) go to 8000
          nlist=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'writ') then
          if (iv.ne.1) go to 8000
          iwrit=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'symb') then
          if (iv.ne.1) go to 8000
          nsymb=ivet(1)
          if (nsymb.gt.12) go to 8000
          go to 100
          endif
      if (dire(1:4).eq.'quar') then
          if (iv.ne.1) go to 8000
          gqmin=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'twop') then
          if (iv.ne.1) go to 8000
          sogs2=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'onep') then
          if (iv.ne.1) go to 8000
          ns1mx=vet(1)
          if (ns1mx.lt.0) go to 8000
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'enan') then
          if (iv.ne.1) go to 8000
          inpena=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'spec') then
          if (iv.ne.1) go to 8000
          nspec=ivet(1)
          if (nspec.gt.12) go to 8000
          go to 100
          endif
      if (dire(1:4).eq.'tria') then
          if (iv.eq.0) go to 8000
          nset=min0(iv,20)
          do 140 i=1,nset
  140     isetPhase(i)=ivet(i)
          go to 100
          endif
      if (dire(1:4).eq.'minf') then
          if (iv.ne.1) go to 8000
          mxsac=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'gmin') then
          if (iv.ne.1) go to 8000
          gminpa=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'cutm') then
          if (iv.ne.1) go to 8000
          cutpa=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'tabl') then
          if (iv.ne.0) go to 8000
          jtabl=1
          go to 100
          endif
      if (dire(1:4).eq.'part') then
          if (iv.ne.0) go to 8000
          jpart=1
          go to 100
          endif
      if (dire(1:4).eq.'plot') then
          if (iv.ne.0) go to 8000
          jplot=1
          go to 100
          endif
      if (dire(1:3).eq.'all') then
          if (iv.ne.0) go to 8000
          jall=1
          go to 100
          endif
      if (dire(1:3).eq.'las') then
          if (iv.ne.0) go to 8000
          lasts=1
          go to 100
          endif
       if (dire(1:4).eq.'cumu')  then
          if (iv.ne.0) go to 8000
          icum=1
          go to 100
          endif
       if (dire(1:4).eq.'nori')  then
          if (iv.ne.3) go to 8000
          nox=ivet(1)
          noy=ivet(2)
          noz=ivet(3)
          go to 100
          endif
      write(lo,6000) diret
 6000 format(' wrong directive on following line:',/a)
      ier=-1
      return
 8000 write(lo, '(22h Error in directive : ,a80)') diret
      ier=-1
      return
 9000 continue
      if (nset.gt.0) ilist=1
      if (jcran.eq.1) then
                        ns1mx=0
                        inpfas=0
                      endif
      if (iynew.gt.0.and.iynew.ne.iydef) then
          iyrand = iynew
*gl*      call pre06
          call UpdateReflInfo
      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine rialfnew(sigmp)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE PhaseModule
      USE ListeXX

c   calcola alfest e alfvar per i rifl. forti e deboli

      dimension vet(12),ivet(12)
      equivalence (vet(1),ivet(1))
ccc
c     print*,jderi
      sigm=sigmp
      sigmq=sigmp*sigmp
      if (jderi.gt.0) s3s2dq=s3s2d(jderi)*s3s2d(jderi)
      q0=0.798
      if (icent.le.0) then
        sigm=2.0*sigmp
        sigmq=2.0*sigmq
        if (jderi.gt.0) then
        s3s2dd=2.0*s3s2d(jderi)
        s3s2dq=2.0*s3s2dq
        endif
        q0=0.886
      endif
      id28=2**30
      ssig  = 0.0
c NEW
      num0=0
      npse=0
c
      salfe=0.0
      seobs=0.0
      salfe0=0.0
      seobs0=0.0
      ckae=1.0
      ckae0=1.0
c NEW
c calcolo alfest e alfvar per i rifl. forti
      do 350 k= 1,numbPhase
      alfvar(k) = 0.0
      alfest(k)=0.0
      li=limref(k)+1
      ls=limref(k+1)
      if(li.gt.ls) go to 350
      do 340 jj= li,ls
      ind=nbinv(jj)
      call depacc(k,ind,a1,ifaz,iw)
      if(nn(2).eq.0) go to 340
      ila=iabs(nn(1))
      ira=iabs(nn(2))
      ita=iabs(nn(3))
      gj=a1 
      if (iw.eq.2) then
                    aj=gj
                   else
                    aj=gj 
                   endif
      seobs=seobs+evet(k)
      if (icent.le.0) go to 300
      if (iw.eq.2) then
                     t2=tanh(gj)
                   else
                     t2=tanh(gj*0.5)
                   endif
      alfest(k)=alfest(k)+aj*t2
      alfvar(k)=alfvar(k)+aj*aj*(1.0-t2*t2)
      go to 340
  300 continue
      t2 = bes(gj)
      if (iw.eq.3) t2=bes(gj)
      alfest(k)=alfest(k)+aj*t2
      alfvar(k) = alfvar(k) + aj * aj * ( 1.0 - t2 * (1.0/gj+t2) )
  340 continue
      alfest(k)=abs(alfest(k))
c     alfvar(k)=4.* abs(alfvar(k))
      alfvar(k)=4.* abs(alfvar(k)) + alfest(k)/5.0
      salfe=salfe+alfest(k)
      ssig  = ssig  + alfvar(k)
      alfvar(k) = sqrt(alfvar(k))
  350 continue
      if(seobs.gt.0.0) ckae=salfe/seobs
c calcolo alfest e alfvar per i rifl. deboli
c
c -----
c     call sub. lettura lista 9 : psizero
c -----
c-- check if list 9 exists
*gl*  iprea=0
*gl*  call srlin (9,lsn,lfw,llw,lpb,ll)
      lfw = InfoOK(9)
      if (lfw > 0) then
*gl*      iDim = 3 * npsi
*gl*      call sflxx(iprea,9,npsi,npsi,num0,nxxe,iccd,1,imat,iDim)
          npsi = NPsiZero
          num0 = NRefZero
          if (npsi > 0) then
          do 25 i=1,npsi
   25     iph0n(i)=Lista09(1,i)
          n=0
          j=1
          do 987 i=1,num0
          llll(i)=0
          alfest0(i)=0.0
          alfvar0(i)=0.0
  987     lim0n(i)=0
          do 1120 i=2,npsi
          iniz=iph0n(i)/id28
          n=n+1
          if(iniz.eq.0) goto 1120
          j=j+1
          lim0n(j)=n
 1120     continue
          j=j + 1
          lim0n(j)=n
c-----------
          n0=nrefc+1
          n0usati=0
          do 360 i=1,num0
          n0=n0-1

          llll(i)=n0

          li=lim0n(i) + 1
          ls=lim0n(i+1)
c         write(6,*)i,n0,li,ls,(ls-li+1),fdelta(jderi,n0)
          if (ls.lt.li ) goto 360
          n0usati=n0usati+1
          do 355 j=li,ls
          iph0n(j)=mod(iph0n(j),id28)
          call unpak3(iph0n(j),k1,k2,ifaz)
          ka1=iabs(k1)
          ka2=iabs(k2)
          aj=s3s2dd*fdelta(jderi,ka1)*fdelta(jderi,ka2)
          alfvar0(i) = alfvar0(i) + aj * aj 
          seobs0=seobs0+evet(n0)
  355     continue
          ssig=ssig+4.5*4.5*alfvar0(i)
c         ssig=ssig+alfvar0(i)
          if (alfvar0(i).lt.0.0) then
             write(6,*)'i alfvar0=',i,alfvar0(i)
             go to 360
          endif
          alfvar0(i)=sqrt(alfvar0(i))
          alfest0(i)=alfvar0(i)*q0
CCC       alfest0(i)=alfvar0(i)*q0/2.0   
          salfe0=salfe0+alfest0(i)
          alfvar0(i)=4.5*alfvar0(i)
  360     continue
          endif
      endif
!
      if (seobs0.gt.0.0) ckae0=salfe0/seobs0
      return
      end
c-----------------------------------------------------------------
      subroutine absnew (nuset,sigm)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE PhaseModule

      common /tables/ stable(500)
      dimension ctable(500),alpha0(500)
c vettore utilizzato per memorizzare il numero di tripletti per riflesso
      dimension ntrr(5000),ntr0(2000),eec(5000),ee0(2000)
      equivalence(stable(91),ctable(1))
c
c NEW inizial. variabili calcolo coeff. di correlaz. (1/8/91)
      seec=0.0
      seeo=0.0
      see0=0.0
      seo0=0.0
      sece=0.0
      seoe=0.0
      scon=0.0
      ecm=0.0
      eom=0.0
      ccorc=0.0
      ccoro=0.0
      scor1=0.0
      scor2=0.0
      scor3=0.0
      rcarl1=0.0
      rcarld1=0.0
c
c    calcolo  absfom , resid  ed error
      q1=0.798
      q4=0.968
      id28=2**30
      error=0.
      errpes=0.
      anum=0.
      nundet=0
      salf=0.0
      salfe=0.0
      salfer=0.0
      dalfa=0.0
      dalf1=0.0
      dalf2=0.0
      dalf3=0.0
      absfom=0.0
      ssigt=ssig
      ssigF=0.0
c
      anumw=0.
      dpsa=0.0
      dps1=0.0
      dps2=0.0
      dps3=0.0
      sigmp=sigm
      if (jderi.gt.0) sigmd=s3s2d(jderi)
      sigmq=sigm*sigm
      sigmdq=sigmd*sigmd
      if (icent.le.0) then
          sigmp=2.0*sigm
          sigmq=2.0*sigmq
          if (jderi.gt.0) sigmd=2.0*sigmd
          sigmq=2.0*sigmdq
       endif

      anume=0.
      dpse=0.0
      dpse1=0.0
      dpse2=0.0
      dpse3=0.0
c
      do 6500 k=1,numbPhase
      ntrr(k)=0
      eec(k)=0.0
      alpha(k)=0.0
c
      li = limref(k) + 1
      ls = limref(k+1)
      if(li.gt.ls) then
                     nundet = nundet + 1
                     go to 6500
                   endif
      if(wt(k).ge.0.1) go to 6100
      nundet = nundet + 1
      iphaz(k)=0
      wt(k)=0.0
      go to 6499
Corig go to 6500
c
 6100 sang = 0.0
      cang = 0.0
      do 6200 jj = li,ls
      ind = nbinv(jj)
      call depacc(k,ind,a1,ifaz,iw)
      gj=abs(a1)
CC    if(iw.ne.2) go to 6200
      if(nn(2).eq.0) go to 6200
      ila = iabs(nn(1))
      ira = iabs(nn(2))
      ita = iabs(nn(3))
      if (iw.eq.2) then
          if(wt(ila).lt.0.1.or.wt(ira).lt.0.1) goto 6200
          ip = isign(iphaz(ila),nn(1)) + isign(iphaz(ira),nn(2))
     *      +  15*ifaz
          a1=gj
      else
       if(wt(ila).lt.0.1 .or. wt(ira).lt.0.1 .or. wt(ita).lt.0.1)then
         goto 6200
       endif
         ip = isign(iphaz(ila),nn(1)) + isign(iphaz(ira),nn(2))
     *      + isign(iphaz(ita),nn(3)) + 15*ifaz
         a1=sigmq*evet(ila)*evet(ira)*evet(ita)
      endif
      ip = mod(ip+36000,360) + 1
      sang = sang + a1 * stable(ip)
      cang = cang + a1 * ctable(ip)
corig ntrr(k)=ntrr(k)+1
 6200 continue
      if(mkang(k).eq.1) go to 6300
      idv = 15*mod(iabs(mkang(k))-1,12) + 1
      t2 = sang*stable(idv) + cang*ctable(idv)
      sang = t2*stable(idv)
      cang = t2*ctable(idv)
 6300 if(abs(sang).lt.0.1e-15) sang=0.0
      if(abs(cang).lt.0.1e-15) cang=0.0
      alpha(k)=sqrt( sang*sang + cang*cang )
corig anum=anum+1.
 6499 anum=anum+1.
      ntrr(k)=ls-li+1
      salf=salf+alpha(k)
      if (wt(k).gt.0.1) salfe=salfe+alfest(k)
      ssigF=ssigF+alfvar(k)**2
      if (knw.gt.0.or.wt(k).gt.0.1) then
           salfer=salfer+alpha(k)
           ip= iabs(ipub(k)-iphaz(k))
           delta=min0 (ip,360-ip)
           error=error+delta
          errpes=errpes+delta*alpha(k)
      endif
 6500 continue
c
c-- indetermined phases number too high
      if(nundet.ge.(numbPhase/2)) return
c
c NEW introduco ciclo sui rifl. deboli
      if(num0.eq.0) go to 7001
      do 7000 k=1,num0
        alpha0(k)=0.0 
        ntr0(k)=0.0
        ee0(k)=0.0
c test per riconoscere i rifl. senza tripl. psi-0
        if(alfest0(k).lt.0.000001.and.alfvar0(k).lt.0.000001) go to 7000
        li=lim0n(k)+1
        ls=lim0n(k+1)
        if(li.gt.ls) go to 7000
        sang = 0.0
        cang = 0.0
        do 7100 j=li,ls
          iph0n(j)=mod(iph0n(j),id28)
          call unpak3(iph0n(j),k1,k2,ifaz)
          ila = iabs(k1)
          ira = iabs(k2)
          if (iphaz(ila).eq.0.or.iphaz(ira).eq.0) goto 7100
          ip = isign(iphaz(ila),k1) + isign(iphaz(ira),k2)
     *      +  15*ifaz
          ip = mod(ip+36000,360) + 1
          a1=sigmd*fdelta(jderi,ila)*fdelta(jderi,ira)
          sang = sang + a1 * stable(ip)
          cang = cang + a1 * ctable(ip)
Corig     ntr0(k)=ntr0(k)+1
 7100   continue
        kk=llll(k)
        if(mkang(kk).eq.1) go to 7300
        idv = 15*mod(iabs(mkang(kk))-1,12) + 1
        t2 = sang*stable(idv) + cang*ctable(idv)
        sang = t2*stable(idv)
        cang = t2*ctable(idv)
 7300   if(abs(sang).lt.0.1e-15) sang=0.0
        if(abs(cang).lt.0.1e-15) cang=0.0
        alpha0(k)=sqrt( sang*sang + cang*cang )
Corig   if (ntr0(k).eq.0) then
Corig      alfless=alfvar0(k)*alfvar0(k)
Corig      ssigt=ssigt-alfless
Corig      go to 7000
Corig   endif
        ntr0(k)=ls-li+1
        anumw=anumw+1.
 7000 continue
 7001 continue
c
c*****************************************************************
      absfom=0.0
      if(salfe.gt.0.0001) absfom = salf / salfe
c----
      do 3580 k=1,numbPhase
      eec(k)=0.0              
      if(ntrr(k).eq.0) go to 3580
corig if (wt(k).le.0.1.or.ntrr(k).eq.0) then
corig    alfless=alfvar(k)*alfvar(k)
corig    ssigt=ssigt-alfless
corig    go to 3580
corig endif 
c
c-- rescaling of alpha
c-- alpha = alfa calcolato per le fom
c-- alfest = alfa stimato dai sumGJ D1(Gj)
c-- alfvar = alfa random
c
      if(ntrr(k).gt.0) eec(k)=alpha(k)/ntrr(k)
      if(absfom.gt.0.0001) alpha(k)=alpha(k)/absfom

      rho1=sqrt(rhov(k))
      dres=0.5/rho1
      if (alpha(k).gt.0.0) then
       wt(k)=bes(0.5*(alpha(k)/2.0+1.5*dres))
       wt(k)=min(1.0,wt(k))
      else
       wt(k)=0.0
      endif

      seec=seec+eec(k)
      seeo=seeo+evet(k)
c
      dalf2=dalf2+(alfest(k)-alpha(k))*(alfest(k)-alpha(k) )
      if (alfvar(k).lt.0.0001) go to 3580
      davi=(alfest(k)-alpha(k))/alfvar(k)
      dalf3 = dalf3 + abs( davi )
      davi=davi*davi
      dalfa=dalfa+davi
      dalf1=dalf1+abs(davi-1.0)
 3580 continue
      if(salfer.gt.0.00001) errpes=errpes/salfer
c
      if(num0.eq.0) go to 3591
      do 3590 k=1,num0
      if(ntr0(k).eq.0) go to 3590
      ee0(k)=alpha0(k)/ntr0(k)
      see0=see0+ee0(k)
      seo0=seo0+evet(llll(k))
c
      dps2 = dps2 + (alfest0(k) - alpha0(k) )*( alfest0(k) - alpha0(k))
      if (alfvar0(k).lt.0.0001) go to 3590
      dpsi=(alfest0(k)-alpha0(k))/alfvar0(k)
      dps3 = dps3 + abs( dpsi )
      dpsi=dpsi*dpsi
      dpsa=dpsa+dpsi
      dps1=dps1+abs(dpsi-1.0)
 3590 continue
 3591 continue
c NEW 11/10/91 : pesaggio delle sommatorie sui rifl.deboli con mabs
      ww0=1.0
      if(absfom.gt.0.0001) ww0=1.0/absfom
      dps3=dps3*ww0
      dpsa=dpsa*ww0
      dps1=dps1*ww0
      dps2=dps2*ww0
c
c*****************************************************************
c NEW calcolo coeffic. di correlaz. tra Ecalc ed Eobs (1/8/'91)
      scon=anum+anumw+anume
      if (scon.gt.0.1) then
          ecm=(seec+see0)/scon
          eom=(seeo+seo0)/scon
      endif
      do 5000 k=1,numbPhase
Corig if(wt(k).le.0.1.or.ntrr(k).eq.0) go to 5000
      if(ntrr(k).eq.0) go to 5000
      ccorc=eec(k)-ecm
      ccoro=evet(k)-eom
      scor1=scor1+ccorc*ccoro
      scor2=scor2+ccorc*ccorc
      scor3=scor3+ccoro*ccoro
      eec(k)=alpha(k)/(ckae*ntrr(k))
      rcarl1=rcarl1+abs(evet(k)-eec(k))
      rcarld1=rcarld1+evet(k)
 5000 continue
      if(num0.eq.0) go to 5100
      do 5050 k=1,num0
      if(ntr0(k).eq.0) go to 5050
      ccorc=ee0(k)-ecm
      ccoro=evet(llll(k))-eom
      scor1=scor1+ccorc*ccoro
      scor2=scor2+ccorc*ccorc
      scor3=scor3+ccoro*ccoro
      ee0(k)=alpha0(k)/(ckae0*ntr0(k))
      rcarl1=rcarl1+abs(evet(llll(k))-ee0(k))
      rcarld1=rcarld1+evet(llll(k))
 5050 continue
 5100 continue
      coeco=-9999
      if((scor2*scor3).gt.0) coeco=scor1/sqrt(scor2*scor3)
      if(rcarld1.gt.0.0) rcarl1=rcarl1/rcarld1
c++++++++++++++++
c calcolo le sommatorie complessive (forti + deboli)
c
      anumt=anum+anumw
      if(anumt.gt.0.1) anumt=1.0/anumt
      if (jderi.eq.0) then
        alfp1=(dalf3+dps3)*anumt
        alfp3=(dalfa+dpsa)*anumt
        alfp4=(dalf1+dps1)*anumt
        alfp2=0.00001
        if(ssigt.gt.0.0001)alfp2=(dalf2+dps2)/ssigt
      else
        alfp1=(dalf3)/anum
        alfp3=(dalfa)/anum
        alfp4=(dalf1)/anum
        alfp2=0.00001
        if(ssigt.gt.0.0001)alfp2=(dalf2)/ssigF
      endif
c
c valori passati alla nuova fomsp comprendenti le vecchie alcom e psicom
      resid  = alfp2 
      almed  = alfp1
      al2    = alfp3 
      al2m1  = alfp4
      if(anum.gt.0.1) anum=1.0/anum
      error  = error * anum
      return
      end
c------------------------------------------------------------------------
      subroutine fomsp(nuset,ns1mx,sogs2,sigmp,
     *         mxsaco,nsacc,nena,shi)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE Grafici
      USE Molcom
      USE PhaseModule
      USE ListeXX

      character*200,strLog
      common /cfomxx/ coms_best,nuset_best
      common /tables/ stable(500)
      common /mag/ sqp4,sq2pi,mi(15),ms(15),dx,iyyy

       dimension iph1(500),iph0(20000),iqu1Ph(20000),iqu2Ph(20000),
     * iqu3Ph(20000),nent1(500),nent2(500),nq1(500),nq2(500),nq3(500),
     * iph21(2514),iph22(2514),lim0(300)
c
**    common /psi0/npsi,num0,alfest0(1000),alfvar0(1000),llll(1000),
**   1 lim0n(1001),iph0n(20000)
      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *          alphap(6000),ktheta(6000),a0est(6000),a0var(6000)

      common/quartet/fomquar(302)
      dimension ctable(500),fig(11),wtj(5000),iphazj(5000),shi(4)
      dimension fig17(11)
      equivalence (stable(91),ctable(1)),(iyzz,fig(11))
c
      ipri0=0
      ww2=0.0
      ntrpos = NSigPos
      ntrneg = NSigNeg
      nen    = NSigEna
c ---
      if(nuset.gt.1) goto 505
c-- initialize number of relationships to zero
      nen=0
      nqen=0
      nquar=0
*?*   ntrneg=0
      ntrpos=0
c ---
c     ....  per absfom
      f1mx=-1.0e+20
      f1mn=1.0e+20
c     ....  per resid
      f2mx=-1.0e+20
      f2mn=1.0e+20
c     ....  per al2
      f21mx=-1.0e+20
      f21mn=1.0e+20
c     ....  per al2m1
      f22mx=-1.0e+20
      f22mn=1.0e+20
c     ....  per almed
      f23mx=-1.0e+20
      f23mn=1.0e+20
c     ....  per ss1
      f3mx=-1.0e+20
      f3mn=1.0e+20
c     ....  per ss2
      f4mx=-1.0e+20
      f4mn=1.0e+20
c     ....  per nquest
      f5mx=-1.0e+20
      f5mn=1.0e+20
c     ....  per ntrest
      f6mx=-1.0e+20
      f6mn=1.0e+20
c     ....  per psi-0
      f7mx=-1.0e+20
      f7mn=1.0e+20
c     ....  per ensintr
      f8mx=-1.0e+20
      f8mn=1.0e+20
c     ....  per ensinqu
      f9mx=-1.0e+20
      f9mn=1.0e+20
c     ....  per rpsi0-1
      f10mx=-1.0e+20
      f10mn=1.0e+20
c     ....  per rpsi0-2
      f11mx=-1.0e+20
      f11mn=1.0e+20
c     ....  per abspsi0
      f12mx=-1.0e+20
      f12mn=1.0e+20
c     ....  per alcom
      f13mx=-1.0e+20
      f13mn=1.0e+20
c     ....  per psicom
      f14mx=-1.0e+20
      f14mn=1.0e+20
c     ....  per alcom normalizzata
      f15mx=-1.0e+20
      f15mn=1.0e+20
c     ....  per psicom normalizzata
      f16mx=-1.0e+20
      f16mn=1.0e+20
c     ....  per cphase
      f17mx=-1.0e+20
      f17mn=1.0e+20
c     ....  per cfom
      f18mx=-1.0e+20
      f18mn=1.0e+20
      
c *********************************************************
c
c  lettura file relazioni
c
c *********************************************************
c -----
c     call sub. lettura lista 20 : quartetti negativi
c -----
c     call sub. lettura lista 21 : quartetti enantiomorfi
c -----
c     call sub. lettura lista 11 : tripletti enantiomorfi
c -----

*gl*      iprea=0
*gl*   42 call srlin (11,lsn,lfw,llw,lpb,ll)
*gl*      if(lfw) 61,61,44
*gl*   44 continue
*gl*      iDim = 2 * nen
*gl*      call sflxx(iprea,11,nen,nen,nxxd,nxxe,iccd,1,imat,iDim)
*gl*      do 60 i=1,nen
*gl*      nent1(i)=imat(1,i)
*gl*   60 nent2(i)=imat(2,i)
      if (nen > 0) then
          do i=1, nen
             nent1(i) = Lista11(1,i)
             nent2(i) = Lista11(2,i)
          enddo
      endif
c -----
c     call sub. lettura preambolo lista 8 : tripletti positivi
c -----
c -----
c     call sub. lettura lista 8 : tripletti positivi
c -----
*gl*  61  call srlin (8,lsn,lfw,llw,lpb,ll)
*gl*      if(lfw) 63,63,62
*gl*  62  continue
*gl*      iDim = 3 * ntrip
*gl*      call sflxx(iprea,8,nxxa,ntrpos,numx,ipten,igm,1,imat,iDim)
*gl*      do 70 i=1,ntrpos
*gl*      iee(i)=imat(1,i)
*gl*      iee1(i)=imat(2,i)
*gl*  70  continue
      if (ntrpos > 0) then
          do i=1, ntrpos
             iee(i)  = Lista08(1,i)
             iee1(i) = Lista08(2,i)
          enddo
      endif
c -----
c     call sub. lettura lista 10 : tripletti negativi
c -----
*gl*   63 call srlin (10,lsn,lfw,llw,lpb,ll)
*gl*      if(lfw) 490,490,64
*gl*   64 continue
*gl*      iDim = 3 * ntrneg
*gl*      call sflxx(iprea,10,ntrneg,ntrneg,nxxd,nxxe,iccd,1,imat,iDim)
*gl*      do 80 i=1,ntrneg
*gl*      iee(ntrpos+i)=imat(1,i)
*gl*      iee1(ntrpos+i)=imat(2,i)
*gl*   80 continue
      if (ntrneg > 0) then
          do i=1, ntrneg
             iee(ntrpos+i)  = Lista10(1,i)
             iee1(ntrpos+i) = Lista10(2,i)
          enddo
      endif
      ntrneg=ntrneg+ntrpos

c ----- compute  f.o.m. s for the different sets of phases
c
  490 continue
      nena=nqen+nen
      nphas=ns1+ns2+ntrneg
      if (nphas.eq.0) ww2=0.0
      if ( num0.eq.0) ww4=0.0
c NEW 11/10/91 elimino contributo MABS pesata da CFOM finale
      attl2=0.968
      attl3=0.798
  505 continue
      if (jall.eq.1) 
     *write(lo,1220)
 1220 format(//////10x,'numerators and denominators of phase ','dependan
     *t foms'//1x,'trial',10x,'ss1fom',14x,'ss2fom',13x,'nquest'
     * ,14x,'ntrest',14x,'fentrs',13x,
     * 'fenqus'/,5x,6(7x,'num       den')/)
      coms=0.0
      if (nundet .ge. (numbPhase/2) )  goto 500
      al2m1=al2m1/attl2
      almed=almed/attl3
      alcom=0.25*(sqrt(al2)+sqrt(al2m1)+sqrt(resid)
     1         +      almed)
c     write(6,*)'ALCOM : ',alcom
c     write(6,*)'******'
c     write(6,*)'alfp3 : ',al2
c     write(6,*)'alfp4 : ',al2m1
c     write(6,*)'alfp2 : ',resid
c     write(6,*)'alfp1 : ',almed

      if(absfom.gt.f1mx) f1mx=absfom
      if(absfom.lt.f1mn) f1mn=absfom
      if(resid .gt.f2mx) f2mx=resid
      if(resid .lt.f2mn) f2mn=resid
      if(al2  .gt.f21mx) f21mx=al2
      if(al2  .lt.f21mn) f21mn=al2
      if(al2m1.gt.f22mx) f22mx=al2m1
      if(al2m1.lt.f22mn) f22mn=al2m1
      if(almed.gt.f23mx) f23mx=almed
      if(almed.lt.f23mn) f23mn=almed
      if(alcom.gt.f13mx) f13mx=alcom
      if(alcom.lt.f13mn) f13mn=alcom
      foms1=0.0
      foms2=0.0
      fomqn=0.0
      sgtot=0.0
c
c   *******         one-phase s.s. f.o.m.*******
c
 150  if(foms1.gt.f3mx) f3mx=foms1
      if(foms1.lt.f3mn) f3mn=foms1
c
c  *******   two-phase  s.s.   f.o.m.*******
c
      fs1num=0.0
      fs2num=0.0
      foms2=0.0
      sg2=0.0

  250 if(foms2.gt.f4mx) f4mx=foms2
      if(foms2.lt.f4mn) f4mn=foms2
c
c  *******     negative quartet f.o.m.   *******
c
      fqnnum=0.0
      fomqn=0.0
      sgq=0.0
c
      gmqn=0.0
      nqn=0
      gmqnn=0.0
      nqnn=0

  310 if(fomqn.gt.f5mx) f5mx=fomqn
      if(fomqn.lt.f5mn) f5mn=fomqn
c
c  *******   psi-zero  f.o.m.    *******
c  -------   psi0, rpsi-1, rpsi-2, abspsi   -----------
c
c nuova procedura - psicom compresa in alcom
      rpsi1=0.0
      rpsi2=0.0
      abspsi=0.0
      fomps0=0.0
      psicom1=0.0
      psicom=0.0
c
c-new vecchio calcolo psicom - non inclusa in cfom
c
      sigm=sigmp
      if(icent.le.0) sigm=2.0*sigmp
      sigmd=s3s2d(jderi)
      if(icent.le.0)sigmd=2.0*s3s2d(jderi)
      id28=2**30
      attps1=0.215
      attps2=0.736
      attps3=1.0
      attps4=0.886
      if(num0.eq.0) go to 450
      s1=0.0
      s2=0.0
      num0u=0
      n0=numbPhase+num0+1
      do 360 i=1,num0

      n0=n0-1   
      li=lim0n(i) + 1
      ls=lim0n(i+1)

      if (ls.lt.li ) goto 360
      num0u=num0u+1
      tt1=0.0
      t2=0.0
      t4=0.0
      do 350 j=li,ls
      iph0n(j)=mod(iph0n(j),id28)
      call unpak3(iph0n(j),k1,k2,ifaz)
      ka1=iabs(k1)
      ka2=iabs(k2)
      if(iphaz(ka1).eq.0.or.iphaz(ka2).eq.0) go to 350
      iarg=isign(iphaz(ka1),k1) + isign(iphaz(ka2),k2) +
     * ifaz*15
      iarg=mod(iarg+36000,360) + 1
      ee=sigmd*fdelta(jderi,ka1)*fdelta(jderi,ka2)
      t3=ee
      t4=t4 + t3*t3
      tt1=tt1 + t3*ctable(iarg)
      t2=t2 + t3*stable(iarg)
350   continue
      t11=sqrt(tt1*tt1 + t2*t2)
      t4=sqrt(t4) * 3.0
c     t4=sqrt(t4) * 1.5
      s1=s1 + t11
      s2=s2 + t4
      t3=0.0
      if (t4.gt.0.0001) t3=t11/t4
      s10=t3*t3
      tt1=0.886
      if (icent.gt.0) tt1=0.798
      rpsi1=rpsi1+(t3-tt1  )*(t3-tt1  )
      rpsi2=rpsi2+abs(s10  -1.0)
      abspsi=abspsi + s10
360   continue
      t3=1.0/float(num0u)
      rpsi1=rpsi1  * t3 / attps1
      rpsi2=rpsi2  * t3 / attps2
      abspsi=abspsi * t3
      if(abs(s2).gt.0.0001) fomps0=s1/(s2*attps4)
      if (absfom.gt.0.001) then
      psicom1=0.25*(fomps0+sqrt(rpsi1)+sqrt(rpsi2)+sqrt(abspsi)) 
      psicom= psicom1/absfom
c---
cdri  if(absfom.gt.0.8)then
cdri  psicom= psicom1/(absfom**(2./3.))
cdri  psicom= psicom1/sqrt(absfom)
cdri                    endif
c---
                           else
      psicom=0.0
                           endif
c     write(6,*)'PSICOM : ',psicom,psicom1,fomps0,abspsi,rpsi2,rpsi1
c-endnew 
  450 if(fomps0.gt.f7mx) f7mx=fomps0
      if(fomps0.lt.f7mn) f7mn=fomps0
      if(rpsi1.gt.f10mx) f10mx=rpsi1
      if(rpsi1.lt.f10mn) f10mn=rpsi1
      if(rpsi2.gt.f11mx) f11mx=rpsi2
      if(rpsi2.lt.f11mn) f11mn=rpsi2
      if(abspsi.gt.f12mx) f12mx=abspsi
      if(abspsi.lt.f12mn) f12mn=abspsi
c
c     ********** tripletti positivi + negativi per CPHASE  ************

c
      fomntr=0.0
      ftrnum=0.0
      sgt=0.0
      if(ntrneg.eq.0) go to 455
      do 1400 i=1,ntrneg
      call unpak3 (iee(i),k1,k2,ifaz)
      call unpak3 (iee1(i),k3,k4,ifaz)
      ka2=iabs(k2)
      ka3=iabs(k3)
      g=k4*0.01
      ga=abs(g)
      if(iphaz(k1).eq.0.or.iphaz(ka2).eq.0.or.iphaz(ka3).eq.0)
     *  go to 1400
      iarg=iphaz(k1)+isign(iphaz(ka2),k2)+isign(iphaz(ka3),k3)
     * + 15*ifaz
      iarg=mod(iarg+36000,360) + 1
      if (i.le.ntrpos) then
                        fomntr=fomntr +ga*ctable(iarg)
                       else
                        fomntr=fomntr -ga*ctable(iarg)
                       endif
      sgt=sgt+ ga *bes(ga)
c
      gmqn=gmqn+ga
      nqn=nqn+1
c
1400  continue
      ftrnum=fomntr
      sgtot=sgtot + sgt
      if(sgt.lt.0.00001) go to 455
      fomntr=fomntr/sgt
455   if(fomntr.gt.f6mx) f6mx=fomntr
      if(fomntr.lt.f6mn) f6mn=fomntr
c
c NEW 5/11/91 peso cphase con D1(<G>) rispetto ad alcomb
      if(nqn.gt.0) then
                      gmqn=gmqn/nqn
                      wqtn=sqrt(bes(gmqn))
                    else
                      wqtn=ww2
                   endif
c
c  *******  enantiomorph sensitive  f.o.m. ' s
c
      fents=0.0
      fenqs=0.0
      gfx=0.1
      ren1=0.0
      gents=0.0
      ren2=0.0
      genqs=0.0
c  ----  skip if space group is centrosymmetric  ----
      if (icent.gt.0) go to 2200
c  +++++++     triplet  f.o.m.' s    +++++++
      if(nen.le.0) go to 2070
      n=0
      do 2050 i=1,nen
      call unpak3 (nent1(i),k1,k2,ifaz)
      call unpak3 (nent2(i),k3,k4,ifaz)
      ka2=iabs(k2)
      ka3=iabs(k3)
      if(iphaz(k1).eq.0.or.iphaz(ka2).eq.0.or.iphaz(ka3).eq.0)
     *  go to 2050
      iarg=iphaz(k1)+isign(iphaz(ka2),k2)+isign(iphaz(ka3),k3)
     * + 15*ifaz
      iarg=mod(iarg+36000,360) + 1
      fents=fents + abs(stable(iarg))
      n=n + 1
2050  continue
      if(n.eq.0) go to 2070
      ren1=float(n)*gfx
      gents=fents*gfx
      s1=1.0/float(n)
      fents=fents*s1
2070  if(fents.gt.f8mx) f8mx=fents
      if(fents.lt.f8mn) f8mn=fents
c  +++++++     quartet  f.o.m.' s    +++++++
2170  if(fenqs.gt.f9mx) f9mx=fenqs
      if(fenqs.lt.f9mn) f9mn=fenqs
 2200 continue
      if(sgtot.gt.0.00001) coms=ftrnum/(1.3*sgtot)
      if (jall.eq.1)
     *write(lo,2220) nuset,ftrnum,sgt,gents,ren1,genqs,ren2
2220  format(1x,i4,6f10.2)
c--
      den12=ren1+ren2
      enan=0.0
      if (abs(den12).gt.0.00001) enan=(gents+genqs)/den12
  500 continue
c
c ======= compute  combined  f.o.m.
c
      if(f1mn.gt.1.0e+19) f1mn=0.0
      if(f2mn.gt.1.0e+19) f2mn=0.0
      if(f21mn.gt.1.0e+19) f21mn=0.0
      if(f22mn.gt.1.0e+19) f22mn=0.0
      if(f23mn.gt.1.0e+19) f23mn=0.0
      if(f3mn.gt.1.0e+19) f3mn=0.0
      if(f4mn.gt.1.0e+19) f4mn=0.0
      if(f5mn.gt.1.0e+19) f5mn=0.0
      if(f6mn.gt.1.0e+19) f6mn=0.0
      if(f7mn.gt.1.0e+19) f7mn=0.0
      if(f8mn.gt.1.0e+19) f8mn=0.0
      if(f9mn.gt.1.0e+19) f9mn=0.0
      if(f10mn.gt.1.0e+19) f10mn=0.0
      if(f11mn.gt.1.0e+19) f11mn=0.0
      if(f12mn.gt.1.0e+19) f12mn=0.0
      if(f13mn.gt.1.0e+19) f13mn=0.0
c     if(f14mn.gt.1.0e+19) f14mn=0.0
      if(f1mx.lt.-1.0e+19) f1mx=0.0
      if(f2mx.lt.-1.0e+19) f2mx=0.0
      if(f21mx.lt.-1.0e+19) f21mx=0.0
      if(f22mx.lt.-1.0e+19) f22mx=0.0
      if(f23mx.lt.-1.0e+19) f23mx=0.0
      if(f3mx.lt.-1.0e+19) f3mx=0.0
      if(f4mx.lt.-1.0e+19) f4mx=0.0
      if(f5mx.lt.-1.0e+19) f5mx=0.0
      if(f6mx.lt.-1.0e+19) f6mx=0.0
      if(f7mx.lt.-1.0e+19) f7mx=0.0
      if(f8mx.lt.-1.0e+19) f8mx=0.0
      if(f9mx.lt.-1.0e+19) f9mx=0.0
      if(f10mx.gt.1.0e+19) f10mx=0.0
      if(f11mx.gt.1.0e+19) f11mx=0.0
      if(f12mx.gt.1.0e+19) f12mx=0.0
      if(f13mx.gt.1.0e+19) f13mx=0.0
c     if(f14mx.lt.-1.0e+19) f14mx=0.0
      if (jall.eq.1)
     *write(lo,510) f1mn,f23mn,f2mn,f21mn,f22mn,f3mn,f4mn,f5mn,f6mn,
     * f7mn,f12mn,f11mn,f10mn,f8mn,f9mn,
     *              f1mx,f23mx,f2mx,f21mx,f22mx,f3mx,f4mx,f5mx,f6mx,
     * f7mx,f12mx,f11mx,f10mx,f8mx,f9mx
  510 format(/// 30x,'++++++++++  Figures  Of  Merit  ++++++++++'//
     *8x,'mabs ',' nalf(1)',' nalf(2)',' nalf(3)',' nalf(4)','    ss1 ',
     *'    ss2 ','    nqu ','    ntr ','  nps(0)','  nps(1)',
     * '  nps(2)','  nps(3)','   entr ','   enqu ',
     * //,' min',15f8.3/,' max',15f8.3)
      if (jall.eq.1) 
     *write (lo,530)
  530 format(///' trial',2x,'mabs ',
     *           ' nalf(1)',' nalf(2)',' nalf(3)',' nalf(4)','    ss1 ',
     *'    ss2 ','    nqu ','    ntr ','  nps(0)','  nps(1)',
     *'  nps(2)','  nps(3)','   entr ','   enqu ',/)
      if (jall.eq.1)
     *write(lo,550) nuset,absfom,almed,resid,al2,al2m1,
     * foms1,foms2,fomqn,fomntr,fomps0,abspsi,
     * rpsi2,rpsi1,fents,fenqs
  550 format(1x,i3,18f8.3)
      if (nundet.lt. (numbPhase/2) ) goto 558
      alcom=0.0
      psicom=0.0
      crel=0.0
      coms=0.0
      goto 586
  558 continue
      crel=coms
*-----------------------
      alcom1=alcom-1.0
      psicom1=psicom-1.0
      crel1=1.2-crel
*-----------------------
      if ( alcom.gt.1.0)  go to 560
      alcom=1.0
      go to 565
c 560 arg=( alcom  -1.0 )**1.5
  560 if (alcom.gt.2.0) arg=( alcom  -1.0 )**0.8
      if (alcom.le.2.0) arg=( alcom  -1.0 )**1.5
      if(arg.gt.87.0) then
                       alcom=0.0
                      else
                       alcom=exp( -arg )
                      endif
  565 if (psicom.gt.1.0) go to 570
      if (num0.eq.0) then
                      psicom=0.0
                     else
                      psicom=1.0
      endif
      goto 575
  570 continue
      psicom=exp( -(( psicom-1.0 )**1.5))
  575 if (nphas.eq.0) go to 581
      if (  crel.lt.0.00001.and.crel.gt.-0.00001)   go to 581
      if (  crel.lt.1.2)   go to 580
      crel=1.0
      go to 581
  580 continue
      crel =exp( -(( 1.2 - crel  )**1.5))
  581 if (alcom.gt.f15mx) f15mx=alcom
      if (alcom.lt.f15mn) f15mn=alcom
      if(coeco.gt.f16mx) f16mx=coeco
      if(coeco.lt.f16mn) f16mn=coeco
      if(  crel.gt.f17mx) f17mx=  crel
      if(  crel.lt.f17mn) f17mn=  crel
      if(psicom.gt.f14mx) f14mx=psicom
      if(psicom.lt.f14mn) f14mn=psicom
c NEW 11/10/91 elimino contributo MABS pesata da CFOM finale
      swwn=1.0/(3.3+0.8*wqtn)
      coms=swwn * (crel*0.8*wqtn + alcom + 1.3*psicom + coeco)
      if( coms.gt.f18mx) f18mx= coms
      if( coms.lt.f18mn) f18mn= coms
      enan=asin(enan)*rtod
  586 nsacc=nsacc+1
      ksacc=ksacc+1
c------ per la graphica
      if (nuset.le.nsxx) cfomx=f18mx
c-------
      if (knw.eq.0)
     *write(lo,751) nuset,absfom,alcom,psicom,crel,coms,error,errpes,
     *              enan,nundet
  751 format(' trial #',i4,' foms=',5f8.3,8x,3f8.3,i6)

c     if (coms > coms_best.and.nuset < nsxx) then
      if (coms > coms_best) then
        coms_best = coms
        nuset_best=nuset
      endif
c     write(strLog,'(9h< Trial >,i4,1x,11hCFOM\dDM\u=,f6.3,2x,
c    * 18h( Best CFOM\dDM\u=,f6.3,2x,10hfor Trial=,i4,2h ))')
c    *  nuset,coms,coms_best,nuset_best
      write(Msg,752) nuset,coms,coms_best,nuset_best 
  752 format(8h Trial  ,i4,1x,'CFOM<sub>DM</sub>=',f6.3,2x,
     * '( Best CFOM<sub>DM</sub>=',f6.3,2x,'for Trial=',i4,' )')
      if (kscreen > 0) then
        if (nuset /= 1) then
          inBoxGr(2) = inBoxGr(2) - 1
        endif
        nLinesGRSav = nLinesGR
        nLinesGR = nLinesGRTrial
c       call TestoGR(Msg, -1, 2, 2)
        call TestoGR(Msg, color_LIGHTRED, 2, 2)
        if (nuset /= 1) then
           nLinesGR = nLinesGRSav
        endif
        call zflush
        call DoSingleIteration()
      endif
c-new



      nerr=0
      err1=0.0
      err2=0.0
      scomb1=0.0
      
      if (knw.eq.1.and.npuntEquiv.gt.0 .and. absfom .gt.0) then
         scomb1=alcom1+psicom1+crel1

         write(lo,9988)nuset,absfom,alcom,psicom,coeco,crel,coms,
     *   nundet,erm1,ermw1,erm2,ermw2,enan,nerr,err1,err2
c    *   nundet,erm1,ermpes1,erm2,ermpes2,enan,nerr,err1,err2
      endif
 9988 format(10h < trial >:,i5,6f8.3,i5,5f8.2,i5,2f8.2)
c-new
      if (ksacc.le.mxsac) then
          nsind=ksacc
          if (ksacc.eq.1) then
             aminco=9.0
             mxsaco=mxsac
          endif
          if (jumpp.eq.1) go to 760
          if (coms.lt.aminco) aminco=coms
          if (coms.lt.0.01.and.ksacc.gt.1) then
             nfom0=nfom0+1
             ksacc=ksacc-1
             go to 660
          endif
      endif
      if (jumpp.eq.1.and.ksacc.gt.mxsaco) then
         mxsaco=mxsaco+1
         nsind=mxsaco
         go to 760
      else
         if (ksacc.gt.mxsac) then
            aminco=fomrt(1,5)
            nsmin=1
            do 710 idn=2,mxsac
               if (fomrt(idn,5).lt.aminco) then
                  aminco=fomrt(idn,5)
                  nsmin=idn
               endif
 710        continue
            nsind=nsmin
            if (coms.lt.aminco) then
               ksacc=ksacc-1
               if (coms.lt.0.01) nfom0=nfom0+1
               goto 660
            endif
      endif
      endif
      if (ipri0.eq.1)
     *write(6,720)nsacc,ksacc,mxsac,mxsaco,nsind,aminco,coms
  720 format(' nsacc: ',i3,2x,'ksacc: ',i3,2x,'mxsac: ',i2,2x,'mxsaco:',
     *i2,2x,'nsind: ',i2,2x,'aminco: ',f8.4,2x,'coms: ',f8.4)
      if (npuntEquiv.gt.0) then
      cfodi=0.009
      jsacc=ksacc-1
      if (jsacc.gt.mxsac) jsacc=mxsac
      if (jsacc.eq.0) go to 760  
      do 730 j=1,jsacc
      cfomd=abs(coms-fomrt(j,5)) 
      if (cfomd.lt.cfodi) then
                           jjeq=j
      cfomd=(abs(absfom-fomrt(jjeq,1))
     *      +abs( alcom-fomrt(jjeq,2))
     *      +abs(crel-fomrt(jjeq,4)))
     *      +abs(psicom-psivet(jjeq))
     *      +abs(coeco-fomrt(jjeq,3))/5.0
      if (cfomd.gt.cfodi) go to 730
      iflag=0
*gl*  call snr16(jjeq,fig,wtj,iphazj)
      call PutGetInitialPhases(2, jjeq, fig, wtj, iphazj)
      do 770 k=1,npuntEquiv
      i=jpunt(k)
      if (wt(i).gt.0.01.and.wtj(i).gt.0.01) then
            iphen=360.000-iphaz(i)
            if (abs(iphaz(i)-iphazj(i)).le.3.or.abs(iphen-iphazj(i))
     *.le.3) then 
                go to 770
            else
                go to 730
            endif
            endif
  770 continue
      write(6,*) ' set equivalente = ',nuset
      ksacc=ksacc-1
      jseteq=jseteq+1
c
c-new 22/04/93 to store equivalent trial with cfom max
c
      if (knw.eq.0) then
         if (coms.gt.fomrt(jjeq,5)) then
            nsind=jjeq
            go to 760
         else
            go to 660
         endif
      else
        if (error.lt.fomrt(jjeq,7)) then
           nsind=jjeq
           go to 760
         else
            go to 660
        endif
      endif
c-endnew
             endif
  730 continue
             endif

  760 fomrt(nsind,1)=absfom
      fomrt(nsind,2)=alcom
CCC   fomrt(nsind,3)=psicom
      fomrt(nsind,3)=coeco
      fomrt(nsind,4)=crel
      fomrt(nsind,5)=coms
      fomrt(nsind,6)=nundet
      fomrt(nsind,7)=error
      fomrt(nsind,8)=errpes
      fomrt(nsind,9)=enan
      fomrt(nsind,10)=nuset
      psivet(nsind)=psicom
      comb1(1,nsind)=alcom1
      comb1(2,nsind)=psicom1
      comb1(3,nsind)=crel1
      comb1(4,nsind)=scomb1
      fomquar(nsind)=fomqn
c     error1(nsind,1)=erm1
c     error1(nsind,2)=ermpes1
c     error2(nsind,1)=erm2
c     error2(nsind,2)=ermpes2

      error1(nsind,1)=erm1
      error1(nsind,2)=ermw1
      error2(nsind,1)=erm2
      error2(nsind,2)=ermw2

      if (knw.gt.0) then
          do 645 idri=1,3
            shif(nsind,idri)=shi(idri)
 645        continue
      end if
      iyzz=iyyy
      if (knw.eq.1.and.jumpp.eq.1.and.lasts.eq.0) go to 660
      nurec=nsind
      fig17(:)=0.0
      do 650 j=1,10
  650 fig(j)=fomrt(nsind,j)
c     if (nurec == 3) then
c         do i=1,numbPhase
c            write(6,666) i,iphaz(i),ipub(i),wt(i)
c         enddo
c     endif
  666 format(i5,')',2i8,f8.4)
*gl*  call snw16(nurec,fig,wt,iphaz)
      call PutGetInitialPhases(1, nurec, fig, wt, iphaz)
      
  660 return
      end
c-------------------------------------------------------------
c
c          Active use of psi-zero relationships
c
c-----------------------------------------------------------------------
      subroutine newpsi(nuset,k,san,can,sang,cang,sangb,cangb,
     *                  subtr,nn0,tnd,alpham)
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE PhaseModule
      
      common /tables/ stable(500)
      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *         alphap(6000),ktheta(6000),a0est(6000),a0var(6000)
      dimension eni1(4),lin1(4,6),bility(50)

      dimension ctable(500)
      equivalence (stable(91),ctable(1))
c
      if (knewpsi.eq.0) return
      sigm=s3s2
      sigmd=s3s2d(jderi)
      q0=0.798
      nn0=0
      if (icent.le.0) then
          sigm=2.0*s3s2
          sigmd=2.0*s3s2d(jderi)
          q0=0.886
      endif
      li=limref0(k) + 1
      ls=limref0(k+1)
      if (ls.ge.li ) then
         ta=0.0
         tn=0.0
         td=0.0
         do 350 j=li,ls
CCC         if(nn0.gt.79) go to 360
            ind=nbinv0(j)
            call depac0 (k,ind,a,ifaz,iw,nn)
            k2=nn(1)
            k3=nn(2)
            nn3=nn(3)
            ka2=iabs(k2) - numbPhase
            ka3=iabs(k3)
c
c-- compute alpha' and theta' respect to refl. ka2
c
c           call newpsi3(ka2)
c
            if (ktheta(ka2).ne.0.and.iphaz(ka3).ne.0) then
               iarg = isign(ktheta(ka2),k2)
     *                + isign(iphaz(ka3),k3) + ifaz*15
               iarg=mod(iarg+36000,360) + 1
               if (alphap(ka2).ge.a0var(ka2)) then
                  aprimo=fdelta(jderi,k)*fdelta(jderi,ka3)*sigmd
                  w=(alphap(ka2)-a0est(ka2)) / a0var(ka2)
                  w=bes(w)
                  tn=tn + w * aprimo * stable(iarg)
                  td=td + w * aprimo * ctable(iarg)
                  nn0=nn0+1
               endif
            endif
  350    continue
  360    tnd=sqrt(tn*tn+td*td)
         soglia=sqrt(alpham) * 0.30
         if (tnd.lt.soglia) return
         san   = san   - tn
         can   = can   - td
         sang  = sang  - tn
         cang  = cang  - td
         sangb = sangb - tn
         cangb = cangb - td
         subtr = sqrt ( tn*tn + td*td )
      endif
      return
      end
c-----------------------------------------------------------------------

      subroutine newpsi1

      USE General
      USE Riflessi
      USE PhaseData
      USE PhaseModule
      USE ListeXX

c  
      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *         alphap(6000),ktheta(6000),a0est(6000),a0var(6000)
      dimension klim0(6001)
      dimension eni1(4),lin1(4,6),bility(50)
c
      !knewpsi=0 ! Dritan
      if (knewpsi.eq.0) return
c
*gl*  iprea=0
*gl*  iDim = 3 * npsi
*gl*  call sflxx(iprea,9,npsi,npsi,num0,nxxe,iccd,1,imat,iDim)
      npsi = NPsiZero
      num0 = NRefZero
      jg=0
      ifaz=-1
      j=0
      do 25 i=1,npsi
*gl*  call unpak3(imat(1,i),kod2,kod3,ishif)
*gl   call unpak3(imat(2,i),kod1,kod2,ishif)
      call unpak3(Lista09(1,i),kod2,kod3,ishif)
      call unpak3(Lista09(2,i),kod1,kod2,ishif)
      jph0(j+1)=((kod1+2048)*4096+kod2+2048)*32+ifaz+1
      jph0(j+2)=((kod3+2048)*4096+jg+2048)*32+ishif+1
   25 j=j+2
c
c   preparation of pointers table for psi-zero
c
      n1=0
      n2=0
      nb1 = numbPhase + num0 + 1
      do 100 i = 1,nb1
100   limref0(i) = 0
      j = 1
      do 120 i = 1,npsi
      call depac0 (0,j,a,ifaz,iw,nn)
      j = j + iw
      do 110 kk = 1,3
      if (nn(kk).ne.0) then
                         n1=iabs(nn(kk))+1
                         limref0(n1) = limref0(n1) + 1
                       endif
110   continue
120   continue
      do 130 i = 1,numbPhase+num0
      limref0(i+1) = limref0(i+1) + limref0(i)
      klim0(i+1) = limref0(i+1)
130   continue
      klim0(1) = 0
c
c  storage of the no. of relations for a given reflexion
      j = 1
      do 150 i = 1,npsi
      call depac0 (0,j,a,ifaz,iw,nn)
      do 140 kk = 1,3
      if (nn(kk).ne.0) then
                         ind=iabs(nn(kk))
                         klim0(ind) = klim0(ind) + 1
                         ind1= klim0(ind)
                         nbinv0(ind1) = j
                       endif
140   continue
      j = j+iw
150   continue
      do 300 i=1,numbPhase+num0
      n1=0
      n2=0
      lm=limref0(i)+1
      ls=limref0(i+1)
      if (lm.gt.ls) goto 300
      do 220 ii=lm,ls
      ind=nbinv0(ii)
      call depac0 (0,ind,a1,ifaz,iw,nn)
      if (iw.eq.2) then
                   n1=n1+1
                  else
                   n2=n2+1
                  endif
  220 continue
c     write (6,280) i,lm,ls,n1,n2
c 280 format(2x,i5,1h),5x,4i8)
  300 continue
      do 400 i=1,num0
      alphap(i)=0.0
      ktheta(i)=0
      a0est(i)=0.0
      a0var(i)=0.0
  400 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine newpsi3(kweak)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE PhaseData
      USE PhaseModule

      common /tables/ stable(500)
      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *          alphap(6000),ktheta(6000),a0est(6000),a0var(6000)
      dimension ctable(500)
      equivalence (stable(91),ctable(1))

c
c     if(kweak.eq.1)
c    *write(6,*) ' NEWPSI3 - npsi,numbPhase,num0',npsi,numbPhase,num0
c     write(6,'(10i8)') (i,iphaz(i),i=1,numbPhase)
      sigm=s3s2
      if (jderi.gt.0) sigmd=s3s2d(jderi)
      q0=0.798
      if (icent.le.0) then
         sigm=2.0*s3s2
         if (jderi.gt.0) sigmd=2.0*s3s2d(jderi)
         q0=0.886
      endif
c
      i=kweak
      ii=i+numbPhase
      alphap(i)=0.0
      ktheta(i)=0
      a0est(i)=0.0
      a0var(i)=0.0
      li=limref0(ii) + 1
      ls=limref0(ii+1)
      if (ls.ge.li ) then
                       ta=0.0
                       tn=0.0
                       td=0.0
c                      num=min0(ls-li+1,80)
                       jcont=0
                       do 350 j=li,ls
c                      if (jcont.gt.num) go to 350
                       jcont=jcont+1
                       ind=nbinv0(j)
                       call depac0 (0,ind,a,ifaz,iw,nn)
                       k2=-nn(2)
                       k3=-nn(3)
                       ifaz=-ifaz
                       ka2=iabs(k2)
                       ka3=iabs(k3)
                       if (iphaz(ka2).ne.0.and.iphaz(ka3).ne.0) then
                           iarg = isign(iphaz(ka2),k2)
     *                          + isign(iphaz(ka3),k3)
     *                          + ifaz*15
                           iarg=mod(iarg+36000,360) + 1
                           ee=fdelta(jderi,ka2)*fdelta(jderi,ka3)*sigmd
                           ta=ta + ee * ee
                           tn=tn + ee * stable(iarg)
                           td=td + ee * ctable(iarg)
                         endif
  350                  continue
                      if (ta.gt.0.001) then
                          ta=sqrt(ta)
                          alphap(i)=  sqrt(tn*tn + td*td) 
                          ip=3600+atan2(tn,td)*rtod
                          ip=mod(ip,360)
                          if (ip.eq.0) ip=360
                          ktheta(i)=ip
                          a0est(i)=ta*q0
                          a0var(i)=ta*3.0
                        endif
                     endif
      return
      end
c-----------------------------------------------------------------------
      subroutine newpsi4(nuset,ipr)
      USE General
      USE PhaseModule

      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *          alphap(6000),ktheta(6000),a0est(6000),a0var(6000)
c
c-- compute alpha' and theta' respect to all refl.
c
      do 10 ka2=1,num0
      call newpsi3(ka2)
   10 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine depac0 (i,ind,a,ifaz,iw,nn)
      USE General
      common /gian/ limref0(6000),nbinv0(91000),jph0(60000),knewpsi,
     *          alphap(6000),ktheta(6000),a0est(6000),a0var(6000)
      dimension nn(8)
c
      icod=0
      do 10 j = 1,3
   10 nn(j) = 0
      call unpak3(jph0(ind),nn(1),nn(2),ifaz)
      call unpak3(jph0(ind+1),nn(3),jg,ifaz)
      iw = 2
      if (i.ne.0) then
                    jj=0
                    do 50 j = 1,3
                    if (iabs(nn(j)).eq.i) jj=j
   50               continue
                    if (jj.eq.0) then
                                   write(lo,90) i,nn(1),nn(2),nn(3)
                                   call cstop(' ')
                                 endif
                    isi = - isign(1,nn(jj))
                    j1 = 1
                    do 70 jcris = 1,3
                    if (jcris.ne.jj) then
                                       nn(j1) = nn(jcris) * isi
                                       j1 = j1+1
                                    endif
   70               continue
                    ifaz = ifaz * isi
                    if (ifaz.lt.0) ifaz=ifaz+24
                  endif
   90 format (5x,'***** error in subroutine depac0 ******',i5,3x,4i5)
      return
      end
c-----------------------------------------------------------------
      subroutine punts1
 
      USE Riflessi
      USE PhaseData
      USE PhaseModule

      dimension jhk(3)
c
      npuntEquiv=0
      do 10 i=1,numbPhase
      jhk(1:3)=khl(1:3,i)
      ks=midolo(jhk)
      if (ks.eq.0) then
               npuntEquiv=npuntEquiv+1
               jpunt(npuntEquiv)=i
              endif
  10  continue
      return
      end
c-----------------------------------------------------------------
      function midolo(hkl)
c-- verifies if a reflection is a seminvariant
c
      USE Symmetry
      common/sym2/msym,nsym2
c
      integer hkl(3),mat(3,3)
*     equivalence (mat(1,1),jsvet(1))

      k = 0
      do i=1,3
         do j=1,3
            k = k + 1
            mat(j,i) = jsvet(k)
         enddo
      enddo

c
      midolo=1
      do 30 ic=1,3
      isum=0
      do 20 i=1,3
   20 isum=isum+mat(ic,i)*hkl(i)
      if (mod(isum,192).ne.0) return
   30 continue
      midolo=0
      return
      end
c-----------------------------------------------------------------
